﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PatchSto.Ability
{
	/// <summary>
	/// 凍結のスキルを受ける側
	/// (行動不可)
	/// </summary>
	class FreezeAbility : thrts.AbilityTemplate
	{
		public const string AbilityName = "凍結";

		thrts.IEffectCommon effect = null;

		public FreezeAbility()
		{
			Name = AbilityName;
			DurationTime = 1 * 30;
		}

		public override bool OnVanish(thrts.IUnit unit)
		{
			if (effect != null)
			{
				effect.Stop();
			}
			return true;
		}

		public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
		{
			if (effect == null)
			{
				effect = unit.Faction.World.EffectManager.CreateTextureEffect(typeof(Effect.FreezingTextureEffect).FullName, unit.Pos);
				unit.AddOnVanishEvent((u) =>
				{
					if (effect != null)
					{
						effect.Stop();
					}
				});
			}

			switch (order)
			{
				case thrts.AbilityOrder.ConstDecParam:
					break;
				case thrts.AbilityOrder.RateDecParam:
					{
						unit.Speed = 0;
					}
					break;
				case thrts.AbilityOrder.ConstIncParam:
					break;
				case thrts.AbilityOrder.RateIncParam:
					break;
				case thrts.AbilityOrder.OtherExecs:
					break;
				default:
					{
						unit.IsForbiddenAttacking = true;
						if (effect != null)
						{
							effect.SetPosition(unit.Pos);
						}
					}
					break;
			}

			return true;
		}
	}
}
