﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PatchSto.Ability
{
	class SoilAbility : thrts.AbilityTemplate
	{
		Building.Library library = null;
		thrts.IEffectCommon effect = null;

		public const string AbilityName = "土符";

		public SoilAbility(Building.Library library)
		{
			Name = AbilityName;
			DurationTime = 100 * thrts.Def.FPS;
			this.library = library;
		}

		public override bool OnVanish(thrts.IUnit unit)
		{
			if (effect != null)
			{
				effect.Stop();
			}
			return true;
		}

		public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
		{
			if (library.SoilTime <= 0)
			{
				if (effect != null)
				{
					effect.Stop();
					effect = null;
				}
				return false;
			}

			if (effect == null)
			{ 
				effect = library.Faction.World.EffectManager.CreateTextureEffect(typeof(Effect.AuraTextureEffect).FullName, unit.Pos);
				unit.AddOnVanishEvent((u) =>
				{
					if (effect != null)
					{
						effect.Stop();
					}
				});
			}

			switch (order)
			{
				case thrts.AbilityOrder.ConstDecParam:
					break;
				case thrts.AbilityOrder.RateDecParam:
					break;
				case thrts.AbilityOrder.ConstIncParam:
					break;
				case thrts.AbilityOrder.RateIncParam:
					{
						unit.Armor = (int)(unit.Armor * 1.5f);
						if (effect != null)
						{
							effect.SetPosition(unit.Pos);
						}
					}
					break;
				case thrts.AbilityOrder.OtherExecs:
					break;
				default:
					break;
			}

			return true;
		}
	}
}
