﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PatchSto.Bomb
{
	public class Fire : thrts.ButtonParameter<thrts.IBuilding>
	{
		bool used = false;
		public Fire()
		{
			Position = Tuple.Create(thrts.ButtonPosition._0, thrts.ButtonPosition._3);
			ButtonImagePath = "PatchSto/Image/Button/Fire";
			ButtonName = "火符";

			Kind = thrts.ButtonKind.Normal;

			NormalButtonEvent = (building, isAppend) =>
			{
				if (used) return;

				var DamageBonus = new float[thrts.AttackBonusSet.None.Length];
				DamageBonus[(int)thrts.TargetObjectType.Clay] = 1.0f;
				DamageBonus[(int)thrts.TargetObjectType.Hero] = 1.00f;
				DamageBonus[(int)thrts.TargetObjectType.Water] = 1.0f;
				DamageBonus[(int)thrts.TargetObjectType.Structure] = 1.0f;

				var units = building.Faction.World.UnitManager.GetUnits(_ => _.Faction != building.Faction);
				foreach (var unit in units)
				{
					building.Faction.World.EffectManager.CreateTextureEffect(typeof(Effect.BombHitRedTextureEffect).FullName, unit.Pos);
					unit.BeDamaged(null, (int)(unit.MaxHP * 0.75f), DamageBonus);
				}

				// 無理やりカットイン表示
				var fu = building.Faction.World.UnitManager.GetUnits(_ => _.Exists()).FirstOrDefault();
				if (fu != null)
				{
					fu.ShowCutin();
				}

				var center = building.Pos;

				for (int y = -3; y <= 3; y++)
				{
					for (int x = -3; x <= 3; x++)
					{
						CreateEffect(building.Faction, center + new thrts.Vector3D(x * 180, y * 180, 0), 14);
					}
				}

				used = true;
			};

			MouseOverTextFunc = (faction) =>
				{
					thrts.ColorTextLine l0 = new thrts.ColorTextLine("画面全体の敵にダメージを与える。");
					return new thrts.ColorTextLine[] { l0 };
				};
		
			CanExecute = (faction, _, building) =>
			{
				return new thrts.ExecutableInfo(!used, new thrts.ColorTextLine("使用済みです。"));
			};
		}

		public void CreateEffect(thrts.IFaction faction, thrts.Vector3D pos, float scale)
		{
			var offset = new thrts.Vector3D(0, 0, 4);
			var effect = faction.World.EffectManager.CreateEffect(typeof(Effect.PillarAreaEffect).FullName, pos + offset);
			effect.SetScale(new thrts.Vector3D(scale, scale, scale));
		}
	}
}
