﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PatchSto.Bomb
{
	public class Gold : thrts.ButtonParameter<thrts.IBuilding>
	{
		bool used = false;

		public Gold()
		{
			Position = Tuple.Create(thrts.ButtonPosition._4, thrts.ButtonPosition._3);
			ButtonImagePath = "PatchSto/Image/Button/Gold";
			ButtonName = "金符";

			Kind = thrts.ButtonKind.Normal;

			NormalButtonEvent = (building, isAppend) =>
			{
				if (used) return;

				building.HP += building.MaxHP / 2;

				// 無理やりカットイン表示
				var fu = building.Faction.World.UnitManager.GetUnits(_ => _.Exists()).FirstOrDefault();
				if (fu != null)
				{
					fu.ShowCutin();
				}

				CreateEffect(building.Faction, building.Pos, 20);

				used = true;
			};

			MouseOverTextFunc = (faction) =>
				{
					thrts.ColorTextLine l0 = new thrts.ColorTextLine("図書館のHPを回復させる。");
					return new thrts.ColorTextLine[] { l0 };
				};
		
			CanExecute = (faction, _, building) =>
			{
				return new thrts.ExecutableInfo(!used, new thrts.ColorTextLine("使用済みです。"));
			};
		}

		public void CreateEffect(thrts.IFaction faction, thrts.Vector3D pos, float scale)
		{
			var offset = new thrts.Vector3D(0, 0, 4);
			var effect = faction.World.EffectManager.CreateEffect(typeof(Effect.KinfuEffect).FullName, pos + offset);
			effect.SetScale(new thrts.Vector3D(scale, scale, scale));
			faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.Shuiin01).FullName, pos);
		}
	}
}
