﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PatchSto.Bomb
{
	public class Water : thrts.ButtonParameter<thrts.IBuilding>
	{
		bool used = false;

		public Water()
		{
			Position = Tuple.Create(thrts.ButtonPosition._1, thrts.ButtonPosition._3);
			ButtonImagePath = "PatchSto/Image/Button/Water";
			ButtonName = "水符";

			Kind = thrts.ButtonKind.Normal;

			NormalButtonEvent = (building, isAppend) =>
			{
				if (used) return;

				var library = building.Parameter as Building.Library;

				library.WaterTime = 10 * thrts.Def.FPS;

				// 無理やりカットイン表示
				var fu = building.Faction.World.UnitManager.GetUnits(_ => _.Exists()).FirstOrDefault();
				if (fu != null)
				{
					fu.ShowCutin();
				}

				library.WaterEffect = building.Faction.World.EffectManager.CreateEffect(typeof(Effect.ShimofuEffect).FullName, building.Pos);
				library.WaterEffect.SetScale(new thrts.Vector3D(15,15,15));

				used = true;
			};

			MouseOverTextFunc = (faction) =>
				{
					thrts.ColorTextLine l0 = new thrts.ColorTextLine("一定時間、復帰時間を短くする。");
					return new thrts.ColorTextLine[] { l0 };
				};
		
			CanExecute = (faction, _, building) =>
			{
				return new thrts.ExecutableInfo(!used, new thrts.ColorTextLine("使用済みです。"));
			};
		}
	}
}
