﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PatchSto.Effect
{
	public class CreateUnitEffect : thrts.EffectParameter
	{
		public CreateUnitEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/common_CreateUnit.efk";
		}
	}

	public class DeadUnitEffect : thrts.EffectParameter
	{
		public DeadUnitEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/common_unit_dead.efk";
		}
	}

	public class PillarAreaEffect : thrts.EffectParameter
	{
		public PillarAreaEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/patch_stElmo_area.efk";
		}
	}

	public class KinfuEffect : thrts.EffectParameter
	{
		public KinfuEffect()
		{
			EffectPath = "PatchSto/3D/Effect/kinfu.efk";
		}
	}

	public class ShimofuEffect : thrts.EffectParameter
	{
		public ShimofuEffect()
		{
			EffectPath = "LotusCraft/3D/Effect/cirno_frost_area.efk";
			LightEffectPath = "LotusCraft/3D/Effect/cirno_frost_area_light.efk";
		}
	}

	public class FreezingTextureEffect : thrts.TextureEffectParameter
	{
		public FreezingTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.FrameCount = 1;
			Animation.FrameTime = 1;
			Animation.Count.X = 1;
			Animation.Count.Y = 1;
			Animation.AlphaBlend = thrts.AlphaBlend.Blend;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Loop;
			Animation.Path = "LotusCraft/Image/TextureEffect/snow01";

			Time = int.MaxValue;
			IsHorizontal = true;
			Is3DMode = true;
		}
	}

	public class NextTextureEffect : thrts.TextureEffectParameter
	{
		public NextTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "PatchSto/Image/TextureEffect/Next";

			Animation.Width = 256;
			Animation.Height = 128;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Stop;
			Animation.FrameCount = 1;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.Count.X = 1;
			Animation.Count.Y = 1;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Blend;
			Animation.Scale.X = 1.0f;
			Animation.Scale.Y = 1.0f;
			
			Time = 30;
		}
	}

	public class KaminokazeTextureEffect : thrts.TextureEffectParameter
	{
		public KaminokazeTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.FrameCount = 32;
			Animation.FrameTime = 2;
			Animation.Count.X = 8;
			Animation.Count.Y = 4;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Loop;
			Animation.Path = "LotusCraft/Image/TextureEffect/sanae_kaminokaze_effect";

			Time = int.MaxValue;
			IsHorizontal = true;
			Is3DMode = true;
		}
	}

	public class AuraTextureEffect : thrts.TextureEffectParameter
	{
		public AuraTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.FrameCount = 32;
			Animation.FrameTime = 2;
			Animation.Count.X = 8;
			Animation.Count.Y = 4;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Loop;
			Animation.Path = "LotusCraft/Image/TextureEffect/common_aura_effect";

			Time = int.MaxValue;
			IsHorizontal = true;
			Is3DMode = true;
		}
	}

	public class NormalHitOrangeTextureEffect : thrts.TextureEffectParameter
	{
		public NormalHitOrangeTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "LotusCraft/Image/TextureEffect/normalHitEffect";

			Animation.Width = 32;
			Animation.Height = 32;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Stop;
			Animation.FrameCount = 10;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.Count.X = 10;
			Animation.Count.Y = 1;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.Scale.X = 1.4f;
			Animation.Scale.Y = 1.4f;

			Time = 11;
		}
	}

	public class NormalHitGreenTextureEffect : thrts.TextureEffectParameter
	{
		public NormalHitGreenTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "LotusCraft/Image/TextureEffect/normalHitEffect";

			Animation.Offset.Y = 32 * 1;
			Animation.Width = 32;
			Animation.Height = 32;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Stop;
			Animation.FrameCount = 10;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.Count.X = 10;
			Animation.Count.Y = 1;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.Scale.X = 1.4f;
			Animation.Scale.Y = 1.4f;

			Time = 11;
		}
	}

	public class NormalHitBlueTextureEffect : thrts.TextureEffectParameter
	{
		public NormalHitBlueTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "LotusCraft/Image/TextureEffect/normalHitEffect";

			Animation.Offset.Y = 32 * 2;
			Animation.Width = 32;
			Animation.Height = 32;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Stop;
			Animation.FrameCount = 10;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.Count.X = 10;
			Animation.Count.Y = 1;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.Scale.X = 1.4f;
			Animation.Scale.Y = 1.4f;

			Time = 11;
		}
	}

	public class NormalHitPurpleTextureEffect : thrts.TextureEffectParameter
	{
		public NormalHitPurpleTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "LotusCraft/Image/TextureEffect/normalHitEffect";

			Animation.Offset.Y = 32 * 3;
			Animation.Width = 32;
			Animation.Height = 32;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Stop;
			Animation.FrameCount = 10;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.Count.X = 10;
			Animation.Count.Y = 1;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.Scale.X = 1.4f;
			Animation.Scale.Y = 1.4f;

			Time = 11;
		}
	}

	public class NormalHitRedTextureEffect : thrts.TextureEffectParameter
	{
		public NormalHitRedTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "LotusCraft/Image/TextureEffect/normalHitEffect";

			Animation.Offset.X = 512 * 1;
			Animation.Offset.Y = 32 * 0;
			Animation.Width = 32;
			Animation.Height = 32;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Stop;
			Animation.FrameCount = 10;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.Count.X = 10;
			Animation.Count.Y = 1;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.Scale.X = 1.4f;
			Animation.Scale.Y = 1.4f;

			Time = 11;
		}
	}

	public class NormalHitYellowTextureEffect : thrts.TextureEffectParameter
	{
		public NormalHitYellowTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "LotusCraft/Image/TextureEffect/normalHitEffect";

			Animation.Offset.X = 512 * 1;
			Animation.Offset.Y = 32 * 1;
			Animation.Width = 32;
			Animation.Height = 32;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Stop;
			Animation.FrameCount = 10;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.Count.X = 10;
			Animation.Count.Y = 1;
			Animation.CenterPosition = thrts.CenterPosition.MiddleMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.Scale.X = 1.4f;
			Animation.Scale.Y = 1.4f;

			Time = 11;
		}
	}

	public class ColumnHitRedTextureEffect : thrts.TextureEffectParameter
	{
		public ColumnHitRedTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "LotusCraft/Image/TextureEffect/normalHitEffect";

			Animation.Offset.Y = 128;
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Stop;
			Animation.FrameCount = 1024 / 64 * 2;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.Count.X = 1024 / 64;
			Animation.Count.Y = 2;
			Animation.CenterPosition = thrts.CenterPosition.LowerMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.Center.Y = -6;
			Animation.Scale.X = 1.4f;
			Animation.Scale.Y = 1.4f;

			Time = 1024 / 64 * 2;
		}
	}

	public class ColumnHitBlueTextureEffect : thrts.TextureEffectParameter
	{
		public ColumnHitBlueTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "LotusCraft/Image/TextureEffect/normalHitEffect";

			Animation.Offset.Y = 256;
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Stop;
			Animation.FrameCount = 1024 / 64 * 2;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.Count.X = 1024 / 64;
			Animation.Count.Y = 2;
			Animation.CenterPosition = thrts.CenterPosition.LowerMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.Center.Y = -6;
			Animation.Scale.X = 1.4f;
			Animation.Scale.Y = 1.4f;

			Time = 1024 / 64 * 2;
		}
	}

	public class ColumnHitGreenTextureEffect : thrts.TextureEffectParameter
	{
		public ColumnHitGreenTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "LotusCraft/Image/TextureEffect/normalHitEffect";

			Animation.Offset.Y = 256 + 128;
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Stop;
			Animation.FrameCount = 1024 / 64 * 2;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.Count.X = 1024 / 64;
			Animation.Count.Y = 2;
			Animation.CenterPosition = thrts.CenterPosition.LowerMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.Center.Y = -6;
			Animation.Scale.X = 1.4f;
			Animation.Scale.Y = 1.4f;

			Time = 1024 / 64 * 2;
		}
	}

	public class BombHitTextureEffect : thrts.TextureEffectParameter
	{
		public BombHitTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "LotusCraft/Image/TextureEffect/normalHitEffect";

			Animation.Offset.Y = 512;
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Stop;
			Animation.FrameCount = 1024 / 64;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.Count.X = 1024 / 64;
			Animation.Count.Y = 1;
			Animation.CenterPosition = thrts.CenterPosition.LowerMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.Center.Y = -32;
			Animation.Scale.X = 6.4f;
			Animation.Scale.Y = 6.4f;

			Time = 1024 / 64;
		}
	}

	public class BombHitRedTextureEffect : thrts.TextureEffectParameter
	{
		public BombHitRedTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "LotusCraft/Image/TextureEffect/normalHitEffect";

			Animation.Offset.Y = 512 + 64;
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Stop;
			Animation.FrameCount = 1024 / 64;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.Count.X = 1024 / 64;
			Animation.Count.Y = 1;
			Animation.CenterPosition = thrts.CenterPosition.LowerMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.Center.Y = -32;
			Animation.Scale.X = 1.4f;
			Animation.Scale.Y = 1.4f;

			Time = 1024 / 64;
		}
	}

	public class BombHitGreenTextureEffect : thrts.TextureEffectParameter
	{
		public BombHitGreenTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "LotusCraft/Image/TextureEffect/normalHitEffect";

			Animation.Offset.Y = 512 + 64 * 2;
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Stop;
			Animation.FrameCount = 1024 / 64;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.Count.X = 1024 / 64;
			Animation.Count.Y = 1;
			Animation.CenterPosition = thrts.CenterPosition.LowerMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.Center.Y = -32;
			Animation.Scale.X = 1.4f;
			Animation.Scale.Y = 1.4f;

			Time = 1024 / 64;
		}
	}

	public class BombHitBlueTextureEffect : thrts.TextureEffectParameter
	{
		public BombHitBlueTextureEffect()
		{
			Animation = new thrts.TextureAnimation();
			Animation.Path = "LotusCraft/Image/TextureEffect/normalHitEffect";

			Animation.Offset.Y = 512 + 64 * 3;
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.LoopType = thrts.TextureAnimation.AnimetionLoopType.Stop;
			Animation.FrameCount = 1024 / 64;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.Count.X = 1024 / 64;
			Animation.Count.Y = 1;
			Animation.CenterPosition = thrts.CenterPosition.LowerMiddle;
			Animation.AlphaBlend = thrts.AlphaBlend.Add;
			Animation.Center.Y = -32;
			Animation.Scale.X = 1.4f;
			Animation.Scale.Y = 1.4f;

			Time = 1024 / 64;
		}
	}

}
