﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PatchSto
{
	public enum HitEffectType
	{
		NormalOrange,
		NormalGreen,
		NormalBlue,
		NormalPurple,
		NormalRed,
		NormalYellow,
		ColumnRed,
		ColumnGreen,
		ColumnBlue,
		Bomb,
		BombRed,
		BombGreen,
		BombBlue,
	}

	class EffectUtls
	{
		public static void ShowCommonHitEffect(thrts.IBullet bullet, thrts.ITargetObject target, HitEffectType hitEffectType)
		{
			var faction = bullet.Generator.Faction;
			float bonus = 0;

			if (target is thrts.IUnit)
			{
				var u = target as thrts.IUnit;
				var type = u.Parameter.UnitType[0];
				bonus = bullet.Parameter.DamageBonus[(int)type];
			}
			else if (target is thrts.IBuilding)
			{
				var b = target as thrts.IBuilding;
				bonus = bullet.Parameter.DamageBonus[(int)thrts.TargetObjectType.Structure];
			}

			// 効果音
			if (bullet.Parameter.Type == thrts.BulletType.ShortRange)
			{
				faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitShortRangeAttack).FullName, target.Pos);
			}

			if (bullet.Parameter.Type == thrts.BulletType.LongRange)
			{
				faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitLongRangeAttack).FullName, target.Pos);
			}

			var pos = target.Pos;
			pos.Z += 6.0f;

			if (target is thrts.IBuilding && bullet.Parameter.Type == thrts.BulletType.LongRange)
			{
				pos = bullet.Position;
			}

			if (target is thrts.IBuilding && bullet.Parameter.Type == thrts.BulletType.ShortRange)
			{
				if (bullet.Generator != null)
				{
					pos = (target.Pos + bullet.Generator.Pos) / 2.0f;
					pos.Z += 6.0f;
				}
			}

			if (hitEffectType == HitEffectType.NormalOrange)
			{
				faction.World.EffectManager.CreateTextureEffect(typeof(Effect.NormalHitOrangeTextureEffect).FullName, pos);
			}
			else if (hitEffectType == HitEffectType.NormalGreen)
			{
				faction.World.EffectManager.CreateTextureEffect(typeof(Effect.NormalHitGreenTextureEffect).FullName, pos);
			}
			else if (hitEffectType == HitEffectType.NormalBlue)
			{
				faction.World.EffectManager.CreateTextureEffect(typeof(Effect.NormalHitBlueTextureEffect).FullName, pos);
			}
			else if (hitEffectType == HitEffectType.NormalPurple)
			{
				faction.World.EffectManager.CreateTextureEffect(typeof(Effect.NormalHitPurpleTextureEffect).FullName, pos);
			}
			else if (hitEffectType == HitEffectType.NormalRed)
			{
				faction.World.EffectManager.CreateTextureEffect(typeof(Effect.NormalHitRedTextureEffect).FullName, pos);
			}
			else if (hitEffectType == HitEffectType.NormalYellow)
			{
				faction.World.EffectManager.CreateTextureEffect(typeof(Effect.NormalHitYellowTextureEffect).FullName, pos);
			}
			else if (hitEffectType == HitEffectType.ColumnRed)
			{
				faction.World.EffectManager.CreateTextureEffect(typeof(Effect.ColumnHitRedTextureEffect).FullName, pos);
			}
			else if (hitEffectType == HitEffectType.ColumnBlue)
			{
				faction.World.EffectManager.CreateTextureEffect(typeof(Effect.ColumnHitBlueTextureEffect).FullName, pos);
			}
			else if (hitEffectType == HitEffectType.ColumnGreen)
			{
				faction.World.EffectManager.CreateTextureEffect(typeof(Effect.ColumnHitGreenTextureEffect).FullName, pos);
			}
			else if (hitEffectType == HitEffectType.Bomb)
			{
				faction.World.EffectManager.CreateTextureEffect(typeof(Effect.BombHitTextureEffect).FullName, pos);
			}
			else if (hitEffectType == HitEffectType.BombRed)
			{
				faction.World.EffectManager.CreateTextureEffect(typeof(Effect.BombHitRedTextureEffect).FullName, pos);
			}
			else if (hitEffectType == HitEffectType.BombGreen)
			{
				faction.World.EffectManager.CreateTextureEffect(typeof(Effect.BombHitGreenTextureEffect).FullName, pos);
			}
			else if (hitEffectType == HitEffectType.BombBlue)
			{
				faction.World.EffectManager.CreateTextureEffect(typeof(Effect.BombHitBlueTextureEffect).FullName, pos);
			}
		}
	}
}
