﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PatchSto.Unit
{
	public class BossRemilia : BossUnitParameter
	{
		public BossRemilia()
		{
			const int HPBase = 900;
			const int HPUp = 240;
			const int ATKBase = 44;
			const int ATKUp = 25;
			const int ArmorsBase = 30;
			const int ArmorsUp = 11;

			float SpeedBase = 1.1f;

			const int LevelUpCostBase = 16000;
			const int LevelUpCostUp = 7000;

			const int LevelUpCostByUnitsBase = 700;
			const int LevelUpCostByUnitsUp = 700;

			const int CostToCreateBase = 1400;

			IconPath = "LotusCraft/Image/Button/Red/Unique/remilia";

			Name = "レミリア・スカーレット(ボス)";

			Speed = SpeedBase * BasisSpeed;

			UnitUtls.SetBossSizeAnimation(this, "LotusCraft/Image/Unit/Red/Unique/remilia");

			HPs[0] = HPBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				HPs[i] = HPs[i - 1] + HPUp;
			}

			ATKs[0] = ATKBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				ATKs[i] = ATKs[i - 1] + ATKUp;
			}

			Armors[0] = ArmorsBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				Armors[i] = Armors[i - 1] + ArmorsUp;
			}

			LevelUpCosts[0] = LevelUpCostBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				LevelUpCosts[i] = LevelUpCosts[i - 1] + LevelUpCostUp;
			}

			LevelUpCostsByUnits[0] = LevelUpCostByUnitsBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				LevelUpCostsByUnits[i] = LevelUpCostsByUnits[i - 1] + LevelUpCostByUnitsUp;
			}

			CostsToCreate[0] = CostToCreateBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				CostsToCreate[i] = CostsToCreate[i - 1] + LevelUpCostByUnitsUp;
			}

			for (int i = 0; i < MaxLevel; i++)
			{
				Rewards[i] = (int)(CostsToCreate[i] * 0.32f);
			}

			ChargeTime = 2 * thrts.Def.FPS;

			Skills[0] = new SkillInformation(SkillType.InstantDeath);

			Skills[5] = new SkillInformation(SkillType.AreaAttack, thrts.Def.MapTipLengthOnField * 1);

			Bullets = new string[] { 
				typeof(BossRemiliaBullet).FullName,
			};

			SetUnitType(PatchSto.UnitType.ShortRange);
		}

		public override void OnLoad(thrts.IFaction faction)
		{
			InitializeParameters();
		}
	}

	public class BossRemiliaBullet : Bullet.NormalBullet
	{
		public BossRemiliaBullet()
		{
			Type = thrts.BulletType.ShortRange;
			MaxRange = 0.5f * thrts.Def.MapTipLengthOnField;

			OnHit += OnHitEffect;

			AttackDelay = (int)(0.0f * thrts.Def.FPS);
			AttackRigor = 0;
			AttackSpeed = AttackDelay + (int)(0.1f * thrts.Def.FPS);
		}

		public static void OnHitEffect(thrts.IBullet bullet, thrts.ITargetObject target)
		{
			EffectUtls.ShowCommonHitEffect(bullet, target, HitEffectType.NormalRed);
		}
	}
}
