﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PatchSto.Unit
{
	public class Byakuren : CommonUnitParameter
	{
		public Byakuren()
		{
			const int HPBase = 250;
			const int HPUp = 120;
			const int ATKBase = 30;
			const int ATKUp = 13;
			const int ArmorsBase = 18;
			const int ArmorsUp = 12;

			float SpeedBase = 1.2f;

			const int LevelUpCostBase = 2000;
			const int LevelUpCostUp = 1000;

			const int LevelUpCostByUnitsBase = 130;
			const int LevelUpCostByUnitsUp = 130;

			const int CostToCreateBase = 200;

			const PatchSto.UnitType unitType = PatchSto.UnitType.ShortRange;

			ChargeTime = 2 * thrts.Def.FPS;

			IconPath = "PatchSto/Image/Button/Unit/Byakuren";

			Name = "聖白蓮";

			Speed = SpeedBase * BasisSpeed;

			UnitUtls.SetAnimation(this, "PatchSto/Image/Unit/Byakuren");

			HPs[0] = HPBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				HPs[i] = HPs[i - 1] + HPUp;
			}

			ATKs[0] = ATKBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				ATKs[i] = ATKs[i - 1] + ATKUp;
			}

			Armors[0] = ArmorsBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				Armors[i] = Armors[i - 1] + ArmorsUp;
			}

			LevelUpCosts[0] = LevelUpCostBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				LevelUpCosts[i] = LevelUpCosts[i - 1] + LevelUpCostUp;
			}

			LevelUpCostsByUnits[0] = LevelUpCostByUnitsBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				LevelUpCostsByUnits[i] = LevelUpCostsByUnits[i - 1] + LevelUpCostByUnitsUp;
			}

			CostsToCreate[0] = CostToCreateBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				CostsToCreate[i] = CostsToCreate[i - 1] + LevelUpCostByUnitsUp;
			}

			for (int i = 0; i < MaxLevel; i++)
			{
				Rewards[i] = (int)(CostsToCreate[i] * 0.32f);
			}

			Skills[2] = new SkillInformation(SkillType.Fear, thrts.Def.MapTipLengthOnField * 2);

			Skills[5] = new SkillInformation(SkillType.Acceleration);

			Bullets = new string[] { 
				typeof(ByakurenBullet).FullName,
			};

			SetUnitType(unitType);
		}

		public override void OnLoad(thrts.IFaction faction)
		{
			InitializeParameters();
		}
	}

	public class ByakurenBullet : Bullet.NormalBullet
	{
		public ByakurenBullet()
		{
			Type = thrts.BulletType.ShortRange;
			MaxRange = 0.5f * thrts.Def.MapTipLengthOnField;

			OnHit += OnHitEffect;

			AttackDelay = (int)(0.0f * thrts.Def.FPS);
			AttackRigor = 0;
			AttackSpeed = AttackDelay + (int)(0.5f * thrts.Def.FPS);
		}
		public static void OnHitEffect(thrts.IBullet bullet, thrts.ITargetObject target)
		{
			EffectUtls.ShowCommonHitEffect(bullet, target, HitEffectType.NormalYellow);
		}
	}
}
