﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PatchSto.Unit
{
	public class Remilia : CommonUnitParameter
	{
		public Remilia()
		{
			const int HPBase = 180;
			const int HPUp = 100;
			const int ATKBase = 34;
			const int ATKUp = 26;
			const int ArmorsBase = 14;
			const int ArmorsUp = 10;

			float SpeedBase = 1.3f;

			const int LevelUpCostBase = 2000;
			const int LevelUpCostUp = 1000;

			const int LevelUpCostByUnitsBase = 120;
			const int LevelUpCostByUnitsUp = 120;

			const int CostToCreateBase = 190;

			const PatchSto.UnitType unitType = PatchSto.UnitType.ShortRange;

			ChargeTime = 2 * thrts.Def.FPS;

			IconPath = "PatchSto/Image/Button/Unit/Remilia";

			Name = "レミリア・スカーレット";

			Speed = SpeedBase * BasisSpeed;

			UnitUtls.SetAnimation(this, "PatchSto/Image/Unit/Remilia");

			HPs[0] = HPBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				HPs[i] = HPs[i - 1] + HPUp;
			}

			ATKs[0] = ATKBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				ATKs[i] = ATKs[i - 1] + ATKUp;
			}

			Armors[0] = ArmorsBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				Armors[i] = Armors[i - 1] + ArmorsUp;
			}

			LevelUpCosts[0] = LevelUpCostBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				LevelUpCosts[i] = LevelUpCosts[i - 1] + LevelUpCostUp;
			}

			LevelUpCostsByUnits[0] = LevelUpCostByUnitsBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				LevelUpCostsByUnits[i] = LevelUpCostsByUnits[i - 1] + LevelUpCostByUnitsUp;
			}

			CostsToCreate[0] = CostToCreateBase;
			for (int i = 1; i < MaxLevel; i++)
			{
				CostsToCreate[i] = CostsToCreate[i - 1] + LevelUpCostByUnitsUp;
			}

			for (int i = 0; i < MaxLevel; i++)
			{
				Rewards[i] = (int)(CostsToCreate[i] * 0.32f);
			}

			Skills[0] = new SkillInformation(SkillType.InstantDeath);

			Skills[5] = new SkillInformation(SkillType.AreaAttack, thrts.Def.MapTipLengthOnField * 1);

			Bullets = new string[] { 
				typeof(RemiliaBullet).FullName,
			};

			SetUnitType(unitType);
		}

		public override void OnLoad(thrts.IFaction faction)
		{
			InitializeParameters();
		}
	}

	public class RemiliaBullet : Bullet.NormalBullet
	{
		public RemiliaBullet()
		{
			Type = thrts.BulletType.ShortRange;
			MaxRange = 0.5f * thrts.Def.MapTipLengthOnField;

			OnHit += OnHitEffect;

			AttackDelay = (int)(0.0f * thrts.Def.FPS);
			AttackRigor = 0;
			AttackSpeed = AttackDelay + (int)(0.5f * thrts.Def.FPS);
		}
		public static void OnHitEffect(thrts.IBullet bullet, thrts.ITargetObject target)
		{
			EffectUtls.ShowCommonHitEffect(bullet, target, HitEffectType.NormalRed);
		}
	}
}
