﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace PatchSto
{
	public enum UnitType
	{ 
		ShortRange,
		MiddleRange,
		LongRange,
		Library,
	}

	class UnitUtls
	{
		public static void SetAnimation(thrts.UnitParameter unitParam, string path)
		{
			var Animation = new TextureAnimation();
			Animation.Path = path;
			Animation.Width = 32;
			Animation.Height = 32;
			Animation.Center.X = 0;
			Animation.Center.Y = -2;
			Animation.CenterPosition = CenterPosition.LowerMiddle;
			Animation.FrameCount = 4;
			Animation.FrameTime = 8;
			Animation.HasDirection = true;
			Animation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			Animation.Count.X = 4;
			Animation.Count.Y = 8;

			var AnimationFrame = new TextureAnimation();
			AnimationFrame.Path = path;
			AnimationFrame.Offset.X = 32 * 4;
			AnimationFrame.Width = 20;
			AnimationFrame.Height = 20;
			AnimationFrame.Center.X = 0;
			AnimationFrame.Center.Y = -4;
			AnimationFrame.CenterPosition = CenterPosition.LowerMiddle;
			AnimationFrame.FrameCount = 4;
			AnimationFrame.FrameTime = 8;
			AnimationFrame.HasDirection = true;
			AnimationFrame.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			AnimationFrame.Count.X = 4;
			AnimationFrame.Count.Y = 8;
			AnimationFrame.Scale.X = 2.0f;
			AnimationFrame.Scale.Y = 2.0f;

			unitParam.Animation = Animation;
			unitParam.AnimationFrame = AnimationFrame;

			unitParam.AnimationWalk = Animation.Clone();
			unitParam.AnimationWalk.FrameTime = 4;

			unitParam.AnimationWalkFrame = AnimationFrame.Clone();
			unitParam.AnimationWalkFrame.FrameTime = 4;

			unitParam.ShadowImagePath = "LotusCraft/Image/Shadow/ShadowUnitSmall";

			unitParam.ClickedWidth = 32;
			unitParam.ClickedHeight = 32;
		}

		public static void SetBossSizeAnimation(thrts.UnitParameter unitParam, string path)
		{
			var Animation = new TextureAnimation();
			Animation.Path = path;
			Animation.Width = 64;
			Animation.Height = 64;
			Animation.Center.X = 0;
			Animation.Center.Y = -6;
			Animation.CenterPosition = CenterPosition.LowerMiddle;
			Animation.FrameCount = 4;
			Animation.FrameTime = 8;
			Animation.HasDirection = true;
			Animation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			Animation.Count.X = 4;
			Animation.Count.Y = 8;

			unitParam.Animation = Animation;

			unitParam.AnimationFrame = Animation.Clone();
			unitParam.AnimationFrame.Offset.X = 256;

			unitParam.AnimationWalk = Animation.Clone();
			unitParam.AnimationWalk.FrameTime = 4;

			unitParam.AnimationWalkFrame = unitParam.AnimationWalk.Clone();
			unitParam.AnimationWalkFrame.Offset.X = 256;
			unitParam.AnimationWalkFrame.FrameTime = 4;

			unitParam.ShadowImagePath = "LotusCraft/Image/Shadow/ShadowUnitBig";

			unitParam.ClickedWidth = 56;
			unitParam.ClickedHeight = 64;
		}

		public static void SetSuikaSmallAnimation(thrts.UnitParameter unitParam, string path)
		{
			var Animation = new TextureAnimation();
			Animation.Path = path;
			Animation.Width = 20;
			Animation.Height = 20;
			Animation.Center.X = 0;
			Animation.Center.Y = -2;
			Animation.CenterPosition = CenterPosition.LowerMiddle;
			Animation.FrameCount = 4;
			Animation.FrameTime = 8;
			Animation.HasDirection = true;
			Animation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			Animation.Count.X = 4;
			Animation.Count.Y = 8;

			var AnimationFrame = new TextureAnimation();
			AnimationFrame.Path = path;
			AnimationFrame.Offset.X = 20 * 4;
			AnimationFrame.Width = 20;
			AnimationFrame.Height = 20;
			AnimationFrame.Center.X = 0;
			AnimationFrame.Center.Y = -2;
			AnimationFrame.CenterPosition = CenterPosition.LowerMiddle;
			AnimationFrame.FrameCount = 4;
			AnimationFrame.FrameTime = 8;
			AnimationFrame.HasDirection = true;
			AnimationFrame.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			AnimationFrame.Count.X = 4;
			AnimationFrame.Count.Y = 8;

			unitParam.Animation = Animation;
			unitParam.AnimationFrame = AnimationFrame;

			unitParam.AnimationWalk = Animation.Clone();
			unitParam.AnimationWalk.FrameTime = 4;

			unitParam.AnimationWalkFrame = AnimationFrame.Clone();
			unitParam.AnimationWalkFrame.FrameTime = 4;

			unitParam.ShadowImagePath = "LotusCraft/Image/Shadow/ShadowUnitSmall";

			unitParam.ClickedWidth = 32;
			unitParam.ClickedHeight = 32;
		}

		public static void SetUFOAnimation(thrts.UnitParameter unitParam, string path)
		{
			var Animation = new TextureAnimation();
			Animation.Path = path;
			Animation.Width = 32;
			Animation.Height = 32;
			Animation.Center.X = 0;
			Animation.Center.Y = -2;
			Animation.CenterPosition = CenterPosition.LowerMiddle;
			Animation.FrameCount = 8;
			Animation.FrameTime = 8;
			Animation.HasDirection = false;
			Animation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			Animation.Count.X = 8;
			Animation.Count.Y = 1;

			var AnimationFrame = new TextureAnimation();
			AnimationFrame.Path = path;
			AnimationFrame.Offset.X = 32 * 8;
			AnimationFrame.Width = 20;
			AnimationFrame.Height = 20;
			AnimationFrame.Center.X = 0;
			AnimationFrame.Center.Y = -4;
			AnimationFrame.CenterPosition = CenterPosition.LowerMiddle;
			AnimationFrame.FrameCount = 8;
			AnimationFrame.FrameTime = 8;
			AnimationFrame.HasDirection = false;
			AnimationFrame.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			AnimationFrame.Count.X = 8;
			AnimationFrame.Count.Y = 1;
			AnimationFrame.Scale.X = 2.0f;
			AnimationFrame.Scale.Y = 2.0f;

			unitParam.Animation = Animation;
			unitParam.AnimationFrame = AnimationFrame;

			unitParam.AnimationWalk = Animation.Clone();
			unitParam.AnimationWalk.FrameTime = 4;

			unitParam.AnimationWalkFrame = AnimationFrame.Clone();
			unitParam.AnimationWalkFrame.FrameTime = 4;

			unitParam.ShadowImagePath = "LotusCraft/Image/Shadow/ShadowUnitSmall";

			unitParam.ClickedWidth = 32;
			unitParam.ClickedHeight = 32;
		}

		public static void SetKedamaAnimation(thrts.UnitParameter unitParameter, string path)
		{
			var Animation = new TextureAnimation();
			Animation.Path = path;
			Animation.Width = 32;
			Animation.Height = 32;
			Animation.Center.X = 0;
			Animation.Center.Y = -2;
			Animation.CenterPosition = CenterPosition.LowerMiddle;
			Animation.FrameCount = 3;
			Animation.FrameTime = 8;
			Animation.HasDirection = true;
			Animation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			Animation.Count.X = 3;
			Animation.Count.Y = 8;

			var AnimationFrame = new TextureAnimation();
			AnimationFrame.Path = path;
			AnimationFrame.Offset.X = 32 * 4;
			AnimationFrame.Width = 20;
			AnimationFrame.Height = 20;
			AnimationFrame.Center.X = 0;
			AnimationFrame.Center.Y = -4;
			AnimationFrame.CenterPosition = CenterPosition.LowerMiddle;
			AnimationFrame.FrameCount = 3;
			AnimationFrame.FrameTime = 8;
			AnimationFrame.HasDirection = true;
			AnimationFrame.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			AnimationFrame.Count.X = 3;
			AnimationFrame.Count.Y = 8;
			AnimationFrame.Scale.X = 2.0f;
			AnimationFrame.Scale.Y = 2.0f;

			unitParameter.Animation = Animation;
			unitParameter.AnimationFrame = AnimationFrame;

			unitParameter.AnimationWalk = Animation.Clone();
			unitParameter.AnimationWalk.FrameTime = 4;

			unitParameter.AnimationWalkFrame = AnimationFrame.Clone();
			unitParameter.AnimationWalkFrame.FrameTime = 4;

			unitParameter.ShadowImagePath = "LotusCraft/Image/Shadow/ShadowUnitSmall";

			unitParameter.ClickedWidth = 32;
			unitParameter.ClickedHeight = 32;
		}
	}
}
