﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Ability.Red
{
	class KoanAbility : thrts.AbilityTemplate
	{
		public float AtkRate{get; private set;}
		public int IncArmor{get;private set;}
		thrts.IEffect effect;
		public KoanAbility(int level,thrts.IEffect effect = null)
		{
			this.Name = "奇跡「弘安の神風」";
			this.DurationTime = 1*30;
			this.effect = effect;
			switch (level)
			{
				case 1:
					AtkRate = 2.0f;
					IncArmor = 4;
					break;
				default:
					AtkRate = 1.0f;
					IncArmor = 0;
					break;
			}

		}
		public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
		{
			switch (order)
			{
				case thrts.AbilityOrder.ConstDecParam:
					break;
				case thrts.AbilityOrder.RateDecParam:
					break;
				case thrts.AbilityOrder.ConstIncParam:
					/// inc armor
					unit.Armor += IncArmor;
					break;
				case thrts.AbilityOrder.RateIncParam:
					foreach(var b in unit.ModifiedBulletParameters)
					{
						/// inc damage
						b.Attack = (int)(b.Attack*AtkRate);
					}
					break;
				case thrts.AbilityOrder.OtherExecs:
					if(effect != null)
						effect.SetPosition(unit.Pos+new thrts.Vector3D(2,2,1));
					break;
				default:
					break;
			}

			return true;
		}
		public override bool OnVanish (thrts.IUnit unit)
		{
			if (effect != null) {
				effect.Stop ();
				effect = null;
			}
			return base.OnVanish (unit);
		}
		public override bool ModifyBullet(thrts.IBullet bullet)
		{
			/// inc damage
			bullet.Attack = (int)(bullet.Attack*AtkRate);
			return base.ModifyBullet(bullet);
		}
	}

}
