﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Ability.Red
{
	class NamazuJisinAbility  : thrts.AbilityTemplate
	{
		public float SpeedRatio;
		IEffect effect;
		public NamazuJisinAbility(int level,IEffect effect = null)
		{
			this.Name = "ナマズ「ほらほら世界が震えるぞ？」";
			this.DurationTime = 4*Def.FPS;
			this.effect = effect;
			switch (level)
			{
				case 1:
					SpeedRatio = 0.2f;
					break;
				default:
					SpeedRatio = 1.0f;
					break;
			}

		}
		public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
		{
			switch (order)
			{
				case thrts.AbilityOrder.ConstDecParam:
					break;
				case thrts.AbilityOrder.RateDecParam:
					unit.Speed *= SpeedRatio;
					break;
				case thrts.AbilityOrder.ConstIncParam:
					break;
				case thrts.AbilityOrder.RateIncParam:
					break;
				case AbilityOrder.OtherExecs:
					if(effect != null)
						effect.SetPosition(unit.Pos+new Vector3D(2,2,1));
					break;
				default:
					break;
			}

			return true;
		}
		public override bool OnVanish (IUnit unit)
		{
			if (effect != null) {
				effect.Stop ();
				effect = null;
			}
			return base.OnVanish (unit);
		}
	}

}
