﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Ability.White
{
	class MasterSparkAbility : thrts.AbilityTemplate
	{
		private float speedRate;
		private float dpsRate;
		public MasterSparkAbility(int level)
		{
			this.Name = "胡蝶夢丸ナイトメア";
			this.DurationTime = 10*30;
			switch (level)
			{
				case 1:
					speedRate = 1.1f;
					dpsRate = 1.1f;
					break;
				case 2:
					speedRate = 1.2f;
					dpsRate = 1.2f;
					break;
				case 3:
					speedRate = 1.3f;
					dpsRate = 1.3f;
					break;
				default:
					speedRate = 1.0f;
					dpsRate = 1.0f;
					break;
			}

		}
		public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
		{
			switch (order)
			{
				case thrts.AbilityOrder.ConstDecParam:
					break;
				case thrts.AbilityOrder.RateDecParam:
					break;
				case thrts.AbilityOrder.ConstIncParam:
					break;
				case thrts.AbilityOrder.RateIncParam:
					///移動速度をspeedRate倍
					unit.Speed *= speedRate;
					/// DPSをdpsRate倍
					foreach(var b in unit.ModifiedBulletParameters)
					{
						b.AttackDelay = (int)Math.Round(b.AttackDelay / dpsRate);
						b.AttackRigor = (int)Math.Round(b.AttackRigor / dpsRate);
						b.AttackSpeed = (int)Math.Floor(b.AttackSpeed / dpsRate);
					}
					break;
				default:
					break;
			}

			return true;
		}
		public override bool ModifyBullet(thrts.IBullet bullet)
		{
			
			return base.ModifyBullet(bullet);
		}
	}

}
