﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.Blue;
using LotusCraft.Unit.Blue;
using LotusCraft.Bullet.Blue;

namespace LotusCraft.Building.Blue
{
	public class Shade : General.BaseStructure
	{
		public Shade ()
		{
			IconPath = "LotusCraft/Image/Button/Blue/Building/Tower";
			Name = "障光「ムーンライトウォール」";
			ButtonDescription += "味方ユニットのみ通り抜ける事のできる遮蔽建物です。\n";
			Size = 2;
			ViewRange = 6*32;


			MakingTime = 0*30;
			Bullets = new string[] { };
			HP = 400;
			Armor = 10;
			Supply = 0;
			Costs = new [] {0,0,0,0};
			Exp = 0;

			PathThroughOnlyAlly = true;
			IsBuiltOnRamp = true;

			Animation = new TextureAnimation ();
			Animation.Path = "LotusCraft/Image/Building/Blue/Barrack";
			Animation.Width = 128;
			Animation.Height = 128;
			Animation.Center.X = 0;
			Animation.Center.Y = -32;
			Animation.CenterPosition = CenterPosition.LowerMiddle;
			Animation.FrameCount = 1;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			Animation.Count.X = 1;
			Animation.Count.Y = 1;

			BuildingAnimation = Animation;
			//ObjectPath = "LotusCraft/3D/Model/Border.mdl";
			//BuildingObjectPath = "LotusCraft/3D/Model/None.mdl";
			ConstructionPlannedObjectPath = "LotusCraft/3D/Model/BuildingConstructionPlanned3.mdl";

			Capacity =  0;

		}
		public override void OnLoad (IFaction faction)
		{
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IBuilding>[]
			{
			};
			

			AutocasterParams = new AutoCastParameter<IBuilding>[]
			{
//				new LotusCraft.AutoCast.DissolveAutoCast(),
			};

		}
		public override void OnVanish (IBuilding building)
		{
				building.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.BreakBuildingSE).FullName, building.Pos);
		}
		public override void OnStartConstruction(IBuilding building)
		{

			IEffect effect = null;
			var offset = new Vector3D(0, 0, 1);
			effect = building.Faction.World.EffectManager.CreateEffect(typeof(Effect.Common.CreateBuildingEffect).FullName, building.Pos + offset);
			var scale = 3.0f * building.Parameter.Size;
			effect.SetScale(new Vector3D(scale, scale, scale));
			building.Completed += () => { if (effect != null) { effect.StopRoot(); effect = null; } };
			building.Destoroyed += () =>
			{
				if (effect != null)
				{
					effect.Stop();
					effect = null;
				}
			};
		}

		public override void OnCompleted (IBuilding building)
		{
			BuildingUtls.ShowComplete(building);

			IEffect effect = null;
			var offset = new Vector3D(0, 0, 1);
			effect = building.Faction.World.EffectManager.CreateEffect(typeof(LunachildMoonLightWall).FullName, building.Pos + offset);
			var scale = 4.0f * building.Parameter.Size;
			effect.SetScale(new Vector3D(scale, scale, scale));
			
			building.Destoroyed += () =>
			{
				if (effect != null)
				{
					effect.Stop();
					effect = null;
				}
			};

			base.OnCompleted (building);
		}
 	}
}
