﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Ability.Green;
using LotusCraft.AutoCast;
using LotusCraft.Unit.Green;
using LotusCraft.Unit.Green.Unique;
using LotusCraft.Effect.Green;
using LotusCraft.Bullet.Green;

namespace LotusCraft.Building.Green
{
	public class HomeBase : General.BaseStructure
	{
		public HomeBase()
		{
			IconPath = "LotusCraft/Image/Button/Green/Building/HomeBase";
			Name = "拠点";
			ShortcutKeyword = "BuildHomeBase";
			Size = 4;
			ViewRange = 16 * Def.MapTipLengthOnField;

			Height = 64.0f;


			MakingTime = 90 * Def.FPS;
			Bullets = new string[] { };
			HP = 3200;
			Armor = 2;
			Supply = 25;
			Costs = new[] { 320, 0, 0, 0 };

			Animation = new TextureAnimation();
			Animation.Path = "LotusCraft/Image/Building/Green/HomeBase";
			Animation.Width = 128;
			Animation.Height = 128;
			Animation.Center.X = 0;
			Animation.Center.Y = -32;
			Animation.CenterPosition = CenterPosition.LowerMiddle;
			Animation.FrameCount = 1;
			Animation.FrameTime = 1;
			Animation.HasDirection = false;
			Animation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			Animation.Count.X = 1;
			Animation.Count.Y = 1;

			ShortcutKeyword = "Home";

			BuildingAnimation = Animation;
			ObjectPath = "LotusCraft/3D/Model/HomeBase.mdl";
			BuildingObjectPath = "LotusCraft/3D/Model/None.mdl";
			ConstructionPlannedObjectPath = "LotusCraft/3D/Model/BuildingConstructionPlanned4.mdl";

		}

		public override void OnLoad(IFaction faction)
		{
			AutocasterParams = new AutoCastParameter<IBuilding>[]
			{
				new EnqueueProductionUnitAutoCast(typeof(Farmer).FullName,faction.GetUnitParameter(typeof(Farmer).FullName).MakingTime, ButtonPosition._0, ButtonPosition._0),
				new EnqueueProductionUnitAutoCast(typeof(Low01).FullName,faction.GetUnitParameter(typeof(Low01).FullName).MakingTime, ButtonPosition._0, ButtonPosition._1),
				new EnqueueProductionUnitAutoCast(typeof(Low02).FullName,faction.GetUnitParameter(typeof(Low02).FullName).MakingTime, ButtonPosition._1, ButtonPosition._0),
				new EnqueueProductionUnitAutoCast(typeof(Low03).FullName,faction.GetUnitParameter(typeof(Low03).FullName).MakingTime, ButtonPosition._2, ButtonPosition._0),
				new EnqueueProductionUnitAutoCast(typeof(Komachi).FullName,faction.GetUnitParameter(typeof(Komachi).FullName).MakingTime, ButtonPosition._1, ButtonPosition._1),
				new EnqueueProductionUnitAutoCast(typeof(Medicine).FullName,faction.GetUnitParameter(typeof(Medicine).FullName).MakingTime, ButtonPosition._2, ButtonPosition._1),
			};
			var ShortcutKeywords = new string[]
			{
				"CreateWorker",
				"CreateSpecial1",
				"CreateClay",
				"CreateWater",
				"CreateSpecial2",
				"CreateSpecial3",
				"CreateHeroine1",
				"CreateHeroine2",
#if !_TRIAL
				"CreateHeroine3",
				"CreateHeroine4",
				"CreateHeroine5",
				"CreateHeroine6",
#endif
			};
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IBuilding>[]
			{
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[0].Name), AutocasterParams[0].ButtonPosX, AutocasterParams[0].ButtonPosY,
					shortcutKeyword: ShortcutKeywords[0]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[1].Name), AutocasterParams[1].ButtonPosX, AutocasterParams[1].ButtonPosY,
					shortcutKeyword: ShortcutKeywords[1]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[2].Name), AutocasterParams[2].ButtonPosX, AutocasterParams[2].ButtonPosY,
					shortcutKeyword: ShortcutKeywords[2]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[3].Name), AutocasterParams[3].ButtonPosX, AutocasterParams[3].ButtonPosY,
					shortcutKeyword: ShortcutKeywords[3]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[4].Name), AutocasterParams[4].ButtonPosX, AutocasterParams[4].ButtonPosY,
					shortcutKeyword: ShortcutKeywords[4]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(AutocasterParams[5].Name), AutocasterParams[5].ButtonPosX, AutocasterParams[5].ButtonPosY,
					shortcutKeyword: ShortcutKeywords[5]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(typeof(Alice).FullName), ButtonPosition._0, ButtonPosition._2,
					shortcutKeyword: ShortcutKeywords[6]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(typeof(Minoriko).FullName), ButtonPosition._1, ButtonPosition._2,
					shortcutKeyword: ShortcutKeywords[7]
					)
					),
#if !_TRIAL
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(typeof(Kasen).FullName), ButtonPosition._2, ButtonPosition._2,
					shortcutKeyword: ShortcutKeywords[8]
					)
					),
				//*
					new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(typeof(Yuka).FullName), ButtonPosition._0, ButtonPosition._3,
					shortcutKeyword: ShortcutKeywords[9]
					)
					),
				//*/
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(typeof(Suika).FullName), ButtonPosition._1, ButtonPosition._3,
					shortcutKeyword: ShortcutKeywords[10]
					)
					),
				new ButtonParameterHolder<IBuilding> (
					new LotusCraft.Button.CreateUnitByBuildingButton (
					faction.GetUnitParameter(typeof(Lyrica).FullName), ButtonPosition._2, ButtonPosition._3,
					shortcutKeyword: ShortcutKeywords[11]
					)
					),
#endif
				new ButtonParameterHolder<IBuilding> (new LotusCraft.Button.DissolveHomeBaseButton()),
			};

		}
		public override void OnVanish(IBuilding building)
		{
			building.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.BreakBuildingSE).FullName, building.Pos);
			var faction = building.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(BreakBuilding).FullName, building.Pos + offset);
			var scale = new Vector3D(40, 40, 40);
			effect.SetScale(scale);

			//			if (building.IsComplete && faction.UserValues.ContainsKey (Button.CreateBuildingByUnitButton.BuildingMaxKey)) {
			//				var maxDic = faction.UserValues [Button.CreateBuildingByUnitButton.BuildingMaxKey] as Dictionary<string,int>;
			//				
			//				// 拠点+魔法陣で最大3つまで
			//				if (maxDic.ContainsKey (typeof(Barrack).FullName))
			//					maxDic [typeof(Barrack).FullName]-=2;
			//			}
		}
		public override void OnStartConstruction(IBuilding building)
		{
			IEffect effect = null;
			var offset = new Vector3D(0, 0, 1);
			effect = building.Faction.World.EffectManager.CreateEffect(typeof(Effect.Common.CreateBuildingEffect).FullName, building.Pos + offset);
			var scale = 3.0f * building.Parameter.Size;
			effect.SetScale(new Vector3D(scale, scale, scale));
			building.Completed += () => { if (effect != null) { effect.StopRoot(); effect = null; } };
			building.Destoroyed += () =>
			{
				if (effect != null)
				{
					effect.Stop();
					effect = null;
				}
			};
		}

		public override void OnCompleted (IBuilding building)
		{
			IEffect effect = null;
			/*
			var faction = building.Faction;
			if (!faction.UserValues.ContainsKey (Button.CreateBuildingByUnitButton.BuildingMaxKey)) {
				faction.UserValues.Add(Button.CreateBuildingByUnitButton.BuildingMaxKey,new Dictionary<string,int>());
			}
			var maxDic = faction.UserValues[Button.CreateBuildingByUnitButton.BuildingMaxKey] as Dictionary<string,int>;
			if (!faction.UserValues.ContainsKey (Button.CreateBuildingByUnitButton.BuildingCurrentKey)) {
				faction.UserValues.Add(Button.CreateBuildingByUnitButton.BuildingCurrentKey,new Dictionary<string,int>());
			}
			var curDic = faction.UserValues[Button.CreateBuildingByUnitButton.BuildingCurrentKey] as Dictionary<string,int>;

			if(!curDic.ContainsKey(typeof(Barrack).FullName))
				curDic.Add(typeof(Barrack).FullName,0);
			if(!maxDic.ContainsKey(typeof(Barrack).FullName))
				maxDic.Add(typeof(Barrack).FullName,0);

			// 拠点+魔法陣で最大3つまで
			maxDic[typeof(Barrack).FullName] += 2;
*/
			building.Updating += () =>
			{
				if (effect == null) {
					effect = building.Faction.World.EffectManager.CreateEffect (
								typeof(Effect.Green.Stronghold).FullName,
								new Vector3D (building.Pos.X, building.Pos.Y, building.Pos.Z + 16));
				}
			};

			building.Destoroyed += () =>
			{
				if (effect != null) {
					effect.Stop ();
				}
			};
			if (building.UserValues.ContainsKey (General.BaseStructure.FirstBuildingKey)) {
				building.AbilityManager.AppendAbility (new Ability.Green.PropagateGardenAbility (26, 1, 5 * Def.FPS, 5));
			} else {
				building.AbilityManager.AppendAbility (new Ability.Green.PropagateGardenAbility (18, 1, 5 * Def.FPS, 5));
			}

            BuildingUtls.ShowComplete(building);

			base.OnCompleted(building);
		}
	}
}

namespace LotusCraft.Bullet.Green
{
	public class HomeBaseBullet : General.LongRangeBullet
	{
		public HomeBaseBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			
			
			this.Attack = 6;
			DamageBonus[(int)TargetObjectType.Hero] = 3f;
			
			Speed = 10.0f * BasisSpeed;
			
			MaxRange = 7*Def.MapTipLengthOnField;
			
			AttackDelay = 0;
			AttackRigor = 0;
			AttackSpeed = (int)(1.5f * 30);
			
			OnHit = OnHitEffect;
			
			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/arrow";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 8;
			TextureAnimation.Center.Y = 8;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 1;
			TextureAnimation.Count.Y = 8;
		}
		static void OnHitEffect(IBullet bullet,ITargetObject target)
		{
			Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalBlue);
		}
	}
}

