using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Bullet.Red
{
	public class CannonBullet : General.CannonBullet
	{
		public CannonBullet()
		{
			Type = BulletType.LongRange;
			
			Attack = 150;
			Speed = 20.0f * BasisSpeed;

			MaxRange = 7 * Def.MapTipLengthOnField;

			AttackDelay = (int)(0.5f * Def.FPS);
			AttackRigor = (int)(0.5f * Def.FPS);
			AttackSpeed = (int)(1.0f * Def.FPS);

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/kome";
			TextureAnimation.AlphaBlend = AlphaBlend.Add;
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 8;
			TextureAnimation.Center.Y = 8;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 8;
		}
	}
	public class CannonSiegeBullet : General.CannonBullet
	{
		public CannonSiegeBullet()
		{
			Type = BulletType.LongRange;
			Attack = 390;
			Speed = 15.0f * BasisSpeed;

			MaxRange = 7 * Def.MapTipLengthOnField;

			AttackDelay = (int)(0.5f * Def.FPS);
			AttackRigor = (int)(2.5f * Def.FPS);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/ball_blue";
			TextureAnimation.AlphaBlend = AlphaBlend.Add;
			TextureAnimation.Width = 32;
			TextureAnimation.Height = 32;
			TextureAnimation.Center.X = 16;
			TextureAnimation.Center.Y = 16;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 4;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 4;
		}
	}
}
