﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Building.Black;
using LotusCraft.Unit.Black;
using LotusCraft.Unit.Black.Unique;
using LotusCraft.Effect;
using LotusCraft.Effect.Black;

namespace LotusCraft.Faction
{
	public class Black : thrts.FactionParameter
	{
		public Black()
		{
			ImageOnSelection800 = "System/BattleSetting/SelectWorkforce/800/workforce_black_m";
			ImageOnSelection1280 = "System/BattleSetting/SelectWorkforce/1280/workforce_black_m";

			ImageLongOnSelection800 = "System/BattleSetting/SelectWorkforce/800/workforce_black";
			ImageLongOnSelection1280 = "System/BattleSetting/SelectWorkforce/1280/workforce_black";

			Name = "黒勢力";
			DefaultScreenPosition = new thrts.Point2D(-480, -640);

			Units = new string[] { 
				typeof(Unit.Common.Mercenary01).FullName,
				typeof(Unit.Common.Mercenary02).FullName,
				typeof(Unit.Common.Eiki).FullName,
				typeof(Unit.Common.Yuyuko).FullName,

				typeof(Farmer).FullName,
				typeof(Low02).FullName,
				typeof(Low03).FullName,

				typeof(Orin).FullName,
				typeof(Youmu).FullName,
				typeof(Oku).FullName,
				typeof(Satori).FullName,
				
				typeof(Mamizou).FullName,
				typeof(Kokoro).FullName,

				typeof(FlyBomber).FullName,
				typeof(FlyFighter).FullName,
				typeof(FlyTransporter).FullName,

#if !_TRIAL
				typeof(Utsuho).FullName,
				
				typeof(Yuyuko).FullName,
				typeof(Yamame).FullName,
#endif
				typeof(Seiga).FullName,
				typeof(Miko).FullName,
				typeof(Rin).FullName,

				typeof(Armillary).FullName,
				typeof(BombSpirit).FullName,
				typeof(ZombieFairy).FullName,

			};
			Buildings = new string[] { 
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Factory).FullName,
				typeof(Airport).FullName,

				typeof(Chireiden).FullName,
			};
			
			TextureEffects = new string[] { 
				typeof(Rin_Shikigami_HitRedTextureEffect).FullName,
				typeof(SatoriTargetTextureEffect).FullName,

				typeof(Effect.Common.AlcoholIconEffect).FullName,
				typeof(Effect.Common.ReiryokuIconEffect).FullName,

				typeof(YamameNetubyouTextureEffect).FullName,

				typeof(Effect.Common.NormalHitOrangeTextureEffect).FullName,
				typeof(Effect.Common.NormalHitGreenTextureEffect).FullName,
				typeof(Effect.Common.NormalHitBlueTextureEffect).FullName,
				typeof(Effect.Common.NormalHitPurpleTextureEffect).FullName,
				typeof(Effect.Common.NormalHitRedTextureEffect).FullName,
				typeof(Effect.Common.NormalHitYellowTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitRedTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitGreenTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitBlueTextureEffect).FullName,
				typeof(Effect.Common.BombHitTextureEffect).FullName,
				typeof(Effect.Common.BombHitRedTextureEffect).FullName,
				typeof(Effect.Common.BombHitGreenTextureEffect).FullName,
				typeof(Effect.Common.BombHitBlueTextureEffect).FullName,

				typeof(Effect.Common.IncreaseBombEffect).FullName,

				typeof(Effect.Common.Area8TextureEffect).FullName,
				typeof(Effect.Common.ExclamationMarkTextureEffect).FullName,

			};

			Effects = new string[] {
				typeof(Arrow).FullName, 
				typeof(Stronghold).FullName,
				typeof(Barracks).FullName,
				typeof(Factories).FullName,
				typeof(FactoriesReactor).FullName,
				typeof(Airports).FullName,
				typeof(CollectAlcohol).FullName,
				typeof(CollectPowerStone).FullName,
				typeof(DownDPSEffect).FullName,
				
				typeof(Effect.Common.CreateBuildingEffect).FullName,
				typeof(BreakBuilding).FullName, 
				typeof(Effect.Common.DissolveBuilding).FullName, 

				typeof(Effect.Common.AttackBombEffect).FullName,
				typeof(Effect.Common.AttackBombAreaEffect).FullName,
				typeof(Effect.Common.FastBombEffect).FullName,
				typeof(Effect.Common.FastBombAreaEffect).FullName,
				
				typeof(Effect.Common.IncreaseBombAreaEffect).FullName,
				typeof(Effect.Common.ReviveBombEffect).FullName,
				typeof(Effect.Common.TownPortalBombEffect).FullName,

				typeof(Effect.Common.CircleAreaEffect).FullName,
				typeof(Effect.Common.DebuffEffect).FullName,
				typeof(Effect.Common.HitRemoteWhiteEffect).FullName,
				typeof(Effect.Common.HitRemoteBlueEffect).FullName,
				typeof(Effect.Common.HitRemoteRedEffect).FullName,
				typeof(Effect.Common.HitRemoteGreenEffect).FullName,
				typeof(Effect.Common.HitCloseRedEffect).FullName,
				typeof(Effect.Common.HitCloseBlueEffect).FullName,
				typeof(Effect.Common.HitCloseGreenEffect).FullName,
                typeof(Effect.Common.HitCloseWhiteEffect).FullName,
				typeof(Effect.Common.HitSplashRedEffect).FullName,
				typeof(Effect.Common.HitSplashBlueEffect).FullName,
				typeof(Effect.Common.HitSplashGreenEffect).FullName,
				typeof(Effect.Common.ChargeEffect).FullName,

				typeof(Effect.Common.MamizouEffect).FullName,
				typeof(Effect.Common.KokoroKirouEffect).FullName,
				typeof(Effect.Common.KokoroKurumaEffect).FullName,
				typeof(Effect.Common.KokoroShishiEffect).FullName,

				typeof(HitRemoteWhiteEffect).FullName,
				typeof(HitRemoteBlueEffect).FullName,
				typeof(HitRemoteRedEffect).FullName,
				typeof(HitRemoteGreenEffect).FullName,
				typeof(HitCloseRedEffect).FullName,
				typeof(HitCloseWhiteEffect).FullName,
				typeof(HitCloseBlueEffect).FullName,
                typeof(HitCloseGreenEffect).FullName,
				typeof(HitSplashRedEffect).FullName,
				typeof(HitSplashBlueEffect).FullName,
				typeof(HitSplashGreenEffect).FullName,
				
				typeof(UtsuhoHitEffect).FullName,
				typeof(UtsuhoHitSplashEffect).FullName,
				typeof(UtsuhoJigokuAreaEffect).FullName,
				typeof(UtsuhoKakuAreaEffect).FullName,
				typeof(UtsuhoKakunetuAreaEffect).FullName,
				typeof(UtsuhoKakunetuHitEffect).FullName,
				typeof(UtsuhoSunAreaEffect).FullName,
				typeof(UtsuhoSunJigokuHitEffect).FullName,
				typeof(UtsuhoSunChangeEffect).FullName,
				typeof(UtsuhoJigokuChangeEffect).FullName,

				typeof(ByoufuAreaEffect).FullName,
				typeof(ByoufuChargeEffect).FullName,
				typeof(SyokuzaiEffect).FullName,
				typeof(SyokuzaiSelfEffect).FullName,
				typeof(YoukaiEffect).FullName,
				typeof(YoukaiAreaEffect).FullName,

				typeof(BoukyouEffect).FullName,
				typeof(FuchouEffect).FullName,
				typeof(HangonAreaEffect).FullName,
				typeof(HangonEffect).FullName,
				typeof(HangonEmitEffect).FullName,

                typeof(ShinkouAreaEffect).FullName,
                typeof(ShinkouHitEffect).FullName,
                typeof(ShinkouChargeEffect).FullName,
                typeof(SenfuEffect).FullName,
				typeof(HihouEffect).FullName,
				typeof(HoshifuruSelfEffect).FullName,
				typeof(HoshifuruHitEffect).FullName,
				typeof(HoshifuruAreaEffect).FullName,

				typeof(JafuHealEffect).FullName,
				typeof(JafuSelfEffect).FullName,
				typeof(NyumaEffect).FullName,
				typeof(NyumaAreaEffect).FullName,
                typeof(KoureiAreaEffect).FullName,
				typeof(KoureiReviveEffect).FullName,
                typeof(TaoSelfEffect).FullName,

				typeof(CaptureChargeEffect).FullName,
				typeof(CaptureAreaEffect).FullName,
				typeof(CaptureEffect).FullName,
				typeof(FilledEffect).FullName,
				typeof(NetubyouEffect).FullName,
				typeof(RopeEffect).FullName,

				typeof(DeadUnitEffect).FullName,
				typeof(DeadUniqueEffect).FullName,
				
				typeof(CommonBolEffect).FullName, 
				typeof(CommonBolAreaEffect).FullName, 
				typeof(RangeCircleEffect).FullName, 
				typeof(SummonEffect).FullName, 

				typeof(Effect.Common.LvUpEffect).FullName,
				typeof(Effect.Common.DeadUniqueEffect).FullName,
				typeof(Effect.Common.DeadUnitEffect).FullName,

				typeof(Effect.Common.CreateBuildingEffect).FullName,
				typeof(Effect.Common.CompleteBuildingEffect).FullName,
				typeof(Effect.Common.CreateUnitEffect).FullName,

				typeof(Effect.Common.UnitCollectAlcoholEffect).FullName,
				typeof(Effect.Common.UnitCollectPowerStoneEffect).FullName,
			};

			SoundEffects = new string[]
			{
				typeof(SoundEffect.BreakBuildingSE).FullName,
				typeof(SoundEffect.ChooseUnit).FullName,
				typeof(SoundEffect.Click).FullName,
				typeof(SoundEffect.CreatedUnit).FullName,
				typeof(SoundEffect.CreatedBuilding).FullName,
				typeof(SoundEffect.EndCharge).FullName,
				typeof(SoundEffect.EndResearch).FullName,
				typeof(SoundEffect.EndRevolution).FullName,
				typeof(SoundEffect.FailedClick).FullName,
				typeof(SoundEffect.HitLongRangeAttack).FullName,
				typeof(SoundEffect.HitShortRangeAttack).FullName,
				typeof(SoundEffect.HitZangeki).FullName,
				typeof(SoundEffect.HitDageki).FullName,
				typeof(SoundEffect.HitOther).FullName,
				typeof(SoundEffect.PCH).FullName,
				typeof(SoundEffect.PointPosition).FullName,
				typeof(SoundEffect.BiriBiri).FullName,
				typeof(SoundEffect.Eat).FullName,
				typeof(SoundEffect.LvUp).FullName,
				typeof(SoundEffect.Charge1).FullName,
				typeof(SoundEffect.Charge2).FullName,
				typeof(SoundEffect.Burst).FullName,
				typeof(SoundEffect.Shuiin01).FullName,
				typeof(SoundEffect.Shuiin02).FullName,
				typeof(SoundEffect.Wind).FullName,
				typeof(SoundEffect.Fire).FullName,
				
				typeof(SoundEffect.Alarm00).FullName,
				typeof(SoundEffect.Alarm01).FullName,
				typeof(SoundEffect.Cleaner01).FullName,
				typeof(SoundEffect.Cleaner02).FullName,
				typeof(SoundEffect.Poison).FullName,

				typeof(SoundEffect.Bom01).FullName,
				typeof(SoundEffect.Bom12).FullName,
			};
			
			CommonUnitButton = new List<ButtonParameterHolder<IUnit>>(){
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.MoveButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StopButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.HoldPositionButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.PatrolButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.AttackMoveButton ()),
				//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StationButton ()),
			};
		}
	}
}
