﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Building.Blue;
using LotusCraft.Unit.Blue;
using LotusCraft.Effect;
using LotusCraft.Effect.Blue;

namespace LotusCraft.Faction
{
	public class Blue : thrts.FactionParameter
	{
		public Blue()
		{
			ImageOnSelection800 = "System/BattleSetting/SelectWorkforce/800/workforce_blue_m";
			ImageOnSelection1280 = "System/BattleSetting/SelectWorkforce/1280/workforce_blue_m";

			ImageLongOnSelection800 = "System/BattleSetting/SelectWorkforce/800/workforce_blue";
			ImageLongOnSelection1280 = "System/BattleSetting/SelectWorkforce/1280/workforce_blue";

			Name = "青勢力";
			DefaultScreenPosition = new thrts.Point2D(-480, -640);

			Units = new string[] { 
				typeof(Unit.Common.Mercenary01).FullName,
				typeof(Unit.Common.Mercenary02).FullName,
				typeof(Unit.Common.Eiki).FullName,
				typeof(Unit.Common.Yukari).FullName,

				typeof(Farmer).FullName,
//				typeof(Low01).FullName,
				typeof(Low02).FullName,
				typeof(Low03).FullName,
				
				typeof(Iku).FullName,
				typeof(Sunny).FullName,
				typeof(Lunar).FullName,
				typeof(Star).FullName,

				typeof(Lety).FullName,
				typeof(HighFairy).FullName,

				typeof(FlyBomber).FullName,
				typeof(FlyFighter).FullName,
				typeof(FlyTransporter).FullName,

				typeof(Unit.Blue.Unique.Chirno).FullName,
				typeof(Unit.Blue.Unique.Mystia).FullName,

#if !_TRIAL
				typeof(Unit.Blue.Unique.Koishi).FullName,
				typeof(Unit.Blue.Unique.Nitori).FullName,
				typeof(Unit.Blue.Unique.Tenshi).FullName,
				typeof(Unit.Blue.Unique.Yukari).FullName,
#endif

			};
			Buildings = new string[] { 
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Factory).FullName,
				typeof(Airport).FullName,

				typeof(BigTree).FullName,

				typeof(Shade).FullName,
				typeof(SukimaBuilding).FullName,

			};

			TextureEffects = new string[] { 
				typeof(Effect.Common.AlcoholIconEffect).FullName,
				typeof(Effect.Common.ReiryokuIconEffect).FullName,

				typeof(Effect.Common.NormalHitOrangeTextureEffect).FullName,
				typeof(Effect.Common.NormalHitGreenTextureEffect).FullName,
				typeof(Effect.Common.NormalHitBlueTextureEffect).FullName,
				typeof(Effect.Common.NormalHitPurpleTextureEffect).FullName,
				typeof(Effect.Common.NormalHitRedTextureEffect).FullName,
				typeof(Effect.Common.NormalHitYellowTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitRedTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitGreenTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitBlueTextureEffect).FullName,
				typeof(Effect.Common.BombHitTextureEffect).FullName,
				typeof(Effect.Common.BombHitRedTextureEffect).FullName,
				typeof(Effect.Common.BombHitGreenTextureEffect).FullName,
				typeof(Effect.Common.BombHitBlueTextureEffect).FullName,

				typeof(Effect.Common.IncreaseBombEffect).FullName,

				typeof(ChirnoFreezingTextureEffect).FullName,
#if !_TRIAL
				typeof(DnaEffect).FullName,
#endif
			};

			Effects = new string[] {
				typeof(Arrow).FullName, 
				typeof(Stronghold).FullName,
				typeof(Barracks).FullName,
				typeof(BarracksReactor).FullName,
				typeof(Factories).FullName,
				typeof(Airports).FullName,
				typeof(CollectAlcohol).FullName,
				typeof(CollectPowerStone).FullName,
				
				typeof(LunachildMoonLightWall).FullName,

				typeof(Effect.Common.AttackBombEffect).FullName,
				typeof(Effect.Common.AttackBombAreaEffect).FullName,
				typeof(Effect.Common.FastBombEffect).FullName,
				typeof(Effect.Common.FastBombAreaEffect).FullName,
				typeof(Effect.Common.IncreaseBombAreaEffect).FullName,
				typeof(Effect.Common.ReviveBombEffect).FullName,
				typeof(Effect.Common.TownPortalBombEffect).FullName,

				typeof(Effect.Common.CreateBuildingEffect).FullName,
				typeof(BreakBuilding).FullName, 
				typeof(Effect.Common.DissolveBuilding).FullName, 
				
				typeof(Effect.Common.CircleAreaEffect).FullName,
				typeof(Effect.Common.DebuffEffect).FullName,
				typeof(Effect.Common.HitRemoteWhiteEffect).FullName,
				typeof(Effect.Common.HitRemoteBlueEffect).FullName,
				typeof(Effect.Common.HitRemoteRedEffect).FullName,
				typeof(Effect.Common.HitRemoteGreenEffect).FullName,
				typeof(Effect.Common.HitCloseRedEffect).FullName,
				typeof(Effect.Common.HitCloseBlueEffect).FullName,
				typeof(Effect.Common.HitCloseGreenEffect).FullName,
                typeof(Effect.Common.HitCloseWhiteEffect).FullName,
				typeof(Effect.Common.HitSplashRedEffect).FullName,
				typeof(Effect.Common.HitSplashBlueEffect).FullName,
				typeof(Effect.Common.HitSplashGreenEffect).FullName,
				typeof(Effect.Common.ChargeEffect).FullName,
				typeof(Effect.Common.LetyEffect).FullName,
				typeof(Effect.Common.HighFairyEffect).FullName,
				typeof(HitRemoteWhiteEffect).FullName,
				typeof(HitRemoteBlueEffect).FullName,
				typeof(HitRemoteRedEffect).FullName,
				typeof(HitRemoteGreenEffect).FullName,
				typeof(HitCloseRedEffect).FullName,
				typeof(HitCloseBlueEffect).FullName,
				typeof(HitCloseGreenEffect).FullName,
                typeof(HitCloseWhiteEffect).FullName,
				typeof(HitSplashRedEffect).FullName,
				typeof(HitSplashBlueEffect).FullName,
				typeof(HitSplashGreenEffect).FullName,

                typeof(IkuThunderEffect).FullName,
				
				typeof(DeadUnitEffect).FullName,
				typeof(DeadUniqueEffect).FullName,
				
				typeof(CommonBolEffect).FullName, 
				typeof(CommonBolAreaEffect).FullName, 
				typeof(RangeCircleEffect).FullName, 

				typeof(Effect.White.KibakujinEffect).FullName,
				typeof(Effect.White.KibakujinAreaEffect).FullName,

				typeof(Effect.White.DaiKekkaiEffect).FullName,
				typeof(Effect.White.DaiKekkaiChargeEffect).FullName,
				typeof(Effect.White.DaiKekkaiShotEffect).FullName,

#if !_TRIAL
				typeof(MuishikiEffect).FullName,
				typeof(PhilosophyAreaEffect).FullName,
				typeof(RoseEffect).FullName,
				typeof(RoseAreaEffect).FullName,
				typeof(DnaAreaEffect).FullName,

				typeof(YukifuEffect).FullName,
				typeof(ShimofuEffect).FullName,
				typeof(IcicleEffect).FullName,
				typeof(PerfectEffect).FullName,
				typeof(FreezingEffect).FullName,
				typeof(ChilnohitEffect).FullName,

				typeof(CageAreaEffect).FullName,
				typeof(CageEffect).FullName,
				typeof(DiveEffect).FullName,
				typeof(YojakuAreaEffect).FullName,
				typeof(YojakuEffect).FullName,
				typeof(YamouAreaEffect).FullName,
				typeof(YamouEffect).FullName,

				typeof(ArmEffect).FullName,
				typeof(MizufuEffect).FullName,
				typeof(CamouflageEffect).FullName,
				typeof(TorpedoEffect).FullName,

				typeof(ChifuEffect).FullName,
				typeof(KifuEffect).FullName,
				typeof(JishinChargeEffect).FullName,
				typeof(JishinAreaEffect).FullName,
				typeof(HisoutenChargeEffect).FullName,
				typeof(HisoutenAreaEffect).FullName,

				typeof(YukariTXEffect).FullName,
				typeof(YukariSeitoshinoAreaEffect).FullName,
				typeof(YukariKekkaiAreaEffect).FullName,
				typeof(YukariKekkaiChargeEffect).FullName,
				typeof(YukariKekkaiEffect).FullName,
#endif

				typeof(Effect.Common.DeadUniqueEffect).FullName,
				typeof(Effect.Common.LvUpEffect).FullName,
				typeof(Effect.Common.DeadUnitEffect).FullName,

				typeof(Effect.Common.CreateBuildingEffect).FullName,
				typeof(Effect.Common.CompleteBuildingEffect).FullName,
				typeof(Effect.Common.CreateUnitEffect).FullName,

				typeof(Effect.Common.UnitCollectAlcoholEffect).FullName,
				typeof(Effect.Common.UnitCollectPowerStoneEffect).FullName,
			};
			SoundEffects = new string[]
			{
				typeof(SoundEffect.BreakBuildingSE).FullName,
				typeof(SoundEffect.ChooseUnit).FullName,
				typeof(SoundEffect.Click).FullName,
				typeof(SoundEffect.CreatedUnit).FullName,
				typeof(SoundEffect.CreatedBuilding).FullName,
				typeof(SoundEffect.EndCharge).FullName,
				typeof(SoundEffect.EndResearch).FullName,
				typeof(SoundEffect.EndRevolution).FullName,
				typeof(SoundEffect.FailedClick).FullName,
				typeof(SoundEffect.HitLongRangeAttack).FullName,
				typeof(SoundEffect.HitShortRangeAttack).FullName,
				typeof(SoundEffect.HitZangeki).FullName,
				typeof(SoundEffect.HitDageki).FullName,
				typeof(SoundEffect.HitOther).FullName,
				typeof(SoundEffect.PCH).FullName,
				typeof(SoundEffect.PointPosition).FullName,
				typeof(SoundEffect.Alarm01).FullName,
				typeof(SoundEffect.BiriBiri).FullName,
				typeof(SoundEffect.Charge1).FullName,
				typeof(SoundEffect.Charge2).FullName,
				typeof(SoundEffect.Shuiin01).FullName,
				typeof(SoundEffect.Shuiin02).FullName,
				typeof(SoundEffect.Burst).FullName,
				typeof(SoundEffect.LvUp).FullName,
				typeof(SoundEffect.Jishin).FullName,
				typeof(SoundEffect.Wind).FullName,
				typeof(SoundEffect.Jet).FullName,
				typeof(SoundEffect.Thunder1).FullName,
				typeof(SoundEffect.Train1).FullName,
			};

#if !_TRIAL
			ModelEffects = new string[]
			{
				typeof(Effect.Blue.YukariTXModelEffect).FullName,
			};
#endif
			CommonUnitButton = new List<ButtonParameterHolder<IUnit>>(){
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.MoveButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StopButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.HoldPositionButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.PatrolButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.AttackMoveButton ()),
				//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StationButton ()),
			};
		}
	}
}
