﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

using LotusCraft.Effect.Green;
using LotusCraft.Unit.Green;
using LotusCraft.Unit.Green.Unique;
using LotusCraft.Building.Green;

namespace LotusCraft.Faction
{
	public class Green : thrts.FactionParameter
	{
		public Green()
		{
			ImageOnSelection800 = "System/BattleSetting/SelectWorkforce/800/workforce_green_m";
			ImageOnSelection1280 = "System/BattleSetting/SelectWorkforce/1280/workforce_green_m";

			ImageLongOnSelection800 = "System/BattleSetting/SelectWorkforce/800/workforce_green";
			ImageLongOnSelection1280 = "System/BattleSetting/SelectWorkforce/1280/workforce_green";

			Name = "緑勢力";
			DefaultScreenPosition = new thrts.Point2D(-480, -640);

			Units = new string[] { 
				typeof(Unit.Common.Mercenary01).FullName,
				typeof(Unit.Common.Mercenary02).FullName,
				typeof(Unit.Common.Eiki).FullName,
				typeof(Unit.Common.Patchouli).FullName,

				typeof(Farmer).FullName,
				typeof(Low01).FullName,
				typeof(Low02).FullName,
				typeof(Low03).FullName,
				typeof(SuikaSmall).FullName,
				typeof(Medicine).FullName,
				typeof(Komachi).FullName,
				typeof(Dolls).FullName,
				typeof(Alice).FullName,

				typeof(Minoriko).FullName,

#if !_TRIAL
				typeof(Kasen).FullName,
				typeof(Lyrica).FullName,
				typeof(Suika).FullName,
				typeof(Yuka).FullName,
				typeof(SeedUnit).FullName,
				typeof(FlowerUnit).FullName,
#endif

				typeof(SuikaSmallCocoon).FullName,
				typeof(Elie).FullName,
				typeof(Kurumi).FullName
			};
			Buildings = new string[] { 
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,

				typeof(Cherry).FullName,
				typeof(Muenzuka).FullName,
				typeof(Higanbana).FullName,
				typeof(Hyoutan).FullName,
				typeof(Court).FullName,
				typeof(SuzuranField).FullName,
				typeof(Gate).FullName,
			};

			TextureEffects = new string[] { 
				typeof(Effect.Common.AlcoholIconEffect).FullName,
				typeof(Effect.Common.ReiryokuIconEffect).FullName,
                typeof(WarTextureEffect).FullName,
                typeof(ParadeDollTextureEffect).FullName,
				typeof(MediTextureEffect).FullName,
                typeof(KomachiTextureEffect).FullName,

#if !_TRIAL
				typeof(YukakuTextureEffect).FullName,
#endif

				typeof(Effect.Common.NormalHitOrangeTextureEffect).FullName,
				typeof(Effect.Common.NormalHitGreenTextureEffect).FullName,
				typeof(Effect.Common.NormalHitBlueTextureEffect).FullName,
				typeof(Effect.Common.NormalHitPurpleTextureEffect).FullName,
				typeof(Effect.Common.NormalHitRedTextureEffect).FullName,
				typeof(Effect.Common.NormalHitYellowTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitRedTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitGreenTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitBlueTextureEffect).FullName,
				typeof(Effect.Common.BombHitTextureEffect).FullName,
				typeof(Effect.Common.BombHitRedTextureEffect).FullName,
				typeof(Effect.Common.BombHitGreenTextureEffect).FullName,
				typeof(Effect.Common.BombHitBlueTextureEffect).FullName,

				typeof(Effect.Common.IncreaseBombEffect).FullName,
			};

			Effects = new string[] {
				typeof(Arrow).FullName, 
				typeof(Stronghold).FullName,
				typeof(Barracks).FullName,
				typeof(Factories).FullName,
				typeof(CollectAlcohol).FullName,
				typeof(CollectPowerStone).FullName,

				typeof(Effect.Common.CircleAreaEffect).FullName,
				typeof(Effect.Common.DebuffEffect).FullName,
				typeof(Effect.Common.AttackBombEffect).FullName,
				typeof(Effect.Common.AttackBombAreaEffect).FullName,
				typeof(Effect.Common.FastBombEffect).FullName,
				typeof(Effect.Common.FastBombAreaEffect).FullName,
				typeof(Effect.Common.IncreaseBombAreaEffect).FullName,
				typeof(Effect.Common.ReviveBombEffect).FullName,
				typeof(Effect.Common.TownPortalBombEffect).FullName,


				typeof(Effect.Common.CreateBuildingEffect).FullName,
				typeof(BreakBuilding).FullName, 

				typeof(Effect.Common.HitRemoteWhiteEffect).FullName,
				typeof(Effect.Common.HitRemoteBlueEffect).FullName,
				typeof(Effect.Common.HitRemoteRedEffect).FullName,
				typeof(Effect.Common.HitRemoteGreenEffect).FullName,
				typeof(Effect.Common.HitCloseRedEffect).FullName,
				typeof(Effect.Common.HitCloseBlueEffect).FullName,
				typeof(Effect.Common.HitCloseGreenEffect).FullName,
                typeof(Effect.Common.HitCloseWhiteEffect).FullName,
				typeof(HitSplashRedEffect).FullName,
				typeof(HitSplashBlueEffect).FullName,
				typeof(HitSplashGreenEffect).FullName,
				typeof(Effect.Common.DissolveBuilding).FullName, 
                typeof(Effect.Common.ChargeEffect).FullName, 

				typeof(DeadUnitEffect).FullName,
				typeof(DeadUniqueEffect).FullName,

				typeof(CommonBolEffect).FullName, 
				typeof(CommonBolAreaEffect).FullName, 
				typeof(RangeCircleEffect).FullName, 
				typeof(HealEffect).FullName, 

				typeof(MedicineSkillEffect).FullName,
				typeof(MedicineAcidEffect).FullName,
				typeof(MedicineAcidCloudEffect).FullName,
				typeof(KomachiSkillEffect).FullName,

				typeof(AliceLvUpEffect).FullName,
				typeof(ParadeSelfEffect).FullName,
				typeof(ParadeDollEffect).FullName,
				typeof(ParadeHitEffect).FullName,
				typeof(WarEffect).FullName,
                typeof(SemiAutoEffect).FullName,
				typeof(WireEffect).FullName,
                
                typeof(KokumotsusinEffect).FullName,
				typeof(AutumnEffect).FullName,
				typeof(PotetoEffect).FullName,
				typeof(OwotoshiEffect).FullName,

#if !_TRIAL
				typeof(MigiteEffect).FullName,
				typeof(MichibikuAreaEffect).FullName,
				typeof(MichibikuEffect).FullName,
				typeof(ShugyouEffect).FullName,
				typeof(YukakuEffect).FullName,

                typeof(BlackHoleEffect).FullName,
				typeof(SuikaOnibiHitEffect).FullName,
				typeof(SuikaMPEffect).FullName,

				typeof(GensoEffect).FullName,

				typeof(ShinsouEffect).FullName,
				typeof(ShinsouAreaEffect).FullName,
				typeof(MeisouEffect).FullName,
				typeof(MeisouAreaEffect).FullName,
				typeof(SoulAreaEffect).FullName,
				typeof(SoloEffect).FullName,
				typeof(SoloAreaEffect).FullName,
				typeof(SoloDebuffEffect).FullName,

#endif

				typeof(Effect.Common.DeadUniqueEffect).FullName,
				typeof(Effect.Common.LvUpEffect).FullName,
				typeof(Effect.Common.DeadUnitEffect).FullName,

				typeof(Effect.Common.CreateBuildingEffect).FullName,
				typeof(Effect.Common.CompleteBuildingEffect).FullName,
				typeof(Effect.Common.CreateUnitEffect).FullName,

				typeof(Effect.Common.UnitCollectAlcoholEffect).FullName,
				typeof(Effect.Common.UnitCollectPowerStoneEffect).FullName,
			};
			SoundEffects = new string[]
			{
				typeof(SoundEffect.BreakBuildingSE).FullName,
				typeof(SoundEffect.ChooseUnit).FullName,
				typeof(SoundEffect.Click).FullName,
				typeof(SoundEffect.CreatedUnit).FullName,
				typeof(SoundEffect.CreatedBuilding).FullName,
				typeof(SoundEffect.EndCharge).FullName,
				typeof(SoundEffect.EndResearch).FullName,
				typeof(SoundEffect.EndRevolution).FullName,
				typeof(SoundEffect.FailedClick).FullName,
				typeof(SoundEffect.HitLongRangeAttack).FullName,
				typeof(SoundEffect.HitShortRangeAttack).FullName,
				typeof(SoundEffect.HitZangeki).FullName,
				typeof(SoundEffect.HitDageki).FullName,
				typeof(SoundEffect.HitOther).FullName,
				typeof(SoundEffect.PCH).FullName,
				typeof(SoundEffect.PointPosition).FullName,
				typeof(SoundEffect.Alarm01).FullName,
				typeof(SoundEffect.Charge1).FullName,
				typeof(SoundEffect.LvUp).FullName,
				typeof(SoundEffect.BiriBiri).FullName,
				typeof(SoundEffect.Shuiin01).FullName,
				typeof(SoundEffect.Shuiin02).FullName,
				typeof(SoundEffect.Burst).FullName,
				typeof(SoundEffect.Wind).FullName,

				typeof(SoundEffect.Bom01).FullName,
				typeof(SoundEffect.Bom12).FullName,

				typeof(SoundEffect.Charge1).FullName,
				typeof(SoundEffect.Charge2).FullName,
			};

		
			CommonUnitButton = new List<ButtonParameterHolder<IUnit>>(){
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.MoveButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StopButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.HoldPositionButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.PatrolButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.AttackMoveButton ()),
				//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StationButton ()),
			};
		}
	}
}
