﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.Neutral;

using LotusCraft.Unit.Neutral;

namespace LotusCraft.Faction
{
	public class Neutral : thrts.FactionParameter
	{
		public Neutral ()
		{
			Name = "中立勢力";
			DefaultScreenPosition = new thrts.Point2D (-480, -640);

			Units = new string[] { 
				// 小鈴死亡時に中立ユニットとなる為
				typeof(Unit.Common.TheBook).FullName,

				typeof(Low01).FullName,
				typeof(Low02).FullName,
				typeof(Low11).FullName,
				typeof(Low12).FullName,
				typeof(High01).FullName,
				typeof(High02).FullName,
			};
			Buildings = new string[] { 
				typeof(thrts.Building.Rock).FullName,
				typeof(thrts.Building.Rock_1500).FullName,
				typeof(thrts.Building.Rock_3000).FullName,
				typeof(thrts.Building.Rock_4500).FullName,
			};

			TextureEffects = new string[] { 
				typeof(Effect.Common.AlcoholIconEffect).FullName,
				typeof(Effect.Common.ReiryokuIconEffect).FullName,

				typeof(Effect.Common.NormalHitOrangeTextureEffect).FullName,
				typeof(Effect.Common.NormalHitGreenTextureEffect).FullName,
				typeof(Effect.Common.NormalHitBlueTextureEffect).FullName,
				typeof(Effect.Common.NormalHitPurpleTextureEffect).FullName,
				typeof(Effect.Common.NormalHitRedTextureEffect).FullName,
				typeof(Effect.Common.NormalHitYellowTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitRedTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitGreenTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitBlueTextureEffect).FullName,
				typeof(Effect.Common.BombHitTextureEffect).FullName,
				typeof(Effect.Common.BombHitRedTextureEffect).FullName,
				typeof(Effect.Common.BombHitGreenTextureEffect).FullName,
				typeof(Effect.Common.BombHitBlueTextureEffect).FullName,
			};

			Effects = new string[] {

				typeof(Effect.Common.HitRemoteWhiteEffect).FullName,
				typeof(Effect.Common.HitRemoteBlueEffect).FullName,
				typeof(Effect.Common.HitRemoteRedEffect).FullName,
				typeof(Effect.Common.HitRemoteGreenEffect).FullName,
				typeof(Effect.Common.HitCloseRedEffect).FullName,
				typeof(Effect.Common.HitCloseBlueEffect).FullName,
				typeof(Effect.Common.HitCloseGreenEffect).FullName,
                typeof(Effect.Common.HitCloseWhiteEffect).FullName,
				typeof(Effect.Common.HitSplashRedEffect).FullName,
				typeof(Effect.Common.HitSplashBlueEffect).FullName,
				typeof(Effect.Common.HitSplashGreenEffect).FullName,

				typeof(DeadUnitEffect).FullName,
			};
			SoundEffects = new string[]
			{
				typeof(SoundEffect.BreakBuildingSE).FullName,
				typeof(SoundEffect.ChooseUnit).FullName,
				typeof(SoundEffect.Click).FullName,
				typeof(SoundEffect.CreatedUnit).FullName,
				typeof(SoundEffect.CreatedBuilding).FullName,
				typeof(SoundEffect.EndCharge).FullName,
				typeof(SoundEffect.EndResearch).FullName,
				typeof(SoundEffect.EndRevolution).FullName,
				typeof(SoundEffect.FailedClick).FullName,
				typeof(SoundEffect.HitLongRangeAttack).FullName,
				typeof(SoundEffect.HitShortRangeAttack).FullName,
				typeof(SoundEffect.PCH).FullName,
				typeof(SoundEffect.PointPosition).FullName,
				typeof(SoundEffect.Alarm01).FullName,
			};

			CommonUnitButton = new List<ButtonParameterHolder<IUnit>>(){
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.MoveButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StopButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.HoldPositionButton ()),
				//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.PatrolButton ()),
				//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.AttackButton ()),
				//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StationButton ()),
			};

			IsNeutral = true;
		}
	}
}
