﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Unit.White;
using LotusCraft.Unit.White.Unique;
using LotusCraft.Building.White;
using LotusCraft.Effect.White;
using LotusCraft.SoundEffect;

namespace LotusCraft.Faction
{
	public class White : thrts.FactionParameter
	{
		public White ()
		{
			ImageOnSelection800 = "System/BattleSetting/SelectWorkforce/800/workforce_white_m";
			ImageOnSelection1280 = "System/BattleSetting/SelectWorkforce/1280/workforce_white_m";

			ImageLongOnSelection800 = "System/BattleSetting/SelectWorkforce/800/workforce_white";
			ImageLongOnSelection1280 = "System/BattleSetting/SelectWorkforce/1280/workforce_white";

			Name = "白勢力";
			DefaultScreenPosition = new thrts.Point2D (-480, -640);

			Units = new string[] { 
				typeof(Unit.Common.Mercenary01).FullName,
				typeof(Unit.Common.Mercenary02).FullName,
				typeof(Unit.Common.Eiki).FullName,
				typeof(Unit.Common.Erin).FullName,

				typeof(Unit.Common.TheBook).FullName,

				typeof(Farmer).FullName,
				typeof(Low02).FullName,
				typeof(Low03).FullName,
				typeof(Kaguya).FullName,

				typeof(Reisen).FullName,
				typeof(Toramaru).FullName,
				typeof(Murasa).FullName,

				typeof(Nazurin).FullName,
				typeof(Kosuzu).FullName,

				typeof(FlyFighter).FullName,
				typeof(FlyBomber).FullName,
				typeof(FlyTransporter).FullName,

				typeof(Reimu).FullName,
				typeof(Marisa).FullName,
				typeof(Akyu).FullName,

#if !_TRIAL
				typeof(Eirin).FullName,
				typeof(Hijiri).FullName,
				typeof(Ichirin).FullName,
#endif

				typeof(NyokiObj).FullName,
                typeof(NyokiObj2).FullName,
			};
			Buildings = new string[] { 
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Bunker).FullName,
				typeof(Factory).FullName,
				typeof(Airport).FullName,

				typeof(Houtou).FullName,
				typeof(Seirensen).FullName,
				typeof(Hospital).FullName,

#if !_TRIAL
				typeof(Omoikane_lv1).FullName,
				typeof(Omoikane_lv2).FullName,
				typeof(Omoikane_lv3).FullName,
#endif
			};

			TextureEffects = new string[] { 

				typeof(Effect.Common.AlcoholIconEffect).FullName,
				typeof(Effect.Common.ReiryokuIconEffect).FullName,
				typeof(Effect.White.NijuKekkaiTextureEffect).FullName,

                typeof(Effect.White.AuraTextureEffect).FullName,

				typeof(Effect.Common.NormalHitOrangeTextureEffect).FullName,
				typeof(Effect.Common.NormalHitGreenTextureEffect).FullName,
				typeof(Effect.Common.NormalHitBlueTextureEffect).FullName,
				typeof(Effect.Common.NormalHitPurpleTextureEffect).FullName,
				typeof(Effect.Common.NormalHitRedTextureEffect).FullName,
				typeof(Effect.Common.NormalHitYellowTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitRedTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitGreenTextureEffect).FullName,
				typeof(Effect.Common.ColumnHitBlueTextureEffect).FullName,
				typeof(Effect.Common.BombHitTextureEffect).FullName,
				typeof(Effect.Common.BombHitRedTextureEffect).FullName,
				typeof(Effect.Common.BombHitGreenTextureEffect).FullName,
				typeof(Effect.Common.BombHitBlueTextureEffect).FullName,

				typeof(Effect.Common.IncreaseBombEffect).FullName,
			};

			Effects = new string[] {  
				typeof(Effect.Common.CreateBuildingEffect).FullName,
				typeof(BreakBuilding).FullName, 
				typeof(Effect.Common.DissolveBuilding).FullName, 

				typeof(Arrow).FullName, 
				typeof(Stronghold).FullName,
				typeof(Barracks).FullName,
				typeof(BarracksReactor).FullName,
				typeof(Factories).FullName,
				typeof(Airports).FullName,
				typeof(CollectAlcohol).FullName,
				typeof(CollectPowerStone).FullName,

				typeof(Effect.Common.AttackBombEffect).FullName,
				typeof(Effect.Common.AttackBombAreaEffect).FullName,
				typeof(Effect.Common.FastBombEffect).FullName,
				typeof(Effect.Common.FastBombAreaEffect).FullName,
				typeof(Effect.Common.IncreaseBombAreaEffect).FullName,
				typeof(Effect.Common.ReviveBombEffect).FullName,
				typeof(Effect.Common.TownPortalBombEffect).FullName,


				typeof(Effect.Common.CircleAreaEffect).FullName,
				typeof(Effect.Common.DebuffEffect).FullName,
				typeof(Effect.Common.HitRemoteWhiteEffect).FullName,
				typeof(Effect.Common.HitRemoteBlueEffect).FullName,
				typeof(Effect.Common.HitRemoteRedEffect).FullName,
				typeof(Effect.Common.HitRemoteGreenEffect).FullName,
				typeof(Effect.Common.HitCloseRedEffect).FullName,
				typeof(Effect.Common.HitCloseBlueEffect).FullName,
				typeof(Effect.Common.HitCloseGreenEffect).FullName,
                typeof(Effect.Common.HitCloseWhiteEffect).FullName,
				typeof(Effect.Common.HitSplashRedEffect).FullName,
				typeof(Effect.Common.HitSplashBlueEffect).FullName,
				typeof(Effect.Common.HitSplashGreenEffect).FullName,

				typeof(Effect.Common.LvUpEffect).FullName,
				typeof(Effect.Common.DeadUniqueEffect).FullName,
				typeof(Effect.Common.DeadUnitEffect).FullName,

				typeof(Effect.Common.CreateBuildingEffect).FullName,
				typeof(Effect.Common.CompleteBuildingEffect).FullName,
				typeof(Effect.Common.CreateUnitEffect).FullName,

				typeof(Effect.Common.UnitCollectAlcoholEffect).FullName,
				typeof(Effect.Common.UnitCollectPowerStoneEffect).FullName,

				typeof(Effect.Common.ChargeEffect).FullName,

				typeof(HitSplashRedEffect).FullName,
				typeof(HitSplashBlueEffect).FullName,
				typeof(HitSplashGreenEffect).FullName,

				typeof(DeadUnitEffect).FullName,
				typeof(DeadUniqueEffect).FullName,

				typeof(CommonBolEffect).FullName, 
				typeof(CommonBolAreaEffect).FullName, 
				typeof(RangeCircleEffect).FullName, 
				typeof(HealEffect).FullName, 
				typeof(BackLightEffect).FullName, 
				typeof(StanEffect).FullName,

				typeof(NijuKekkaiEffect).FullName,
				typeof(NijuKekkaiAreaEffect).FullName,
				typeof(KibakujinEffect).FullName,
				typeof(KibakujinAreaEffect).FullName,
				typeof(MusoHuinAreaEffect).FullName,
				typeof(MusoHuinChargeEffect).FullName,
				typeof(MusoHuinRedBulletEffect).FullName,
				typeof(MusoHuinRedHitEffect).FullName,
				typeof(MusoHuinBlueBulletEffect).FullName,
				typeof(MusoHuinBlueHitEffect).FullName,
				typeof(MusoHuinGreenBulletEffect).FullName,
				typeof(MusoHuinGreenHitEffect).FullName,
				typeof(DaiKekkaiEffect).FullName,
				typeof(DaiKekkaiChargeEffect).FullName,
				typeof(DaiKekkaiShotEffect).FullName,

#if !_TRIAL
				typeof(MissouChargeEffect).FullName,
				typeof(MissouAreaEffect).FullName,
				typeof(OmoikaneAreaEffect).FullName,
				typeof(OmoikaneHealEffect).FullName,
				typeof(NightmareEffect).FullName,
				typeof(NightmareAreaEffect).FullName,
				typeof(HouraiEffect).FullName,
				typeof(HouraiAreaEffect).FullName,

				typeof(NyokiEffect).FullName, 
				typeof(TenkyuAreaEffect).FullName, 
				typeof(TenkyuEffect).FullName, 
				typeof(TaidenEffect).FullName, 
				typeof(UnzanEffect).FullName,

                typeof(NyoraiEffect).FullName,
				typeof(ChojinEffect).FullName,
                typeof(AirmakimonoEffect).FullName,
                typeof(StarSwordAreaEffect).FullName,
                typeof(StarSwordEffect).FullName,
#endif
				typeof(KiokuEffect).FullName,
				typeof(GumonziEffect).FullName,
				typeof(HiedaEffect).FullName,
				typeof(MiareAreaEffect).FullName,
				typeof(MiareEffect).FullName,

				typeof(MarisaSparkAreaEffect).FullName,
				typeof(MarisaMasterSparkAreaEffect).FullName,
				typeof(MarisaStarAreaEffect).FullName,
				typeof(MarisaBlazingAreaEffect).FullName,
				typeof(MarisaOrreriesSunRed).FullName,
				typeof(MarisaOrreriesSunBlue).FullName,
				typeof(MarisaOrreriesSunGreen).FullName,
				typeof(MarisaOrreriesSunPurple).FullName,
				typeof(MarisaOrreriesSunOrange).FullName,
				typeof(MarisaOrreriesSunYellow).FullName,
				typeof(MarisaOrreriesSunArea).FullName,

				typeof(KaguyaMobAreaEffect).FullName,
				typeof(KaguyaMobHitEffect).FullName,
				typeof(KaguyaMobHitBigEffect).FullName,
				typeof(KaguyaMobFlashEffect).FullName,
				typeof(KaguyaMobChangeEffect).FullName,

				typeof(SummonEffect).FullName,

			};

			ModelEffects = new string[]
			{
				typeof(KaguyaMobAreaModelEffect).FullName,
			};

			SoundEffects = new string[]
			{
				typeof(SoundEffect.BreakBuildingSE).FullName,
				typeof(SoundEffect.ChooseUnit).FullName,
				typeof(SoundEffect.Click).FullName,
				typeof(SoundEffect.CreatedUnit).FullName,
				typeof(SoundEffect.CreatedBuilding).FullName,
				typeof(SoundEffect.EndCharge).FullName,
				typeof(SoundEffect.EndResearch).FullName,
				typeof(SoundEffect.EndRevolution).FullName,
				typeof(SoundEffect.FailedClick).FullName,
				typeof(SoundEffect.HitLongRangeAttack).FullName,
				typeof(SoundEffect.HitShortRangeAttack).FullName,
				typeof(SoundEffect.HitZangeki).FullName,
				typeof(SoundEffect.HitDageki).FullName,
				typeof(SoundEffect.HitOther).FullName,
				typeof(SoundEffect.PCH).FullName,
				typeof(SoundEffect.PointPosition).FullName,
				typeof(SoundEffect.Alarm01).FullName,
				typeof(SoundEffect.Charge1).FullName,
				typeof(SoundEffect.Charge2).FullName,
				typeof(SoundEffect.BiriBiri).FullName,
				typeof(SoundEffect.Maspa).FullName,
				typeof(SoundEffect.Burst).FullName,
				typeof(SoundEffect.Jet).FullName,
				typeof(SoundEffect.Shuiin01).FullName,
				typeof(SoundEffect.Shuiin02).FullName,
				typeof(SoundEffect.LvUp).FullName,
				typeof(SoundEffect.Wind).FullName,

				typeof(SoundEffect.Bom01).FullName,
				typeof(SoundEffect.Bom12).FullName,
			};
			

			CommonUnitButton = new List<ButtonParameterHolder<IUnit>>(){
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.MoveButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StopButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.HoldPositionButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.PatrolButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.AttackMoveButton ()),
				//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StationButton ()),
			};
		}
	}
}
