﻿#if !_TRIAL
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

using LotusCraft.Effect.Black;
using LotusCraft.Bullet.Black;
using LotusCraft.Ability.Black;
using LotusCraft.Ability;

namespace LotusCraft.Spell.Black
{
	class Boukyo:thrts.SpellParameter<thrts.IUnit>
	{
		const int affectRadius = 1;
		int[] maxAbs;
		public Boukyo()
		{
			DefaultLevel = 0;
			MaxLevel = 3;
			Name = " 亡郷「亡我郷 -自尽-」";
			string basePath = "Black/Spell/Boukyo/";


			CoolTimes = new int[MaxLevel+1];
			CoolTimes[0] = 0;
			CoolTimes[1] = 45*Def.FPS;
			CoolTimes[2] = 15*Def.FPS;
			CoolTimes[3] = 5*Def.FPS;
			
			MinRanges = new float[4];
			MinRanges[0] = 0;
			MinRanges[1] = 0;
			MinRanges[2] = 0;
			MinRanges[3] = 0;
			MaxRanges = new float[4];
			MaxRanges[0] = 0;
			MaxRanges[1] = 1.2f*Def.MapTipLengthOnField;
			MaxRanges[2] = 1.4f*Def.MapTipLengthOnField;
			MaxRanges[3] = 1.6f*Def.MapTipLengthOnField;

			maxAbs = new int[MaxLevel + 1];
			maxAbs[0] = 0;
			maxAbs[1] = 400;
			maxAbs[2] = 600;
			maxAbs[3] = 800;

			Description = "指定したユニットを吸収しHPを回復する。\nヒロインを吸収する事はできない。";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"最大回復HP" + maxAbs[1] + "、中立・味方下級・味方上級のみ",
				"最大回復HP" + maxAbs[2] + "、中立・下級・味方上級のみ",
				"最大回復HP" + maxAbs[3] + "、中立・下級・上級のみ",
			};
			
			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._1;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;
			
			/// オートキャストの生成
			/// オートキャスト無し
			SpellAutoCasts = null;
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0", 0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",PrivilegeModeSpelling, 1,true,true),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "2",PrivilegeModeSpelling, 2,true,true),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "3",PrivilegeModeSpelling, 3,true,true),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}
		public IEnumerable<object> PrivilegeModeSpelling (thrts.IUnit selfUnit, IUnit targetUnit,IBuilding targetBuilding, int level)
		{
			// スペルが現在使用可能か判断
			var spell = selfUnit.GetSpellWithName (Name);
			if (null == spell || !spell.CanExec)
			{
				yield return false;
				yield break;
			}

			if (null == targetUnit || !targetUnit.Exists() || targetUnit.HP < 1 || targetUnit.Parameter.IsUnique)
			{
				yield return false;
				yield break;
			}

			if (!selfUnit.Faction.World.IsSameTeam(selfUnit.Faction,targetUnit.Faction)) {

				if ( (level < 2 && targetUnit.Faction.Parameter.GetType() != typeof(Faction.Neutral)) 
				  || (level < 3 && targetUnit.Parameter is Unit.General.Special))
				{
					yield return false;
					yield break;
				}
			}

			/// reset cooltime
			spell.ResetCoolTime();

			var abs = Math.Min(maxAbs[level],targetUnit.HP * level );

			// death now
			targetUnit.HP = 0;

			// heal hp
			selfUnit.HP += abs;

			var offset = new Vector3D(2, 2, 1);
			var effect = selfUnit.Faction.World.EffectManager.CreateEffect(typeof(BoukyouEffect).FullName, targetUnit.Pos+offset);
			var scale = affectRadius * 10;
			effect.SetScale(new Vector3D(scale, scale, scale));
			effect.SetPosition(targetUnit.Pos + offset);

			selfUnit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.Eat).FullName, selfUnit.Pos);

			// end
			yield return false;
		}
	}
}
#endif