﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.Blue;
using LotusCraft.Ability.Blue;
using LotusCraft.Building.Blue;


namespace LotusCraft.Spell.Blue
{
	class Sukima:thrts.SpellParameter<thrts.IUnit>
	{
		const int interval = 15;
		int[] maxNum = new int[4];
		public Sukima()
		{
			DefaultLevel = 0;
			MaxLevel = 3;
			Name = "罔両「八雲紫の神隠し」";
			string basePath = "Blue/Spell/Sukima/";

			maxNum = new int[MaxLevel+1];
			maxNum[0] = 2;
			maxNum[1] = 4;
			maxNum[2] = 6;
			maxNum[3] = 8;

			CoolTimes = new int[MaxLevel+1];
			CoolTimes[0] = 30*Def.FPS;
			CoolTimes[1] = 30*Def.FPS;
			CoolTimes[2] = 30*Def.FPS;
			CoolTimes[3] = 30*Def.FPS;
			
			MaxRanges = new float[MaxLevel+1];
			MaxRanges[0] = 4*Def.MapTipLengthOnField;
			MaxRanges[1] = 5*Def.MapTipLengthOnField;
			MaxRanges[2] = 5*Def.MapTipLengthOnField;
			MaxRanges[3] = 6*Def.MapTipLengthOnField;
			

			Description += "ユニットが自由に出入り可能なスキマを建設する。基本は最大数" + maxNum[0]+"ヶ";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"スキマ最大数 + " + (maxNum[1] - maxNum[0]),
				"スキマ最大数 + " + (maxNum[2] - maxNum[0]),
				"スキマ最大数 + " + (maxNum[3] - maxNum[0]),
			};

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._0;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// スキマアビリティ取得のためのオートキャストを設定
			SpellAutoCasts = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				null,
				null,
				null,
				null,
			};
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",PrivilegeModeSpelling,0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",PrivilegeModeSpelling,1),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "2",PrivilegeModeSpelling,2),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "3",PrivilegeModeSpelling,3),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}
		public IEnumerable<object> PrivilegeModeSpelling (thrts.IUnit selfUnit, Vector2D targetPosition, int level)
		{
			var ret = Spelling(selfUnit,targetPosition,level);
			yield return ret;
		}

		public bool Spelling (thrts.IUnit selfUnit, Vector2D targetPosition, int level)
		{
			var spell = selfUnit.GetSpellWithName (this.Name);
			if (null == spell) {
				return false;
			}

			if(!spell.CanExec){
				return false;
			}
			

			var sukimaStayAbility = selfUnit.AbilityManager.GetAbilityWithName (SukimaStayAbility.AbilityName) as SukimaStayAbility;

			if (null == sukimaStayAbility) {
				/// search building handling ability
				var sukimas = selfUnit.Faction.World.BuildingManager.GetBuildings (b => null != b && selfUnit.Faction == b.Faction && b.Parameter is SukimaBuilding);
				foreach (var b in sukimas) {
					if (b.AbilityManager.ContainsAbility (SukimaStayAbility.AbilityName)) {
						sukimaStayAbility = b.AbilityManager.GetAbilityWithName (SukimaStayAbility.AbilityName) as SukimaStayAbility;
						if (sukimaStayAbility != null) {
							sukimaStayAbility.Speller = selfUnit;
							if (selfUnit.AbilityManager.AppendAbility (sukimaStayAbility)) {
								b.AbilityManager.RemoveAbility (SukimaStayAbility.AbilityName, false);
								
								break;
							}
							else
							{
								sukimaStayAbility = null;
							}
						}
					}
				}

				/// create new ability
				if (null == sukimaStayAbility) {
					sukimaStayAbility = new SukimaStayAbility(selfUnit);
					if (!selfUnit.AbilityManager.AppendAbility (sukimaStayAbility)) {
						sukimaStayAbility = null;
					}
				}
			}


			/// return if failer
			if (null == sukimaStayAbility) {
				return false;
			}
			/*
			foreach (var b in sukimaStayAbility.Buildings) {
				if(b.IsHit(targetPosition.X,targetPosition.Y,1))
				{
					selfUnit.Escape();
					selfUnit.Enter(new Vector2D(b.Pos.X,b.Pos.Y));
				}
			}
			*/
			if (sukimaStayAbility.Buildings.Count () >= maxNum [level]) {
				return false;
			}

			IBuilding sukima = null;
			selfUnit.StartBuilding (selfUnit.Faction.GetBuildingParameter (typeof(SukimaBuilding).FullName), 
			                        new Point2D ((int)(targetPosition.X / Def.MapTipLengthOnField), (int)(targetPosition.Y / Def.MapTipLengthOnField)),
			                        out sukima);
			if (null != sukima) {
				sukima.Completed += () => sukimaStayAbility.AppendSkima(sukima);
				sukima.StartConstruction(selfUnit,0);
				spell.ResetCoolTime();
			}

			return true;
		}
		public bool AutoCastAction (IUnit selfUnit)
		{
			if (selfUnit.AbilityManager.ContainsAbility (SukimaStayAbility.AbilityName)) {
				return true;
			} else {
				var sukimas = selfUnit.Faction.World.BuildingManager.GetBuildings (b => null != b && selfUnit.Faction == b.Faction && b.Parameter is SukimaBuilding);
				foreach (var b in sukimas) {
					if (b.AbilityManager.ContainsAbility (SukimaStayAbility.AbilityName)) {
						var sukimaStayAbility = b.AbilityManager.GetAbilityWithName (SukimaStayAbility.AbilityName) as SukimaStayAbility;
						if (sukimaStayAbility != null) {
							sukimaStayAbility.Speller = selfUnit;
							if (selfUnit.AbilityManager.AppendAbility (sukimaStayAbility)) {
								b.AbilityManager.RemoveAbility (SukimaStayAbility.AbilityName, false);

								return true;
							}
						}
					}
				}

				if (selfUnit.AbilityManager.AppendAbility (new SukimaStayAbility(selfUnit))) {
					return true;
				}
				else
				{
					return false;
				}
			}
		}
	}
}



namespace LotusCraft.Ability.Blue
{
	class SukimaStayAbility : thrts.AbilityTemplate
	{
		Vector3D offset;
		public IUnit Speller = null;
		public LinkedList<IUnit> StayUnits;
		public LinkedList<IBuilding> Buildings;
		public const string AbilityName = "罔両「八雲紫の神隠し」";
		public SukimaStayAbility(IUnit speller = null)
		{
			this.Name = AbilityName;
			this.DurationTime = 1;
			this.Speller = speller;
			StayUnits = new LinkedList<IUnit>();
			Buildings = new LinkedList<IBuilding>();
			
		}

		public override bool OnVanish (IUnit unit)
		{
			/// round robin ability
			if (null != Buildings && Buildings.Any ()) {
				foreach ( var b in Buildings)
					 if(b != null && b.Exists() && b.AbilityManager.AppendAbility(this))
						return base.OnVanish (unit);
			}

			/// destroy if all vanished

			/// destroy units
			if (StayUnits != null) {
				foreach ( var u in StayUnits)
				{
					if(u.Exists())
						u.HP =  -1;
				}
			}
			/// destroy sukima
			if (Buildings != null) {
				foreach ( var b in Buildings)
				{
					if(b.Exists())
						b.HP =  -1;
				}
			}
			return base.OnVanish (unit);
		}
		public override bool OnVanish (IBuilding building)
		{
			/// round robin speller
			if (Speller != null && Speller.Exists () && Speller.AbilityManager.AppendAbility (this)) {
				DurationTime = 1;
				return base.OnVanish (building);
			}
			
			/// round robin ability
			if (null != Buildings && Buildings.Any ()) {
				foreach ( var b in Buildings)
				{
					if(b != null && b.Exists() && b.AbilityManager.AppendAbility(this))
					{
						DurationTime = 1;
						return base.OnVanish (building);
					}
				}
			}

			/// destroy if all vanished

			/// destroy units
			if (StayUnits != null) {
				foreach ( var u in StayUnits)
				{
					if(u.Exists())
						u.HP =  -1;
				}
			}
			/// destroy sukima
			if (Buildings != null) {
				foreach ( var b in Buildings)
				{
					if(b.Exists())
						b.HP =  -1;
				}
			}
			return base.OnVanish (building);
		}

		// inf ability
		public override void DecDurationTime ()
		{
			return ;
		}

		public void AppendSkima (IBuilding building)
		{
			if(building == null || !building.Exists())
				return;

			if (null != building &&  !Buildings.Contains(building)) {
				Buildings.AddLast(building);
				building.UnitStayed += OnStayUnit;
				building.UnitReleased += OnReleaseUnit;
				building.Destoroyed += () =>OnDestroySukima(building);
				foreach(var u in StayUnits)
				{
						building.StayUnit(u);
				}
			}
		}
		public void OnStayUnit (IBuilding building, IUnit unit)
		{
			if(building == null || !building.Exists() || !Buildings.Contains(building))
				return;

			if (null != unit && unit.Exists () && !StayUnits.Contains(unit)) {
				StayUnits.AddLast (unit);
				foreach (var b in Buildings) {
					if(b != null && b.Exists())
						if (building.UniqueID != b.UniqueID)
							b.StayUnit (unit);
				}
			}
		}
		public void OnReleaseUnit (IBuilding building, IUnit unit)
		{
			if(building == null || !building.Exists() || !Buildings.Contains(building))
				return;

			if (null != unit && StayUnits.Contains(unit)) {
				StayUnits.Remove (unit);
				foreach (var b in Buildings) {
					if(b != null && b.Exists())
						if (building.UniqueID != b.UniqueID)
							b.RemoveStayedUnit(unit);
				}
			}
		}
		public void OnDestroySukima (IBuilding building)
		{
			if(building == null || !Buildings.Contains(building))
				return;

			/// roundrobin stayed units
			var unitList = StayUnits.ToArray ();

			/// remove sukima list
			if (Buildings.Contains (building))
				Buildings.Remove (building);

			/// seach roundrobin units
			var targets = Buildings.Where (_ => null != _ && _.Exists () && _.UniqueID != building.UniqueID);

			if (targets.Any ()) {
				var nextSukima = targets.First();
				foreach(var u in unitList)
					building.MigrateStayedUnit(nextSukima,u);
			} else {
				// release yukari
				if(unitList.Contains(Speller))
				{
					building.ReleaseSelectedUnit(Speller.UniqueID);
				}
				// stay all units
				foreach (var u in unitList) {
					building.RemoveStayedUnit(u);
				}
			}
		}
	}
	
}
