﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Unit.Green;
using LotusCraft.Ability;
using LotusCraft.Ability.Green;
using LotusCraft.Effect.Green;

namespace LotusCraft.Spell.Green
{
	class FlowerMaster:thrts.SpellParameter<thrts.IUnit>
	{
		public static string SpellName = "四季のフラワーマスター";
		public static string DecPropagateGardenIntervalKey = "flowerMasterDecPropIntervalKey";
		public static string IncMaxPropagateGardenKey = "flowerMasterIncMaxKey";
		
		int[] DecPropagateGardenIntervals;
		int[] incMaxPropagateRadiuses;
		public FlowerMaster()
		{
			DefaultLevel = 0;
			MaxLevel = 3;
			Name = SpellName;
			string basePath = "Green/Spell/FlowerMaster/";
			
			IsPassive= true;
			
			DecPropagateGardenIntervals = new int[MaxLevel+1];
			DecPropagateGardenIntervals[0] = 0;
			DecPropagateGardenIntervals[1] = 1*Def.FPS;
			DecPropagateGardenIntervals[2] = 2*Def.FPS;
			DecPropagateGardenIntervals[3] = 3*Def.FPS;
			incMaxPropagateRadiuses = new int[MaxLevel+1];
			incMaxPropagateRadiuses[0] = 0;
			incMaxPropagateRadiuses[1] = 2;
			incMaxPropagateRadiuses[2] = 5;
			incMaxPropagateRadiuses[3] = 8;
			
			Description = "花畑が繁茂する。花畑の上では緑勢力のユニットの移動速度が30%増加。";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"花畑の拡大間隔"+DecPropagateGardenIntervals[1]/Def.FPS+"秒減少、最大範囲+"+incMaxPropagateRadiuses[1]+"。",
				"花畑の拡大間隔"+DecPropagateGardenIntervals[2]/Def.FPS+"秒減少、最大範囲+"+incMaxPropagateRadiuses[2]+"。",
				"花畑の拡大間隔"+DecPropagateGardenIntervals[3]/Def.FPS+"秒減少、最大範囲+"+incMaxPropagateRadiuses[3]+"。",
			};
			
			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._0;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;
			
			/// オートキャスト
			SpellAutoCasts = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,15,null),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,15,(unit)=>Spelling(unit,1),true),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,15,(unit)=>Spelling(unit,2),true),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,15,(unit)=>Spelling(unit,3),true),
			};
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",1),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "2",2),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "3",3),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}
		public bool Spelling (thrts.IUnit selfUnit, int level)
		{
			
			return true;
		}
		public override void OnLvUp (IFaction faction, int lv)
		{
			if (lv >= 0 && lv <=  MaxLevel) {
				if (faction.UserValues.ContainsKey (DecPropagateGardenIntervalKey)) {
					if (DecPropagateGardenIntervals.Length > lv)
						faction.UserValues [DecPropagateGardenIntervalKey] = DecPropagateGardenIntervals [lv];
				} else {
					if (DecPropagateGardenIntervals.Length > lv)
						faction.UserValues.Add (DecPropagateGardenIntervalKey, DecPropagateGardenIntervals [lv]);

				}
				if (faction.UserValues.ContainsKey (IncMaxPropagateGardenKey)) {
					if (incMaxPropagateRadiuses.Length > lv)
						faction.UserValues [IncMaxPropagateGardenKey] = incMaxPropagateRadiuses [lv];
				} else {
					if (incMaxPropagateRadiuses.Length > lv)
						faction.UserValues.Add (IncMaxPropagateGardenKey, incMaxPropagateRadiuses [lv]);
				}
			}
			base.OnLvUp (faction, lv);
		}
	}
}

#endif