﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

using LotusCraft.Effect.Red;
using LotusCraft.Bullet.Red;
using LotusCraft.Ability.Red;
using LotusCraft.Ability;

namespace LotusCraft.Spell.Red
{
	class Fujiyama:thrts.SpellParameter<thrts.IUnit>
	{
        float spellDuration = 0.5f;
        float damage;
        int interval = 5;
        Vector3D targetPos;
        bool setEffect = false;

        IEffect areaEffect = null;
        IEffect areaEffect2 = null;
        IEffect effect = null;
        public Fujiyama()
		{
			DefaultLevel = 0;
			MaxLevel = 3;
            Name = "蓬莱「凱風快晴 －フジヤマヴォルケイノ－」";
			Description = "指定地点の周辺に連続してダメージを与える。\n作業員へのダメージ-50%";
            string basePath = "Red/Spell/Fujiyama/";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"50ダメージ",
				"50×2ダメージ",
				"50×3ダメージ",
			};

            CoolTimes = new int[MaxLevel + 1];
            CoolTimes[0] = 0;
            CoolTimes[1] = 12 * Def.FPS;
            CoolTimes[2] = 12 * Def.FPS;
            CoolTimes[3] = 12 * Def.FPS;

            MaxRanges = new float[MaxLevel + 1];
            MaxRanges[0] = 0;
            MaxRanges[1] = 5 * Def.MapTipLengthOnField;
            MaxRanges[2] = 5 * Def.MapTipLengthOnField;
            MaxRanges[3] = 5 * Def.MapTipLengthOnField;

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._2;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャスト
            SpellAutoCasts = null;
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",PrivilegeModeSpelling,1),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "2",PrivilegeModeSpelling,2),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "3",PrivilegeModeSpelling,3),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}
        public IEnumerable<object> PrivilegeModeSpelling(IUnit selfUnit, Vector2D targetPosition, int level)
        {
			// スペルが現在使用可能か判断
			var spell = selfUnit.GetSpellWithName (Name);
			if (null == spell || !spell.CanExec) {
				yield return false;
				yield break;
			}
			// reset cooltime
            spell.ResetCoolTime();

            float affectRadius = 0;
            int nowlevel = 0;

            targetPos = selfUnit.Faction.World.GetGroundAtPos(targetPosition);

            {
                affectRadius = 1.25f;
                // create charge effect
                var offset = new Vector3D(0, 0, 1);
                var effect = selfUnit.Faction.World.EffectManager.CreateEffect(typeof(KouanChargeEffect).FullName, targetPos + offset);
                var effectScale = affectRadius * 2.6f + 4f;
                effect.SetScale(new Vector3D(effectScale, effectScale, effectScale));

                for (int i = 0; i < 8; ++i)
                {
                    if (i < 8) effectScale -= 0.5f;
                    effect.SetScale(new Vector3D(effectScale, effectScale, effectScale));
                    yield return true;
                }

                //add spell ability
                setEffect = true; nowlevel = 1;
                bool flag = selfUnit.AbilityManager.AppendAbility(new Ability.SpellContinuousAbility((unit) => Spelling(unit, nowlevel), null, offset, (int)(spellDuration * Def.FPS), this.Name + "Areadamage", interval));
                if (!flag) { selfUnit.DoFindEnemyAutomatically = true; yield break; }

				selfUnit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.Bom01).FullName, targetPos);

                for (int i = 0; i < (int)(spellDuration * Def.FPS) - 2; ++i) yield return true;
                if (level == 1) { for (int i = 0; i < 5; ++i) yield return true; }
            }

            if (level >= 2)
            {
                affectRadius = 2f;
                // create charge effect
                var offset = new Vector3D(0, 0, 1);
                var effect = selfUnit.Faction.World.EffectManager.CreateEffect(typeof(KouanChargeEffect).FullName, targetPos + offset);
                var effectScale = affectRadius * 2.9f + 4f;
                effect.SetScale(new Vector3D(effectScale, effectScale, effectScale));

                for (int i = 0; i < 8; ++i)
                {
                    if (i < 8) effectScale -= 0.5f;
                    effect.SetScale(new Vector3D(effectScale, effectScale, effectScale));
                    yield return true;
                }

                //add spell ability
                setEffect = true; nowlevel = 2;
                bool flag = selfUnit.AbilityManager.AppendAbility(new Ability.SpellContinuousAbility((unit) => Spelling(unit, nowlevel), null, offset, (int)(spellDuration * Def.FPS), this.Name + "Areadamage", interval));
                if (!flag) { selfUnit.DoFindEnemyAutomatically = true; yield break; }

				selfUnit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.Bom01).FullName, targetPos);

                for (int i = 0; i < (int)(spellDuration * Def.FPS) - 2; ++i) yield return true;
                if (level == 2) { for (int i = 0; i < 5; ++i) yield return true; }
            }
            if (level == 3)
            {
                selfUnit.DoFindEnemyAutomatically = true;
                affectRadius = 2.75f;
                // create charge effect
                var offset = new Vector3D(0, 0, 1);
                var effect = selfUnit.Faction.World.EffectManager.CreateEffect(typeof(KouanChargeEffect).FullName, targetPos + offset);
                var effectScale = affectRadius * 3.1f + 4f;
                effect.SetScale(new Vector3D(effectScale, effectScale, effectScale));

                for (int i = 0; i < 12; ++i)
                {
                    if (i < 8) effectScale -= 0.4f;
                    effect.SetScale(new Vector3D(effectScale, effectScale, effectScale));
                    yield return true;
                }

                //add spell ability
                setEffect = true; nowlevel = 3;
                bool flag = selfUnit.AbilityManager.AppendAbility(new Ability.SpellContinuousAbility((unit) => Spelling(unit, nowlevel), null, offset, (int)(spellDuration * Def.FPS), this.Name + "Areadamage", interval));
				selfUnit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.Bom01).FullName, targetPos);

				
			}

            for (int i = 0; i < 10; ++i) yield return true;
            selfUnit.DoFindEnemyAutomatically = true;

            yield return true;
        }
        public bool Spelling(thrts.IUnit selfUnit, int level)
        {
            float affectRadius = 0;
            switch (level)
            {
                case 1:
                    damage = 50;
                    affectRadius = 1.25f;
                    break;
                case 2:
                    damage = 50;
                    affectRadius = 2f;
                    break;
                case 3:
                    damage = 50;
                    affectRadius = 2.75f;
                    break;
                default:
                    affectRadius = 0;
                    damage = 0;
                    break;
            }

            /// 地点(x,y)を中心にユニットを選択
            var selfFaction = selfUnit.Faction;
            var world = selfFaction.World;
            var targets = selfFaction.World.GetObjectFromCircle(new Circle2D(affectRadius * 32, new Vector2D(targetPos.X, targetPos.Y))).Where(_ => _ != null);
            foreach (IUnit u in targets.OfType<IUnit>().Where(_ => !world.IsSameTeam(selfFaction, _.Faction)))
            {
                if (!u.AbilityManager.ContainsAbility(this.Name + "HitEffect"))
                {
                    /// エフェクトを描画
                    var faction = u.Faction;
                    Vector3D offset = new Vector3D(2.0f, 2.0f, 1.0f);
                    var effect = world.EffectManager.CreateEffect(typeof(HitSplashRedEffect).FullName, u.Pos);
                    var scale = new Vector3D(8, 8, 8);
                    effect.SetScale(scale);

                    var hitAbility = new Ability.EffectContinuousAbility(effect, 20, this.Name + "HitEffect");
                    var flag = u.AbilityManager.AppendAbility(hitAbility);
                    if (!flag)
                        effect.Stop();
                    else
                    {
						if(u.Parameter.IsFarmer)
	                        u.BeDamaged(selfUnit, (int)Math.Ceiling(0.5f*damage), AttackBonusSet.Hero);
						else
							u.BeDamaged(selfUnit, (int)(damage), AttackBonusSet.Hero);

                        selfFaction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitOther).FullName, u.Pos);
                    }

                }
            }

            if (setEffect)
            {
                
                var offset = new Vector3D(0, 0, 1);
                var size = 6 * affectRadius * 2 - 3f;
                var exEffect = selfUnit.Faction.World.EffectManager.CreateEffect(typeof(FujiyamaEffect).FullName, targetPos + offset);
                exEffect.SetScale(new Vector3D(size, size, size));
                
                setEffect = false;
            }

            return true;
        }

        public void OnVanishUnit(thrts.IUnit selfUnit)
        {
            if (areaEffect != null)
            {
                areaEffect.Stop();
                areaEffect = null;
            }
        }
	}
}
