﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

using LotusCraft.Effect.Red;
using LotusCraft.Bullet.Red;
using LotusCraft.Ability.Red;
using LotusCraft.Ability;

namespace LotusCraft.Spell.Red
{
	class Saitan:thrts.SpellParameter<thrts.IUnit>
	{
        IEffect areaEffect = null;
        int duration = 20;
        int[] chargeTime = new int[2];
        public Saitan()
		{
			DefaultLevel = 0;
			MaxLevel = 1;
            RequireLevels[0] = 6;
            Name = "「フェニックス再誕」";
            Description = "自身のHPが0になった時、HP/CDを全回復して復活する。";
            string basePath = "Red/Spell/Saitan/";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
                "",
			};

            CoolTimes = new int[MaxLevel + 1];
            CoolTimes[0] = 0;
            CoolTimes[1] = 120 * Def.FPS;

            chargeTime[0] = 0;
            chargeTime[1] = 2 * 30;

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._3;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

            /// オートキャスト無し
            SpellAutoCasts = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,1,null),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,1,(unit)=>AutocastAction(unit),true),
			};
            /// スペルのボタンを生成
            SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",1/*(unit)=>PrivilegeModeSpelling(unit,1)*/),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}

        public bool AutocastAction(IUnit selfUnit)
        {
            if (selfUnit.GetSpellWithName(Name).GetCoolTimeRate() > 0) return true;

            if (selfUnit.AbilityManager.ContainsAbility(this.Name + "_Revive"))
            {
                selfUnit.AbilityManager.ExtendLifetimeWithName(1, this.Name + "_Revive",1*2);
            }
            else
            {
                var offset = new Vector3D(2, 2, 1);
                var size = 6 * 2 * 2;
                areaEffect = selfUnit.Faction.World.EffectManager.CreateEffect(typeof(SaitanEffect).FullName, selfUnit.Pos + offset);
                areaEffect.SetScale(new Vector3D(size, size, size));

                selfUnit.AbilityManager.AppendAbility(new Ability.FollowEffectAbility(areaEffect, offset,  2, this.Name + "_Revive"));
                selfUnit.Vanishing += Revive;
            }

            return true;
        }

        public IEnumerable<object> PrivilegeModeSpelling(thrts.IUnit selfUnit, int level)
		{
            {
                var unitRadius = selfUnit.Parameter.Radius;

                var offset = new Vector3D(2, 2, 1);
                var size = 6 * 2 * 2;
                areaEffect = selfUnit.Faction.World.EffectManager.CreateEffect(typeof(SaitanEffect).FullName, selfUnit.Pos + offset);
                areaEffect.SetScale(new Vector3D(size, size, size));
                
                selfUnit.Vanishing += Revive;;
                bool flag = selfUnit.AbilityManager.AppendAbility(new Ability.EffectFollowContinuousAbility(areaEffect, (int)(duration * Def.FPS), this.Name + "AreaEffect", offset));
            }

            yield break;
		}

        public void Revive(thrts.IUnit u)
        {
            if (u.AbilityManager.ContainsAbility(this.Name + "_Revive"))
            {
                //u.AbilityManager.RemoveAbility(this.Name + "AreaEffect");

                // reset cooltime
                u.GetSpellWithName(Name).ResetCoolTime();

                // show cutin
                u.ShowCutin();

                int l = u.GetSpellWithName("不死「火の鳥　-鳳翼天翔-」").Level;
                Hinotori h = new Hinotori();

                u.GetSpellWithName("不死「火の鳥　-鳳翼天翔-」").ResetCoolTime(h.CoolTimes[l]);
                u.GetSpellWithName("蓬莱「凱風快晴 －フジヤマヴォルケイノ－」").ResetCoolTime(12*Def.FPS);

                var offset = new Vector3D(2, 2, 1);
                var size = 9 * 2 * 2;
                var newEffect = u.Faction.World.EffectManager.CreateEffect(typeof(SaitanReviveEffect).FullName, u.Pos + offset);
                newEffect.SetScale(new Vector3D(size, size, size));
                u.AbilityManager.AppendAbility(new Ability.EffectFollowContinuousAbility(newEffect, (int)(3 * Def.FPS), this.Name + "ReviveEffect", offset));

                //var newEffect2 = u.Faction.World.EffectManager.CreateEffect(typeof(SaitanEffect).FullName, u.Faction, u.Pos + offset);
                //size = 6 * 2 * 2;
                //newEffect2.SetScale(new Vector3D(size, size, size));
                //u.AbilityManager.AppendAbility(new Ability.EffectFollowContinuousAbility(newEffect2, (int)(3 * Def.FPS), this.Name + "ReviveEffect2", offset));

                if (areaEffect != null)
                {
                    areaEffect.Stop();
                    areaEffect = null;
                }

                u.AbilityManager.RemoveAbility(this.Name + "_Revive");

                u.HP = u.MaxHP;
            }
        }

        public void OnVanishUnit(thrts.IUnit selfUnit)
        {
            if (areaEffect != null)
            {
                areaEffect.Stop();
                areaEffect = null;
            }
        }
	}
}
