﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

using LotusCraft.Effect.Red;
using LotusCraft.Bullet.Red;
using LotusCraft.Ability.Red;
using LotusCraft.Ability;

namespace LotusCraft.Spell.Red
{
	class SuwakoSkill:thrts.SpellParameter<thrts.IUnit>
	{
		const int interval = 10;
		public SuwakoSkill()
		{
			DefaultLevel = 1;
			MaxLevel = 1;
			IsPassive = true;
			Name = "土着神「手長足長さま」";
			string basePath = "Red/Spell/SuwakoSkill/";

			CoolTimes = new int[2];
			CoolTimes[0] = 4*30;
			CoolTimes[1] = 4*30;

			Description = "対空攻撃の射程と攻撃力が上昇する。";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"射程+2、攻撃力+2",
			};

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._0;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャストの生成
			SpellAutoCasts = new AutoCastParameter<IUnit>[]
			{
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,1,null),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,1,(unit)=>Spelling(unit,1),true),
			};
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",1),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}

		public bool Spelling(thrts.IUnit selfUnit, int level)
		{
			if (!selfUnit.Exists ())
				return false;
			
			if (selfUnit.AbilityManager.ContainsAbility (SuwakoSkillAbility.AbilityName)) {
				selfUnit.AbilityManager.ExtendLifetimeWithName(interval,SuwakoSkillAbility.AbilityName,interval*2);
			}
			else
			{
				selfUnit.AbilityManager.AppendAbility(new SuwakoSkillAbility(interval*2,2,2*Def.MapTipLengthOnField));
			}
			return true;
		}
		public IEnumerable<object> PrivilegeModeSpelling (thrts.IUnit selfUnit, int level)
		{
			yield return false;
		}

		class SuwakoSkillAbility : thrts.AbilityTemplate
		{
			public int IncAirAtk;
			public float IncAirRange;
			public const string AbilityName = "土着神「手長足長さま」";
			public SuwakoSkillAbility(int duration,int incAirAtk,float incAirRange)
			{
				DurationTime = duration;
				Name = AbilityName;

				IncAirAtk = incAirAtk;
				IncAirRange = incAirRange;
			}
			public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
			{
				switch (order)
				{
				case thrts.AbilityOrder.ConstDecParam:
					break;
				case thrts.AbilityOrder.RateDecParam:
					break;
				case thrts.AbilityOrder.ConstIncParam:
					var bulletParam = unit.GetModifiedBulletParameter(typeof(SuwakoAirBullet).FullName);
					if(null != bulletParam)
					{
						bulletParam.MaxRange += IncAirRange;
						bulletParam.Attack += IncAirAtk;
					}
					break;
				case thrts.AbilityOrder.RateIncParam:
					break;
				case AbilityOrder.OtherExecs:
					break;
				default:
					break;
				}
				
				return base.ExecUnitAbility(unit,order);
			}
			
		}

	}
}
