﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LotusCraft.Spell.FactionName
{
	class SpellToArround:thrts.SpellParameter<thrts.IUnit>
	{
		public SpellToArround()
		{
			DefaultLevel = 0;
			MaxLevel = 3;
			Name = "SpellName";
			string basePath = "FactionName/Spell/SpellToArround/";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"Lv1効果",
				"Lv2効果",
				"Lv3効果",
			};

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._1;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャストの生成
			SpellAutoCasts = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,60,null),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,60,this.AutoCastAction_lv1),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,60,this.AutoCastAction_lv2),
				new LotusCraft.AutoCast.SpellAutoCast<thrts.IUnit>(this,60,this.AutoCastAction_lv3),
			};
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",(unit)=>PrivilegeModeSpelling(unit,1)),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "2",(unit)=>PrivilegeModeSpelling(unit,2)),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "3",(unit)=>PrivilegeModeSpelling(unit,3)),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}
		public IEnumerable<object> PrivilegeModeSpelling(thrts.IUnit selfUnit, int level)
		{
			yield return true;
		}
		public bool Spelling (thrts.IUnit selfUnit, int level)
		{
			return true;
		}
		public bool AutoCastAction_lv1(thrts.IUnit unit)
		{
			PrivilegeModeSpelling(unit, 1);
			return true;
		}
		public bool AutoCastAction_lv2(thrts.IUnit unit)
		{
			PrivilegeModeSpelling(unit, 2);
			return true;
		}
		public bool AutoCastAction_lv3(thrts.IUnit unit)
		{
			PrivilegeModeSpelling(unit, 3);
			return true;
		}
	}
}
