﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Ability.White;
using LotusCraft.Ability;
using LotusCraft.Effect.White;
using LotusCraft.Bullet.White;

// 1203 damage adjasted

namespace LotusCraft.Spell.White
{
	class Oomedama:thrts.SpellParameter<thrts.IUnit>
	{
		float angle = 0;
		const int duration = 21*Def.FPS;
		public Oomedama()
		{
			DefaultLevel = 0;
			MaxLevel = 1;
			RequireLevels[0] = 6;
			Name = "忿怒「天変大目玉焼き」";
			Description = "自分の上に雲山が出現し、周囲を焼き払う。";
			string basePath = "White/Spell/Oomedama/";
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				"3秒毎に 80ダメージx4。"+duration/(float)Def.FPS+"秒間",
			};

			CoolTimes = new int[MaxLevel + 1];
			CoolTimes[0] = 0;
			CoolTimes[1] = 120 * Def.FPS;

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._3;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャストの生成
			SpellAutoCasts = null;
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0", 0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",PrivilegeModeSpelling, 1),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}
		public IEnumerable<object> PrivilegeModeSpelling(thrts.IUnit selfUnit, int level)
		{
			// スペルが現在使用可能か判断
			var spell = selfUnit.GetSpellWithName (Name);
			if (null == spell || !spell.CanExec) {
				yield return false;
				yield break;
			}
			spell.ResetCoolTime();

			selfUnit.DoFindEnemyAutomatically = false;

			selfUnit.ShowCutin();

			// 雲山出現
			selfUnit.AbilityManager.AppendAbility(new OomedamaAbility(duration));

			for (int i = 0; i < 2 * Def.FPS; i++) yield return true;

			selfUnit.DoFindEnemyAutomatically = true;
			
			yield return true;
		}
	}

	class OomedamaAbility : thrts.AbilityTemplate
	{
		IEffect effect = null;
		IBullet bullet = null;

		int counter = 0;
		const int interval = 3*Def.FPS;
		const int moveTime = Def.FPS/2;
		float[] angles = new float[5];
		float angle = 0;
		float nextAngle = 0;

		const string AbilityName =  "忿怒「天変大目玉焼き」";
		public OomedamaAbility(int duration)
		{
			this.Name = AbilityName;

			this.DurationTime = duration;

			counter = interval;
			angles = new float[5];
			angles[0] = 180;
			angles[1] = 225;
			angles[2] = 270;
			angles[3] = 247.5f;
			angles[4] = 202.5f;
		}
		public override bool ExecUnitAbility(thrts.IUnit unit, thrts.AbilityOrder order)
		{
			switch (order)
			{
				case thrts.AbilityOrder.ConstDecParam:
					unit.IsForbiddenAttacking = true;
					break;
				case thrts.AbilityOrder.RateDecParam:
					break;
				case thrts.AbilityOrder.ConstIncParam:
					break;
				case thrts.AbilityOrder.RateIncParam:
					break;
				case AbilityOrder.OtherExecs:
					if(++counter >= interval)
					{
						counter = 0;
						
						if(nextAngle != 0)
						{
							angle = nextAngle;
							nextAngle = angles[unit.Faction.World.NextRand(angles.Length)];
						}
						else
						{
							nextAngle = angles[unit.Faction.World.NextRand(angles.Length)];
							angle = nextAngle;
						}
						
						if(null != bullet)
						{
							if(bullet.Exists)
								bullet.Vanish();
							
							bullet = null;
						}
						
						if(effect != null)
							effect.Stop();
						
						effect = unit.Faction.World.EffectManager.CreateEffect(typeof(Effect.White.UnzanEffect).FullName, unit.Pos);
						effect.SetScale(new Vector3D(15.0f,15.0f,15.0f));
						effect.SetRotation(new Vector3D(0, 0, angle));
						unit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.Shuiin01).FullName, unit.Pos);
						
					}
					if(counter <= moveTime)
					{
						unit.Speed=0;
						var a = angle + (nextAngle - angle)*(counter/(float)moveTime);
						effect.SetRotation(new Vector3D(0, 0, a));
					}else if(bullet == null)
					{
						unit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.Burst).FullName, unit.Pos);
						bullet = unit.CreateBullet(typeof(Bullet.White.OomedamaBullet).FullName,unit.Pos,unit.Pos);
						// エフェクトが-90度( angle = 0 で x=0 の線上に乗る)だけズレているので補正
						bullet.Rotation = nextAngle;
						
						bullet.Updating += (IBullet obj) => 
						{
							// デバッグ
							/*
							{
								float dis = (obj.Parameter.LengthX / 2) - obj.Parameter.RotateCenterX;
								var disx = (float)(Math.Cos(-1*(obj.Rotation)*Math.PI/180.0) ) * dis;
								var disy = (float)Math.Sin(-1*(obj.Rotation)*Math.PI/180.0 ) * dis;
								unit.Faction.World.DrawDebugRectangle(new Vector3D(obj.Position.X + disx, obj.Position.Y + disy, obj.Position.Z),
																   obj.Parameter.LengthX, obj.Parameter.LengthY, obj.Rotation,
																   new Color(1.0f, 1.0f, 1.0f, 1.0f));
								unit.Faction.World.DrawDebugCircle(new Circle2D(obj.Parameter.LengthY/2.0f,new Vector2D(obj.Position.X,obj.Position.Y)),obj.Position.Z+2,new Color(1.0f, 1.0f, 1.0f, 1.0f));
							}
							//*/
						};
					}
//					if (effect != null)
//						effect.SetPosition(unit.Pos + new Vector3D(2, 2, 1));
					break;
				default:
					break;
			}

			return true;
		}
		public override bool OnVanish(IUnit unit)
		{
			unit.IsForbiddenAttacking = false;
			return base.OnVanish(unit);
		}
	}
}

namespace LotusCraft.Bullet.White
{
	public class OomedamaBullet : thrts.BulletParameter
	{
		public OomedamaBullet()
		{
			Init();
		}
		protected void Init()
		{
			Type = BulletType.LongRange;
			HitType = BulletHitType.Multi;
			this.Attack = 80;
			Again = Def.FPS/2;
			Speed = 0.0f * BasisSpeed;
			Gravity = 0f;
			MaxRange = Def.MapTipLengthOnField;

			LengthX = 10*Def.MapTipLengthOnField;
			LengthY = 4*Def.MapTipLengthOnField;
			RotateCenterX =LengthX/2;
			UseRot = true;

			CollisionType = BulletCollisionType.Square;

			AttackDelay = 0;
			AttackRigor = 0;
			Duration = (int)(1.5f * Def.FPS) + 1;
			AttackSpeed = (int)(3.0f * Def.FPS);
		}
		protected static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			var faction = bullet.Generator.Faction;
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.ColumnRed);
			faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitOther).FullName, target.Pos);

			string num = bullet.Parameter.Attack.ToString();
			
			if (num != "")
			{
				var u = target as IUnit;
				var b = target as IBuilding;
				if (u != null)
				{
					if (!u.AbilityManager.ContainsAbility("大目玉ヒット" + num))
					{
						u.AbilityManager.AppendAbility(new EffectContinuousAbility(null, 30, "大目玉ヒット" + num));
					}
				}
				if (b != null)
				{
					if (!b.AbilityManager.ContainsAbility("大目玉ヒット" + num))
					{
						b.AbilityManager.AppendAbility(new EffectContinuousAbility(null, 30, "大目玉ヒット" + num));
					}
				}
			}
		}
	}
}

#endif