﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Ability.White;
using LotusCraft.Effect.White;

// 1203 damage adjasted

namespace LotusCraft.Spell.White
{
	class Tettui:thrts.SpellParameter<thrts.IUnit>
	{
		Vector3D targetPos;
		int duration = 1;
		TettuiAbility[] spellAbilities = new[]
		{
			new TettuiAbility(0),
			new TettuiAbility(1),
			new TettuiAbility(2),
			new TettuiAbility(3),
		};

		int[] damages;
		public Tettui()
		{
			DefaultLevel = 0;
			MaxLevel = 3;
			Name = "拳骨「天空鉄槌落とし」";
			Description = "指定地点の周囲にダメージと、移動速度減少を与える。";
			string basePath = "White/Spell/Tettui/";

			damages = new int[MaxLevel+1];
			damages[0] = 0;
			damages[1] = 30;
			damages[2] = 50;
			damages[3] = 70;
			/// レベル別の能力説明
			EffectDescriptions = new string[]
			{
				damages[1]+"ダメージ/5%",
				damages[2]+"ダメージ/10%",
				damages[3]+"ダメージ/15%",
			};

			CoolTimes = new int[MaxLevel + 1];
			CoolTimes[0] = 0;
			CoolTimes[1] = 12 * Def.FPS;
			CoolTimes[2] = 12 * Def.FPS;
			CoolTimes[3] = 12 * Def.FPS;

			MaxRanges = new float[MaxLevel + 1];
			MaxRanges[0] = 0;
			MaxRanges[1] = 7 * Def.MapTipLengthOnField;
			MaxRanges[2] = 7 * Def.MapTipLengthOnField;
			MaxRanges[3] = 7 * Def.MapTipLengthOnField;

			/// ボタンの位置
			ButtonPosX = thrts.ButtonPosition._1;
			ButtonPosY = thrts.ButtonPosition._2;
			LvUpButtonPosX = ButtonPosX;
			LvUpButtonPosY = thrts.ButtonPosition._1;

			/// オートキャストの生成
			SpellAutoCasts = null;
			/// スペルのボタンを生成
			SpellButtons = new thrts.ButtonParameter<thrts.IUnit>[]
			{
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "0",0),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "1",PrivilegeModeSpelling,1),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "2",PrivilegeModeSpelling,2),
				new LotusCraft.Button.SpellButton<thrts.IUnit>(this,basePath + "3",PrivilegeModeSpelling,3),
			};
			LevelUpSpellButton = new LotusCraft.Button.LevelUpSpellButton(this, basePath + "LvUp");
		}
		public IEnumerable<object> PrivilegeModeSpelling(thrts.IUnit selfUnit, Vector2D targetPosition, int level)
		{
			// スペルが現在使用可能か判断
			var spell = selfUnit.GetSpellWithName (Name);
			if (null == spell || !spell.CanExec) {
				yield return false;
				yield break;
			}
			// reset cooltime
			spell.ResetCoolTime();

			selfUnit.DoFindEnemyAutomatically = false;

			float affectRadius = 0;
			switch (level)
			{
				case 1:
					affectRadius = 2f;
					break;
				case 2:
					affectRadius = 2f;
					break;
				case 3:
					affectRadius = 2f;
					break;
				default:
					affectRadius = 0;
					break;
			}

			targetPos = selfUnit.Faction.World.GetGroundAtPos(targetPosition);

			float v = 2.4f;
			float z = 170;
			float attackz = z + targetPos.Z;
			int time = 0;

			/// get call Effect;
			var offset = new Vector3D(2, 2, z);
			var effect = selfUnit.Faction.World.EffectManager.CreateEffect(typeof(TenkyuAreaEffect).FullName, targetPos + offset);
			effect.SetScale(new Vector3D(2 * affectRadius * 2, 2 * affectRadius * 2, 2 * affectRadius * 2));

			while (z > 1)
			{
				if (v < 3.0f) v -= 0.6f;
				if (v <= 0 || v >= 2.5f) v += 4f;
				z -= v;
				if (z < 1) z = 1;
				offset = new Vector3D(2, 2, z);
				effect.SetPosition(targetPos + offset);
				attackz = z + targetPos.Z;
				time++;

				if (time % 2 >= 1)
					selfUnit.AbilityManager.AppendAbility(new Ability.SpellContinuousAbility((unit) => Spelling(unit, level, ref attackz), null, offset, 2, this.Name + "Areadamage", 1));

				yield return true;
			}
			selfUnit.AbilityManager.AppendAbility(new Ability.SpellContinuousAbility((unit) => Spelling(unit, level, ref attackz), null, offset, 2, this.Name + "Areadamage", 1));
			selfUnit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitDageki).FullName, targetPos);

			for (int i = 0; i < 15; i++) yield return true;

			if (effect != null)
			{
				effect.Stop();
				effect = null;
			}

			selfUnit.DoFindEnemyAutomatically = true;
			yield return true;
		}

		public bool Spelling(thrts.IUnit selfUnit, int level,ref float z)
		{
			int damage = damages[level];
			float affectRadius = 0;
			switch (level)
			{
				case 1:
					affectRadius = 2f;
					break;
				case 2:
					affectRadius = 2f;
					break;
				case 3:
					affectRadius = 2f;
					break;
				default:
					damage = 0;
					break;
			}

			/// 地点(x,y)を中心にユニットを選択
			var selfFaction = selfUnit.Faction;
			var world = selfFaction.World;
			var targets = selfFaction.World.GetObjectFromCircle(new Circle2D(affectRadius * 32, new Vector2D(targetPos.X, targetPos.Y))).Where(_ => _ != null);
			foreach (IUnit u in targets.OfType<IUnit>().Where(_ => !world.IsSameTeam(selfFaction, _.Faction)))
			{
				if (!u.AbilityManager.ContainsAbility(spellAbilities[level].Name) && u.Pos.Z < z + 40 && u.Pos.Z > z - 20)
				{
					IEffect effect = null;
					Vector3D offset = new Vector3D(2.0f, 2.0f, 1.0f);
					if (u != selfUnit)
					{
						/// エフェクトを描画
						var faction = u.Faction;
						effect = world.EffectManager.CreateEffect(typeof(TenkyuEffect).FullName, u.Pos + offset);
						effect.SetScale(new Vector3D(2, 2, 2));
						
					}
					if (u.AbilityManager.AppendAbility(new TettuiAbility(level, effect)))
					{
						u.BeDamaged(selfUnit, damage, AttackBonusSet.None);
						selfFaction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitLongRangeAttack).FullName, u.Pos);

						if (u.HP <= 0)
						{
							effect.Stop();
							effect = null;
						}

                        var hiteffect = world.EffectManager.CreateEffect(typeof(Effect.Common.HitRemoteWhiteEffect).FullName, u.Pos + offset);
						var scale = new Vector3D(8, 8, 8);
						hiteffect.SetScale(scale);
					}
					else if (effect != null)
					{
						effect.Stop();
						effect = null;
					}
				}
			}

			return true;
		}
	}
}

#endif