﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using thrts;

namespace LotusCraft.Story
{
	public class Story03 : thrts.Mission
	{
		public override string[] GetSelectableFactions()
		{
			return new string[] {
				typeof( Faction.White ).FullName
			};
		}

		public override string[] GetEnableFactions()
		{
			return new string[]	{
				typeof( Faction.White ).FullName,
				typeof( Faction.Black ).FullName
			};
		}

		public override string[] GetSelectableMaps()
		{
			return new string[] {
				"LotusCraft/Story/Story03.map",
			};
		}

		public Story03()
			: base()
		{
			Name = "ストーリー03";
			Description = "プロローグ3話のマップ";
			Mode = thrts.MissionMode.Story;

			this.TheNumberOfMaximumSelectablePlayersInTeam = 0;
			this.TheNumberOfSelectableTeams = 0;
		}

		int[] Reimu = null;
		int[] Marisa = null;
		int[] Ichirin = null;
		int[] Hijiri = null;
		int[] Miko = null;
		int[] Seiga = null;
		int[] Rin = null;
		int[] Yukari = null;
        int Back1 = 0;
		Area[] areas = null;
		IBuilding blackHome = null;
		IBuilding blackHigh = null;
		IBuilding whiteHome = null;
		IBuilding whiteHigh = null;
		IBuilding Houtou = null;

		int enemySpan = 1550;

		/// <summary>
		/// 神子のスペルを使用されたかどうか
		/// </summary>
		bool executedMikoSpall = false;

		public override void OnInitialize(thrts.IWorld world)
		{
			world.Factions[1].PlayerName = "黒勢力";

			// 最初から負けないように
			world.Factions[0].DoesNotLose = true;
			world.Factions[1].DoesNotLose = true;


			// 初期資源を配布
			world.Factions[0].IncResource(0, 200);
			world.Factions[0].IncResource(1, 200);

			// 難易度調整
			if (world.StoryUtilities.GetDifficulty() == 0)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low02).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low03).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Orin).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Oku).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Satori).FullName).HP /= 2;

				enemySpan = 2400;
			}
			else if (world.StoryUtilities.GetDifficulty() == 0)
			{
				enemySpan = 2000;
			}
			else if (world.StoryUtilities.GetDifficulty() == 2)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low02).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low02).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low03).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low03).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Satori).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Satori).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Oku).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Oku).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Orin).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Orin).FullName).HP * 0.2);

				enemySpan = 1300;
			}

			// 本拠の位置を初期視点にする
			var home = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.White.HomeBase)).First();
			var basePos = home.Pos;
			// 初期視点位置
			world.Factions[0].Parameter.DefaultScreenPosition
				= new Point2D((int)basePos.X, (int)basePos.Y);

			var homeparam = world.Factions[0].GetBuildingParameter(typeof(Building.White.HomeBase).FullName);

			// ボタン仕様禁止
			var ui = world.StoryUI;
			ui.HideButton(home, ButtonPosition._2, ButtonPosition._1);
			ui.HideButton(home, ButtonPosition._2, ButtonPosition._2);

			
			//homeparam.ButtonParams

			base.OnInitialize(world);
		}

		public override System.Collections.IEnumerable Update(IWorld world)
		{
			var ui = world.StoryUI;
			areas = new[]{
				world.AllPurposeArea.First(_ => _.Name == "野良資源")
			};
			blackHome = GetBuildings<Building.Black.HomeBase>(world).First();
			blackHigh = GetBuildings<Building.Black.Factory>(world).First();
			whiteHome = GetBuildings<Building.White.HomeBase>(world).First();
			whiteHigh = GetBuildings<Building.White.Factory>(world).First();
			Houtou = GetBuildings<Building.White.Houtou>(world).First();

			Reimu = LoadTachies(ui, "LotusCraft/Image/Tachie/Reimu_N", "LotusCraft/Image/Tachie/Reimu_S", "LotusCraft/Image/Tachie/Reimu_W");
			Marisa = LoadTachies(ui, "LotusCraft/Image/Tachie/Marisa_N", "LotusCraft/Image/Tachie/Marisa_S", "LotusCraft/Image/Tachie/Marisa_W");
			Hijiri = LoadTachies(ui, "LotusCraft/Image/Tachie/Hijiri_N", "LotusCraft/Image/Tachie/Hijiri_S", "LotusCraft/Image/Tachie/Hijiri_W");
			Ichirin = LoadTachies(ui, "LotusCraft/Image/Tachie/Ichirin_N", "LotusCraft/Image/Tachie/Ichirin_S", "LotusCraft/Image/Tachie/Ichirin_W");
			Miko = LoadTachies(ui, "LotusCraft/Image/Tachie/Miko_N", "LotusCraft/Image/Tachie/Miko_S", "LotusCraft/Image/Tachie/Miko_W");
			Seiga = LoadTachies(ui, "LotusCraft/Image/Tachie/Seiga_N", "LotusCraft/Image/Tachie/Seiga_S", "LotusCraft/Image/Tachie/Seiga_W");
			Rin = LoadTachies(ui, "LotusCraft/Image/Tachie/Rin_N", "LotusCraft/Image/Tachie/Rin_S", "LotusCraft/Image/Tachie/Rin_W");
			Yukari = LoadTachies(ui, "LotusCraft/Image/Tachie/Yukari_N", "LotusCraft/Image/Tachie/Yukari_S", "LotusCraft/Image/Tachie/Yukari_W");
            Back1 = ui.LoadImage("LotusCraft/Image/Back/Black");

			var mikoUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Black.Unique.Miko)).First();
			mikoUnit.AddExperience(3000);
			var seigaUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Black.Unique.Seiga)).First();
			seigaUnit.AddExperience(2000);
			var rinUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Black.Unique.Rin)).First();
			rinUnit.AddExperience(1200);

			// 難易度調整
			if (world.StoryUtilities.GetDifficulty() == 2)
			{
				mikoUnit.AddExperience(2000);
				seigaUnit.AddExperience(2000);
				rinUnit.AddExperience(2000);
			}

			world.ChangeBGM(BGMList.Boushuen_Story1);

			//*
			foreach (var item in Talk会話冒頭(world))
			{
				yield return null;
			}
			//*/

			world.ChangeBGM(BGMList.Battle_Senkai);

			for (int i = 0; i < 100; i++)
			{
				yield return null;
			}

			var rect = areas[0] as AreaRectangle;
			world.Factions[0].GetSite(500, (int)(Math.Min(rect.Start.X, rect.End.X) * thrts.Def.MapTipLengthOnField), (int)((int)Math.Min(rect.Start.Y, rect.End.Y) * thrts.Def.MapTipLengthOnField), 6000);
			world.ForceToUpdateVision();
			world.Factions[0].MoveScreenPosition(new Vector2D((int)((int)Math.Min(rect.Start.X, rect.End.X) * thrts.Def.MapTipLengthOnField), (int)((int)Math.Min(rect.Start.Y, rect.End.Y) * thrts.Def.MapTipLengthOnField)));

			foreach (var item in Talk野良資源説明(world))
			{
				yield return null;
			}

			world.Factions[0].MoveScreenPosition(new Vector2D((int)whiteHome.Pos.X, (int)whiteHome.Pos.Y));

			for (int i = 0; i < 1800*2; i++)
			{
				if (world.StoryUtilities.IsSelected(whiteHigh) || world.StoryUtilities.IsSelected(Houtou)) {
					break;
				}
				yield return null;
			}

			foreach (var item in Talk星召喚(world))
			{
				yield return null;
			}

			ui.ShowConditionText("目的：敵拠点の撃破");

			int c = 0;
			
			while (true)
			{
				if (!blackHome.Exists())
				{
					foreach (var item2 in Talk勝利(world))
					{
						yield return null;
					}
					world.Factions[1].DoesNotLose = false;
					world.Factions[1].Lose();
                    world.StoryUtilities.SetDataToSaveData("LotusCraft.Prologue.03", "Clear");
					
					if (world.StoryUtilities.GetDifficulty() == 0)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Prologue.03.Easy", "Clear");
					}
					else if (world.StoryUtilities.GetDifficulty() == 1)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Prologue.03.Normal", "Clear");
					}
					else if (world.StoryUtilities.GetDifficulty() == 2)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Prologue.03.Hard", "Clear");
					}
					world.ChangeBGM(BGMList.Boushuen_Win);

					break;
				}
				if (!whiteHome.Exists())
				{
					foreach (var item2 in Talk敗北(world))
					{
						yield return null;
					}
					world.Factions[0].DoesNotLose = false;
					world.Factions[0].Lose();
					world.ChangeBGM(BGMList.Boushuen_Lose);

					break;
				}

				// スペル発動
				if (mikoUnit.Exists() && !executedMikoSpall && world.StoryUtilities.GetDifficulty() > 1)
				{
					TryCallMikoSpell(world, mikoUnit);
				}

				// ざこ
				if (c % enemySpan == 0)
				{
					if (c >= enemySpan * 5)
					{
						if (c == enemySpan * 5) {
							if (blackHigh.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, blackHigh);
								uniqueIDs.Add(l1.UniqueID);
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, blackHigh);
								uniqueIDs.Add(l2.UniqueID);
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, blackHigh);
								uniqueIDs.Add(l3.UniqueID);
								world.UnitManager.AttackMove(uniqueIDs, whiteHome, false);
							}
						}
						else if (c == enemySpan * 6)
						{
							if (blackHigh.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, blackHigh);
								uniqueIDs.Add(l1.UniqueID);
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, blackHigh);
								uniqueIDs.Add(l2.UniqueID);
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, blackHigh);
								uniqueIDs.Add(l3.UniqueID);
								var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, blackHigh);
								uniqueIDs.Add(l4.UniqueID);
								world.UnitManager.AttackMove(uniqueIDs, whiteHome, false);
							}
						}
						else if (c == enemySpan * 15 || c == enemySpan * 20)
						{
							if (blackHigh.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Oku).FullName, blackHigh);
								uniqueIDs.Add(l1.UniqueID);
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Orin).FullName, blackHigh);
								uniqueIDs.Add(l2.UniqueID);
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Satori).FullName, blackHigh);
								uniqueIDs.Add(l3.UniqueID);
								world.UnitManager.AttackMove(uniqueIDs, whiteHome, false);
							}
						}
						else
						{
							if (blackHigh.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								if (world.StoryUtilities.GetDifficulty() == 2) {
									var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Orin).FullName, blackHigh);
									uniqueIDs.Add(l1.UniqueID);
								}
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, blackHigh);
								uniqueIDs.Add(l2.UniqueID);
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, blackHigh);
								uniqueIDs.Add(l3.UniqueID);
								world.UnitManager.AttackMove(uniqueIDs, whiteHome, false);
							}

						}
					}
				}

				c++;
				yield return null;
			}
			
			yield return base.Update(world);
		}

		private void TryCallMikoSpell(IWorld world, IUnit mikoUnit)
		{
			if (executedMikoSpall) return;

			var units = world.UnitManager.GetUnits(_ => _.Faction == world.Factions[0]);
			foreach (var u in units)
			{
				var radius = 8 * thrts.Def.MapTipLengthOnField;

				if (radius * radius > (u.Pos.X - blackHome.Pos.X) * (u.Pos.X - blackHome.Pos.X) + (u.Pos.Y - blackHome.Pos.Y) * (u.Pos.Y - blackHome.Pos.Y))
				{
					var targetPos = u.Pos;
					var spell = world.Factions[1].GetUnitSpellButtonParameter(mikoUnit.Parameter.GetType().FullName, new SpellButtonKey("「星降る神霊廟」", 1));
					spell.NormalButtonEvent(mikoUnit, false);
					executedMikoSpall = true;
				}
			}
		}

		#region Story
		private System.Collections.IEnumerable Talk会話冒頭(IWorld world)
		{
			var ui = world.StoryUI;

			#region Talk1
			
			ui.PauseGame();
			ui.Show();
            ui.ShowImage(Back1, StoryUIImagePosition.Back2, false, false, false);
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【霊夢】\n妖怪寺にスカウトに行くはずが");
			ui.ShowImage(Marisa[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【魔理沙】\n人里を出たそうそうに出くわしたと来たもんだ");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Ichirin[0],StoryUIImagePosition.Left,true,false);
			ui.ShowImage(Hijiri[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【聖】\nこれは珍しい、その様子ですと命蓮寺に用事でも？");
			ui.ShowImage(Marisa[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【魔理沙】\n二人セットでってことはなかなかないからな\nついでに寺じゃなくてその中身に入り用だ");
			ui.ShowImage(Ichirin[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【一輪】\n姐さん");
			ui.ShowImage(Hijiri[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【聖】\nええ。申し訳ないのですが、これから私たちは出向くところがありまして");
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【霊夢】\n大丈夫よ。すごく端的に言えば紫からあんたたちと同盟を結ぼうと思って");
			ui.ShowImage(Hijiri[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【聖】\n同盟、ですか");
			ui.ShowImage(Marisa[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【魔理沙】\nまぁ別件で出向くなら知らないが、どうもこれからひと波乱ありそうな顔してるぜ？");
			ui.ShowImage(Hijiri[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【聖】\n実は豊聡耳神子に、果し合いを申し込まれまして……。これから出向くところなのです");
			ui.ShowImage(Marisa[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【魔理沙】\nまぁこの機会に雌雄を決しようってところか。自信はあるのか？");
			ui.ShowImage(Hijiri[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【聖】\nできれば穏便に済ませたいのですが");
			ui.ShowText("【聖】\nスペルカードルールではないルールで、複数人を代表に立ててとのことだったんですが…");
            ui.ShowText("【聖】\n星に行かせるわけにもいかず、村紗もやりすぎてしまうしで、私と一輪しかこっちからは出せないんですよね");
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【霊夢】\nだったらちょうどいいじゃない。渡りに船ってことで私たちも連れて行きなさいよ");
			ui.ShowImage(Reimu[2],StoryUIImagePosition.Left,false,false);
			ui.ShowImage(Marisa[0],StoryUIImagePosition.Front,true,false);
			ui.ShowText("【魔理沙】\n私たちが居れば百一人力だぜ。私が一で霊夢が百だ。楽をさせてもらうぜ");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowText("【聖】\nでも先方がどう言うか……");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Miko[1],StoryUIImagePosition.Front,true,false);
			ui.ShowText("【神子】\n私たちは構いませんよ");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\n遅いのでこちらから出向かせて貰いました");
			ui.ShowImage(Seiga[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【青娥】\nこんにちは");
			ui.ShowImage(Hijiri[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【聖】\n……！？");
			ui.ShowImage(Miko[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nそんなに身構えなくても結構ですよ。それに果し合いではなく、単なる演習へのお誘いですし");
			ui.ShowImage(Hijiri[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【聖】\n演習？");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nええ。この提案にはきっと裏がある。面白半分で制定したのかもしれませんが、幻想郷の賢者を名乗る八雲紫のことです。\nきっと深い意図が隠されているに違いありません");
			ui.ShowText("【神子】\n貴方たちと手を組むことは布都や屠自古の手前できませんが、このルールに慣れておく必要はあるように感じます");
			ui.ShowImage(Reimu[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【霊夢】\n紫の奴のことだから、案外暇潰し以上の理由なんてないんじゃないの？");
			ui.ShowImage(Marisa[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【魔理沙】\n私もそんな気がするぜ");
			ui.ShowImage(Ichirin[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【一輪】\n姐さん、私はこの話を受けてもいいと思うけど。参戦すると決めた以上、できれば勝っていきたいし、私はですけど");
			ui.ShowImage(Hijiri[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【聖】\nそう、ですね……。いいでしょう。その話、受けて立ちます");
			ui.ShowImage(Seiga[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【青娥】\nそれなら私たちの戦場へとご案内～");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1,StoryUIImagePosition.Back,true);
			ui.ShowImage(-1,StoryUIImagePosition.Back2,true);
			ui.ShowImage(Miko[1],StoryUIImagePosition.Front,true,false);
			ui.ShowText("【神子】\nルールはそれぞれの拠点を攻略することを目標とする\nそっちに二人入ったようだから私も一人助っ人を呼ばせてもらうよ");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Hijiri[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【聖】\n霊夢さん魔理沙さん、お願いしますね");
			ui.ShowImage(Ichirin[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【一輪】\nできればここは私たちだけで切り抜けたいけど");
			ui.ShowImage(Marisa[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【魔理沙】\n水臭いぜ。これから同じ釜の飯を食うんだからな");
			ui.ShowImage(Ichirin[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【一輪】\n確定事項なの？");
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【霊夢】\n細かいことは気にしない。今はあいつらを片付けることが大事でしょ");
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\n…………");
			ui.ShowImage(Miko[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\nあのー……切り抜けるとか片付けるとか、演習のお誘いなんですけど？");
			ui.ShowImage(Hijiri[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【聖】\n……すみません");
			ui.ShowImage(Seiga[1],StoryUIImagePosition.Front,true,false);
			ui.ShowText("【青娥】\nククク、勇者たちよ。魔王神子を倒せるかな？");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Miko[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n乗らないで！");
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);

			var talkEnd = ui.ShowText(""); 
			while (!ui.IsCompleted(talkEnd))
				yield return null;
			
			ui.Hide();
			ui.ResumeGame();
			#endregion


			yield return null;
		}

		private System.Collections.IEnumerable Talk野良資源説明(IWorld world)
		{
			var ui = world.StoryUI;

			#region Talk2,3
			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Marisa[0], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【魔理沙】\nところどころに酒や霊石があるな、あれも有効活用するか");
			ui.ShowImage(Hijiri[0], StoryUIImagePosition.Right, true, false);
			ui.ShowText("【聖】\nそうですね\nただ今は資源が足りないですから後で建てに行きましょう");
			ui.ShowImage(Marisa[2], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【魔理沙】\nんぅ？酒回収所とかなんてそんな酒を消費しなかったよな？\nなんでいますぐ行かないんだ？");
			ui.ShowImage(Hijiri[2], StoryUIImagePosition.Right, false, false);
			ui.ShowText("【聖】\nええとですね、資源を集めるのは近くに拠点も無いといけないんですよ");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true);
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【紫】\n彼女の言うとおり、資源採取は採取用の建築物を建てればいいわけではないわ");
			//ui.ShowText("(拠点がある場合とない場合の比較画像があれば表示)");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【紫】\n拠点を近くに置かないとこのふたつの建物は仕事をしてくれないの、ここを気をつけないといけないわね");
			ui.ShowText("【紫】\n採取が行われているかは、エフェクトが出ているかどうかで判断できるわ");
			ui.ShowImage(-1, StoryUIImagePosition.Left, true);
			var talkEnd2 = ui.ShowText(""); 
			while (!ui.IsCompleted(talkEnd2))
				yield return null;
			
			ui.Hide();
			ui.ResumeGame();
			
			#endregion


			yield return null;
		}

		private System.Collections.IEnumerable Talk星召喚(IWorld world)
		{
			
			var ui = world.StoryUI;

			#region Talk6
			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Ichirin[0], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【一輪】\n姐さん、アレもついでに出しておこうか？");
			ui.ShowImage(Hijiri[0], StoryUIImagePosition.Right, true, false);
			ui.ShowText("【聖】\nそうですね、せっかくですしお願いします");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true);
			var talkEnd0 = ui.ShowText(""); 
			while (!ui.IsCompleted(talkEnd0))
				yield return null;
			
			ui.Hide();
			ui.ResumeGame();
			#endregion

			world.Factions[0].GetSite(500, (int)whiteHigh.Pos.X, (int)whiteHigh.Pos.Y, 6000);
			world.Factions[0].MoveScreenPosition(new Vector2D((int)whiteHigh.Pos.X, (int)whiteHigh.Pos.Y));

			Utl.PutUnitAroundBuilding(world, world.Factions[0], typeof(LotusCraft.Unit.White.Toramaru).FullName, whiteHigh);
			Utl.PutUnitAroundBuilding(world, world.Factions[0], typeof(LotusCraft.Unit.White.Toramaru).FullName, whiteHigh);
			Utl.PutUnitAroundBuilding(world, world.Factions[0], typeof(LotusCraft.Unit.White.Toramaru).FullName, Houtou);
			Utl.PutUnitAroundBuilding(world, world.Factions[0], typeof(LotusCraft.Unit.White.Toramaru).FullName, Houtou);

			#region Talk6
			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Marisa[0], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【魔理沙】\nお？なんかちっこい毘沙門天様が何匹か出てきたが、こいつらはなんなんだ？");
			ui.ShowImage(Hijiri[0], StoryUIImagePosition.Right, true, false);
			ui.ShowText("【聖】\n私達を見立てた式神も用意しているとか、この子たちもなかなか強いんですよ");
			ui.ShowImage(-1, StoryUIImagePosition.Left, true);
			ui.ShowImage(-1, StoryUIImagePosition.Right, true);
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Front, true, false);
			ui.ShowText("【紫】\nそうそう、この弾幕少女を象った式は結構強力なのよ");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Front, false, false);
			ui.ShowText("【紫】\nそれじゃあ説明いくわね？");
			ui.ShowImage(-1, StoryUIImagePosition.Front, true);

			var barracks = ui.LoadImage("LotusCraft/Story/Story03/story03_barracks");
			ui.ShowImage(barracks, StoryUIImagePosition.Right, true);
			
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【紫】\n兵を生産する魔法陣にはいくつか種類があるわ、これは前回使った下級魔法陣と呼ばれるものよ");
			
			var factory = ui.LoadImage("LotusCraft/Story/Story03/story03_factory");
			ui.ShowImage(factory, StoryUIImagePosition.Right, true);
			
			ui.ShowText("【紫】\nそしてこれが上級魔法陣、こちらからは私達東方のキャラを象った式神、\nゲーム内で上級兵と呼ばれるユニットが出せるの、今回使うする白チームは彼女らが使えるわね");

			var mobs = ui.LoadImage("LotusCraft/Story/Story03/story03_mobs");
			ui.ShowImage(mobs, StoryUIImagePosition.Right, true);
			
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【紫】\nこんなかんじで最初は蓬来山輝夜しか生産できないわ");
			ui.ShowText("【紫】\n残りの3体を生産するには、それぞれ対応する建物を事前に建築しておく必要があるの\n寅丸星だったら宝塔、村紗水蜜だったら聖輦船、鈴仙だったら診療所ね。");
			ui.ShowText("【紫】\nまた、この生産を解禁するための建造物自体からもそれぞれ対応した上級兵が生産可能よ？");
			ui.ShowText("【紫】\n上級兵は基本性能が高かったり、範囲攻撃できたり、味方を回復させたりと\n下級兵には無い特別な能力を持っていたりもするわ");
			ui.ShowImage(Yukari[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【紫】\n上級兵は強力だけど\"人口\"の枠を多く使ってしまう欠点もあるわね");
			ui.ShowImage(Yukari[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【紫】\n人口…プレイヤーが同時にステージに存在させることのできるユニットの数には上限が存在するわ");
			ui.ShowText("【紫】\n人口は右上のメニューボタンの左にある枠に示されてるものよ");
			ui.ShowText("【紫】\n右上のこの数字が上限と現在の人口を表しているわ");
			ui.ShowText("【紫】\nそしてユニットの質に比例して1ユニット辺りの人口の値は増えていくの");
			ui.ShowText("【紫】\n例えば、霊夢は人口の空きが10必要で、兎下級兵(水)は1、輝夜(式神)なら6となっているわ");
			
			ui.ShowImage(Yukari[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【紫】\n人口上限の値は、建築物の多くを立てれば増やすことが可能よ\n生産をしても上限いっぱいでは魔法陣から出てこないから注意が必要ね");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【紫】\nまた、上級兵のほとんどは属性ボーナスを持っているわ");

			var zokusei = ui.LoadImage("LotusCraft/Story/Story03/story03_zokusei");
			ui.ShowImage(zokusei, StoryUIImagePosition.Right, true);

			ui.ShowImage(Yukari[0], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【紫】\nこのゲームのユニットや建築物はヒロインを除いて水、岩、鋼の三種類の属性を持っているの");

			ui.ShowImage(Yukari[1], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【紫】\nそして特定の属性にダメージボーナスを持っているユニットが多数存在するわ");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【紫】\nただ、これはストーリーモードを進める上ではそこまで重要ではないわ");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【紫】\n貴方が対人戦で上級者を目指すのなら、意識すると良い要素ね？");

			var bounus = ui.LoadImage("LotusCraft/Story/Story03/story03_bounus");
			ui.ShowImage(bounus, StoryUIImagePosition.Right, true);
			
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Left, false, false);
			ui.ShowText("【紫】\nボーナス自体はユニットを選択したときに見れるステータス画面の右下や\nユニット生産のアイコンにカーソルを合わせれば確認ができるわ");
			
			ui.ShowImage(-1, StoryUIImagePosition.Left, true);
			ui.ShowImage(-1, StoryUIImagePosition.Right, true);

			var talkEnd2 = ui.ShowText("");
			while (!ui.IsCompleted(talkEnd2))
				yield return null;
			
			ui.Hide();
			ui.ResumeGame();
			#endregion
		}

	

		private System.Collections.IEnumerable Talk勝利(IWorld world)
		{
			var ui = world.StoryUI;

			#region Talk12
			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Rin[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【燐】\nんじゃお姉さんたちまた今度ねー");
			ui.ShowImage(Miko[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\nやれやれ、負けてしまいましたか。助っ人どうもありがとうございました。例のアレについてはまたご主人のほうを通して");
			ui.ShowImage(Rin[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【燐】\n毎度ー");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowText("");
			ui.ShowImage(Hijiri[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【聖】\n今回はどうにかなりましたね");
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【霊夢】\nまぁこんなところで躓いてられないわよね");
			ui.ShowImage(Marisa[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【魔理沙】\nところで、だ。他にお前らはどいつらを囲い込んでるんだ？");
			ui.ShowImage(Miko[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【神子】\n地底の勢力と話をつけています。");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【神子】\n私たちの他の勢力に関してはわからないですが、八雲紫はどうやら天人と手を組んでいるようですね");
			ui.ShowImage(Reimu[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【霊夢】\n天人嫌いの紫が天人と、ね。不思議な組み合わせもあったものね");
			ui.ShowImage(Marisa[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【魔理沙】\nいやよいやよも好きのうちって言葉があるだろ？　あれだろ");
			ui.ShowImage(Ichirin[2], StoryUIImagePosition.Right, true, false);
			ui.ShowText("【一輪】\nそれは違うと思うけど");
			ui.ShowImage(Seiga[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【青娥】\nいずれにせよ、また当たることもあるでしょう。今回はいい収穫になったわ");
			ui.ShowImage(Miko[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【神子】\nええ。次は勝ちを譲る気はないので。そのへんはよろしくお願いしますね。それでは");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(-1,StoryUIImagePosition.Back,true);
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Marisa[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【魔理沙】\n順調に仲間も集まってきたが、これからどうするんだ？");
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【霊夢】\n魔法の森にでも行ってアリスにでも声かけましょうか。他に当てもないしね");
			ui.ShowImage(Hijiri[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【聖】\nあ、それでしたら人里のほうに今、永遠亭の薬師が往診に来ているとかなんとか");
			ui.ShowImage(Reimu[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【霊夢】\n兎じゃなくって薬師のほう？");
			ui.ShowImage(Hijiri[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【聖】\nええ、稗田の家に定期的に用があるとかで");
			ui.ShowImage(Marisa[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【魔理沙】\nなるほどな。永琳だったら頼りになりそうだ。駄目元で声をかけてみる価値はありそうだ");
			ui.ShowImage(Reimu[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【霊夢】\n兎のほうだったら無視してたところだけどね");
            ui.ShowImage(Ichirin[2], StoryUIImagePosition.Left, true, false);
			ui.ShowText("【一輪】\n兎さんの扱いって一体……");
			ui.ShowImage(Hijiri[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【聖】\n考えちゃ駄目よ、一輪");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Marisa[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【魔理沙】\nじゃあ次の目的地は再度、人里だな。ついでに阿求の奴も拾ってやることにしよう");
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【霊夢】\nええ。そうと決まったら出発よ");
			ui.ShowImage(Hijiri[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【聖】\nあ、話の腰を折るようで申し訳ないですが、しばらく寺を空ける旨を皆に伝えなければいけないので、私は遅れて追いかけることにします。\n稗田家で合流できそうならそこでということで");
			ui.ShowImage(Reimu[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【霊夢】\nいまいち纏まりがないわね、ほんと");
			ui.ShowImage(Marisa[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【魔理沙】\nそういうもんなんだろ。じゃあ行こうぜ");

			var talkEnd0 = ui.ShowText("", false);
			while (!ui.IsCompleted(talkEnd0))
				yield return null;
			ui.Hide();
			ui.ResumeGame();
			#endregion

			yield return null;
		}

		private System.Collections.IEnumerable Talk敗北(IWorld world)
		{
			var ui = world.StoryUI;

			ui.PauseGame();
			ui.Show();
			ui.Hide();
			ui.ResumeGame();

			yield return null;
		}
		#endregion

		private int[] LoadTachies(IStoryUI ui, string path_N, string path_S, string path_W)
		{
			return new int[3]{
				ui.LoadImage( path_N ),
				ui.LoadImage( path_S ),
				ui.LoadImage( path_W )
			};
		}

		/// <summary>
		/// ユニットをエリア上に生成する。
		/// </summary>
		/// <param name="world"></param>
		/// <param name="faction"></param>
		/// <param name="paramType"></param>
		/// <param name="area"></param>
		/// <returns></returns>
		public IEnumerable<IUnit> PutUnitsOnArea(IWorld world, IFaction faction, Type paramType, Area area)
		{
			var ar = area as AreaRectangle;
			if (ar == null) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min(ar.Start.X, ar.End.X);
			var sy = Math.Min(ar.Start.Y, ar.End.Y);
			var ex = Math.Max(ar.Start.X, ar.End.X);
			var ey = Math.Max(ar.Start.Y, ar.End.Y);

			for (var y = sy; y <= ey; y++)
			{
				for (var x = sx; x <= ex; x++)
				{
					var u =
						world.UnitManager.Create(paramType.FullName, faction, (x + 0.5f) * thrts.Def.MapTipLengthOnField, (y + 0.5f) * thrts.Def.MapTipLengthOnField, faction);
					if (u != null) units.Add(u);
				}
			}

			return units;
		}

		public IEnumerable<IUnit> PutEnemy(IWorld world, Type unitType, Area area, int num, IBuilding target)
		{
			var rect = area as AreaRectangle;
			if (rect == null) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min(rect.Start.X, rect.End.X);
			var sy = Math.Min(rect.Start.Y, rect.End.Y);
			var ex = Math.Max(rect.Start.X, rect.End.X);
			var ey = Math.Max(rect.Start.Y, rect.End.Y);

			for (var y = sy; y < ey; y++)
			{
				for (var x = sx; x < ex; x++)
				{
					if (units.Count >= num)
						goto LoopEnd;

					var u = world.UnitManager.Create(
						unitType.FullName,
						world.Factions[1],
						(x + 0.5f) * thrts.Def.MapTipLengthOnField,
						(y + 0.5f) * thrts.Def.MapTipLengthOnField,
						world.Factions[1]);
					if (u != null)
						units.Add(u);
				}
			}
		LoopEnd:

			if (target != null)
				world.UnitManager.SelectTarget(units, new Vector2D(target.Pos.X, target.Pos.Y), false);

			return units;
		}

		bool IsUnitOnArea(AreaRectangle region, IUnit unit)
		{
			var startx = Math.Min(region.Start.X, region.End.X) * Def.MapTipLengthOnField;
			var starty = Math.Min(region.Start.Y, region.End.Y) * Def.MapTipLengthOnField;
			var endx = Math.Max(region.Start.X, region.End.X) * Def.MapTipLengthOnField;
			var endy = Math.Max(region.Start.Y, region.End.Y) * Def.MapTipLengthOnField;
			if (unit.Pos.X < endx && startx < unit.Pos.X && unit.Pos.Y < endy && starty < unit.Pos.Y)
			{
				return true;
			}
			return false;
		}

		IEnumerable<IBuilding> GetBuildings<T>(IWorld world) where T : BuildingParameter
		{
			return world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(T));
		}
	}
}
