﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using thrts;

namespace LotusCraft.Story
{
	public class Story05 : thrts.Mission
	{
		public override string[] GetSelectableFactions()
		{
			return new string[] {
				typeof( Faction.White ).FullName
			};
		}

		public override string[] GetEnableFactions()
		{
			return new string[]	{
				typeof( Faction.White ).FullName,
				typeof( Faction.Red ).FullName,
				typeof( Faction.Neutral ).FullName
			};
		}

		public override string[] GetSelectableMaps()
		{
			return new string[] {
				"LotusCraft/Story/Story05.map",
			};
		}

		public Story05()
			: base()
		{
			Name = "ストーリー05";
			Description = "白2話のマップ";
			Mode = thrts.MissionMode.Story;

			this.TheNumberOfMaximumSelectablePlayersInTeam = 0;
			this.TheNumberOfSelectableTeams = 0;
		}

		int[] Reimu = null;
		int[] Marisa = null;
		int[] Akyu = null;
		int[] Eirin = null;
		int[] Ichirin = null;
		int[] Hijiri = null;

		int[] Yukari = null;

		int[] Mokou = null;
		int[] Patchuli = null;
		int[] Sakuya = null;
		int[] Remilia = null;
		int[] Sanae = null;
		int[] Aya = null;
		int Back1 = -1;

		Area[] areas = null;
		IBuilding redHome = null;
		IBuilding redLow = null;
		IBuilding redHigh = null;
		IBuilding whiteHome = null;

		int enemySpan = 1500;

        /// <summary>
        /// スペルを使用されたかどうか
        /// </summary>
        bool executedRemiliaSpall = false;

		public override void OnInitialize( thrts.IWorld world )
		{
			world.Factions[1].PlayerName = "赤勢力";

			// 中立処理
			var neutrals = world.Factions.Where(_ => _.Parameter.GetType() == typeof(LotusCraft.Faction.Neutral));
			foreach (var neutral in neutrals)
			{
				neutral.IsNeutral = false;
			}

			// 経験値補正
            world.Factions[2].GetUnitParameter(typeof(LotusCraft.Unit.Neutral.Low11).FullName).HP /= 3;
			
			// 中立扱いを解除
			world.Factions[2].IsNeutral = false;
			
			// 最初から負けないように
			world.Factions[0].DoesNotLose = true;
			world.Factions[1].DoesNotLose = true;
			world.Factions[2].DoesNotLose = true;


			// 初期資源を配布
			world.Factions[0].IncResource( 0, 200 );
			world.Factions[0].IncResource( 1, 200 );

			// 難易度調整
			if (world.StoryUtilities.GetDifficulty() == 0)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Red.Low02).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Red.Low01).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Red.Flandre).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Red.Kanako).FullName).HP /= 2;

				enemySpan = 1600;
			}
			else if (world.StoryUtilities.GetDifficulty() == 2)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Red.Low02).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Red.Low02).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Red.Low01).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Red.Low01).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Red.Flandre).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Red.Flandre).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Red.Kanako).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Red.Kanako).FullName).HP * 0.2);
				
				enemySpan = 1300;
			}

			// 本拠の位置を初期視点にする
			var basePos = world.BuildingManager.GetBuildings( _ => _.Parameter.GetType() == typeof( LotusCraft.Building.White.HomeBase ) ).First().Pos;
			// 初期視点位置
			world.Factions[0].Parameter.DefaultScreenPosition
				= new Point2D( (int)basePos.X, (int)basePos.Y );

			base.OnInitialize( world );
		}

		public override System.Collections.IEnumerable Update( IWorld world )
		{
			var ui = world.StoryUI;
			//areas = new[]{
			//	world.AllPurposeArea.First(_ => _.Name == "召喚位置１"),
			//	world.AllPurposeArea.First(_ => _.Name == "召喚位置２"),
			//	world.AllPurposeArea.First( _ => _.Name == "補給拠点イベント" )
			//};
			redHome = GetBuildings<Building.Red.HomeBase>( world ).First();
			redLow = GetBuildings<Building.Red.Barrack>(world).First();
			redHigh = GetBuildings<Building.Red.Factory>(world).First();
			
			whiteHome = GetBuildings<Building.White.HomeBase>( world ).First();

			Reimu = LoadTachies( ui, "LotusCraft/Image/Tachie/Reimu_N", "LotusCraft/Image/Tachie/Reimu_S", "LotusCraft/Image/Tachie/Reimu_W" );
			Marisa = LoadTachies( ui, "LotusCraft/Image/Tachie/Marisa_N", "LotusCraft/Image/Tachie/Marisa_S", "LotusCraft/Image/Tachie/Marisa_W" );
			Akyu = LoadTachies( ui, "LotusCraft/Image/Tachie/Akyu_N", "LotusCraft/Image/Tachie/Akyu_S", "LotusCraft/Image/Tachie/Akyu_W" );
			Eirin = LoadTachies( ui, "LotusCraft/Image/Tachie/Eirin_N", "LotusCraft/Image/Tachie/Eirin_S", "LotusCraft/Image/Tachie/Eirin_W" );
			Hijiri = LoadTachies( ui, "LotusCraft/Image/Tachie/Hijiri_N", "LotusCraft/Image/Tachie/Hijiri_S", "LotusCraft/Image/Tachie/Hijiri_W" );
			Ichirin = LoadTachies( ui, "LotusCraft/Image/Tachie/Ichirin_N", "LotusCraft/Image/Tachie/Ichirin_S", "LotusCraft/Image/Tachie/Ichirin_W" );
			Mokou = LoadTachies( ui, "LotusCraft/Image/Tachie/Mokou_N", "LotusCraft/Image/Tachie/Mokou_S", "LotusCraft/Image/Tachie/Mokou_W" );
			Remilia = LoadTachies(ui, "LotusCraft/Image/Tachie/Remilia_N", "LotusCraft/Image/Tachie/Remilia_S", "LotusCraft/Image/Tachie/Remilia_W");
			Sakuya = LoadTachies(ui, "LotusCraft/Image/Tachie/Sakuya_N", "LotusCraft/Image/Tachie/Sakuya_S", "LotusCraft/Image/Tachie/Sakuya_W");
			Patchuli = LoadTachies(ui, "LotusCraft/Image/Tachie/Patchouli_N", "LotusCraft/Image/Tachie/Patchouli_S", "LotusCraft/Image/Tachie/Patchouli_W");
			Aya = LoadTachies( ui, "LotusCraft/Image/Tachie/Aya_N", "LotusCraft/Image/Tachie/Aya_S", "LotusCraft/Image/Tachie/Aya_W" );
			Sanae = LoadTachies(ui, "LotusCraft/Image/Tachie/Sanae_N", "LotusCraft/Image/Tachie/Sanae_S", "LotusCraft/Image/Tachie/Sanae_W");
			Yukari = LoadTachies(ui, "LotusCraft/Image/Tachie/Yukari_N", "LotusCraft/Image/Tachie/Yukari_S", "LotusCraft/Image/Tachie/Yukari_W");

            Back1 = ui.LoadImage("LotusCraft/Image/Back/Black");

			var remiliaUnit = world.UnitManager.GetUnits( _ => _.Parameter.GetType() == typeof( Unit.Red.Unique.Remilia ) ).First();
			remiliaUnit.AddExperience(3000);
			var sakuyaUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Red.Unique.Sakuya)).First();
			sakuyaUnit.AddExperience(1000);
			var patchuliUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Red.Unique.Patchouli)).First();
			patchuliUnit.AddExperience(1500);

			// 難易度調整
			if (world.StoryUtilities.GetDifficulty() == 2)
			{
				remiliaUnit.AddExperience(3000);
				sakuyaUnit.AddExperience(2500);
				patchuliUnit.AddExperience(3000);
			}

			world.ChangeBGM(BGMList.Boushuen_Story1);

			//*
			foreach( var item in Talk会話冒頭( world ) )
			{
				yield return null;
			}
			//*/

			world.ChangeBGM(BGMList.Battle_Kouma);
			
			ui.ShowConditionText( "目的：敵を殲滅する" );

			int i = 0;
			while(true)
			{
				var enemyCount = world.UnitManager.GetUnits(_ => _.Faction == world.Factions[1]).Count();
				if(enemyCount < 1)
				{
					foreach( var item2 in Talk勝利( world ) )
					{
						yield return null;
					}
					world.Factions[1].DoesNotLose = false;
					world.Factions[1].Lose();
					world.Factions[2].DoesNotLose = false;
					world.Factions[2].Lose();

					world.StoryUtilities.SetDataToSaveData("LotusCraft.White.02", "Clear");

					if (world.StoryUtilities.GetDifficulty() == 0)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.White.02.Easy", "Clear");
					}
					else if (world.StoryUtilities.GetDifficulty() == 1)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.White.02.Normal", "Clear");
					}
					else if (world.StoryUtilities.GetDifficulty() == 2)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.White.02.Hard", "Clear");
					}

					break;
				}
				if( !whiteHome.Exists() )
				{
					foreach( var item2 in Talk敗北( world ) )
					{
						yield return null;
					}
					world.Factions[0].DoesNotLose = false;
					world.Factions[0].Lose();
					world.Factions[2].DoesNotLose = false;
					world.Factions[2].Lose();

					break;
				}

                // スペル発動
                if (remiliaUnit.Exists() && !executedRemiliaSpall && world.StoryUtilities.GetDifficulty() > 0)
                {
                    TryCallRemiliaSpell(world, remiliaUnit);
                }
                var mokouUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Red.Unique.Moko)).FirstOrDefault();
                if (mokouUnit != null)
                {
                    if (mokouUnit.Exists())
                    {
                        TryCallMokouSpell(world, mokouUnit);
                    }
                }

				// ユニーク
				if (i == enemySpan * 9) {
					if (sakuyaUnit.Exists())
					{
						List<int> uniqueIDs = new List<int>();
						
						uniqueIDs.Add(sakuyaUnit.UniqueID);
						world.UnitManager.AttackMove(uniqueIDs, whiteHome, false);
						TryCallSakuyaSpell(world, sakuyaUnit);
					}
				}
				else if (i == enemySpan * 12)
				{
					if (redHome.Exists() && world.StoryUtilities.GetDifficulty() == 2)
					{
						List<int> uniqueIDs = new List<int>();
						var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Red.Unique.Sanae).FullName, redHome);
						uniqueIDs.Add(l1.UniqueID);
						world.UnitManager.AttackMove(uniqueIDs, whiteHome, false);
						l1.AddExperience(3000);
						
                        TryCallSanaeSpell(world, l1);
					}
				}
				if (i == enemySpan * 15)
				{
					if (redHome.Exists() && world.StoryUtilities.GetDifficulty() == 2)
					{
						List<int> uniqueIDs = new List<int>();
						var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Red.Unique.Moko).FullName, redHome);
						uniqueIDs.Add(l1.UniqueID);
						l1.AddExperience(4000);
						world.UnitManager.AttackMove(uniqueIDs, whiteHome, false);
					}
				}

				// ざこ
				if (i % enemySpan == 0)
				{
					if (i > enemySpan*5)
					{
						if (i < enemySpan * 10)
						{
							if (redLow.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Red.Low01).FullName, redLow);
								uniqueIDs.Add(l1.UniqueID);
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Red.Low01).FullName, redLow);
								uniqueIDs.Add(l2.UniqueID);
								world.UnitManager.AttackMove(uniqueIDs, whiteHome, false);
							}
						}
						else if (i < enemySpan * 18)
						{
							if (redLow.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Red.Low01).FullName, redLow);
								uniqueIDs.Add(l1.UniqueID);
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Red.Low02).FullName, redLow);
								uniqueIDs.Add(l3.UniqueID);
								world.UnitManager.AttackMove(uniqueIDs, whiteHome, false);
							}

							if (redHigh.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var h1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Red.Flandre).FullName, redHigh);
								uniqueIDs.Add(h1.UniqueID);
								var h2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Red.Flandre).FullName, redHigh);
								uniqueIDs.Add(h2.UniqueID);
								world.UnitManager.AttackMove(uniqueIDs, whiteHome, false);
							}
						}
						else {
							if (redLow.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Red.Low01).FullName, redLow);
								uniqueIDs.Add(l1.UniqueID);
								var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Red.Low01).FullName, redLow);
								uniqueIDs.Add(l2.UniqueID);
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Red.Low02).FullName, redLow);
								uniqueIDs.Add(l3.UniqueID);
								world.UnitManager.AttackMove(uniqueIDs, whiteHome, false);
							}

							if (redHigh.Exists())
							{
								List<int> uniqueIDs = new List<int>();
								var h1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Red.Flandre).FullName, redHigh);
								uniqueIDs.Add(h1.UniqueID);
								var h2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Red.Flandre).FullName, redHigh);
								uniqueIDs.Add(h2.UniqueID);
								var h3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Red.Flandre).FullName, redHigh);
								uniqueIDs.Add(h3.UniqueID);
								var h4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Red.Flandre).FullName, redHigh);
								uniqueIDs.Add(h3.UniqueID);
								world.UnitManager.AttackMove(uniqueIDs, whiteHome, false);
							}
						}
					}
				}

				i++;
				yield return null;
			}



			yield return base.Update( world );
		}

        private void TryCallMokouSpell(IWorld world, IUnit MokouUnit)
        {
            if (!MokouUnit.Exists()) return;

            var units = world.UnitManager.GetUnits(_ => _.Faction == world.Factions[0]);
            foreach (var u in units)
            {
                var radius = 6 * thrts.Def.MapTipLengthOnField;

                if (radius * radius > (u.Pos.X - MokouUnit.Pos.X) * (u.Pos.X - MokouUnit.Pos.X) + (u.Pos.Y - MokouUnit.Pos.Y) * (u.Pos.Y - MokouUnit.Pos.Y))
                {
                    var targetPos = u.Pos;
                    var spell = world.Factions[1].GetUnitSpellButtonParameter(MokouUnit.Parameter.GetType().FullName, new SpellButtonKey("不死「火の鳥　-鳳翼天翔-」", 2));
                    spell.NormalButtonEvent(MokouUnit, false);
                }
            }
            
        }

        private void TryCallSanaeSpell(IWorld world, IUnit SanaeUnit)
        {
            if (!SanaeUnit.Exists()) return;

            SanaeUnit.LvUpSpellWithName("奇跡「神の風」", 2);
            
        }

		private void TryCallSakuyaSpell(IWorld world, IUnit SakuyaUnit)
		{
			if (!SakuyaUnit.Exists()) return;

			SakuyaUnit.LvUpSpellWithName("銀符「シルバーバウンド」", 2);

		}

        private void TryCallRemiliaSpell(IWorld world, IUnit RemiliaUnit)
        {
            if (executedRemiliaSpall || !RemiliaUnit.Exists()) return;

            var units = world.UnitManager.GetUnits(_ => _.Faction == world.Factions[0]);
            foreach (var u in units)
            {
                var radius = 7 * thrts.Def.MapTipLengthOnField;

                if (radius * radius > (u.Pos.X - RemiliaUnit.Pos.X) * (u.Pos.X - RemiliaUnit.Pos.X) + (u.Pos.Y - RemiliaUnit.Pos.Y) * (u.Pos.Y - RemiliaUnit.Pos.Y))
                {
                    var targetPos = u.Pos;
                    var spell = world.Factions[1].GetUnitSpellButtonParameter(RemiliaUnit.Parameter.GetType().FullName, new SpellButtonKey("紅魔「スカーレットデビル」", 1));
                    spell.NormalButtonEvent(RemiliaUnit, false);
                    executedRemiliaSpall = true;
                }
            }
        }

		#region Story
		private System.Collections.IEnumerable Talk会話冒頭( IWorld world )
		{
			var ui = world.StoryUI;

			#region Talk1
			
			ui.PauseGame();
			ui.Show();
			ui.ShowText("～紅魔館～");
			ui.ShowImage(Aya[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【文】\n連れてきましたよ");
			ui.ShowImage(Reimu[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【霊夢】\n相変わらず窓もない真っ赤っかとしょうもない館ね");
			ui.ShowImage(Sakuya[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【咲夜】\nしょうもないのなら来なければ良かったのではないかと");
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【霊夢】\n来なかったら来なかったでここの主がへそ曲げるでしょ。それでまた霧でも出されたらそっちのほうが面倒だもの。");
			ui.ShowImage(Reimu[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【霊夢】\n来てやったんだから、ちょっとぐらい大目に見ときなさい");
			ui.ShowImage(Marisa[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【魔理沙】\n私が来ると露骨に機嫌を損ねそうな奴もいるがな");
			ui.ShowImage(Patchuli[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【パチュリー】\nきちんとした手続きを踏み、なおかつ盗人猛々しい態度を改め、その上でぴーちくばーちく喋らないのであれば客間ぐらいにまでは来ることを許すけど");
			ui.ShowImage(Marisa[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【魔理沙】\nああそうかい。生まれ変わった次のときにはそうなっているように努力しないこともない");
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【霊夢】\n珍しい顔も居るけど？");
			ui.ShowImage(Mokou[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【妹紅】\nそれはお互い様だろう。そこの天狗に助っ人として連れてこられたんだよ\nそっちだってなぜか、輝夜んとこの薬師を連れているじゃないか");
			ui.ShowImage(Eirin[1],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【永琳】\n姫がこの場に居たらそれはそれで大変だっただろうし、私が来て正解だったかしら");
			ui.ShowImage(Mokou[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【妹紅】\nふん");
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【霊夢】\nそれでレミリアの奴はどこに行ったの？　呼びつけて主が姿を現さないなんて");
			ui.ShowImage(Sakuya[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【咲夜】\nお嬢様はプティングを召し上がっておられるので");
			ui.ShowImage(Sakuya[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【咲夜】\nそれに、会話も弾まれているようですし");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Hijiri[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【白蓮】\nお初にお目にかかります。紅魔館に高名な魔女がいらっしゃるとは聞いていたのですが");
			ui.ShowImage(Patchuli[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【パチュリー】\n私も噂だけは聞いて居たわ。法界に封じられていたんですってね。肉体強化の魔法を主に使うとか");
			ui.ShowImage(Hijiri[2],StoryUIImagePosition.Right,false,false);
			ui.ShowImage(Patchuli[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【パチュリー】\n私の喘息も、それで手っ取り早く克服できればいいのだけど");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Eirin[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【永琳】\nそれにしてもあなたが紅魔館に与しているだなんて");
			ui.ShowImage(Mokou[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【妹紅】\n食い扶持が貰えるならな。あんただって糊口を凌ぐために薬を里に卸してるだろ");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Akyu[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【阿求】\nそれでどうして東風谷さんまでが紅魔館に？");
			ui.ShowImage(Sanae[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【早苗】\n宴席で無理やり言質を……。お酒に酔わせてあんなことを言わせるだなんて");
			ui.ShowImage(Aya[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【文】\nいや言質取っただけですよね！？");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Reimu[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【霊夢】\n……和んでるわね");
			ui.ShowImage(Marisa[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【魔理沙】\nたまには客として来る紅魔館もいいもんだな");
			ui.ShowImage(Sakuya[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【咲夜】\n普段からそうしたらいいのに");
			ui.ShowText("【魔理沙】\n普段は招かれざる客って奴だからな");
			ui.ShowImage(Sakuya[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【咲夜】\n招かれるようにしたらいいのに");
			ui.ShowText("【魔理沙】\nたまにじゃないと味わえない妙があるってものだろ。");
			ui.ShowImage(Marisa[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【魔理沙】\nしかしいいのか？　メイド長が世間話に興じてるだなんて");
			ui.ShowImage(Sakuya[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【咲夜】\nせっかくの親睦の機会だという、お嬢様の計らいなので");
			ui.ShowImage(Reimu[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【霊夢】\nまぁ阿求なんか目をキラキラさせてるわね");
			ui.ShowImage(Sakuya[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【咲夜】\nうちのことを変な風に書かなければいいんだけど");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Remilia[1],StoryUIImagePosition.Front,true,false);
			ui.ShowText("【レミリア】\n待たせたな");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【霊夢】\nようやくおでましね");
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Remilia[0],StoryUIImagePosition.Front,false,false);
			ui.ShowText("【レミリア】\n雑な歓待で申し訳なかったけれど、それとこれとは別。\n今回私たちは本気で霊夢たちにも勝つつもりよ。");
			ui.ShowImage(Sanae[0],StoryUIImagePosition.Right,true,false);
			ui.ShowImage(Aya[0],StoryUIImagePosition.Left,true,false);
			ui.ShowImage(Remilia[1],StoryUIImagePosition.Front,false,false);
			ui.ShowText("【レミリア】\nそのために傭兵も雇ったんだから");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Aya[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【文】\nどーもどーも");
			ui.ShowImage(Mokou[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【妹紅】\n返事する必要はないと思うけど");
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(Hijiri[0],StoryUIImagePosition.Left,true,false);
			ui.ShowImage(Akyu[1],StoryUIImagePosition.Right,true,false);
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Front,true,false);
			ui.ShowText("【霊夢】\nはん、そんな烏合の衆で私たちに勝てると思っているのかしら");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Akyu[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【阿求】\n私たちも烏合の衆だと思いますが");
			ui.ShowImage(Reimu[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【霊夢】\nじゃあ主人公補正");
			ui.ShowText("【阿求】\nうーん。それがあるかは悩ましいところですね");
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【霊夢】\nどういうことよ");
			ui.ShowImage(Akyu[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【阿求】\n主人公補正が本当にあるかどうかは置いといて、今回は異変とは呼べない単なる遊戯ですからね。");
			ui.ShowImage(Akyu[2],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【阿求】\n異変は人間の手によって解決されるものという原則は働きませんし\n純粋な力比べでしかないということです");
			ui.ShowImage(Marisa[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【魔理沙】\nだったら力勝ちすればいいってことだな。望むところだ");
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(Remilia[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【レミリア】\n以前は不覚を取ったが、今回はその意趣返しとさせてもらおうか");
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【霊夢】\nしつこいわね。悪いけど今回も勝たせてもらうから");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			var talkEnd = ui.ShowText( "", false );

			while( !ui.IsCompleted( talkEnd ) )
				yield return null;

			ui.Hide();
			ui.ResumeGame();

			#endregion

			yield return null;
		}

		

		private System.Collections.IEnumerable Talk勝利( IWorld world )
		{
			world.ChangeBGM(BGMList.Boushuen_Win);

			var ui = world.StoryUI;

			#region Talk12
			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Reimu[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【霊夢】\n雇ってきたって言ってきた割にはいつものメンツだったわね");
			ui.ShowImage(Remilia[2],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【レミリア】\nふん。今回は申請した対戦じゃないから小手調べだったのよ");
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【霊夢】\n申請？");
			ui.ShowImage(Remilia[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【レミリア】\n聞いていないのかしら？");
			ui.ShowImage(Remilia[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【レミリア】\n\"代表同士が戦いに同意する\"　\"他の勢力がその戦いを見届ける\"");
			ui.ShowText("【レミリア】\nこの二点をクリアして、どちらが勝利したかを八雲紫に報告するのよ");
			ui.ShowImage(Reimu[2],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【霊夢】\nまぁ、どこで優勝チームを作るのかってのは気になっていたけど");
			ui.ShowImage(Remilia[0],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【レミリア】\n無論、一対一だけじゃなく、バトルロイヤル形式になったりもするだろうけどね。あの隙間女も一勢力を率いているみたいだし");
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【霊夢】\nふぅん。とりあえず今回は勝ち逃げさせてもらうことにするわ");
			ui.ShowImage(Remilia[1],StoryUIImagePosition.Right,false,false);
			ui.ShowText("【レミリア】\nいずれにしても次は負けないから。そのつもりで。咲夜。お客様を見送りなさい");
			ui.ShowImage(Sakuya[1],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【咲夜】\n畏まりました");
			ui.ShowImage(-1,StoryUIImagePosition.Right,true);
			ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Back1,StoryUIImagePosition.Front,true);
			var talkEnd = ui.ShowImage(Back1, StoryUIImagePosition.Back2, true);
			while (!ui.IsCompleted(talkEnd))
				yield return null;
			
			world.ChangeBGM(BGMList.Battle_Hakurei);

            ui.ShowText("\n～博麗神社～");
			ui.ShowImage(-1,StoryUIImagePosition.Front,true);
			ui.ShowImage(Reimu[2],StoryUIImagePosition.Left,true,false);
			ui.ShowText("【霊夢】\nはー疲れた");
			ui.ShowImage(Reimu[0],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【霊夢】\nそれでそろそろ聞かせてもらえるのかしら");
			ui.ShowImage(Yukari[0],StoryUIImagePosition.Right,true,false);
			ui.ShowText("【紫】\n何をかしら？");
            world.ChangeBGM(BGMList.None);
			ui.ShowImage(Reimu[1],StoryUIImagePosition.Left,false,false);
			ui.ShowText("【霊夢】\n今回の、本当の目的");
			ui.ShowImage(Yukari[1],StoryUIImagePosition.Right,false,false);
			var talkEnd0 = ui.ShowText( "", false );
			while( !ui.IsCompleted( talkEnd0 ) )
				yield return null;
			ui.Hide();
			ui.ResumeGame();
			#endregion

			yield return null;
		}

		private System.Collections.IEnumerable Talk敗北( IWorld world )
		{
			var ui = world.StoryUI;

			//ui.PauseGame();
			//ui.Show();
			//ui.ShowImage( Mokou[1], StoryUIImagePosition.Front, true, false );
			//ui.ShowText( "【チルノ】\nこれであたいが最強だー！" );
			//ui.Hide();
			//ui.ResumeGame();

			yield return null;
		}
		#endregion

		private int[] LoadTachies( IStoryUI ui, string path_N, string path_S, string path_W )
		{
			return new int[3]{
				ui.LoadImage( path_N ),
				ui.LoadImage( path_S ),
				ui.LoadImage( path_W )
			};
		}

		/// <summary>
		/// ユニットをエリア上に生成する。
		/// </summary>
		/// <param name="world"></param>
		/// <param name="faction"></param>
		/// <param name="paramType"></param>
		/// <param name="area"></param>
		/// <returns></returns>
		public IEnumerable<IUnit> PutUnitsOnArea( IWorld world, IFaction faction, Type paramType, Area area )
		{
			var ar = area as AreaRectangle;
			if( ar == null ) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min( ar.Start.X, ar.End.X );
			var sy = Math.Min( ar.Start.Y, ar.End.Y );
			var ex = Math.Max( ar.Start.X, ar.End.X );
			var ey = Math.Max( ar.Start.Y, ar.End.Y );

			for( var y = sy; y <= ey; y++ )
			{
				for( var x = sx; x <= ex; x++ )
				{
					var u =
						world.UnitManager.Create( paramType.FullName, faction, ( x + 0.5f ) * thrts.Def.MapTipLengthOnField, ( y + 0.5f ) * thrts.Def.MapTipLengthOnField, faction );
					if( u != null ) units.Add( u );
				}
			}

			return units;
		}

		public IEnumerable<IUnit> PutEnemy( IWorld world, Type unitType, Area area, int num, IBuilding target )
		{
			var rect = area as AreaRectangle;
			if( rect == null ) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min( rect.Start.X, rect.End.X );
			var sy = Math.Min( rect.Start.Y, rect.End.Y );
			var ex = Math.Max( rect.Start.X, rect.End.X );
			var ey = Math.Max( rect.Start.Y, rect.End.Y );

			for( var y = sy; y < ey; y++ )
			{
				for( var x = sx; x < ex; x++ )
				{
					if( units.Count >= num )
						goto LoopEnd;

					var u = world.UnitManager.Create(
						unitType.FullName,
						world.Factions[1],
						( x + 0.5f ) * thrts.Def.MapTipLengthOnField,
						( y + 0.5f ) * thrts.Def.MapTipLengthOnField,
						world.Factions[1] );
					if( u != null )
						units.Add( u );
				}
			}
		LoopEnd:

			if( target != null )
				world.UnitManager.SelectTarget( units, new Vector2D( target.Pos.X, target.Pos.Y ), false );

			return units;
		}

		bool IsUnitOnArea( AreaRectangle region, IUnit unit )
		{
			var startx = Math.Min( region.Start.X, region.End.X ) * Def.MapTipLengthOnField;
			var starty = Math.Min( region.Start.Y, region.End.Y ) * Def.MapTipLengthOnField;
			var endx = Math.Max( region.Start.X, region.End.X ) * Def.MapTipLengthOnField;
			var endy = Math.Max( region.Start.Y, region.End.Y ) * Def.MapTipLengthOnField;
			if( unit.Pos.X < endx && startx < unit.Pos.X && unit.Pos.Y < endy && starty < unit.Pos.Y )
			{
				return true;
			}
			return false;
		}

		IEnumerable<IBuilding> GetBuildings<T>( IWorld world ) where T : BuildingParameter
		{
			return world.BuildingManager.GetBuildings( _ => _.Parameter.GetType() == typeof( T ) );
		}
	}
}

#endif