﻿#if !_TRIAL

using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using thrts;

namespace LotusCraft.Story
{

	public class StoryBlack04 : thrts.Mission
	{
		enum Difficulty
		{
			Easy,
			Normal,
			Hard
		}

		readonly Dictionary<int, int> Experience;
		private int Back1;
		private int[] Miko;
		private int[] Rin;
		private int[] Yuyuko;
		private int[] Hijiri;
		private int[] Eirin;
		private int[] Seiga;

		int 敵召喚インターバル = int.MaxValue;
		int 下級召喚まで = int.MaxValue;
		int 上級召喚まで = int.MaxValue;
		int 難易度アップインターバル = int.MaxValue;
		int 難易度アップまで = int.MaxValue;

		int 星召喚数 = 0;
		int 星召喚割合 = 0;
		int 村紗召喚数 = 0;
		int 村紗召喚割合 = 0;
		int 青兎召喚数 = 0;
		int 青兎召喚割合 = 0;

		Difficulty difficulty;

		IEnumerable<Tuple<IBuilding, Area>> 星召喚場所;
		IEnumerable<Tuple<IBuilding, Area>> 村紗召喚場所;
		IEnumerable<Tuple<IBuilding, Area>> 兎召喚場所;

		AreaRectangle 寺敷地;

		public StoryBlack04()
		{
			Name = "黒4話";
			Description = "黒4話専用マップ";
			Mode = thrts.MissionMode.Story;

			this.TheNumberOfMaximumSelectablePlayersInTeam = 0;
			this.TheNumberOfSelectableTeams = 0;
			Experience = new Dictionary<int, int>()
			{
				{0, 0},
				{1,	0}, 
				{2,	60},
				{3,	200},
				{4,	500},
				{5,	1200},
				{6,	2400},
 				{7,	4000},
				{8,	6000},
				{9, 8300},
				{10, 11000},
				{11, 14500}
			};
		}

		/// <summary>
		/// 自軍の勢力
		/// </summary>
		/// <returns></returns>
		public override string[] GetSelectableFactions()
		{
			return new string[] { 
				typeof(LotusCraft.Faction.Black).FullName 
			};
		}
		/// <summary>
		/// 登場する勢力
		/// </summary>
		/// <returns></returns>
		public override string[] GetEnableFactions()
		{
			return new string[] { 
				typeof(LotusCraft.Faction.Black).FullName,
				typeof(LotusCraft.Faction.White).FullName, 
			};
		}
		/// <summary>
		/// 使用するマップ
		/// </summary>
		/// <returns></returns>
		public override string[] GetSelectableMaps()
		{
			return new string[] {
				"LotusCraft/Story/StoryBlack04.map",
			};
		}

		public override void OnInitialize(IWorld world)
		{
			world.Factions[1].PlayerName = "白勢力";

			// 最初から負けないように
			world.Factions.ForEach(f => f.DoesNotLose = true);

			// 初期資源を配布
			world.Factions[0].IncResource(0, 200);
			world.Factions[0].IncResource(1, 200);

			// 難易度調整
			if (world.StoryUtilities.GetDifficulty() == 0)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Low03).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Murasa).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Toramaru).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Unique.Ichirin).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Unique.Hijiri).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Unique.Eirin).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Reisen).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Kaguya).FullName).HP /= 2;

				world.UnitManager.GetUnits(u => u.Faction.Index == 1).Do(u => u.MaxHP = u.Parameter.HP).ForEach(u => u.HP = u.Parameter.HP);

				下級召喚まで = 60 * 30 * 4;
				上級召喚まで = int.MaxValue;
				敵召喚インターバル = 30 * 90;
				難易度アップまで = 10 * 60 * 30;
				難易度アップインターバル = 20 * 60 * 30;

				星召喚数 = 0;
				星召喚割合 = 0;
				村紗召喚数 = 0;
				村紗召喚割合 = 0;
				青兎召喚数 = 2;
				青兎召喚割合 = 1;

				difficulty = Difficulty.Easy;
			}
			else if (world.StoryUtilities.GetDifficulty() == 1)
			{
				下級召喚まで = 60 * 30 * 2;
				上級召喚まで = 6 * 60 * 30;
				敵召喚インターバル = 30 * 60;
				難易度アップまで = 5 * 60 * 30;
				難易度アップインターバル = 15 * 60 * 30;

				星召喚数 = 1;
				星召喚割合 = 1;
				村紗召喚数 = 3;
				村紗召喚割合 = 2;
				青兎召喚数 = 4;
				青兎召喚割合 = 2;

				difficulty = Difficulty.Normal;
			}
			else if (world.StoryUtilities.GetDifficulty() == 2)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Low03).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Low03).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Murasa).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Murasa).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Toramaru).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Toramaru).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Unique.Ichirin).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Unique.Ichirin).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Unique.Hijiri).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Unique.Hijiri).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Unique.Eirin).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Unique.Eirin).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Reisen).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Reisen).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Kaguya).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.White.Kaguya).FullName).HP * 0.2);

				world.UnitManager.GetUnits(u => u.Faction.Index == 1).Do(u => u.MaxHP = u.Parameter.HP).ForEach(u => u.HP = u.Parameter.HP);

				下級召喚まで = 60 * 30 * 2;
				上級召喚まで = 6 * 60 * 30;
				敵召喚インターバル = 30 * 40;
				難易度アップまで = 2 * 60 * 30;
				難易度アップインターバル = 15 * 60 * 30;

				星召喚数 = 2;
				村紗召喚数 = 6;
				青兎召喚数 = 6;

				星召喚数 = 2;
				星召喚割合 = 1;
				村紗召喚数 = 6;
				村紗召喚割合 = 2;
				青兎召喚数 = 6;
				青兎召喚割合 = 3;

				difficulty = Difficulty.Hard;
			}
			{
				var areas = world.AllPurposeArea.ToDictionary(a => a.Name, a => a);

				星召喚場所 = Enumerable.Zip(
					GetBuildings(world.Factions[1], typeof(LotusCraft.Building.White.Houtou)),
					areas
						.Where(a => a.Key.Contains("星召喚"))
						.OrderBy(p => p.Key)
						.Select(p => p.Value),
					Tuple.Create)
					.ToList();
				村紗召喚場所 = Enumerable.Zip(
					GetBuildings(world.Factions[1], typeof(LotusCraft.Building.White.Seirensen)),
					areas
						.Where(a => a.Key.Contains("村紗召喚"))
						.OrderBy(p => p.Key)
						.Select(p => p.Value),
					Tuple.Create)
					.ToList();
				兎召喚場所 = Enumerable.Zip(
					GetBuildings(world.Factions[1], typeof(LotusCraft.Building.White.Barrack)),
					areas
						.Where(a => a.Key.Contains("兎召喚"))
						.OrderBy(p => p.Key)
						.Select(p => p.Value),
					Tuple.Create)
					.ToList();
				寺敷地 = areas["寺ゾーン"] as AreaRectangle;
			}

			var homePos = GetBuildings(world.Factions[0], typeof(LotusCraft.Building.Black.HomeBase))
				.Single().Pos;
			world.Factions[0].Parameter.DefaultScreenPosition = new Point2D((int)homePos.X, (int)homePos.Y);

			var ui = world.StoryUI;
			{
				Back1 = ui.LoadImage("LotusCraft/Image/Back/Black");
				Miko = new[] { ui.LoadImage("LotusCraft/Image/Tachie/Miko_N"), ui.LoadImage("LotusCraft/Image/Tachie/Miko_S"), ui.LoadImage("LotusCraft/Image/Tachie/Miko_W") };
				Rin = new[] { ui.LoadImage("LotusCraft/Image/Tachie/Rin_N"), ui.LoadImage("LotusCraft/Image/Tachie/Rin_S"), ui.LoadImage("LotusCraft/Image/Tachie/Rin_W") };
				Yuyuko = new[] { ui.LoadImage("LotusCraft/Image/Tachie/Yuyuko_N"), ui.LoadImage("LotusCraft/Image/Tachie/Yuyuko_S"), ui.LoadImage("LotusCraft/Image/Tachie/Yuyuko_W") };
				Hijiri = new[] { ui.LoadImage("LotusCraft/Image/Tachie/Hijiri_N"), ui.LoadImage("LotusCraft/Image/Tachie/Hijiri_S"), ui.LoadImage("LotusCraft/Image/Tachie/Hijiri_W") };
				Eirin = new[] { ui.LoadImage("LotusCraft/Image/Tachie/Eirin_N"), ui.LoadImage("LotusCraft/Image/Tachie/Eirin_S"), ui.LoadImage("LotusCraft/Image/Tachie/Eirin_W") };
				Seiga = new[] { ui.LoadImage("LotusCraft/Image/Tachie/Seiga_N"), ui.LoadImage("LotusCraft/Image/Tachie/Seiga_S"), ui.LoadImage("LotusCraft/Image/Tachie/Seiga_W") };
			}
			base.OnInitialize(world);
		}
		void White初期化(IWorld world)
		{
			world.UnitManager.GetUnits(u => u.Faction == world.Factions[1])
				.Where(u => u.Parameter.IsUnique)
				.ForEach(u => u.AddExperience(Experience[11]));

			GetUnits(world.Factions[1], typeof(LotusCraft.Unit.White.Unique.Ichirin))
				.Do(u => u.LvUpSpellWithName("忿怒「天変大目玉焼き」"))
				.ForEach(u => u.LvUpSpellWithName("稲妻「帯電入道」", 3));
			GetUnits(world.Factions[1], typeof(LotusCraft.Unit.White.Unique.Eirin))
				.ForEach(u => u.LvUpSpellWithName("禁薬「蓬莱の薬」"));
			GetUnits(world.Factions[1], typeof(LotusCraft.Unit.White.Unique.Hijiri))
				.ForEach(u => u.LvUpSpellWithName("超人「聖白蓮」"));

			// 輝夜スタンバイ
			GetUnits(world.Factions[1], typeof(LotusCraft.Unit.White.Kaguya)).ForEach(u => u.HoldPosition(false));
			// 優曇華スタンバイ
			GetUnits(world.Factions[1], typeof(LotusCraft.Unit.White.Reisen)).ForEach(u => u.HoldPosition(false));
		}

		public override IEnumerable Update(IWorld world)
		{
			world.ChangeBGM(BGMList.Boushuen_Story3);

			foreach (var item in 導入会話(world))
				yield return item;

			{
				world.ChangeBGM(BGMList.Battle_Hitozato);
			}
			White初期化(world);

			world.StoryUI.ShowConditionText("目的：敵拠点を撃破");

			var 一輪 = GetUnits(world.Factions[1], typeof(LotusCraft.Unit.White.Unique.Ichirin)).Single();
			var 聖 = GetUnits(world.Factions[1], typeof(LotusCraft.Unit.White.Unique.Hijiri)).Single();
			var 永琳 = GetUnits(world.Factions[1], typeof(LotusCraft.Unit.White.Unique.Eirin)).Single();

			var 一輪ラストスペル使用したか = false;
			var 聖ラストスペル使用したか = false;
			var 永琳ラストスペル使用したか = false;

			int frameCount = 0;

			while (true)
			{
				if (difficulty != Difficulty.Easy && !一輪ラストスペル使用したか)
				{
					if (一輪.HP < 一輪.MaxHP)
					{
						一輪.Faction.GetUnitSpellButtonParameter(一輪.Parameter.GetType().FullName, new SpellButtonKey("忿怒「天変大目玉焼き」", 1)).NormalButtonEvent(一輪, false);

						一輪ラストスペル使用したか = true;
					}
				}
				if (difficulty != Difficulty.Easy && !聖ラストスペル使用したか)
				{
					if (world.GetObjectFromCircle(new Circle2D(聖.ViewRange, new Vector2D(聖.Pos.X, 聖.Pos.Y)))
						.OfType<IUnit>()
						.Where(u => u.Faction.Index == 0)
						.Where(u => u.FlyingState == FlyingState.TouchGround)
						.Skip(10)
						.Any())
					{
						聖.Faction.GetUnitSpellButtonParameter(聖.Parameter.GetType().FullName, new SpellButtonKey("超人「聖白蓮」", 1)).NormalButtonEvent(聖, false);

						聖ラストスペル使用したか = true;
					}
				}
				if (difficulty != Difficulty.Easy && !永琳ラストスペル使用したか)
				{
					if (world.GetObjectFromCircle(new Circle2D(永琳.ViewRange, new Vector2D(永琳.Pos.X, 永琳.Pos.Y)))
						.OfType<IUnit>()
						.Where(u => u.Faction.Index == 1)
						.Skip(10)
						.Any())
					{
						永琳.Faction.GetUnitSpellButtonParameter(永琳.Parameter.GetType().FullName, new SpellButtonKey("禁薬「蓬莱の薬」", 1)).NormalButtonEvent(永琳, false);

						永琳ラストスペル使用したか = true;
					}
				}
				if (難易度アップまで < frameCount && frameCount % 難易度アップインターバル == 0)
				{
					敵召喚インターバル = Math.Max(30 * 10, 敵召喚インターバル / 2);
					星召喚数 = Math.Min(30, 星召喚数 * 2);
					星召喚割合 = Math.Min(30, 星召喚割合 * 2);
					村紗召喚数 = Math.Min(30, 村紗召喚数 * 2);
					村紗召喚割合 = Math.Min(30, 村紗召喚割合 * 2);
					青兎召喚数 = Math.Min(30, 青兎召喚数 * 2);
					青兎召喚割合 = Math.Min(30, 青兎召喚割合 * 2);
				}
				if (frameCount % 敵召喚インターバル == 0)
				{
					var target =
						System.Linq.EnumerableExtentionsForNeetpia.Concat<ITargetObject>(
							GetUnitsInArea(world, 寺敷地).Where(u => u.Faction.Index == 0),
							world.BuildingManager.GetBuildings(b => b.Faction.Index == 0),
							world.UnitManager.GetUnits(u => u.Faction.Index == 0))
						.FirstOrDefault();

					if (target != null)
					{
						if (上級召喚まで <= frameCount)
						{
							world.UnitManager.AttackMove(PutEnemy<LotusCraft.Unit.White.Toramaru>(星召喚場所, 星召喚割合, 星召喚数).Select(u => u.UniqueID).ToList(), target, false);
							world.UnitManager.AttackMove(PutEnemy<LotusCraft.Unit.White.Murasa>(村紗召喚場所, 村紗召喚割合, 村紗召喚数).Select(u => u.UniqueID).ToList(), target, false);
						}
						if (下級召喚まで <= frameCount)
						{
							world.UnitManager.AttackMove(PutEnemy<LotusCraft.Unit.White.Low03>(兎召喚場所, 青兎召喚割合, 青兎召喚数).Select(u => u.UniqueID).ToList(), target, false);
						}
					}
				}
				if (GetBuildings(world.Factions[1], typeof(LotusCraft.Building.White.HomeBase)).IsEmpty())
				{
					foreach (var item in 勝利会話(world))
						yield return item;

					world.Factions[0].DoesNotLose = true;
					world.Factions[0].Win();
					world.Factions[1].DoesNotLose = true;
					world.Factions[1].Lose();

					world.StoryUtilities.SetDataToSaveData("LotusCraft.Black.04", "Clear");

					switch (difficulty)
					{
						case Difficulty.Easy:
							world.StoryUtilities.SetDataToSaveData("LotusCraft.Black.04.Easy", "Clear");
							break;
						case Difficulty.Normal:
							world.StoryUtilities.SetDataToSaveData("LotusCraft.Black.04.Normal", "Clear");
							break;
						case Difficulty.Hard:
							world.StoryUtilities.SetDataToSaveData("LotusCraft.Black.04.Hard", "Clear");
							break;
						default:
							break;
					}

					world.ChangeBGM(BGMList.Boushuen_Win);

					break;
				}
				else if ((world.UnitManager.GetUnits(u => u.Faction.Index == 0).IsEmpty() && world.BuildingManager.GetBuildings(b => b.Faction.Index == 0).IsEmpty()))
				{
					world.ChangeBGM(BGMList.Boushuen_Lose);

					world.Factions[0].DoesNotLose = true;
					world.Factions[0].Lose();
					world.Factions[1].DoesNotLose = true;
					world.Factions[1].Win();

					break;
				}
				else
				{
					frameCount++;
					yield return null;
				}
			}
			while (true)
				yield return null;
		}

		IEnumerable<IUnit> GetUnitsInArea(IWorld world, AreaRectangle rect)
		{
			if (rect == null)
				return new IUnit[0];

			var cx = (rect.Start.X + rect.End.X) * thrts.Def.MapTipLengthOnField / 2;
			var cy = (rect.Start.Y + rect.End.Y) * thrts.Def.MapTipLengthOnField / 2;

			var width = Math.Abs(rect.Start.X - rect.End.X) * thrts.Def.MapTipLengthOnField;
			var height = Math.Abs(rect.Start.Y - rect.End.Y) * thrts.Def.MapTipLengthOnField;

			return world.GetObjectOnRectangle(cx, cy, width, height, 0, true, true).OfType<IUnit>();
		}

		IEnumerable<IUnit> PutEnemy<TUnit>(IEnumerable<Tuple<IBuilding, Area>> appearArea, int numPerArea, int total)
			where TUnit : UnitParameter
		{
			return appearArea.Where(a => a.Item1.Exists())
				.SelectMany(a => PutEnemy<TUnit>(a.Item1.Faction, a.Item2, numPerArea))
				.Take(total);
		}

		IEnumerable<IUnit> PutEnemy<TUnit>(IFaction faction, Area area, int num)
			where TUnit : UnitParameter
		{
			var rect = area as AreaRectangle;
			if (rect == null)
				yield break;

			int unitCount = 0;
			var type = typeof(TUnit);

			var sx = Math.Min(rect.Start.X, rect.End.X);
			var sy = Math.Min(rect.Start.Y, rect.End.Y);
			var ex = Math.Max(rect.Start.X, rect.End.X);
			var ey = Math.Max(rect.Start.Y, rect.End.Y);

			for (var y = sy; y < ey; y++)
			{
				for (var x = sx; x < ex; x++)
				{
					if (unitCount >= num)
						yield break;

					var u = faction.World.UnitManager.Create(
						type.FullName,
						faction,
						(x + 0.5f) * thrts.Def.MapTipLengthOnField,
						(y + 0.5f) * thrts.Def.MapTipLengthOnField,
						faction);
					if (u != null)
					{
						unitCount++;
						yield return u;
					}
				}
			}
		}

		IEnumerable<IBuilding> GetBuildings(IFaction faction, Type parameterType)
		{
			return faction.World.BuildingManager.GetBuildings(b => b.Faction == faction && b.Parameter.GetType() == parameterType);
		}
		IEnumerable<IUnit> GetUnits(IFaction faction, Type parameterType)
		{
			return faction.World.UnitManager.GetUnits(u => u.Faction == faction && u.Parameter.GetType() == parameterType);
		}

		IEnumerable 導入会話(IWorld world)
		{
			var ui = world.StoryUI;

			ui.PauseGame();
			ui.Show();
			ui.ShowText("～人里～");
			ui.ShowImage(Miko[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【神子】\nそろそろメインイベントをこなしましょうか");
			ui.ShowImage(Seiga[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【青娥】\nメインイベントとは？");
			ui.ShowImage(Miko[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\n挨拶回りは済ませましたし、あとは個人的な用件を済ませようと思いまして");
			ui.ShowImage(Rin[0], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【お燐】\n何処に行こうとあたいらは付いてくだけさね");
			ui.ShowImage(Yuyuko[1], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【幽々子】\n私もまだ付き合うわよー");
			ui.ShowImage(Miko[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\nありがたいことです。");
			ui.ShowImage(Miko[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\n至極個人的な用件なのですが、こういう機会でもないと中々機会が持てないもので");
			ui.ShowImage(Seiga[1], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【青娥】\nというと、やはり寺に？");
			ui.ShowImage(Miko[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\nええ。やはり気になってしまいまして");
			ui.ShowImage(Yuyuko[0], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【幽々子】\n気になる女の子が？");
			ui.ShowImage(Miko[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\nまぁ、そうなりますかね");
			ui.ShowImage(Yuyuko[1], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【幽々子】\nあら、ダメですよ。そんな方々にちょっかいを出しているようじゃ");
			ui.ShowImage(Miko[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\n一夫多妻の時代に生まれておりまして");
			ui.ShowImage(Yuyuko[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【幽々子】\nでも自由恋愛ではなかったんでしょう？");
			ui.ShowImage(Miko[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\nそれはそれ、これはこれです");
			ui.ShowImage(Seiga[1], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【青娥】\n留守番している子達に怒られますよ");
			ui.ShowImage(Back1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(Hijiri[0], StoryUIImagePosition.Right, true, false, true);
			ui.ShowImage(Miko[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowImage(-1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowText("【白蓮】\n………");
			ui.ShowText("【神子】\n………");
			ui.ShowImage(Hijiri[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【白蓮】\n慌ただしい行事はもう終わったと思っていたんですが");
			ui.ShowImage(Miko[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\n各方面もだいたい沈静化したようですが、個人的な用事が");
			ui.ShowImage(Hijiri[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【白蓮】\n私は積極的に角を立てるようなことはしたくないのですが……");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, true);
			ui.ShowImage(Eirin[1], StoryUIImagePosition.Front, true, false, true);
			ui.ShowText("【永琳】\nあら。お邪魔だったかしら");
			ui.ShowImage(-1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(Miko[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【神子】\nこれはこれは、薬師の八意さんですよね");
			ui.ShowImage(Eirin[0], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【永琳】\nええ。あら？　あなたは……");
			ui.ShowImage(Miko[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\n一応、仙人をやっておりますので");
			ui.ShowImage(Eirin[1], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【永琳】\n大変でしょう。寿命を伸ばすというのは");
			ui.ShowImage(Miko[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\nええ。それなりに");
			ui.ShowImage(Yuyuko[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【幽々子】\n私、蓬莱人はちょっと苦手かしら");
			ui.ShowImage(Miko[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【神子】\n蓬莱人？");
			ui.ShowImage(Yuyuko[1], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【幽々子】\nええ、不老不死の妙薬を飲んだ、生きても死んでもいないよくわからないモノよ");
			ui.ShowImage(Eirin[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【永琳】\n失礼なことを言うわね。その通りだけど");
			ui.ShowImage(Miko[2], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【神子】\nまさか白蓮さん、あなた");
			ui.ShowImage(Hijiri[2], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【白蓮】\n単に、お茶をしていただけですよ。せっかく御縁を持てたので");
			ui.ShowImage(Miko[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\n……");
			ui.ShowImage(Eirin[1], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【永琳】\n不老不死にそんなに興味があるの？");
			ui.ShowImage(Miko[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\nこの体になったのも、そもそもそれが理由ですしね");
			ui.ShowImage(Eirin[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【永琳】\nそんないいものではないのに");
			ui.ShowText("【神子】\n必要かそうでないかで言えば、私には必要だったものです");
			ui.ShowImage(Yuyuko[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【幽々子】\n私は嫌いだわ。蓬莱人には能力が通じないんですもの");
			ui.ShowImage(Eirin[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【永琳】\n何かしら深い理由があるみたいだけど、今回はそれが理由ではなんじゃなくって？");
			ui.ShowImage(Miko[2], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【神子】\nええ、まぁ。色々ありましたが、良いライバルとして仲良くしたいなと思いまして");
			ui.ShowImage(Hijiri[2], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【白蓮】\nそれはこちらとしても構わないのですが");
			ui.ShowImage(Miko[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\nええ。それでせっかくのいい機会なので、遊んでみませんかと。本気で");
			ui.ShowImage(Hijiri[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【白蓮】\n……");
			ui.ShowImage(Eirin[1], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【永琳】\n私も付き合わなきゃいけなさそうな流れね");
			ui.ShowImage(Miko[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\nせっかく触れ合った御縁ですし");
			ui.ShowImage(Hijiri[2], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【白蓮】\nわかりました。お付き合いしましょう");
			ui.ShowImage(Miko[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\nそうこなくっちゃ");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, true);
			var talkEnd = ui.ShowText("", false);

			while (!ui.IsCompleted(talkEnd))
			{
				yield return null;
			}

			ui.Hide();
			ui.ResumeGame();
		}

		IEnumerable 勝利会話(IWorld world)
		{
			var ui = world.StoryUI;
			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Miko[1], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【神子】\nいい勝負でした。また遊びましょう");
			ui.ShowImage(Hijiri[0], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【白蓮】\nええ、こうやって交流を持てることは良いことかと");
			ui.ShowImage(Miko[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\n貴重な機会を作ってくれたことに感謝しなくては");
			ui.ShowImage(Yuyuko[0], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【幽々子】\n紫はあれはあれで面倒見がいいから");
			ui.ShowImage(Yuyuko[1], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【幽々子】\nじゃなきゃ幻想郷なんか作ってないんだけど");
			ui.ShowImage(Miko[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\nそれは実感していますね");
			ui.ShowText("【幽々子】\n素直じゃないだけでいい子なのよー。本人に言ったら誤魔化すけど");
			ui.ShowImage(Miko[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\nそれはありそう");
			ui.ShowImage(Hijiri[2], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【白蓮】\n……まぁ、仲良くするにこしたことはないですよね");
			ui.ShowImage(Miko[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\n腹に抱えたものがあったとしても、ね\nいがみ合う必要性などどこにもないわけですし");
			ui.ShowImage(Yuyuko[1], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【幽々子】\nその代わり美味しいものをお腹に詰め込めば解決よ");
			ui.ShowImage(Miko[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\n画期的な解決法ですね");
			ui.ShowImage(Miko[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\nそうだ、皆さんを私の家に招待しましょう\n桃源郷というわけにはいきませんが、うちの者たちにも紹介したいので");
			ui.ShowImage(Eirin[0], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【永琳】\n私も？");
			ui.ShowImage(Miko[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【神子】\nええ、ぜひ");
			ui.ShowImage(Eirin[1], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【永琳】\n望んでいるような話はできないけどね");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, true);
			ui.ShowImage(Miko[0], StoryUIImagePosition.Front, true, false, true);
			ui.ShowText("交流目的としての機会\nそう割り切った神子は、ひとまず自分たちの顔を売ることにした");
			ui.ShowText("もちろん為政者として幻想郷に君臨するつもりはないが、\n身内に爆弾を抱えている身としては、何かが起きてからは遅いのである");
			ui.ShowImage(Miko[2], StoryUIImagePosition.Front, false, false, true);
			ui.ShowText("【神子】\n布都も屠自古も、もう少し交流を持ってくれればいいのですがね");
			ui.ShowImage(Miko[0], StoryUIImagePosition.Front, false, false, true);
			ui.ShowText("仙人としての道を極める前に、まだ俗世間とは縁を持たなくてはいけない。それに、弄れば面白そうな宗教家に、不老不死だという薬師も居る");
			ui.ShowImage(Miko[1], StoryUIImagePosition.Front, false, false, true);
			ui.ShowText("【神子】\n少なくとも、退屈することはなさそうだった");
			var talkEnd = ui.ShowText("", false);

			while (!ui.IsCompleted(talkEnd))
			{
				yield return null;
			}

			ui.Hide();
			ui.ResumeGame();
		}
	}
}
#endif