﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using thrts;

namespace LotusCraft.Story
{
	public class StoryBlue02 : thrts.Mission
	{
		public override string[] GetSelectableFactions()
		{
			return new string[] {
				typeof( Faction.Blue ).FullName
			};
		}

		public override string[] GetEnableFactions()
		{
			return new string[]	{
				typeof( Faction.Black ).FullName,
                typeof( Faction.Blue ).FullName
			};
		}

		public override string[] GetSelectableMaps()
		{
			return new string[] {
				"LotusCraft/Story/StoryBlue02.map",
			};
		}

		public StoryBlue02()
			: base()
		{
			Name = "ストーリー青02";
			Description = "青2話のマップ";
			Mode = thrts.MissionMode.Story;

			this.TheNumberOfMaximumSelectablePlayersInTeam = 0;
			this.TheNumberOfSelectableTeams = 0;
		}

		int[] Yukari = null;
		int[] Tenshi = null;
        int[] Koishi = null;
        int[] Yuyuko = null;
        int[] Rin = null;
        int[] Utsuho = null;
        int[] Miko = null;
		int Back1 = 0;

		Area[] areas = null;
		IBuilding ownHome = null;
		IBuilding enemyHome = null;
		IBuilding enemyHigh1 = null;
		IBuilding enemyHigh2 = null;
		IBuilding enemyChireiden = null;

        int enemyspan = 1800;

		public override void OnInitialize( thrts.IWorld world )
		{
			
			// 最初から負けないように
			world.Factions[0].DoesNotLose = true;
			world.Factions[1].DoesNotLose = true;
			

			// 初期資源を配布
			world.Factions[0].IncResource( 0, 200 );
			world.Factions[0].IncResource( 1, 200 );

			// 難易度調整
			if (world.StoryUtilities.GetDifficulty() == 0)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low02).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low03).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Youmu).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Satori).FullName).HP /= 2;
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Orin).FullName).HP /= 2;
			}
			else if (world.StoryUtilities.GetDifficulty() == 2)
			{
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low02).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low02).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low03).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Low03).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Youmu).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Youmu).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Satori).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Satori).FullName).HP * 0.2);
				world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Orin).FullName).HP += (int)(world.Factions[1].GetUnitParameter(typeof(LotusCraft.Unit.Black.Orin).FullName).HP * 0.2);
				
			}

			// 本拠の位置を初期視点にする
			var basePos = world.BuildingManager.GetBuildings( _ => _.Parameter.GetType() == typeof( LotusCraft.Building.Blue.HomeBase )).FirstOrDefault().Pos;
			// 初期視点位置
			world.Factions[0].Parameter.DefaultScreenPosition
				= new Point2D( (int)basePos.X, (int)basePos.Y );
			
			// ボタン仕様禁止
			var home = world.BuildingManager.GetBuildings(_ => _.Faction == world.Factions[0] && _.Parameter.GetType() == typeof(LotusCraft.Building.Blue.HomeBase)).First();
			world.StoryUI.HideButton(home, ButtonPosition._1, ButtonPosition._1);
			world.StoryUI.HideButton(home, ButtonPosition._1, ButtonPosition._2);

			base.OnInitialize( world );
		}

		public override System.Collections.IEnumerable Update( IWorld world )
		{
			var ui = world.StoryUI;
			
			enemyHome = GetBuildings<Building.Black.HomeBase>(world).Where(_ => _.Faction == world.Factions[1]).First();
			enemyHigh1 = GetBuildings<Building.Black.Factory>(world).Where(_ => _.Faction == world.Factions[1]).First();
			enemyHigh2 = GetBuildings<Building.Black.Factory>(world).Where(_ => _.Faction == world.Factions[1]).Skip(1).First();
			
			enemyChireiden = GetBuildings<Building.Black.Chireiden>(world).Where(_ => _.Faction == world.Factions[1]).First();
			
			ownHome = GetBuildings<Building.Blue.HomeBase>( world ).Where(_=>_.Faction == world.Factions[0]).First();

            Yukari = LoadTachies(ui, "LotusCraft/Image/Tachie/Yukari_N", "LotusCraft/Image/Tachie/Yukari_S", "LotusCraft/Image/Tachie/Yukari_W");
			Tenshi = LoadTachies( ui, "LotusCraft/Image/Tachie/Tenshi_N", "LotusCraft/Image/Tachie/Tenshi_S", "LotusCraft/Image/Tachie/Tenshi_W" );
            Miko = LoadTachies(ui, "LotusCraft/Image/Tachie/Miko_N", "LotusCraft/Image/Tachie/Miko_S", "LotusCraft/Image/Tachie/Miko_W");
            Koishi = LoadTachies(ui, "LotusCraft/Image/Tachie/Koishi_N", "LotusCraft/Image/Tachie/Koishi_S", "LotusCraft/Image/Tachie/Koishi_W");
            Yuyuko = LoadTachies(ui, "LotusCraft/Image/Tachie/Yuyuko_N", "LotusCraft/Image/Tachie/Yuyuko_S", "LotusCraft/Image/Tachie/Yuyuko_W");
            Rin = LoadTachies(ui, "LotusCraft/Image/Tachie/Rin_N", "LotusCraft/Image/Tachie/Rin_S", "LotusCraft/Image/Tachie/Rin_W");
            Utsuho = LoadTachies(ui, "LotusCraft/Image/Tachie/Utsuho_N", "LotusCraft/Image/Tachie/Utsuho_S", "LotusCraft/Image/Tachie/Utsuho_W");

			Back1 = ui.LoadImage("LotusCraft/Image/Back/Black");

            var tenshiUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Blue.Unique.Tenshi)).First();
            
            var yuyukoUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Black.Unique.Yuyuko)).First();
            yuyukoUnit.AddExperience(4000);
            var rinUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Black.Unique.Rin)).First();
            rinUnit.AddExperience(1500);
            var utsuhoUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.Black.Unique.Utsuho)).First();
            utsuhoUnit.AddExperience(2000);

			if (world.StoryUtilities.GetDifficulty() == 0) {
				tenshiUnit.AddExperience(200);
			}
			if (world.StoryUtilities.GetDifficulty() == 1)
			{
				yuyukoUnit.AddExperience(1000);
				rinUnit.AddExperience(500);
				utsuhoUnit.AddExperience(1000);
				yuyukoUnit.LvUpSpellWithName("符牒「死蝶の舞」", 2);
				utsuhoUnit.LvUpSpellWithName("遮光「核熱バイザー」", 1);
			}
			else if (world.StoryUtilities.GetDifficulty() == 2)
			{
				yuyukoUnit.AddExperience(2000);
				rinUnit.AddExperience(1000);
				utsuhoUnit.AddExperience(2000);
				yuyukoUnit.LvUpSpellWithName("符牒「死蝶の舞」", 3);
				utsuhoUnit.LvUpSpellWithName("遮光「核熱バイザー」", 2);
			}


			world.ChangeBGM(BGMList.Boushuen_Story1);

			//*
			foreach( var item in Talk会話冒頭( world ) )
			{
				yield return null;
			}
			//*/

			world.ChangeBGM(BGMList.Battle_Senkai);

            for (var c = 0; c < 100; c++) {
                yield return null;
            }

            foreach (var item in Talk戦闘開始(world))
            {
                yield return null;
            }

            ui.ShowConditionText("目的：敵の本拠の撃破");

			int i = 0;
			while(true)
			{
				if(!enemyHome.Exists())
				{
					foreach( var item2 in Talk勝利( world ) )
					{
						yield return null;
					}
					world.Factions[1].DoesNotLose = false;
					world.Factions[1].Lose();

					world.StoryUtilities.SetDataToSaveData("LotusCraft.Blue.02", "Clear");

					if (world.StoryUtilities.GetDifficulty() == 0)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Blue.02.Easy", "Clear");
					}
					else if (world.StoryUtilities.GetDifficulty() == 1)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Blue.02.Normal", "Clear");
					}
					else if (world.StoryUtilities.GetDifficulty() == 2)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Blue.02.Hard", "Clear");
					}
					world.ChangeBGM(BGMList.Boushuen_Win);

					break;
				}
				if( !ownHome.Exists() )
				{
					foreach( var item2 in Talk敗北( world ) )
					{
						yield return null;
					}
					world.Factions[0].DoesNotLose = false;
					world.Factions[0].Lose();
					world.ChangeBGM(BGMList.Boushuen_Lose);

					break;
				}

				if (GetBuildings<Building.Blue.HomeBase>(world).Where(_ => _.Faction == world.Factions[0]).Count() > 1) {
					enemyspan = 1700;
				}

				if (i == enemyspan * 7)
				{
					if (enemyHome.Exists() && rinUnit.Exists())
					{
						List<int> uniqueIDs = new List<int>();
						uniqueIDs.Add(rinUnit.UniqueID);
						if (enemyHigh1.Exists() && world.StoryUtilities.GetDifficulty() > 0)
						{
							var h1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Orin).FullName, enemyHigh1);
							uniqueIDs.Add(h1.UniqueID);
							var h2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Orin).FullName, enemyHigh1);
							uniqueIDs.Add(h2.UniqueID);
						}
						foreach (var ln in uniqueIDs)
						{
							var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
							n.HP = n.MaxHP;
						}
						world.UnitManager.AttackMove(uniqueIDs, ownHome, false);
					}
				}

				if (i == enemyspan * 10)
				{
					if (enemyHome.Exists() && utsuhoUnit.Exists())
					{
						List<int> uniqueIDs = new List<int>();
						uniqueIDs.Add(utsuhoUnit.UniqueID);
						if (enemyHigh2.Exists() && world.StoryUtilities.GetDifficulty()>0)
						{
							var h1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Oku).FullName, enemyHigh2);
							uniqueIDs.Add(h1.UniqueID);
							var h2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Oku).FullName, enemyHigh2);
							uniqueIDs.Add(h2.UniqueID);
						}
						foreach (var ln in uniqueIDs)
						{
							var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
							n.HP = n.MaxHP;
						}
						world.UnitManager.AttackMove(uniqueIDs, ownHome, false);
					}
				}
				
				// ざこ
                if (i % enemyspan == 0 && i >= enemyspan * 6)
				{
                    if (i < enemyspan * 8)
                    {
                        if (enemyChireiden.Exists())
                        {
                            List<int> uniqueIDs = new List<int>();
                            var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, enemyChireiden);
                            uniqueIDs.Add(l1.UniqueID);
                            world.UnitManager.AttackMove(uniqueIDs, ownHome, false);
                        }
                        if (enemyHigh1.Exists())
                        {
                            List<int> uniqueIDs = new List<int>();
                            var h1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low02).FullName, enemyHigh1);
                            uniqueIDs.Add(h1.UniqueID);
                            world.UnitManager.AttackMove(uniqueIDs, ownHome, false);
                        }
						if (enemyHigh2.Exists())
						{
							List<int> uniqueIDs = new List<int>();
							var h1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Youmu).FullName, enemyHigh2);
							uniqueIDs.Add(h1.UniqueID);
							if (world.StoryUtilities.GetDifficulty() > 0) {
								var h4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Youmu).FullName, enemyHigh2);
								uniqueIDs.Add(h4.UniqueID);
							}
							foreach (var ln in uniqueIDs)
							{
								var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
								n.HP = n.MaxHP;
							}
							world.UnitManager.AttackMove(uniqueIDs, ownHome, false);
						}
                    }
                    else
                    {
                        if (enemyChireiden.Exists())
                        {
                            List<int> uniqueIDs = new List<int>();
							var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Orin).FullName, enemyChireiden);
							uniqueIDs.Add(l2.UniqueID); 
							if (world.StoryUtilities.GetDifficulty() == 2)
							{
								var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Satori).FullName, enemyChireiden);
								uniqueIDs.Add(l1.UniqueID);
							}
							else {
								var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, enemyChireiden);
								uniqueIDs.Add(l3.UniqueID);
							}
							if (world.StoryUtilities.GetDifficulty() > 0)
							{
								var h5 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Orin).FullName, enemyHigh2);
								uniqueIDs.Add(h5.UniqueID);
							}
							foreach (var ln in uniqueIDs)
							{
								var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
								n.HP = n.MaxHP;
							}
                            world.UnitManager.AttackMove(uniqueIDs, ownHome, false);

                        }

                        if (enemyHigh1.Exists())
                        {
                            List<int> uniqueIDs = new List<int>();
                            if (world.StoryUtilities.GetDifficulty() == 2)
							{
								var h2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Oku).FullName, enemyHigh1);
								uniqueIDs.Add(h2.UniqueID);
							}
							if (world.StoryUtilities.GetDifficulty() > 0)
							{
								var h5 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Oku).FullName, enemyHigh2);
								uniqueIDs.Add(h5.UniqueID);
							}
							var h3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Low03).FullName, enemyHigh1);
							uniqueIDs.Add(h3.UniqueID);
							foreach (var ln in uniqueIDs)
							{
								var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
								n.HP = n.MaxHP;
							}
                            world.UnitManager.AttackMove(uniqueIDs, ownHome, false);
                        }

						if (enemyHigh2.Exists())
						{
							List<int> uniqueIDs = new List<int>();
							var h1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Youmu).FullName, enemyHigh2);
							uniqueIDs.Add(h1.UniqueID);
							if (world.StoryUtilities.GetDifficulty() == 2)
							{
								var h4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Youmu).FullName, enemyHigh2);
								uniqueIDs.Add(h4.UniqueID);
							}
							if (world.StoryUtilities.GetDifficulty() > 0)
							{
								var h5 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Oku).FullName, enemyHigh2);
								uniqueIDs.Add(h5.UniqueID);
							}
							var h3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.Black.Youmu).FullName, enemyHigh2);
							uniqueIDs.Add(h3.UniqueID);
							foreach (var ln in uniqueIDs)
							{
								var n = world.UnitManager.GetUnits(_ => _.UniqueID == ln).FirstOrDefault();
								n.HP = n.MaxHP;
							}
							world.UnitManager.AttackMove(uniqueIDs, ownHome, false);
						}
                    }
				}

				i++;
				yield return null;
			}



			yield return base.Update( world );
		}

		#region Story
		private System.Collections.IEnumerable Talk会話冒頭( IWorld world )
		{
			var ui = world.StoryUI;

			#region Talk1
            ui.PauseGame();
            ui.Show();
            ui.ShowImage(Back1,StoryUIImagePosition.Back2,false,false,false);
            ui.ShowImage(Tenshi[0],StoryUIImagePosition.Right,true,false);
            ui.ShowText("【天子】\n今後の方針は決まっているの？");
            ui.ShowImage(Yukari[0],StoryUIImagePosition.Left,true,false);
            ui.ShowText("【紫】\n私たちの役割はGM(ゲームマスター)だから、参加者を楽しませるような試みを考えます");
            ui.ShowText("【天子】\n勝手に楽しんでそうなものだけど");
            ui.ShowText("【紫】\n霊夢たちも今頃仲間集めに勤しんでいる頃でしょう\n私のほうでも何人な目星は付けたけれど、戦力になるかっていうと微妙なのよね");
            ui.ShowImage(Tenshi[1],StoryUIImagePosition.Right,false,false);
            ui.ShowText("【天子】\nふーん。まぁ私が居れば大丈夫でしょうけど");
            ui.ShowImage(Yukari[1],StoryUIImagePosition.Left,false,false);
            ui.ShowText("【紫】\nあら、どうも萃香たちもやる気みたいなんだけど");
            ui.ShowImage(Tenshi[2],StoryUIImagePosition.Right,false,false);
            ui.ShowText("【天子】\nげ");
            ui.ShowImage(Yukari[2],StoryUIImagePosition.Left,false,false);
            ui.ShowText("【紫】\nせめてもう一人、戦力として数えられる面子を揃えられればいいんだけど");
            ui.ShowText("【？？？】\n確かに確かに");
            ui.ShowImage(Tenshi[0],StoryUIImagePosition.Right,false,false);
            ui.ShowText("【天子】\nでもそんな都合良く転がってる？\n衣玖じゃちょっと物足りないし、そもそも乗ってきてくれないでしょうし");
            ui.ShowImage(Tenshi[2],StoryUIImagePosition.Right,false,false);
            ui.ShowText("【天子】\n『そういうのは私の仕事ではありませんので』みたいな感じで");
            ui.ShowText("【？？？】\n下手にどこかの勢力の人員を引き抜いたら面倒なことになってしまうし？");
            ui.ShowImage(-1,StoryUIImagePosition.Left,true);
            ui.ShowImage(-1,StoryUIImagePosition.Right,true);
            ui.ShowImage(Yukari[0],StoryUIImagePosition.Right,true,false);
            ui.ShowText("【紫】\nそうそう。それで、どこから見ていたの？");
            ui.ShowText("【？？？】\nあなたたちが遊び始めた頃からかしら。");
            ui.ShowImage(Koishi[1],StoryUIImagePosition.Left,true,false);
            ui.ShowText("【こいし】\nなんだか楽しそうな話をしているんですもの\n私も混ぜてほしいなって");
            ui.ShowImage(Tenshi[0],StoryUIImagePosition.Right,true,false);
            ui.ShowText("【天子】\n誰こいつ？");
            ui.ShowImage(Yukari[0],StoryUIImagePosition.Right,true,false);
            ui.ShowText("【紫】\n地底の管理者の妹君ですわ");
            ui.ShowImage(Tenshi[2],StoryUIImagePosition.Right,true,false);
            ui.ShowText("【天子】\nじゃあ面倒事になるんじゃないの？");
            ui.ShowImage(Koishi[0],StoryUIImagePosition.Left,false,false);
            ui.ShowText("【こいし】\nお姉ちゃんのことなら大丈夫\nお姉ちゃんは基本的に私に対して不干渉だから");
            ui.ShowImage(Tenshi[0],StoryUIImagePosition.Right,false,false);
            ui.ShowText("【天子】\nじゃあそこは問題ないとして、実力のほうはどうなのかしら");
            ui.ShowImage(Koishi[1],StoryUIImagePosition.Left,false,false);
            ui.ShowText("【こいし】\n試してみる？");
            ui.ShowImage(Tenshi[0],StoryUIImagePosition.Right,false,false);
            ui.ShowText("【天子】\n……やめとく");
            ui.ShowImage(Tenshi[1], StoryUIImagePosition.Right, false, false);
            ui.ShowText("【天子】\nそれに、ある程度頭数として数えられるんだったら、あとは私がなんとかするもの");
            ui.ShowImage(Yukari[0],StoryUIImagePosition.Right,true,false);
            ui.ShowText("【紫】\nこれで三名ね\n一度、幽々子のところにも顔を出しておくかしら");
            ui.ShowImage(-1,StoryUIImagePosition.Front,true);
            ui.ShowImage(-1,StoryUIImagePosition.Right,true);
            ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(Back1, StoryUIImagePosition.Back2, true);
            ui.ShowText("\n～白玉楼～");
            ui.ShowImage(-1,StoryUIImagePosition.Front,true);
            ui.ShowImage(Yuyuko[0],StoryUIImagePosition.Right,true,false);
            ui.ShowText("【幽々子】\nあら、またお誘いなのかしら？");
            ui.ShowImage(Yukari[0],StoryUIImagePosition.Left,true,false);
            ui.ShowText("【紫】\nまたって、わざわざ冥界にまで出向くのが居たの？");
            ui.ShowImage(Yuyuko[1],StoryUIImagePosition.Right,false,false);
            ui.ShowText("【幽々子】\nええ。豊聡耳神子さんって言うの。私、情熱的に口説かれちゃって");
            ui.ShowImage(Yukari[0],StoryUIImagePosition.Left,false,false);
            ui.ShowText("【紫】\n幽々子ならそうするかもって思ってたわ");
            ui.ShowImage(Koishi[1],StoryUIImagePosition.Left,true,false);
            ui.ShowText("【こいし】\nここ、凄く良い処ね");
            ui.ShowImage(Yuyuko[0],StoryUIImagePosition.Right,false,false);
            ui.ShowText("【幽々子】\nありがと。で、紫のほうもただで帰るわけじゃないんでしょ？");
            ui.ShowImage(Yukari[1],StoryUIImagePosition.Left,true,false);
            ui.ShowText("【紫】\nせっかくだし、親友を誘った人の顔でも見ていこうかしらって思って");
            ui.ShowText("【幽々子】\nほかのアテを見つけたらまた迎えに来てくれるらしいから、ここで待っていたらいいわ");
            ui.ShowImage(Yuyuko[1],StoryUIImagePosition.Right,false,false);
            ui.ShowText("【幽々子】\nあなたたちも楽に寛いでくれていいのよ");
            ui.ShowImage(Koishi[1],StoryUIImagePosition.Left,true,false);
            ui.ShowText("【こいし】\nはーい");
            ui.ShowImage(-1,StoryUIImagePosition.Front,true);
            ui.ShowImage(-1,StoryUIImagePosition.Right,true);
            ui.ShowImage(-1,StoryUIImagePosition.Left,true);
            ui.ShowImage(-1,StoryUIImagePosition.Front,true);
            ui.ShowImage(Miko[2],StoryUIImagePosition.Left,true,false);
            ui.ShowText("【神子】\nやれやれ、ようやく迎えに来ることができましたよ");
            ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
            ui.ShowText("【神子】\nこれはこれは");
            ui.ShowImage(Yukari[0],StoryUIImagePosition.Right,true,false);
            ui.ShowText("【紫】\nきちんと顔を合わせるのはこれが初めてかしら");
            ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
            ui.ShowText("【神子】\nええ。会えて嬉しい限りです");
            ui.ShowImage(Koishi[1],StoryUIImagePosition.Right,true,false);
            ui.ShowText("【こいし】\nあれ、お空にお燐じゃない");
            ui.ShowImage(Rin[2],StoryUIImagePosition.Right,true,false);
            ui.ShowText("【お燐】\nこいし様！？　まさかこんなところでお会いするだなんて");
            ui.ShowImage(Yuyuko[1],StoryUIImagePosition.Right,true,false);
            ui.ShowText("【幽々子】\nあらあら、どうやら面白い組み合わせができ上がったみたいね");
            ui.ShowImage(Yukari[0],StoryUIImagePosition.Right,true,false);
            ui.ShowText("【紫】\nええ。豊聡耳様、でよろしかったでしょうか？");
            ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
            ui.ShowText("【神子】\n神子で構いませんよ\nなんでしょうか、大賢者殿");
            ui.ShowImage(Miko[2],StoryUIImagePosition.Left,false,false);
            ui.ShowText("【神子】\n");
            ui.ShowImage(Yukari[2],StoryUIImagePosition.Right,false,false);
            ui.ShowText("【紫】\n私もゆかりんでいいわ。");
            ui.ShowImage(Yukari[1],StoryUIImagePosition.Right,false,false);
            ui.ShowText("【紫】\n提案なんだけれど、ここで偶然会ったのも何かの縁\n是非、お手合せ願いたいわ");
            ui.ShowImage(Yuyuko[2],StoryUIImagePosition.Right,true,false);
            ui.ShowText("【幽々子】\nでも白玉楼でやっちゃダメよ\n妖夢が怒るんだから");
            ui.ShowImage(Miko[1],StoryUIImagePosition.Left,false,false);
            ui.ShowText("【神子】\n是非、受けましょう");
            ui.ShowImage(Miko[0],StoryUIImagePosition.Left,false,false);
            ui.ShowText("【神子】\n場所は仙界でよろしいでしょうか\n勿論、お互い公平な条件になるようにはしますので");
            ui.ShowImage(Yukari[1],StoryUIImagePosition.Right,true,false);
            ui.ShowText("【紫】\n構わないわ。いいわよね？");
            ui.ShowImage(Tenshi[1],StoryUIImagePosition.Right,true,false);
            ui.ShowText("【天子】\nええ。初戦、勝って飾るわよ");
            ui.ShowImage(Koishi[1],StoryUIImagePosition.Right,true,false);
            ui.ShowText("【こいし】\nうちの子たちだからって、容赦しないからね");
            ui.ShowImage(Rin[2],StoryUIImagePosition.Left,true,false);
            ui.ShowText("【お燐】\nうへー、い、嫌だなぁ");
            ui.ShowImage(-1,StoryUIImagePosition.Right,true);
            ui.ShowImage(-1,StoryUIImagePosition.Left,true);
			ui.ShowImage(-1, StoryUIImagePosition.Back2, true);
            
			var talkEnd = ui.ShowText( "", false );

			while( !ui.IsCompleted( talkEnd ) )
				yield return null;

			ui.Hide();
			ui.ResumeGame();

			#endregion

			yield return null;
		}

        private System.Collections.IEnumerable Talk戦闘開始(IWorld world)
        {
            var ui = world.StoryUI;

            #region Talk1.5
            ui.PauseGame();
            ui.Show();
            ui.ShowImage(Miko[0], StoryUIImagePosition.Left, true, false);
            ui.ShowText("【神子】\nルールはいかがしましょう？");
            ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, true, false);
            ui.ShowText("【紫】\n本格的な試合はこちらも未経験が多いですし、普通に攻め合いでいいでしょうか？");
            ui.ShowImage(Yuyuko[1], StoryUIImagePosition.Left, true, false);
            ui.ShowText("【幽々子】\n助かるわ、私も未経験者ですもの");
            ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false);
            ui.ShowText("【紫】\n先に敵拠点を陥落させたものの勝ち、それでいきましょう？");
            ui.ShowImage(-1, StoryUIImagePosition.Right, true);
            ui.ShowImage(-1, StoryUIImagePosition.Left, true);
            ui.ShowImage(Koishi[0], StoryUIImagePosition.Left, true, false);
            ui.ShowText("【こいし】\nミミズクの首を討ち取ったら終わりじゃないのかしら？");
            ui.ShowImage(Tenshi[0], StoryUIImagePosition.Right, true, false);
            ui.ShowText("【天子】\nあくまで遊びでしょ、一人殺し合いするつもりなら向こうの獣に引き取らせるわよ");
            ui.ShowImage(-1, StoryUIImagePosition.Right, true);
            ui.ShowImage(-1, StoryUIImagePosition.Left, true);

            var talkEnd = ui.ShowText("", false);

            while (!ui.IsCompleted(talkEnd))
                yield return null;

            ui.Hide();
            ui.ResumeGame();

            #endregion

            yield return null;
        }

		private System.Collections.IEnumerable Talk勝利( IWorld world )
		{
			var ui = world.StoryUI;

			#region Talk12
            ui.PauseGame();
            ui.Show();
            ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, true, false);
            ui.ShowText("【紫】\n神子様はお出にならないのですね");
            ui.ShowImage(Miko[2], StoryUIImagePosition.Left, true, false);
            ui.ShowText("【神子】\nまだその時ではないと思いまして");
            ui.ShowImage(Miko[1], StoryUIImagePosition.Left, false, false);
            ui.ShowText("【神子】\n楽しみにしていますよ");
            ui.ShowImage(Yukari[2], StoryUIImagePosition.Right, false, false);
            ui.ShowText("【紫】\nまぁ、そうやって幽々子を口説いたのですね");
            ui.ShowImage(Yuyuko[1], StoryUIImagePosition.Left, true, false);
            ui.ShowText("【幽々子】\n情熱的に口説かれちゃって");
            ui.ShowImage(Utsuho[2], StoryUIImagePosition.Left, true, false);
            ui.ShowText("【お空】\nジゴロ？");
            ui.ShowImage(Koishi[0], StoryUIImagePosition.Right, true, false);
            ui.ShowText("【こいし】\n女の敵？");
            ui.ShowImage(Rin[2], StoryUIImagePosition.Left, true, false);
            ui.ShowText("【お燐】\nどこで覚えてきたんだか");
            ui.ShowText("", false);

			var talkEnd0 = ui.ShowText( "", false );
			while( !ui.IsCompleted( talkEnd0 ) )
				yield return null;
			ui.Hide();
			ui.ResumeGame();
			#endregion

			yield return null;
		}

		private System.Collections.IEnumerable Talk敗北( IWorld world )
		{
			var ui = world.StoryUI;

			//ui.PauseGame();
			//ui.Show();
			//ui.Hide();
			//ui.ResumeGame();

			yield return null;
		}
		#endregion

		private int[] LoadTachies( IStoryUI ui, string path_N, string path_S, string path_W)
		{
			return new int[3]{
				ui.LoadImage( path_N ),
				ui.LoadImage( path_S ),
				ui.LoadImage( path_W )
			};
		}

		/// <summary>
		/// ユニットをエリア上に生成する。
		/// </summary>
		/// <param name="world"></param>
		/// <param name="faction"></param>
		/// <param name="paramType"></param>
		/// <param name="area"></param>
		/// <returns></returns>
		public IEnumerable<IUnit> PutUnitsOnArea( IWorld world, IFaction faction, Type paramType, Area area )
		{
			var ar = area as AreaRectangle;
			if( ar == null ) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min( ar.Start.X, ar.End.X );
			var sy = Math.Min( ar.Start.Y, ar.End.Y );
			var ex = Math.Max( ar.Start.X, ar.End.X );
			var ey = Math.Max( ar.Start.Y, ar.End.Y );

			for( var y = sy; y <= ey; y++ )
			{
				for( var x = sx; x <= ex; x++ )
				{
					var u =
						world.UnitManager.Create( paramType.FullName, faction, ( x + 0.5f ) * thrts.Def.MapTipLengthOnField, ( y + 0.5f ) * thrts.Def.MapTipLengthOnField, faction );
					if( u != null ) units.Add( u );
				}
			}

			return units;
		}

		public IEnumerable<IUnit> PutEnemy( IWorld world, Type unitType, Area area, int num, IBuilding target )
		{
			var rect = area as AreaRectangle;
			if( rect == null ) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min( rect.Start.X, rect.End.X );
			var sy = Math.Min( rect.Start.Y, rect.End.Y );
			var ex = Math.Max( rect.Start.X, rect.End.X );
			var ey = Math.Max( rect.Start.Y, rect.End.Y );

			for( var y = sy; y < ey; y++ )
			{
				for( var x = sx; x < ex; x++ )
				{
					if( units.Count >= num )
						goto LoopEnd;

					var u = world.UnitManager.Create(
						unitType.FullName,
						world.Factions[1],
						( x + 0.5f ) * thrts.Def.MapTipLengthOnField,
						( y + 0.5f ) * thrts.Def.MapTipLengthOnField,
						world.Factions[1] );
					if( u != null )
						units.Add( u );
				}
			}
		LoopEnd:

			if( target != null )
				world.UnitManager.SelectTarget( units, new Vector2D( target.Pos.X, target.Pos.Y ), false );

			return units;
		}

		bool IsUnitOnArea( AreaRectangle region, IUnit unit )
		{
			var startx = Math.Min( region.Start.X, region.End.X ) * Def.MapTipLengthOnField;
			var starty = Math.Min( region.Start.Y, region.End.Y ) * Def.MapTipLengthOnField;
			var endx = Math.Max( region.Start.X, region.End.X ) * Def.MapTipLengthOnField;
			var endy = Math.Max( region.Start.Y, region.End.Y ) * Def.MapTipLengthOnField;
			if( unit.Pos.X < endx && startx < unit.Pos.X && unit.Pos.Y < endy && starty < unit.Pos.Y )
			{
				return true;
			}
			return false;
		}

		IEnumerable<IBuilding> GetBuildings<T>( IWorld world ) where T : BuildingParameter
		{
			return world.BuildingManager.GetBuildings( _ => _.Parameter.GetType() == typeof( T ) );
		}
	}
}

#endif