﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Story
{
	public class StoryBlue04 : thrts.Mission
	{
		public override string[] GetSelectableFactions()
		{
			return new string[] {
				typeof( Faction.Red ).FullName
			};
		}

		public override string[] GetEnableFactions()
		{
			return new string[]	{
				typeof( Faction.Red ).FullName,
				typeof( Faction.Green ).FullName,
				typeof( Faction.Blue ).FullName,
			};
		}

		public override string[] GetSelectableMaps()
		{
			return new string[] {
				"LotusCraft/Story/StoryBlue04.map",
			};
		}

		public StoryBlue04()
			: base()
		{
			Name = "ストーリー青04";
			Description = "青4話のマップ";
			Mode = thrts.MissionMode.Story;

			this.TheNumberOfMaximumSelectablePlayersInTeam = 0;
			this.TheNumberOfSelectableTeams = 0;
		}

		int[] Reimu = null;
		int[] Marisa = null;
		int[] Yukari = null;
		int[] Tenshi = null;
		int[] Koishi = null;
		int[] Akyu = null;

		int[] Chilno = null;
		int[] Eirin = null;
		int[] Hijiri = null;
		int[] Ichirin = null;
		int[] Mystia = null;
		int[] Nitori = null;

		int Back1 = 0;
		IBuilding whiteHome = null;
		IBuilding blueHome = null;

		IBuilding[] whiteLow = null;

		const int enemySpan = 1800;

		/// <summary>
		/// スペルを使用されたかどうか
		/// </summary>
		bool executedMarisaSpall1 = false;
		bool executedMarisaSpall2 = false;

		public override void OnInitialize(thrts.IWorld world)
		{
			// 最初から負けないように
			world.Factions[0].DoesNotLose = true;
			world.Factions[1].DoesNotLose = true;

			// 初期資源を配布
			world.Factions[0].IncResource(0, 200);
			world.Factions[0].IncResource(1, 200);

			// 本拠の位置を初期視点にする
			var home = world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(LotusCraft.Building.Blue.HomeBase)).First();
			var basePos = home.Pos;

			// 初期視点位置
			world.Factions[0].Parameter.DefaultScreenPosition = new Point2D((int)basePos.X, (int)basePos.Y);

			world.Factions[1].PlayerName = "白勢力";

			base.OnInitialize(world);
		}

		public override System.Collections.IEnumerable Update(IWorld world)
		{
			var ui = world.StoryUI;

			whiteHome = GetBuildings<Building.White.HomeBase>(world).First();
			blueHome = GetBuildings<Building.Blue.HomeBase>(world).First();

			whiteLow = GetBuildings<Building.White.Barrack>(world).ToArray();

			Reimu = LoadTachies(ui, "LotusCraft/Image/Tachie/Reimu_N", "LotusCraft/Image/Tachie/Reimu_S", "LotusCraft/Image/Tachie/Reimu_W");
			Marisa = LoadTachies(ui, "LotusCraft/Image/Tachie/Marisa_N", "LotusCraft/Image/Tachie/Marisa_S", "LotusCraft/Image/Tachie/Marisa_W");
			Yukari = LoadTachies(ui, "LotusCraft/Image/Tachie/Yukari_N", "LotusCraft/Image/Tachie/Yukari_S", "LotusCraft/Image/Tachie/Yukari_W");
			Tenshi = LoadTachies(ui, "LotusCraft/Image/Tachie/Tenshi_N", "LotusCraft/Image/Tachie/Tenshi_S", "LotusCraft/Image/Tachie/Tenshi_W");
			Koishi = LoadTachies(ui, "LotusCraft/Image/Tachie/Koishi_N", "LotusCraft/Image/Tachie/Koishi_S", "LotusCraft/Image/Tachie/Koishi_W");
			Akyu = LoadTachies(ui, "LotusCraft/Image/Tachie/Akyu_N", "LotusCraft/Image/Tachie/Akyu_S", "LotusCraft/Image/Tachie/Akyu_W");
			Chilno = LoadTachies(ui, "LotusCraft/Image/Tachie/Chilno_N", "LotusCraft/Image/Tachie/Chilno_S", "LotusCraft/Image/Tachie/Chilno_W");
			Eirin = LoadTachies(ui, "LotusCraft/Image/Tachie/Eirin_N", "LotusCraft/Image/Tachie/Eirin_S", "LotusCraft/Image/Tachie/Eirin_W");
			Hijiri = LoadTachies(ui, "LotusCraft/Image/Tachie/Hijiri_N", "LotusCraft/Image/Tachie/Hijiri_S", "LotusCraft/Image/Tachie/Hijiri_W");
			Ichirin = LoadTachies(ui, "LotusCraft/Image/Tachie/Ichirin_N", "LotusCraft/Image/Tachie/Ichirin_S", "LotusCraft/Image/Tachie/Ichirin_W");
			Mystia = LoadTachies(ui, "LotusCraft/Image/Tachie/Mystia_N", "LotusCraft/Image/Tachie/Mystia_S", "LotusCraft/Image/Tachie/Mystia_W");
			Nitori = LoadTachies(ui, "LotusCraft/Image/Tachie/Nitori_N", "LotusCraft/Image/Tachie/Nitori_S", "LotusCraft/Image/Tachie/Nitori_W");
	
			Back1 = ui.LoadImage("LotusCraft/Image/Back/Black");

			int experience = 0;
			if (world.StoryUtilities.GetDifficulty() == 0)
			{
				experience = 3000;
			}
			else if (world.StoryUtilities.GetDifficulty() == 1)
			{
				experience = 5000;
			}
			else if (world.StoryUtilities.GetDifficulty() > 1)
			{
				experience = 7000;
			}


			var reimuUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.White.Unique.Reimu)).First();
			reimuUnit.AddExperience(experience);

			var marisaUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.White.Unique.Marisa)).First();
			marisaUnit.AddExperience(experience);

			var hijiriUnit = world.UnitManager.GetUnits(_ => _.Parameter.GetType() == typeof(Unit.White.Unique.Hijiri)).First();
			hijiriUnit.AddExperience(experience);

			world.ChangeBGM(BGMList.Boushuen_Story3);

			//*
			foreach (var item in Talk会話冒頭(world))
			{
				yield return null;
			}
			//*/

			world.ChangeBGM(BGMList.Battle_Hitozato);

			ui.ShowConditionText("目的：敵拠点の撃破");

			int c = 0;

			TryCallMarisaSpell1(world, marisaUnit);

			while (true)
			{
				// 勝利条件
				if (!whiteHome.Exists())
				{
					foreach (var item2 in Talk勝利(world))
					{
						yield return null;
					}
					world.Factions[1].DoesNotLose = false;
					world.Factions[1].Lose();

					world.StoryUtilities.SetDataToSaveData("LotusCraft.Blue.04", "Clear");

					if (world.StoryUtilities.GetDifficulty() == 0)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Blue.04.Easy", "Clear");
					}
					else if (world.StoryUtilities.GetDifficulty() == 1)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Blue.04.Normal", "Clear");
					}
					else if (world.StoryUtilities.GetDifficulty() == 2)
					{
						world.StoryUtilities.SetDataToSaveData("LotusCraft.Blue.04.Hard", "Clear");
					}
					break;
				}

				// 敗北条件
				if (!blueHome.Exists())
				{
					foreach (var item2 in Talk敗北(world))
					{
						yield return null;
					}
					world.Factions[0].DoesNotLose = false;
					world.Factions[0].Lose();
					break;
				}

				// スペル発動
				if (marisaUnit.Exists() && !executedMarisaSpall2)
				{
					TryCallMarisaSpell2(world, marisaUnit);
				}

				/*
				if (mikoUnit.Exists() && !executedMikoSpall)
				{
					TryCallMikoSpell(world, mikoUnit);
				}

				if (marisaUnit.Exists() && !executedSuikaSpall)
				{
					TryCallSuikaSpell(world, marisaUnit);
				}
				if (reimuUnit.Exists() && !executedLylicaSpall)
				{
					TryCallLylicaSpell(world, reimuUnit);
				}
				*/

				// 萃香突撃
				/*
				if (c > 0 && c % (thrts.Def.FPS * 60 * 5) == 0)
				{
					if (marisaUnit.Exists())
					{
						var uniqueIDs = new List<int>();
						uniqueIDs.Add(marisaUnit.UniqueID);

						world.UnitManager.AttackMove(uniqueIDs, redHome, false);
					}
				}

				// 幽々子突撃
				if (c > 0 && c % (thrts.Def.FPS * 60 * 10) == 0)
				{
					if (yuyukoUnit.Exists())
					{
						var uniqueIDs = new List<int>();
						uniqueIDs.Add(yuyukoUnit.UniqueID);

						world.UnitManager.AttackMove(uniqueIDs, redHome, false);
					}
				}
				*/

				// ざこ
				if (c % enemySpan == 0)
				{
					if (c >= enemySpan * 5)
					{
						if (c == enemySpan * 5)
						{
							foreach (var low in whiteLow)
							{
								if (low.Exists())
								{
									List<int> uniqueIDs = new List<int>();
									var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.White.Low02).FullName, low);
									uniqueIDs.Add(l1.UniqueID);
									var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.White.Low02).FullName, low);
									uniqueIDs.Add(l2.UniqueID);
									var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.White.Low02).FullName, low);
									uniqueIDs.Add(l3.UniqueID);
									var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.White.Low02).FullName, low);
									uniqueIDs.Add(l4.UniqueID);
									world.UnitManager.AttackMove(uniqueIDs, blueHome, false);
								}
							}
						}
						else if (c == enemySpan * 8)
						{
							if (world.StoryUtilities.GetDifficulty() > 1)
							{
								foreach (var low in whiteLow)
								{
									if (low.Exists())
									{
										List<int> uniqueIDs = new List<int>();
										var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.White.Toramaru).FullName, low);
										uniqueIDs.Add(l1.UniqueID);
										world.UnitManager.AttackMove(uniqueIDs, blueHome, false);
									}
								}
							}

							foreach (var low in whiteLow)
							{
								if (low.Exists())
								{
									List<int> uniqueIDs = new List<int>();
									var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.White.Low02).FullName, low);
									uniqueIDs.Add(l1.UniqueID);
									var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.White.Low02).FullName, low);
									uniqueIDs.Add(l2.UniqueID);
									var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.White.Low02).FullName, low);
									uniqueIDs.Add(l3.UniqueID);
									var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.White.Low02).FullName, low);
									uniqueIDs.Add(l4.UniqueID);
									world.UnitManager.AttackMove(uniqueIDs, blueHome, false);
								}
							}
						}
						else
						{
							if (world.StoryUtilities.GetDifficulty() > 1)
							{
								foreach (var low in whiteLow)
								{
									if (low.Exists())
									{
										List<int> uniqueIDs = new List<int>();
										var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.White.Toramaru).FullName, low);
										uniqueIDs.Add(l1.UniqueID);
										var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.White.Toramaru).FullName, low);
										uniqueIDs.Add(l2.UniqueID);
										world.UnitManager.AttackMove(uniqueIDs, blueHome, false);
									}
								}
							}

							foreach (var low in whiteLow)
							{
								if (low.Exists())
								{
									List<int> uniqueIDs = new List<int>();
									var l1 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.White.Low02).FullName, low);
									uniqueIDs.Add(l1.UniqueID);
									var l2 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.White.Low02).FullName, low);
									uniqueIDs.Add(l2.UniqueID);
									var l3 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.White.Low02).FullName, low);
									uniqueIDs.Add(l3.UniqueID);
									var l4 = Utl.PutUnitAroundBuilding(world, world.Factions[1], typeof(LotusCraft.Unit.White.Low02).FullName, low);
									uniqueIDs.Add(l4.UniqueID);
									world.UnitManager.AttackMove(uniqueIDs, blueHome, false);
								}
							}
						}
					}
				}

				c++;
				yield return null;
			}

			yield return base.Update(world);
		}

		void TryCallMarisaSpell1(IWorld world, IUnit marisaUnit)
		{
			if (executedMarisaSpall1) return;

			marisaUnit.LvUpSpellWithName("儀符「オーレリーズサン」", 3);
			executedMarisaSpall1 = true;
		}

		private void TryCallMarisaSpell2(IWorld world, IUnit marisaUnit)
		{
			if (executedMarisaSpall2) return;

			var units = world.UnitManager.GetUnits(_ => _.Faction == world.Factions[0]);
			foreach (var u in units)
			{
				var radius = 6 * thrts.Def.MapTipLengthOnField;

				if (radius * radius > (u.Pos.X - marisaUnit.Pos.X) * (u.Pos.X - marisaUnit.Pos.X) + (u.Pos.Y - marisaUnit.Pos.Y) * (u.Pos.Y - marisaUnit.Pos.Y))
				{
					var targetPos = u.Pos;
					var spell = world.Factions[1].GetUnitSpellButtonParameter(marisaUnit.Parameter.GetType().FullName, new SpellButtonKey("魔砲「マスタースパーク」", 1));
					spell.SelectPlaceButtonEvent(marisaUnit, new Vector2D(u.Pos.X, u.Pos.Y), false);
					executedMarisaSpall2 = true;
				}
			}
		}

		/*
		private void TryCallMikoSpell(IWorld world, IUnit mikoUnit)
		{
			if (executedMikoSpall) return;

			var units = world.UnitManager.GetUnits(_ => _.Faction == world.Factions[0]);
			foreach (var u in units)
			{
				var radius = 6 * thrts.Def.MapTipLengthOnField;

				if (radius * radius > (u.Pos.X - mikoUnit.Pos.X) * (u.Pos.X - mikoUnit.Pos.X) + (u.Pos.Y - mikoUnit.Pos.Y) * (u.Pos.Y - mikoUnit.Pos.Y))
				{
					var targetPos = u.Pos;
					var spell = world.Factions[2].GetUnitSpellButtonParameter(mikoUnit.Parameter.GetType().FullName, new SpellButtonKey("神光「逆らう事なきを宗とせよ」", 1));
					spell.SelectPlaceButtonEvent(mikoUnit, new Vector2D(u.Pos.X, u.Pos.Y), false);
					executedMikoSpall = true;
				}
			}
		}

		private void TryCallSuikaSpell(IWorld world, IUnit suikaUnit)
		{
			if (executedSuikaSpall) return;

			var units = world.UnitManager.GetUnits(_ => _.Faction == world.Factions[0]);
			foreach (var u in units)
			{
				var radius = 6 * thrts.Def.MapTipLengthOnField;

				if (radius * radius > (u.Pos.X - suikaUnit.Pos.X) * (u.Pos.X - suikaUnit.Pos.X) + (u.Pos.Y - suikaUnit.Pos.Y) * (u.Pos.Y - suikaUnit.Pos.Y))
				{
					var targetPos = u.Pos;
					var spell = world.Factions[1].GetUnitSpellButtonParameter(suikaUnit.Parameter.GetType().FullName, new SpellButtonKey("鬼神「ミッシングパープルパワー」", 1));
					spell.NormalButtonEvent(suikaUnit, false);
					executedSuikaSpall = true;
				}
			}
		}

		private void TryCallLylicaSpell(IWorld world, IUnit lyUnit)
		{
			if (executedLylicaSpall || !lyUnit.Exists()) return;

			var units = world.UnitManager.GetUnits(_ => _.Faction == world.Factions[0]);
			foreach (var u in units)
			{
				var radius = 6 * thrts.Def.MapTipLengthOnField;

				if (radius * radius > (u.Pos.X - lyUnit.Pos.X) * (u.Pos.X - lyUnit.Pos.X) + (u.Pos.Y - lyUnit.Pos.Y) * (u.Pos.Y - lyUnit.Pos.Y))
				{
					var targetPos = u.Pos;
					var spell = world.Factions[1].GetUnitSpellButtonParameter(lyUnit.Parameter.GetType().FullName, new SpellButtonKey("騒符「リリカ・ソロライブ」", 1));
					spell.NormalButtonEvent(lyUnit, false);
					executedLylicaSpall = true;
				}
			}
		}
		*/


		#region Story
		private System.Collections.IEnumerable Talk会話冒頭(IWorld world)
		{
			var ui = world.StoryUI;

			#region Talk1
			ui.PauseGame();
			ui.Show();
			ui.ShowText("～人里～");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【紫】\n天子は好き放題に動いてて、チルノたちはそれなりに言うことは聞いてくれるけど……");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\n前からの因縁をこれで晴らそうとしているのも居たりと\nまぁ、それなりに成功したのかしら、ね");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\n霊夢には勘ぐられちゃったけど、なんとか納得して貰えたし");
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【霊夢】\nところで紫");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\nファッ！？");
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【霊夢】\n豪華景品をよこしなさいよ");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\nな、なんのことだかわからないのだけど");
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【霊夢】\nとぼけないでよ。確かに、豪華景品を用意してるって言ったわよね");
			ui.ShowText("【紫】\n(この子、初めから景品目当てで――)");
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【霊夢】\nまさか妖怪の賢者様ともあろうお方が、お言葉を違えるので？");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\nまぁ落ち着きなさい霊夢\n別に何を景品にしようとは考えていなかったとか、そういう事情はないんだから");
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【霊夢】\nあら？\n溜め込んでる高価なものがあるんじゃないの？");
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【霊夢】\n魔理沙が言ってたわ。あいつからは金の匂いがプンプンするって");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\nどういう嗅覚してるのよ……");
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【霊夢】\n私も鬼じゃないわ。いろいろ考えたけど");
			ui.ShowImage(Reimu[1], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【霊夢】\nこう、あんたたち妖怪同士で遊ぶのを黙認するから、手数料をこう、ね？");
			ui.ShowText("【紫】\nそんなヤクザなことを言う博麗の巫女なんて今代が初めてよ");
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【霊夢】\n私はいつだって最先端なの。");
			ui.ShowText("【霊夢】\n阿求のお陰でだいぶ誤魔化すことはできたけど、\n妖怪たちが活発化してるって、一部の人は神経質になってたりするのよ");
			ui.ShowText("【紫】\nそれはそうだろうけど");
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【霊夢】\nじゃあ迷惑料ってことでなんかよこしなさいよ");
			ui.ShowText("【紫】\nぐぬぬぬ……");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\nそうだわ。それこそ、決着を付けましょう。\n頼れる仲間たちとの絆を見せてもらうわ");
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【霊夢】\n仲間……？");
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【霊夢】\n絆……？");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\nなんでもいいから魔理沙たちを連れてきなさい");
			ui.ShowImage(Back1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【霊夢】\n連れてきたわよ");
			ui.ShowImage(Marisa[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【魔理沙】\n連れてこられてやったぜ");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\n手っ取り早く解決しましょう。\n私が勝ったら払わない。負けたら払う。");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\nそれでいいかしら");
			ui.ShowImage(Reimu[1], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【霊夢】\nいいわ。博麗の巫女は妖怪には決して屈しないのよ");
			ui.ShowImage(Marisa[2], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【魔理沙】\n冬の食事に一品付け足すために必死なんだ\n買い出しに行き辛いもんな。わかるよ");
			ui.ShowImage(Reimu[1], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【霊夢】\n世知辛い世の中だからこそ、本気よ\n食事の充実のためなら、私は魂を妖怪にも売ろう");
			ui.ShowImage(Hijiri[2], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【白蓮】\nというわけで、私たちも本気でやらせてもらいますよ");
			ui.ShowImage(Tenshi[1], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【天子】\nま、なんでもいいけどちゃっちゃと決着つけちゃいましょう\n好き勝手やらせてもらった恩もあるしね");
			ui.ShowImage(Koishi[1], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【こいし】\nそれなりに楽しかったかな？");
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【紫】\n正真正銘、これが最後の勝負よ");
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【霊夢】\n別に最後ってわけでもないと思うけど");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("", false);


			var talkEnd = ui.ShowText("");
			while (!ui.IsCompleted(talkEnd))
				yield return null;

			ui.Hide();
			ui.ResumeGame();
			#endregion


			yield return null;
		}



		private System.Collections.IEnumerable Talk勝利(IWorld world)
		{
			var ui = world.StoryUI;

			#region Talk12
			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Yukari[1], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【紫】\n勝った！　第三部完！");
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【霊夢】\nぐぬぬぬ……");
			ui.ShowImage(Marisa[2], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【魔理沙】\n負けちまったな。残念無念だリベンジだ");
			ui.ShowImage(Hijiri[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【白蓮】\nお互い全力を尽くしたのですし、勝ち負けなど些細なことですよ");
			ui.ShowImage(Reimu[1], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【霊夢】\nでも負けは負けなのよ\n悔しいのよ。当たり前だけど");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\n勝ったり負けたりで盛り上がれる内が華なのよ\n単純明快で、楽しいごっこ遊びのうちが");
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【霊夢】\nまぁ、そうなんだろうけど");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, true);
			ui.ShowImage(Koishi[1], StoryUIImagePosition.Front, true, false, true);
			ui.ShowText("【こいし】\nじゃあ私はそろそろ帰ろっかな\nたまにはお姉ちゃんのところにも顔を出してあげないといけないし");
			ui.ShowImage(-1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(Tenshi[0], StoryUIImagePosition.Front, true, false, true);
			ui.ShowText("【天子】\n私も、衣玖がブツブツ言う前に帰ろっかな");
			ui.ShowImage(Tenshi[2], StoryUIImagePosition.Front, false, false, true);
			ui.ShowText("【天子】\nもう言ってるかもしれないけど");
			ui.ShowImage(-1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(Nitori[1], StoryUIImagePosition.Front, true, false, true);
			ui.ShowText("【にとり】\nこういうのもなかなか楽しかったよ\nそれじゃあ私も帰るね、山来ることがあったらその時はよろしく盟友達");
			ui.ShowImage(-1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(Mystia[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowImage(Chilno[1], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【チルノ】\nアタイたちはこれから森で妖精たちに広めてくる！");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, true);
			ui.ShowImage(Hijiri[0], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【白蓮】\n私達も寺に戻ります");
			ui.ShowImage(Ichirin[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【一輪】\nお疲れ様、戻ったら村紗たちとも遊んでみようかしら？");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, true);
			ui.ShowImage(Eirin[0], StoryUIImagePosition.Front, true, false, true);
			ui.ShowText("【永琳】\nこれでひとまずの顛末は過ぎたかしら？\n姫へのみやげ話にはなりそうね");
			ui.ShowImage(-1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(Akyu[0], StoryUIImagePosition.Front, true, false, true);
			ui.ShowText("【阿求】\nそれでは私も");
			ui.ShowImage(Akyu[1], StoryUIImagePosition.Front, false, false, true);
			ui.ShowText("【阿求】\n博麗の巫女ではなく霊夢としての話、この話も纒めておきませんと");
			ui.ShowImage(-1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(Marisa[0], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【魔理沙】\nんじゃー私は神社にでも茶をしばきに");
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【霊夢】\n素直に帰りなさいよ、あんたは");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【紫】\nじゃあ私も、神社に行こうかしら");
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【霊夢】\nあー、うーん");
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【霊夢】\nまぁ、あんたにしては珍しく、許可を取ってきてるし、来なさいよ");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\nそうさせてもらうわね");
			ui.ShowImage(Back1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Front, true, false, true);
			ui.ShowText("勝ち負けの境界が明確な遊び\n泥沼や焦土に成り果てた諍いも数え切れないほどある今世では、どれだけ救われたことなのだろう。");
			ui.ShowText("いずれ遊びに収まらないことも起きるかもしれないが、\nそうならないように努力するのが自分の役目である。");
			ui.ShowText("願わくば、このような平々凡々な日々が、一日でも長く続くことを。");
			ui.ShowImage(-1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【霊夢】\n早く来なさいよ");
			ui.ShowImage(Yukari[0], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【紫】\nええ。すぐに行きますわ");
			ui.ShowText("", false);


			var talkEnd0 = ui.ShowText("", false);
			while (!ui.IsCompleted(talkEnd0))
				yield return null;
			ui.Hide();
			ui.ResumeGame();
			#endregion

			yield return null;
		}

		private System.Collections.IEnumerable Talk敗北(IWorld world)
		{
			var ui = world.StoryUI;

			ui.PauseGame();
			ui.Show();
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【霊夢】\n私達が優勝、文句はないわね");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Right, true, false, true);
			ui.ShowText("【紫】\n待ちなさい霊夢、正式な勝利は立会人が…");
			ui.ShowImage(Reimu[2], StoryUIImagePosition.Left, false, false, true);
			ui.ShowText("【霊夢】\n言質は取ってるわよ");
			ui.ShowImage(Akyu[1], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【霊夢】\nこっちには御阿礼の子もいるんだから");
			ui.ShowImage(Yukari[2], StoryUIImagePosition.Right, false, false, true);
			ui.ShowText("【紫】\nぐぬぬぬぬ…");
			ui.ShowImage(Reimu[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【霊夢】\nというわけで、魔理沙さっそく貰いに行きましょう\n山分けだからなるだけ多く、マヨヒガの枡があったらそれは私が予約しておくわ！");
			ui.ShowImage(Marisa[0], StoryUIImagePosition.Left, true, false, true);
			ui.ShowText("【魔理沙】\nたしか瓶でも茶碗でもいいんだよな？よしまかされよう");
			ui.ShowImage(-1, StoryUIImagePosition.Right, true, false, false);
			ui.ShowImage(-1, StoryUIImagePosition.Left, true, false, true);
			ui.ShowImage(Back1, StoryUIImagePosition.Front, true, false, true);
			ui.ShowText("その後、博麗の巫女は米櫃が尽きる事無く毎日白いご飯を食べれるようになり");
			ui.ShowText("スキマ妖怪は狐さんにこっぴどく叱られたそうな、めでたしめでたし");
			var talkEnd0 = ui.ShowText("", false);
			while (!ui.IsCompleted(talkEnd0))
				yield return null;
			ui.Hide();
			ui.ResumeGame();

			yield return null;
		}
		#endregion

		private int[] LoadTachies(IStoryUI ui, string path_N, string path_S, string path_W)
		{
			return new int[3]{
				ui.LoadImage( path_N ),
				ui.LoadImage( path_S ),
				ui.LoadImage( path_W )
			};
		}

		/// <summary>
		/// ユニットをエリア上に生成する。
		/// </summary>
		/// <param name="world"></param>
		/// <param name="faction"></param>
		/// <param name="paramType"></param>
		/// <param name="area"></param>
		/// <returns></returns>
		public IEnumerable<IUnit> PutUnitsOnArea(IWorld world, IFaction faction, Type paramType, Area area)
		{
			var ar = area as AreaRectangle;
			if (ar == null) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min(ar.Start.X, ar.End.X);
			var sy = Math.Min(ar.Start.Y, ar.End.Y);
			var ex = Math.Max(ar.Start.X, ar.End.X);
			var ey = Math.Max(ar.Start.Y, ar.End.Y);

			for (var y = sy; y <= ey; y++)
			{
				for (var x = sx; x <= ex; x++)
				{
					var u =
						world.UnitManager.Create(paramType.FullName, faction, (x + 0.5f) * thrts.Def.MapTipLengthOnField, (y + 0.5f) * thrts.Def.MapTipLengthOnField, faction);
					if (u != null) units.Add(u);
				}
			}

			return units;
		}

		public IEnumerable<IUnit> PutEnemy(IWorld world, Type unitType, Area area, int num, IBuilding target)
		{
			var rect = area as AreaRectangle;
			if (rect == null) return new IUnit[0];

			List<IUnit> units = new List<IUnit>();

			var sx = Math.Min(rect.Start.X, rect.End.X);
			var sy = Math.Min(rect.Start.Y, rect.End.Y);
			var ex = Math.Max(rect.Start.X, rect.End.X);
			var ey = Math.Max(rect.Start.Y, rect.End.Y);

			for (var y = sy; y < ey; y++)
			{
				for (var x = sx; x < ex; x++)
				{
					if (units.Count >= num)
						goto LoopEnd;

					var u = world.UnitManager.Create(
						unitType.FullName,
						world.Factions[1],
						(x + 0.5f) * thrts.Def.MapTipLengthOnField,
						(y + 0.5f) * thrts.Def.MapTipLengthOnField,
						world.Factions[1]);
					if (u != null)
						units.Add(u);
				}
			}
		LoopEnd:

			if (target != null)
				world.UnitManager.SelectTarget(units, new Vector2D(target.Pos.X, target.Pos.Y), false);

			return units;
		}

		bool IsUnitOnArea(AreaRectangle region, IUnit unit)
		{
			var startx = Math.Min(region.Start.X, region.End.X) * Def.MapTipLengthOnField;
			var starty = Math.Min(region.Start.Y, region.End.Y) * Def.MapTipLengthOnField;
			var endx = Math.Max(region.Start.X, region.End.X) * Def.MapTipLengthOnField;
			var endy = Math.Max(region.Start.Y, region.End.Y) * Def.MapTipLengthOnField;
			if (unit.Pos.X < endx && startx < unit.Pos.X && unit.Pos.Y < endy && starty < unit.Pos.Y)
			{
				return true;
			}
			return false;
		}

		IEnumerable<IBuilding> GetBuildings<T>(IWorld world) where T : BuildingParameter
		{
			return world.BuildingManager.GetBuildings(_ => _.Parameter.GetType() == typeof(T));
		}
	}
}

#endif