using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Unit.Black;
using LotusCraft.Building.Black;
using LotusCraft.Spell.Black;
using LotusCraft.Bullet.Black;

namespace LotusCraft.Technology.Black
{
	public class BuildingHpLv1Tech : BuildingHPTech
	{
		public BuildingHpLv1Tech()
			:base()
		{
			this.Name += "";
			this.ButtonDescription+="\n"+"";
			this.Costs = new [] {125,125,0,0};
			this.TechTime = 120 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Factory).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/building_hp1";
		}
	}
	public class BuildingArmorLv1Tech : BuildingArmorTech
	{
		public BuildingArmorLv1Tech()
			:base()
		{
			this.Name += " 前編";
			this.ButtonDescription+="\n"+"";
			this.Costs = new [] {150,150,0,0};
			this.TechTime = 150 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Factory).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/building_defence1";
			this.NextLevel = 1;
		}
	}
	public class BuildingArmorLv2Tech : BuildingArmorTech
	{
		public BuildingArmorLv2Tech()
			:base()
		{
			this.Name += " 後編";
			this.ButtonDescription+="\n"+"";
			this.Costs = new [] {300,300,0,0};
			this.TechTime = 180 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Factory).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/building_defence2";
		}
	}
	public class InfantryArmorLv1Tech : UnitArmorTech
	{
		public InfantryArmorLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(Low02).FullName,
				typeof(Low03).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_defence1";
			this.NextLevel = 1;
		}
	}
	public class InfantryArmorLv2Tech : UnitArmorTech
	{
		public InfantryArmorLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.ButtonDescription+="\n"+"";
			this.TechTime = 120 *Def.FPS;
			this.RequireTechnologies = new string[]{
				typeof(InfantryArmorLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low02).FullName,
				typeof(Low03).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_defence2";
			this.NextLevel = 2;
		}
	}
	public class InfantryArmorLv3Tech : UnitArmorTech
	{
		public InfantryArmorLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.ButtonDescription+="\n"+"";
			this.Costs = new [] {250,250,0,0};
			this.TechTime = 150 *Def.FPS;
			this.RequireTechnologies = new string[]{
				typeof(InfantryArmorLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low02).FullName,
				typeof(Low03).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_defence3";
		}
	}
	public class GunLv1Tech : GunTech
	{
		public GunLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(Low02Bullet).FullName,
				typeof(Low03Bullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_attack1";
			this.NextLevel = 1;
		}
	}
	public class GunLv2Tech : GunTech
	{
		public GunLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.ButtonDescription+="\n"+"";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 *Def.FPS;
			this.RequireTechnologies = new string[]{
				typeof(GunLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low02Bullet).FullName,
				typeof(Low03Bullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_attack2";
			this.NextLevel = 2;
		}
	}
	public class GunLv3Tech : GunTech
	{
		public GunLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.Costs = new [] {250,250,0,0};
			this.TechTime = 150 *Def.FPS;
			this.ButtonDescription+="\n"+"";
			this.RequireTechnologies = new string[]{
				typeof(GunLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low02Bullet).FullName,
				typeof(Low03Bullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_attack3";
		}
	}
	public class CannonArmorLv1Tech : CannonArmorTech
	{
		public CannonArmorLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(Orin).FullName,
				typeof(Satori).FullName,
				typeof(Oku).FullName,
				typeof(Youmu).FullName,
				typeof(Mamizou).FullName,
				typeof(Kokoro).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_defence1";
			this.NextLevel = 1;
		}
	}
	public class CannonArmorLv2Tech : CannonArmorTech
	{
		public CannonArmorLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 *Def.FPS;
			this.ButtonDescription+="\n"+"";
			this.RequireTechnologies = new string[]{
				typeof(CannonArmorLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Orin).FullName,
				typeof(Satori).FullName,
				typeof(Oku).FullName,
				typeof(Youmu).FullName,
				typeof(Mamizou).FullName,
				typeof(Kokoro).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_defence2";
			this.NextLevel = 2;
		}
	}
	public class CannonArmorLv3Tech : CannonArmorTech
	{
		public CannonArmorLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.ButtonDescription+="\n"+"";
			this.TechTime = 150 *Def.FPS;
			this.Costs = new [] {250,250,0,0};
			this.RequireTechnologies = new string[]{
				typeof(CannonArmorLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Orin).FullName,
				typeof(Satori).FullName,
				typeof(Oku).FullName,
				typeof(Youmu).FullName,
				typeof(Mamizou).FullName,
				typeof(Kokoro).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_defence3";
		}
	}
	public class CannonAtkLv1Tech : CannonAtkTech
	{
		public CannonAtkLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(OrinBullet).FullName,
				typeof(SatoriBullet).FullName,
				typeof(OkuBullet).FullName,
				typeof(YoumuBullet).FullName,
				typeof(MamizouBullet).FullName,
				typeof(KokoroBullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_attack1";
			this.NextLevel = 1;
		}
	}
	public class CannonAtkLv2Tech : CannonAtkTech
	{
		public CannonAtkLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.ButtonDescription+="\n"+"";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 *Def.FPS;
			this.RequireTechnologies = new string[]{
				typeof(CannonAtkLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(OrinBullet).FullName,
				typeof(SatoriBullet).FullName,
				typeof(OkuBullet).FullName,
				typeof(YoumuBullet).FullName,
				typeof(MamizouBullet).FullName,
				typeof(KokoroBullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_attack2";
			this.NextLevel = 2;
		}
	}
	public class CannonAtkLv3Tech : CannonAtkTech
	{
		public CannonAtkLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.ButtonDescription+="\n"+"";
			this.Costs = new [] {250,250,0,0};
			this.TechTime = 150 *Def.FPS;
			this.RequireTechnologies = new string[]{
				typeof(CannonAtkLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(OrinBullet).FullName,
				typeof(SatoriBullet).FullName,
				typeof(OkuBullet).FullName,
				typeof(YoumuBullet).FullName,
				typeof(MamizouBullet).FullName,
				typeof(KokoroBullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_attack3";
		}
	}
	/*
	public class YoumuSkillTech : SpecialSkillTech
	{
		public YoumuSkillTech(ButtonPosition x = ButtonPosition._0,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(YoumuSkill).FullName;
			this.Name = "魂魄妖夢修練 基本編";
			this.Description = "相手の防御力を無視します。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.ButtonDescription = "";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.RequireBuildings = new string[]
			{
				typeof(Factory).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/Black/YoumuSkill";
		}
	}
	public class SatoriSkillTech : SpecialSkillTech
	{
		public SatoriSkillTech(ButtonPosition x = ButtonPosition._1,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(SatoriSkill).FullName;
			this.Name = "古明地さとり修練 基本編";
			this.Description = "周囲の敵の攻撃力を大幅に低下させます。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.RequireBuildings = new string[]
			{
				typeof(Factory).FullName,
				typeof(Chireiden).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/Black/SatoriSkill";
		}
	}
	public class OrinSkillTech : SpecialSkillTech
	{
		public OrinSkillTech(ButtonPosition x = ButtonPosition._2,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(OrinSkill).FullName;
			this.Name = "ちびお燐修練 基本編";
			this.Description = "攻撃がヒットしたユニットは、死亡時に爆発します。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.RequireBuildings = new string[]
			{
				typeof(Factory).FullName,
				typeof(Chireiden).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/Black/OrinSkill";

		}
	}
	public class OkuSkillTech : SpecialSkillTech
	{
		public OkuSkillTech(ButtonPosition x = ButtonPosition._3,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(OkuSkill).FullName;
			this.Name = "ちびお空修練 基本編";
			this.Description = "周囲のユニットにダメージを与える。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.RequireBuildings = new string[]
			{
				typeof(Factory).FullName,
				typeof(Chireiden).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/Black/OkuSkill";
		}
	}
	*/
}
