﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Unit.Blue;
using LotusCraft.Building.Blue;
using LotusCraft.Spell.Blue;
using LotusCraft.Bullet.Blue;

namespace LotusCraft.Technology.Blue
{
	public class BuildingHpLv1Tech : BuildingHPTech
	{
		public BuildingHpLv1Tech()
			:base()
		{
			this.Name += "";
			this.ButtonDescription+="\n"+"";
			this.Costs = new [] {125,125,0,0};
			this.TechTime = 120 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Factory).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/building_hp1";
		}
	}
	public class BuildingArmorLv1Tech : BuildingArmorTech
	{
		public BuildingArmorLv1Tech()
			:base()
		{
			this.Name += " 前編";
			this.ButtonDescription+="\n"+"";
			this.Costs = new [] {150,150,0,0};
			this.TechTime = 150 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Factory).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/building_defence1";
			this.NextLevel = 1;
		}
	}
	public class BuildingArmorLv2Tech : BuildingArmorTech
	{
		public BuildingArmorLv2Tech()
			:base()
		{
			this.Name += " 後編";
			this.ButtonDescription+="\n"+"必要建物 : 上級魔法陣";
			this.Costs = new [] {300,300,0,0};
			this.TechTime = 180 *Def.FPS;
			this.TechTargets = new string[]
			{
				typeof(HomeBase).FullName,
				typeof(ProduceResType0).FullName,
				typeof(ProduceResType1).FullName,
				typeof(Barrack).FullName,
				typeof(BlackSmith).FullName,
				typeof(Tower).FullName,
				typeof(Factory).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/building_defence2";
		}
	}
	public class InfantryArmorLv1Tech : UnitArmorTech
	{
		public InfantryArmorLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.armorInc += 0;
			this.TechTargets = new string[]
			{
				typeof(Low02).FullName,
				typeof(Low03).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_defence1";
			this.NextLevel = 1;
		}
	}
	public class InfantryArmorLv2Tech : UnitArmorTech
	{
		public InfantryArmorLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 *Def.FPS;
			this.armorInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(InfantryArmorLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low02).FullName,
				typeof(Low03).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_defence2";
			this.NextLevel = 2;
		}
	}
	public class InfantryArmorLv3Tech : UnitArmorTech
	{
		public InfantryArmorLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.Costs = new [] {250,250,0,0};
			this.TechTime = 150 *Def.FPS;
			this.armorInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(InfantryArmorLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low02).FullName,
				typeof(Low03).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_defence3";
		}
	}
	public class GunLv1Tech : GunTech
	{
		public GunLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.atkInc += 0;
			this.TechTargets = new string[]
			{
				typeof(Low02Bullet).FullName,
				typeof(Low03Bullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_attack1";
			this.NextLevel = 1;
		}
	}
	public class GunLv2Tech : GunTech
	{
		public GunLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 *Def.FPS;
			this.atkInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(GunLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low02Bullet).FullName,
				typeof(Low03Bullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_attack2";
			this.NextLevel = 2;
		}
	}
	public class GunLv3Tech : GunTech
	{
		public GunLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.Costs = new [] {250,250,0,0};
			this.TechTime = 150 *Def.FPS;
			this.atkInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(GunLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Low02Bullet).FullName,
				typeof(Low03Bullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/low_attack3";
		}
	}
	public class CannonArmorLv1Tech : CannonArmorTech
	{
		public CannonArmorLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.armorInc += 0;
			this.TechTargets = new string[]
			{
				typeof(Iku).FullName,
				typeof(Star).FullName,
				typeof(Lunar).FullName,
				typeof(Sunny).FullName,
				typeof(LetyBullet).FullName,
				typeof(HighFairyBullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_defence1";
			this.NextLevel = 1;
		}
	}
	public class CannonArmorLv2Tech : CannonArmorTech
	{
		public CannonArmorLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 *Def.FPS;
			this.armorInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(CannonArmorLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Iku).FullName,
				typeof(Star).FullName,
				typeof(Lunar).FullName,
				typeof(Sunny).FullName,
				typeof(LetyBullet).FullName,
				typeof(HighFairyBullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_defence2";
			this.NextLevel = 2;
		}
	}
	public class CannonArmorLv3Tech : CannonArmorTech
	{
		public CannonArmorLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.TechTime = 150 *Def.FPS;
			this.Costs = new [] {250,250,0,0};
			this.armorInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(CannonArmorLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(Iku).FullName,
				typeof(Star).FullName,
				typeof(Lunar).FullName,
				typeof(Sunny).FullName,
				typeof(Lety).FullName,
				typeof(HighFairy).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_defence3";
		}
	}
	public class CannonAtkLv1Tech : CannonAtkTech
	{
		public CannonAtkLv1Tech()
			:base()
		{
			this.Name += " 初級編";
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.atkInc += 0;
			this.TechTargets = new string[]
			{
				typeof(IkuBullet).FullName,
				typeof(StarBullet).FullName,
				typeof(LunarBullet).FullName,
				typeof(SunnyBullet).FullName,
				typeof(LetyBullet).FullName,
				typeof(HighFairyBullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_attack1";
			this.NextLevel = 1;
		}
	}
	public class CannonAtkLv2Tech : CannonAtkTech
	{
		public CannonAtkLv2Tech()
			:base()
		{
			this.Name += " 中級編";
			this.Costs = new [] {175,175,0,0};
			this.TechTime = 120 *Def.FPS;
			this.atkInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(CannonAtkLv1Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(IkuBullet).FullName,
				typeof(StarBullet).FullName,
				typeof(LunarBullet).FullName,
				typeof(SunnyBullet).FullName,
				typeof(LetyBullet).FullName,
				typeof(HighFairyBullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_attack2";
			this.NextLevel = 2;
		}
	}
	public class CannonAtkLv3Tech : CannonAtkTech
	{
		public CannonAtkLv3Tech()
			:base()
		{
			this.Name += " 上級編";
			this.Costs = new [] {250,250,0,0};
			this.TechTime = 150 *Def.FPS;
			this.atkInc += 0;
			this.RequireTechnologies = new string[]{
				typeof(CannonAtkLv2Tech).FullName,
			};
			this.RequireBuildings = new string[] {
				typeof(Factory).FullName,
			};
			this.TechTargets = new string[]
			{
				typeof(IkuBullet).FullName,
				typeof(StarBullet).FullName,
				typeof(LunarBullet).FullName,
				typeof(SunnyBullet).FullName,
				typeof(LetyBullet).FullName,
				typeof(HighFairyBullet).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/high_attack3";
		}
	}
	/*
	public class IkuSkillTech : SpecialSkillTech
	{
		public IkuSkillTech(ButtonPosition x = ButtonPosition._0,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(IkuSkill).FullName;
			this.Name = "永江衣玖修練 基本編";
			this.Description = "攻撃が即時必中になり、攻撃が命中したユニットの移動速度を低下させます。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.RequireBuildings = new string[]
			{
				typeof(Factory).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/Blue/IkuSkill";
		}
	}
	public class SunnySkillTech : SpecialSkillTech
	{
		public SunnySkillTech(ButtonPosition x = ButtonPosition._1,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(SunnySkill).FullName;
			this.Name = "サニーミルク修練 基本編";
			this.Description = "周囲の味方ユニットが、敵AIに見つからないようになります。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.RequireBuildings = new string[]
			{
				typeof(Factory).FullName,
				typeof(BigTree).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/Blue/SunnyMilkSkill";
		}
	}
	public class LunarSkillTech : SpecialSkillTech
	{
		public LunarSkillTech(ButtonPosition x = ButtonPosition._2,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(LunarSkill).FullName;
			this.Name = "ルナチャイルド修練 基本編";
			this.Description = "味方のみ通行可能な壁を出現させます。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.RequireBuildings = new string[]
			{
				typeof(Factory).FullName,
				typeof(BigTree).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/Blue/LunaChildSkill";

		}
	}
	public class StarSkillTech : SpecialSkillTech
	{
		public StarSkillTech(ButtonPosition x = ButtonPosition._3,ButtonPosition y = ButtonPosition._2)
		{
			this.skillName = typeof(StarSkill).FullName;
			this.Name = "スターサファイア修練 基本編";
			this.Description = "探知モードになる事ができます。";
			this.ButtonDescription = Description;
			this.ButtonPosX = x;
			this.ButtonPosY = y;
			this.Costs = new [] {100,100,0,0};
			this.TechTime = 90 *Def.FPS;
			this.RequireBuildings = new string[]
			{
				typeof(Factory).FullName,
				typeof(BigTree).FullName,
			};
			this.IconPath = "LotusCraft/Image/Button/Technology/Blue/StarSafireSkill";
		}
	}
	*/
}
