﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.Black;
using LotusCraft.Bullet.Black;
using LotusCraft.Building.Black;

namespace LotusCraft.Unit.Black
{
	public class FlyBomber : General.Fly
	{
		public FlyBomber ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Black/Fly02";
			#endregion

			#region UnitParams
			Name = "UFO(対地)";
			HP = 180;
			Armor = 0;
			Speed =1.3f * BasisSpeed;
			
			PopulationWeight = 3;
			
			ViewRange = 12 * Def.MapTipLengthOnField;
			
			MakingTime = 55 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {125,125,0,0};
			UnitType = new TargetObjectType[]{TargetObjectType.Water,};
			CanState = false;//他のオブジェに駐留可能か
            ButtonDescription = "飛行・対地ユニット\n高い連射性能を持つ\n";
			#endregion

			#region Animation
			this.SetUFOAnimation("LotusCraft/Image/Unit/Black/Fly02");
			Animation.HasDirection = false;
			AnimationWalk.HasDirection = false;
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(Fly01Bullet).FullName, };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			#region Buttons
			#endregion
			base.OnLoad (faction);
		}
		public override void OnAppear (IUnit unit)
		{
			if(null != unit)
				unit.AbilityManager.AppendAbility(new Ability.Common.UFOCloakAbility());
			base.OnAppear (unit);
		}
	}
}
namespace LotusCraft.Bullet.Black
{
	public class Fly01Bullet : General.MiddleRangeBullet
	{
		public Fly01Bullet()
		{
			Type = BulletType.LongRange;
			DoesHitOnlyTarget = true;
			this.Attack = 5;
			
			HasSplash = true;
			SplashDamageRates.Add(0.75f * Def.MapTipLengthOnField, 0.75f);
			
			Speed = 10.0f * BasisSpeed;
			SpaceType = BulletSpaceType.Earth;
			MaxRange = 3 * Def.MapTipLengthOnField;
			
			AttackDelay = 0*Def.FPS;
			AttackRigor = 0 * Def.FPS;
			AttackSpeed = (int)(0.2f*Def.FPS);

			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 0;
			TextureAnimation.Center.Y = 0;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 1;
			TextureAnimation.Count.Y = 1;
			TextureAnimation.Offset.X = 128 * 2 + 16 * 0;
			TextureAnimation.Offset.Y = 128 * 1 + 16 * 0;
			TextureAnimation.AlphaBlend = AlphaBlend.Add;
		}
        static void OnHitEffect(IBullet bullet, ITargetObject target)
        {
            LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
        }
	}
}
