﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Black;
using LotusCraft.Building.Black;
using LotusCraft.Effect.Black;
using LotusCraft.Spell.Black;

namespace LotusCraft.Unit.Black
{
	public class Oku : General.Special
	{
		public Oku ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Black/Oku";
			#endregion

			#region UnitParams
			Name = "霊烏路 空(式神)";
			HP = 380;
			Armor = 2;
			Radius = (float)Utls.UnitSize.Large;
			Speed = 1.1f * BasisSpeed;

			PopulationWeight = 2;

//			ViewRange = 6*Def.MapTipLengthOnField;
            ButtonDescription = "近接ユニット\n耐久力が高く、周囲の敵ユニットにダメージを与える";

			UnitType = new TargetObjectType[]{TargetObjectType.Clay,};

			Costs = new [] {125,150,0,0};

			MakingTime = 38 * Def.FPS;

			RequireBuildings = new string[]{
				typeof(Chireiden).FullName,
			};

			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Black/Oku");
			#endregion

			#region BuildableObjcets
//			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(OkuBullet).FullName };
			#endregion
		}

		public override void OnLoad (IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new OkuSkill (),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit> (SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
			};
			#endregion
			
			base.OnLoad(faction);
		}
	}
}

namespace LotusCraft.Bullet.Black
{
	public class OkuBullet : General.ShortRangeBullet
	{
		public OkuBullet()
		{
			Type = BulletType.ShortRange;
			this.Attack = 60;
			DamageBonus[(int)TargetObjectType.Water] = 1.6f;
			DamageBonus[(int)TargetObjectType.Structure] = 1.2f;
			Speed = 10.0f * BasisSpeed;
//			MaxRange = 1 * Def.MapTipLengthOnField;

			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(3.0f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;


			OnHit = OnHitEffect;
			
			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/ball_yellow";
			TextureAnimation.AlphaBlend = AlphaBlend.Add;
			TextureAnimation.Width = 32;
			TextureAnimation.Height = 32;
			TextureAnimation.Center.X = 16;
			TextureAnimation.Center.Y = 16;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 4;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 4;
		}
        static void OnHitEffect(IBullet bullet, ITargetObject target)
        {
            LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
        }
	}
}
