using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Black;
using LotusCraft.Building.Black;
using LotusCraft.Effect.Black;

namespace LotusCraft.Unit.Black
{
	public class Orin : General.Special
	{
		public Orin()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Black/Orin";
			#endregion

			#region UnitParams
			Name = "火焔猫 燐(式神)";
			HP = 350;
			Radius = (float)Utls.UnitSize.Large;
			Armor = 0;
			Speed = 1.0f * BasisSpeed;

			PopulationWeight = 5;

			ViewRange = 14 * Def.MapTipLengthOnField;

			MakingTime = 48 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {150,175,0,0};

			ButtonDescription = "遠距離砲撃ユニット\n範囲攻撃を持ち撃破した敵ユニットを爆破させ周囲にダメージを与える";
			Description = _ => ButtonDescription.Split('\n').Select(s => new ColorTextLine(s));
			UnitType = new TargetObjectType[]{TargetObjectType.Water,};

			RequireBuildings = new string[]{
				typeof(Chireiden).FullName,
			};

			#endregion
			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Black/Orin");
			#endregion

			#region BuildableObjcets
//			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(OrinBullet).FullName };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Black.OrinSkill (),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit> (SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
			};
			#endregion

			base.OnLoad(faction);
		}
	}
}


namespace LotusCraft.Bullet.Black
{
	public class OrinBullet : General.CannonBullet
	{
		public OrinBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Earth;

			HasSplash = true;
			IsSplashMissHit = true;
			SplashDamageRates.Add(0.4f * Def.MapTipLengthOnField, 0.50f);
			SplashDamageRates.Add(0.7f * Def.MapTipLengthOnField, 0.25f);
			SplashDamageRates.Add(1.1f * Def.MapTipLengthOnField, 0.125f);

			this.Attack = 24;
			DamageBonus[(int)TargetObjectType.Clay] = 1.5f;
			DamageBonus[(int)TargetObjectType.Structure] = 2.0f;
			Speed = 7.0f * BasisSpeed;

			MaxRange = 7 * Def.MapTipLengthOnField;

			AttackDelay = (int)(0.5f * Def.FPS);
			AttackRigor = (int)(1.0f * Def.FPS);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;

			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/ball_red";
			TextureAnimation.AlphaBlend = AlphaBlend.Add;
			TextureAnimation.Width = 32;
			TextureAnimation.Height = 32;
			TextureAnimation.Center.X = 0;
			TextureAnimation.Center.Y = 0;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 1;
			TextureAnimation.Count.Y = 1;
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.ColumnRed);
			
			/*
			var unit = bullet.Generator as IUnit;
			if (unit != null &&
				unit.Exists() &&
				!unit.AbilityManager.ContainsAbility(LotusCraft.Ability.Black.OrinSkillAbility.AbilityName))
			{	
			}
			*/
		}
	}
}
