﻿#if !_TRIAL
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using LotusCraft.Bullet.Black;
using LotusCraft.Effect.Black;
using thrts;

namespace LotusCraft.Unit.Black.Unique
{
	public class Utsuho : General.Unique
    {
        public Utsuho()
        {
            #region Icon
            IconPath = "LotusCraft/Image/Button/Black/Unique/Utsuho";
			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Utsuho";
            #endregion

			Costs = new [] {400,300,0,0};
			defaultCosts = new [] {400,300,0,0};
			incCosts = new []{10,5,0,0};

            #region define_lv_param
			HPs[0] = 50 + (800 + 150)/2 + 150;
			HPs[1] = 50 + HPs[0];
			HPs[2] = 50 + HPs[1];
			HPs[3] = 50 + HPs[2];
			HPs[4] = 50 + HPs[3];
			HPs[5] = 50 + HPs[4];
			HPs[6] = 50 + HPs[5];
			HPs[7] = 50 + HPs[6];
			HPs[8] = 50 + HPs[7];
			HPs[9] = 50 + HPs[8];
			
			Armors[0] = 2;
			Armors[1] = 2;
			Armors[2] = 3;
			Armors[3] = 3;
			Armors[4] = 4;
			Armors[5] = 4;
			Armors[6] = 5;
			Armors[7] = 5;
			Armors[8] = 6;
			Armors[9] = 6;

			ATKs [0] = 2 + 26+2+2;
			ATKs [1] = 2 + ATKs [0];
			ATKs [2] = 3 + ATKs [1];
			ATKs [3] = 3 + ATKs [2];
			ATKs [4] = 3 + ATKs [3];
			ATKs [5] = 4 + ATKs [4];
			ATKs [6] = 4 + ATKs [5];
			ATKs [7] = 4 + ATKs [6];
			ATKs [8] = 4 + ATKs [7];
			ATKs [9] = 5 + ATKs [8];

            #endregion

            #region UnitParams
			Name = "霊烏路 空";
            HP = HPs[0];
            Speed = 1.1f * BasisSpeed;

            #endregion

            #region Animation
            this.SetBigSizeAnimation("LotusCraft/Image/Unit/Black/Unique/Utsuho");
			#endregion

			#region Cutin
			this.SetCutinAnimation("LotusCraft/Image/Cutin/Utsuho");
			//Cutin.Type = CutinType.SlidinFromRight;
			#endregion

            #region Spell
            SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Black.Kakunetsu(),
				new LotusCraft.Spell.Black.Shako(),
				new LotusCraft.Spell.Black.Kakufu(),
				new LotusCraft.Spell.Black.Jigoku(),
				new LotusCraft.Spell.SpellLevelUp("Black"),
			};
            #endregion

            #region AutoCasts
            AutocasterParams = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
				SpellParams[1].DefaultAutoCast,
				SpellParams[2].DefaultAutoCast,
				SpellParams[3].DefaultAutoCast,
				SpellParams[4].DefaultAutoCast,
                // 経験値取得用オートキャスト
				new LotusCraft.AutoCast.ExpFlagAutoCast<thrts.IUnit> (this.Name+"Exp"),
				// 自動回復用オートキャスト +1% HP/sec
				new LotusCraft.AutoCast.HealUniqueAutoCast<thrts.IUnit>(this.Name+"AutoHeal",0.06f),
			};
            #endregion

            #region Bullets
            Bullets = new string[] { 
				typeof(UtuhoBullet).FullName  
			};
            #endregion
        }
        public override void OnLoad(thrts.IFaction faction)
        {
//			kindName = this.GetType().FullName;
			#region Buttons
            ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].DefaultSpellButton,SpellParams[1].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].DefaultSpellButton,SpellParams[2].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].DefaultSpellButton,SpellParams[3].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].DefaultSpellButton,SpellParams[4].SpellButtons),
//				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].LevelUpSpellButton),
			};
            #endregion
            base.OnLoad(faction);
        }
        public override void OnLvUp(thrts.IUnit unit)
        {
			base.OnLvUp(unit);
        }

        public override void OnVanish(IUnit unit)
        {
            var faction = unit.Faction;
            var offset = new Vector3D(-2, -2, 8);
            var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUniqueEffect).FullName, unit.Pos + offset);
            var scale = new Vector3D(8, 8, 8);
            effect.SetScale(scale);
            base.OnVanish(unit);
        }
    }
}

namespace LotusCraft.Bullet.Black
{
	public class UtuhoBullet : General.HeroBullet
	{
		public UtuhoBullet()
		{
			Type = BulletType.ShortRange;
			this.Attack = 0;
			Speed = 10.0f * BasisSpeed;
			Gravity = 0f;
			MaxRange = 1.0f * Def.MapTipLengthOnField;

			AttackDelay = (int)(0.5f * 30);
			AttackRigor = (int)(0.5f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;

			OnHit = OnHitEffect;

		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			var faction = bullet.Generator.Faction;
			var offset = new Vector3D(0, 0, 4);
			var scale = new Vector3D(8, 8, 8);

			if (bullet.Parameter.HasSplash)
			{
				var effect = faction.World.EffectManager.CreateEffect(typeof(UtsuhoHitSplashEffect).FullName, target.Pos + offset);
				effect.SetScale(scale);
			}
			else
			{
				var effect = faction.World.EffectManager.CreateEffect(typeof(UtsuhoHitEffect).FullName, target.Pos + offset);
				effect.SetScale(scale);
			}

			faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitShortRangeAttack).FullName, target.Pos);
		}
	}
}

#endif