using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Black;
using LotusCraft.Building.Black;
using LotusCraft.Spell.Black;
using LotusCraft.Effect.Black;

namespace LotusCraft.Unit.Black
{
	public class Youmu : General.Special
	{
		public Youmu ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Black/Youmu";
			#endregion

			#region UnitParams
			Name = "魂魄 妖夢(式神)";
			HP = 260;
			Radius = (float)Utls.UnitSize.Small;
			Speed = 1.1f * BasisSpeed;

			PopulationWeight = 1;

            ButtonDescription = "近接ユニット　相手の防御力を無視する";

			ViewRange = 10*32;

			UnitType = new TargetObjectType[]{TargetObjectType.Water,};

			Costs = new [] {125,50,0,0};
			MakingTime = 35 * Def.FPS;

			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Black/Youmu");
			#endregion

			#region BuildableObjcets
//			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(new thrts.Unit.Button.BuildingButton()),
				new thrts.ButtonParameterHolder<thrts.IUnit>(new thrts.Unit.Button.AttackStateButton()),
				new thrts.ButtonParameterHolder<thrts.IUnit>(new thrts.Unit.Button.HoldPositionButton()),
				new thrts.ButtonParameterHolder<thrts.IUnit>(new thrts.Unit.Button.StationButton()),
			};
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(YoumuBullet).FullName };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new YoumuSkill (),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit> (SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
			};
#endregion
			
			base.OnLoad(faction);
		}
	}
}
namespace LotusCraft.Bullet.Black
{
	public class YoumuBullet : General.ShortRangeBullet
	{
		public YoumuBullet()
		{
			Type = BulletType.LongRange;
			this.Attack = 15;
			Speed = 10.0f * BasisSpeed;
			Gravity = 0f;
			DamageBonus[(int)TargetObjectType.Clay] = 1.6f;
			DamageBonus[(int)TargetObjectType.Structure] = 1.4f;
//			MaxRange = 1 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(0.8f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;

		}
        static void OnHitEffect(IBullet bullet, ITargetObject target)
        {
            LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
        }
	}
}
