﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.Blue;
using LotusCraft.Bullet.Blue;

namespace LotusCraft.Unit.Blue
{
	public class FlyFighter : General.Fly
	{
		public FlyFighter ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Blue/Fly01";
			#endregion

			#region UnitParams
			Name = "UFO(対空)";
			HP = 280;
			Armor = 0;
			Speed =1.2f * BasisSpeed;
			
			PopulationWeight = 2;
			
			ViewRange = 14 * Def.MapTipLengthOnField;
			
			MakingTime = 45 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {100,125,0,0};
			UnitType = new TargetObjectType[]{TargetObjectType.Clay,};
			CanState = false;//他のオブジェに駐留可能か
            ButtonDescription = "飛行・対空ユニット\n長距離射程を持つ\n";
#endregion


			#region Animation
			this.SetUFOAnimation("LotusCraft/Image/Unit/Blue/Fly01");
			Animation.HasDirection = false;
			AnimationWalk.HasDirection = false;
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(Fly02Bullet).FullName, };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			#region Buttons
			#endregion
			base.OnLoad (faction);
		}
		public override void OnAppear (IUnit unit)
		{
			if(null != unit)
				unit.AbilityManager.AppendAbility(new Ability.Common.UFOCloakAbility());
			base.OnAppear (unit);
		}
	}
}
namespace LotusCraft.Bullet.Blue
{
	public class Fly02Bullet : General.LongRangeBullet
	{
		public Fly02Bullet()
		{
			Type = BulletType.LongRange;
			DoesHitOnlyTarget = true;
			this.Attack = 12;
			DamageBonus[(int)TargetObjectType.Clay] = 1.5f;
			Speed = 10.0f * BasisSpeed;
			SpaceType = BulletSpaceType.Sky;
			MaxRange = 8 * Def.MapTipLengthOnField;
			
			AttackDelay = 0;
			AttackRigor = 0;
			AttackSpeed = 1*Def.FPS;

			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 0;
			TextureAnimation.Center.Y = 0;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 1;
			TextureAnimation.Count.Y = 1;
			TextureAnimation.Offset.X = 128 * 2 + 16 * 0;
			TextureAnimation.Offset.Y = 128 * 1 + 16 * 1;
			TextureAnimation.AlphaBlend = AlphaBlend.Add;
		}
		static void OnHitEffect(IBullet bullet,ITargetObject target)
		{
			var faction = bullet.Generator.Faction;
			var offset = new Vector3D(-2,-2,8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(HitRemoteBlueEffect).FullName,faction,target.Pos+offset);
			var scale = new Vector3D(8,8,8);
			effect.SetScale(scale);
			faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitLongRangeAttack).FullName, target.Pos);
		}
	}
}