﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Blue;
using LotusCraft.Effect.Blue;

namespace LotusCraft.Unit.Blue
{
	public class Iku : General.Special
	{
		public Iku()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Blue/Iku";
			#endregion

			#region UnitParams
			Name = "永江 衣玖";
			HP = 380;
			Radius = (float)Utls.UnitSize.Large;
			Armor = 0;
			Speed = 1.0f * BasisSpeed;

			PopulationWeight = 5;

			ViewRange = 14 * Def.MapTipLengthOnField;

			MakingTime = 47 * 30;
			/// mine,gas,sup,?
			Costs = new [] {150,200,0,0};

            ButtonDescription = "遠距離砲撃ユニットです\n鈍足化を与える必中の攻撃を行う";
			Description = _ => ButtonDescription.Split('\n').Select(s => new ColorTextLine(s));
			UnitType = new TargetObjectType[]{TargetObjectType.Water,};

			#endregion
			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Blue/Iku");
			#endregion

			#region BuildableObjcets
//			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Bullets
			Bullets = new string[] { 
				typeof(IkuBullet).FullName,
			};
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Blue.IkuSkill (),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit> (SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
			};
			#endregion

			base.OnLoad(faction);
		}
	}
}


namespace LotusCraft.Bullet.Blue
{
	public class IkuBullet : General.CannonBullet
	{
		public IkuBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Earth;
			
			this.Attack = 30;
			Speed = 7.0f * BasisSpeed;
			
			MaxRange = 7 * Def.MapTipLengthOnField;

			DamageBonus[(int)TargetObjectType.Water] = 1.2f;
			DamageBonus[(int)TargetObjectType.Structure] = 1.4f;

			AttackDelay = (int)(0.2f * 30);
			AttackRigor = (int)(0.0f * 30);
			AttackSpeed = (int)(2.0f * 30);
			
			OnHit = OnHitEffect;
			
			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/ball_blue";
			TextureAnimation.AlphaBlend = AlphaBlend.Add;
			TextureAnimation.Width = 32;
			TextureAnimation.Height = 32;
			TextureAnimation.Center.X = 16;
			TextureAnimation.Center.Y = 16;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 4;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 4;
		}
        static void OnHitEffect(IBullet bullet, ITargetObject target)
        {
			var unit = bullet.Generator as IUnit;
			if (unit != null &&
				unit.Exists() &&
				!unit.AbilityManager.ContainsAbility(LotusCraft.Ability.Blue.IkuSkillAbility.AbilityName))
			{
				LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalBlue);
			}
        }
	}
}
