﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.Blue;
using LotusCraft.Bullet.Blue;

namespace LotusCraft.Unit.Blue
{
	public class Low02 : General.Clay
	{
		public Low02 ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Blue/Low02";
#endregion
			
			#region UnitParams
			Name = "天女"+Name;
			HP = 260;
			Armor = 0;
			Speed = 1.2f * BasisSpeed;

			ButtonDescription = "遠距離ユニット\n移動速度が速く対空攻撃ができる、岩属性に対してボーナスを持つ";

			ViewRange = 12*Def.MapTipLengthOnField;
			
			PopulationWeight = 2;
			
			MakingTime = 36 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {125,50,0,0};
#endregion
			
			
			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Blue/Low02");
#endregion
			
			#region BuildableObjcets
#endregion
			
			#region Bullets
			Bullets = new string[] { typeof(Low02Bullet).FullName, };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			#region Buttons
#endregion
			
			base.OnLoad (faction);
		}
		
		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUnitEffect).FullName, unit.Pos + offset, faction);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
	}
}

namespace LotusCraft.Bullet.Blue
{
	public class Low02Bullet : General.MiddleRangeBullet
	{
		public Low02Bullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			DoesHitOnlyTarget = true;
			this.Attack = 12;
			Speed = 10.0f * BasisSpeed;
			MaxRange = 6 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.2f * 30); 
			AttackRigor = (int)(0.0f * 30);
			AttackSpeed = (int)(1.0f * 30);
			
			DamageBonus[(int)TargetObjectType.Clay] = 1.5f;
			
			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 8;
			TextureAnimation.Center.Y = 8;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 8;
			TextureAnimation.Offset.X = 128 * 0 + 16 * 0;
			TextureAnimation.Offset.Y = 128 * 1 + 16 * 0;
		}
        static void OnHitEffect(IBullet bullet, ITargetObject target)
        {
            LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
        }
	}
}
