﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.Blue;

namespace LotusCraft.Unit.Blue
{
	public class Low03 : General.Water
	{
		public Low03 ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Blue/Low03";
			#endregion

			#region UnitParams
			Name = "天女"+Name;
			HP = 50;
			Armor = 0;
			Speed = 1.1f * BasisSpeed;
			ViewRange = 16*Def.FPS;

			ButtonDescription = "飛行偵察ユニット\n攻撃は出来ないが、広い視界を持ち敵AIから発見されずに活動出来る";

			PopulationWeight = 1;

			MoveType |= UnitMoveType.Air;
			MakingTime = 30 * Def.FPS;

			/// mine,gas,sup,?
			Costs = new [] {50,25,0,0};
			#endregion


			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Blue/Low03");
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
//			Bullets = new string[] { typeof(Bullet.Blue.Low03Bullet).FullName, };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			#region Buttons
			#endregion

			base.OnLoad (faction);
		}

		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUnitEffect).FullName, unit.Pos + offset, faction);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}

		public override void OnAppear (IUnit unit)
		{
			unit.Updating+= () => 
			{
				// 近くにDetectorが居たら透明になれない
				if(unit.Faction.World.GetObjectFromCircle(new Circle2D(16*Def.MapTipLengthOnField,new Vector2D(unit.Pos.X,unit.Pos.Y)))
				   .OfType<IUnit>()
				   .Any(_=>!unit.Faction.World.IsSameTeam(_.Faction,unit.Faction) && _.IsDetector && Utl.InCircle(unit.Pos,_.Pos,_.ViewRange) ) )
				{
					unit.IsPreventedFromFindingEnemy = false;
				}
				else
				{
					unit.IsPreventedFromFindingEnemy = true;
				}
				unit.IsSemitransparent = true;
				unit.IsForbiddenAttacking = true;
				unit.DoFindEnemyAutomatically = false;
			};
			base.OnAppear (unit);
		}
	}
}

namespace LotusCraft.Bullet.Blue
{
	public class Low03Bullet : General.LongRangeBullet
	{
		public Low03Bullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			DoesHitOnlyTarget = true;
			this.Attack = 8;
			Speed = 10.0f * BasisSpeed;
			MaxRange = 5 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(0.8f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;

			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 8;
			TextureAnimation.Center.Y = 8;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 8;
			TextureAnimation.Offset.X = 128 * 0 + 16 * 3;
			TextureAnimation.Offset.Y = 128 * 1 + 16 * 0;
		}
        static void OnHitEffect(IBullet bullet, ITargetObject target)
        {
            LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalBlue);
        }
	}
}
