﻿#if !_TRIAL
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Blue;
using LotusCraft.Effect.Blue;
using LotusCraft.Building.Blue;


namespace LotusCraft.Unit.Blue.Unique
{
	public class Yukari : General.Unique
	{
		public Yukari ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Blue/Unique/yukari";
			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Yukari";
			#endregion

			#region define_lv_param
			HPs[0] = 30 + 800/2 + 150;
			HPs[1] = 30 + HPs[0];
			HPs[2] = 30 + HPs[1];
			HPs[3] = 30 + HPs[2];
			HPs[4] = 30 + HPs[3];
			HPs[5] = 30 + HPs[4];
			HPs[6] = 30 + HPs[5];
			HPs[7] = 30 + HPs[6];
			HPs[8] = 30 + HPs[7];
			HPs[9] = 30 + HPs[8];
			
			Armors[0] = 1;
			Armors[1] = 1;
			Armors[2] = 2;
			Armors[3] = 2;
			Armors[4] = 3;
			Armors[5] = 3;
			Armors[6] = 4;
			Armors[7] = 4;
			Armors[8] = 5;
			Armors[9] = 5;

			ATKs [0] = 2 + 20;
			ATKs [1] = 2 + ATKs [0];
			ATKs [2] = 2 + ATKs [1];
			ATKs [3] = 3 + ATKs [2];
			ATKs [4] = 3 + ATKs [3];
			ATKs [5] = 3 + ATKs [4];
			ATKs [6] = 3 + ATKs [5];
			ATKs [7] = 4 + ATKs [6];
			ATKs [8] = 4 + ATKs [7];
			ATKs [9] = 4 + ATKs [8];
			

#endregion

			#region UnitParams
			Name = "八雲 紫";
			HP = HPs[0];
			Speed = 0.9f*BasisSpeed;

			#endregion

			#region Animation
			this.SetBigSizeAnimation("LotusCraft/Image/Unit/Blue/Unique/yukari");
			#endregion

			#region Cutin
			this.SetCutinAnimation("LotusCraft/Image/Cutin/Yukari");
			Cutin.Type = CutinType.FadeIn;
			#endregion


			BuildingsMade = new[] { 
				typeof(SukimaBuilding).FullName,
			};

			#region Bullets
			Bullets = new string[] { 
				typeof(YukariBullet).FullName,
				typeof(HaisenBullet).FullName,
			};
			#endregion
		}
		public override void OnLoad (thrts.IFaction faction)
		{

			#region Spell
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Blue.Sukima (),
				new LotusCraft.Spell.Blue.Haisen (),
				new LotusCraft.Spell.Blue.KyakkanKekkai (),
				new LotusCraft.Spell.Blue.DanmakuKekkai(),
				new LotusCraft.Spell.SpellLevelUp("Blue"),
			};
			#endregion
			
			#region AutoCasts
			AutocasterParams = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
				SpellParams[1].DefaultAutoCast,
				SpellParams[2].DefaultAutoCast,
				SpellParams[3].DefaultAutoCast,
				SpellParams[4].DefaultAutoCast,
				// 経験値取得用オートキャスト
				new LotusCraft.AutoCast.ExpFlagAutoCast<thrts.IUnit> (this.Name+"Exp"),
				// 自動回復用オートキャスト +1% HP/sec
				new LotusCraft.AutoCast.HealUniqueAutoCast<thrts.IUnit>(this.Name+"AutoHeal"),
			};
			#endregion
			
			#region Buttons
			
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].DefaultSpellButton,SpellParams[1].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].DefaultSpellButton,SpellParams[2].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].DefaultSpellButton,SpellParams[3].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].DefaultSpellButton,SpellParams[4].SpellButtons),
				//				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].LevelUpSpellButton),
			};
			#endregion

			base.OnLoad(faction);
			
		}
		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUniqueEffect).FullName, faction, unit.Pos + offset);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
		public override void OnLvUp (thrts.IUnit unit)
		{
			base.OnLvUp(unit);
		}
	}

}

namespace LotusCraft.Bullet.Blue
{
	public class YukariBullet : General.HeroBullet
	{
		public YukariBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			this.Attack = 15;
			Speed = 10.0f * BasisSpeed;
			
			MaxRange = 7 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.5f * 30);
			AttackRigor = (int)(0.5f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 0;
			TextureAnimation.Center.Y = 0;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 8;
			TextureAnimation.Offset.X = 128 * 0 + 16 * 4;
			TextureAnimation.Offset.Y = 128 * 1 + 16 * 0;
		}
		static void OnHitEffect(IBullet bullet,ITargetObject target)
		{
			Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalPurple);
		}
	}
}

#endif