﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Common;
using LotusCraft.Effect.Common;

namespace LotusCraft.Unit.Common
{
	public class Yuyuko : Patchouli
	{
		public Yuyuko ()
			:base()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Common/yuyuko";
//			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Yuyuko";
#endregion
			Name = "西行寺 幽々子 (式神)";
            ButtonDescription = "防衛ユニット\n長距離射程と対空能力を持つが、同時に2体までしか存在できない";
			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Common/Yuyuko");
#endregion
			#region Bullets
			Bullets = new string[] { 
				typeof(YuyukoBullet).FullName, 
			};
#endregion
			
		}
	}
	public class Yukari : Patchouli
	{
		public Yukari ()
			:base()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Common/Yukari";
//			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Yukari";
#endregion
			Name = "八雲 紫 (式神)";
            ButtonDescription = "防衛ユニット\n長距離射程と対空能力を持つが、同時に2体までしか存在できない";
			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Common/Yukari");
#endregion
			#region Bullets
			Bullets = new string[] { 
				typeof(YukariBullet).FullName, 
			};
#endregion
			
		}
	}
	public class Erin : Patchouli
	{
		public Erin ()
			:base()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Common/Erin";
//			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Erin";
			#endregion
			Name = "八意 永琳 (式神)";
            ButtonDescription = "防衛ユニット\n長距離射程と対空能力を持つが、同時に2体までしか存在できない";
			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Common/Erin");
			#endregion
			#region Bullets
			Bullets = new string[] { 
				typeof(ErinBullet).FullName, 
			};
			#endregion

		}
	}
	public class Patchouli : General.Special
	{
		public Patchouli ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Common/Patchouli";
//			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Patch";
			#endregion

			#region UnitParams
			Name = "パチュリー・ノーレッジ(式神)";
			HP = 400;
			Armor = 2;

			Speed = 0.3f*BasisSpeed;

            ButtonDescription = "防衛ユニット\n長距離射程と対空能力を持つが、同時に2体までしか存在できない";

			UnitType = new TargetObjectType[]{TargetObjectType.None};
			IsDefence = true;
			
			ViewRange = 12 * Def.MapTipLengthOnField;

			MaximumExists = 2;
			CanState = false;

			Costs = new int[4];
			Costs[0] = 80;
			Costs[1] = 0;
			Costs[2] = 0;
			Costs[3] = 0;

			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Common/Patchouli");
			#endregion

			#region AutoCasts
			AutocasterParams = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				// 自動回復用オートキャスト +1% HP/sec
				new LotusCraft.AutoCast.HealUniqueAutoCast<thrts.IUnit> (this.Name + "AutoHeal"),
			};
			#endregion

			#region Bullets
			Bullets = new string[] { 
				typeof(PatchouliBullet).FullName, 
			};
			#endregion
		}
		public override void OnLoad (thrts.IFaction faction)
		{
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
			};
#endregion
			
			base.OnLoad (faction);
		}

		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUniqueEffect).FullName, unit.Pos + offset);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
	}
}

namespace LotusCraft.Bullet.Common
{
	public class YuyukoBullet : Black.YuyukoBullet
	{
		public YuyukoBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			this.Attack = 25;
			Speed = 7.0f * BasisSpeed;
			Gravity = 0.5f;
			MaxRange = 9 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * Def.FPS);
			AttackRigor = (int)(0.0f * Def.FPS);
			AttackSpeed =  (int)(2.0f * Def.FPS);
		}
	}
	public class YukariBullet : Blue.YukariBullet
	{
		public YukariBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			this.Attack = 25;
			Speed = 7.0f * BasisSpeed;
			Gravity = 0.5f;
			MaxRange = 9 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * Def.FPS);
			AttackRigor = (int)(0.0f * Def.FPS);
			AttackSpeed =  (int)(2.0f * Def.FPS);
		}
	}
	public class ErinBullet : White.EirinBullet
	{
		public ErinBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			this.Attack = 25;
			Speed = 7.0f * BasisSpeed;
			Gravity = 0.5f;
			MaxRange = 9 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * Def.FPS);
			AttackRigor = (int)(0.0f * Def.FPS);
			AttackSpeed =  (int)(2.0f * Def.FPS);
		}
	}
	public class PatchouliBullet : Red.PatchouliBullet
	{
		public PatchouliBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			this.Attack = 25;
			Speed = 7.0f * BasisSpeed;
			Gravity = 0.5f;
			MaxRange = 9 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * Def.FPS);
			AttackRigor = (int)(0.0f * Def.FPS);
			AttackSpeed =  (int)(2.0f * Def.FPS);
		}
	}
}
#endif