﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

/*
namespace LotusCraft.Unit.General
{
	public class Cannon : thrts.UnitParameter
	{
		public Cannon()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/chen";
			#endregion

			#region UnitParams
			Name = "砲兵";
			HP = 1500;
			Radius = (float)Utls.UnitSize.Large;
			Speed = 1.0f * BasisSpeed;

			PopulationWeight = 3;

			ViewRange = 16 * Def.MapTipLengthOnField;
			UnitType = new TargetObjectType[]{TargetObjectType.Clay,};

			MakingTime = 30 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {150,125,0,0};
			SelectPriority = 30;
			#endregion

			#region Description
			ButtonDescription += "攻城用ユニットです。\nこのユニットは、広い射程と高い攻撃力を持ちます。";

			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			if(ConcurrentProductions > 1)
				Exp = Costs.Sum()/(3*ConcurrentProductions);
			else
				Exp = Costs.Sum()/3;

			if(StationWeight < 2)
				StationWeight = PopulationWeight;

			#region Buttons
			ButtonParams = ButtonParams.Concat(faction.Parameter.CommonUnitButton).ToArray();
			#endregion

		}
		public override void OnAppear (IUnit unit)
		{
			if (unit.Faction.World.CurrentTime > 10)
			{
				unit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.CreatedUnit).FullName, unit.Pos);

				// 生成エフェクト
				var effect = unit.Faction.World.EffectManager.CreateEffect(typeof(Effect.Common.CreateUnitEffect).FullName, unit.Pos);
				effect.SetScale(new Vector3D(3, 3, 3));
			}
			base.OnAppear (unit);
		}
		public override void OnVanish (IUnit unit)
		{
			unit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.PCH).FullName, unit.Pos);
			base.OnVanish (unit);
		}
	}
}
*/
namespace LotusCraft.Bullet.General
{
	public class CannonBullet : thrts.BulletParameter
	{
		public CannonBullet()
		{
			Type = BulletType.LongRange;
			Attack = 32;
            Speed = 8.0f * BasisSpeed;
//			Gravity = 0;
			
			DamageBonus = new float[AttackBonusSet.None.Length];
			for(int i=0;i<this.DamageBonus.Length;++i)
				DamageBonus[i] = AttackBonusSet.None[i];

			IsSplashMissHit = true;

			MaxRange = 12 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.8f * Def.FPS);
			AttackRigor = (int)(0.2f * Def.FPS);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;

		}
	}
}