﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Unit.General
{
	public class Farmer : thrts.UnitParameter
	{
		public Farmer()
		{
			#region Icon
 //		   IconPath = "LotusCraft/Image/Button/chen";
			#endregion

			#region UnitParams
			Name = "作業者";
			IsFarmer = true;
			HP = 65;
			Radius = (float)Utls.UnitSize.VerySmall;
			Speed = 1.2f * BasisSpeed;

			ViewRange = 8 * 32;

			MakingTime = 15 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {30,0,0,0};
			SelectPriority = 50;
			UnitType = new TargetObjectType[]{TargetObjectType.Water,};

			ResourcesGotten = new int[] { 0, 1 };
			#endregion

			#region Description
			ButtonDescription += "作業用ユニット。\n建築、資源回収、偵察、非常時の戦闘等に使用する。";
			#endregion

			/*
			#region Animation
			Animation = new TextureAnimation();
			Animation.Path = "LotusCraft/Image/Unit/unit";
			Animation.Width = 32;
			Animation.Height = 32;
			Animation.Center.X = 0;
			Animation.Center.Y = 10;
			Animation.CenterPosition = CenterPosition.MiddleMiddle;
			Animation.FrameCount = 4;
			Animation.FrameTime = 4;
			Animation.HasDirection = true;
			Animation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			Animation.Count.X = 4;
			Animation.Count.Y = 8;
			#endregion

			#region BuildableObjcets
//			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Bullets
//			Bullets = new string[] { "LotusCraft.Bullet.Melee" };
			#endregion
			*/

//			SelectBullet = (unti,target,distance)=>{return (target is IBuilding) && (target as IBuilding).IsComplete ? -1 : 0;};

		}
		public override void OnLoad (IFaction faction)
		{
			if(ConcurrentProductions > 1)
				Exp = Costs.Sum()/(3*ConcurrentProductions);
			else
				Exp = Costs.Sum()/3;

			if(StationWeight < 2)
				StationWeight = PopulationWeight;

			#region Buttons
			ButtonParams = ButtonParams
				.Concat(faction.Parameter.CommonUnitButton).ToArray();
			#endregion
		}
		public override void OnAppear (IUnit unit)
		{
			if (unit.Faction.World.CurrentTime > 10)
			{
				unit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.CreatedUnit).FullName, unit.Pos);

				// 生成エフェクト
				var effect = unit.Faction.World.EffectManager.CreateEffect(typeof(Effect.Common.CreateUnitEffect).FullName, unit.Pos);
				effect.SetScale(new Vector3D(3, 3, 3));
			}
			base.OnAppear (unit);
		}
		public override void OnVanish (IUnit unit)
		{
			unit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.PCH).FullName, unit.Pos);
			base.OnVanish (unit);
		}
	}
}
