﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Unit.General
{
	public class Clay : thrts.UnitParameter
	{
		public Clay()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/chen";
			#endregion

			#region UnitParams
			Name = "(岩)";
			HP = 400;
			Radius = (float)Utls.UnitSize.Small;
			Speed = 1.0f * Speed;

			ViewRange = 10 * 32;

			MakingTime = 20 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {100,0,0,0};
			SelectPriority = 40;
			UnitType = new TargetObjectType[]{TargetObjectType.Clay,};
			#endregion

			#region Description
			ButtonDescription += "岩属性を持つユニットです。";

			#endregion
			/*
			#region Animation
			Animation = new TextureAnimation();
			Animation.Path = "LotusCraft/Image/Unit/unit";
			Animation.Width = 32;
			Animation.Height = 32;
			Animation.Center.X = 0;
			Animation.Center.Y = 10;
			Animation.CenterPosition = CenterPosition.MiddleMiddle;
			Animation.FrameCount = 4;
			Animation.FrameTime = 4;
			Animation.HasDirection = true;
			Animation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			Animation.Count.X = 4;
			Animation.Count.Y = 8;
			#endregion

			#region BuildableObjcets
			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion
			
			#region Bullets
			Bullets = new string[] { "LotusCraft.Bullet.Melee" };
			#endregion
			*/
		}
		public override void OnLoad (IFaction faction)
		{
			if(ConcurrentProductions > 1)
				Exp = Costs.Sum()/(3*ConcurrentProductions);
			else
				Exp = Costs.Sum()/3;

			if(StationWeight < 2)
				StationWeight = PopulationWeight;
			#region Buttons
			ButtonParams = ButtonParams.Concat(faction.Parameter.CommonUnitButton).ToArray();
			#endregion

		}
		public override void OnAppear (IUnit unit)
		{
			if (unit.Faction.World.CurrentTime > 10)
			{
				unit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.CreatedUnit).FullName, unit.Pos);

				// 生成エフェクト
				var effect = unit.Faction.World.EffectManager.CreateEffect(typeof(Effect.Common.CreateUnitEffect).FullName, unit.Pos);
				effect.SetScale(new Vector3D(3, 3, 3));
			}

			base.OnAppear (unit);
		}
		public override void OnVanish (IUnit unit)
		{
			unit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.PCH).FullName, unit.Pos);
			base.OnVanish (unit);
		}
	}
}
namespace LotusCraft.Bullet.General
{
	public class ShortRangeBullet : thrts.BulletParameter
	{
		public ShortRangeBullet()
		{
			Type = BulletType.ShortRange;
			SpaceType = BulletSpaceType.Earth;
			this.Attack = 30;
			Speed = 10.0f * BasisSpeed;
			Gravity = 0f;
			MaxRange = 0.5f * Def.MapTipLengthOnField;
			DamageBonus = new float[AttackBonusSet.None.Length];
			for(int i=0;i<this.DamageBonus.Length;++i)
				DamageBonus[i] = AttackBonusSet.None[i];

			AttackDelay = (int)(0.5f * 30);
			AttackRigor = (int)(0.5f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;

		}
	}
}
