﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Unit.General
{
	public class Special : thrts.UnitParameter
	{
		public Special()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/chen";
			#endregion

			#region UnitParams
			Name = "testunit";
			HP = 1350;
			Radius = (float)Utls.UnitSize.Medium;
			Speed = 1.0f*BasisSpeed;

			ViewRange = 10*Def.MapTipLengthOnField;
			UnitType = new TargetObjectType[]{TargetObjectType.Water,};

			MakingTime = 30 * Def.FPS;
			SelectPriority = 20;

			PopulationWeight = 4;

			#endregion
/*
			#region Animation
			this.SetBoushuenSizeAnimation("LotusCraft/Image/Unit/unit.png");
			#endregion

			#region BuildableObjcets
			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Bullets
			Bullets = new string[] { "LotusCraft.Bullet.Gun" };
			#endregion
			*/
		}
		public override void OnLoad (IFaction faction)
		{
			if(ConcurrentProductions > 1)
				Exp = Costs.Sum()/(3*ConcurrentProductions);
			else
				Exp = Costs.Sum()/3;

			if(StationWeight < 2)
				StationWeight = PopulationWeight;
			#region Buttons
			ButtonParams = ButtonParams.Concat(faction.Parameter.CommonUnitButton).ToArray();
			#endregion

		}
		public override void OnAppear (IUnit unit)
		{
			if (unit.Faction.World.CurrentTime > 10)
			{
				unit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.CreatedUnit).FullName, unit.Pos);

				// 生成エフェクト
				var effect = unit.Faction.World.EffectManager.CreateEffect(typeof(Effect.Common.CreateUnitEffect).FullName, unit.Pos);
				effect.SetScale(new Vector3D(3, 3, 3));
			}

			base.OnAppear (unit);
		}
		public override void OnVanish (IUnit unit)
		{
			unit.Faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.PCH).FullName, unit.Pos);
			base.OnVanish (unit);
		}
	}
}
