﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Green;
using LotusCraft.Effect.Green;

namespace LotusCraft.Unit.Green
{
	public class Dolls : General.Special
	{
		public Dolls ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Green/Dolls";
			#endregion

			#region UnitParams
			Name = "人形";
			HP = 80;
			Radius = (float)Utls.UnitSize.Small;
			Speed = 1.0f*BasisSpeed;

			PopulationWeight = 0;

			MakingTime = 20 * Def.FPS;
			/// mine,gas
			Costs = new [] {60,0,0,0};

			IsSummon = true;

			CanState = false;

			// 
			Exp =  20;
			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Green/Dolls");
			#endregion

			#region BuildableObjcets
//			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Bullets
			Bullets = new string[] {
				typeof(DollBullet).FullName,
			};
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			#region Buttons
			#endregion
			
			base.OnLoad (faction);
		}

        public override void OnVanish(IUnit unit)
        {
            var faction = unit.Faction;
            var offset = new Vector3D(-2, -2, 8);
            var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUnitEffect).FullName, unit.Pos + offset);
            var scale = new Vector3D(8, 8, 8);
            effect.SetScale(scale);
            base.OnVanish(unit);
        }
		public override void OnAppear (IUnit unit)
		{
			unit.AbilityManager.AppendAbility(new Ability.Green.OnGardenEffectAbility());
			base.OnAppear (unit);
		}
	}
}

namespace LotusCraft.Bullet.Green
{
	public class DollBullet : General.ShortRangeBullet
	{
		public DollBullet()
		{
			Type = BulletType.ShortRange;
			SpaceType = BulletSpaceType.Earth;
			this.Attack = 12;
			Speed = 0.0f;
			
			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(1.5f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;
			
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
		}
	}
}
