﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.Green;
using LotusCraft.Building.Green;
using LotusCraft.Bullet.Green;

namespace LotusCraft.Unit.Green
{
	public class Elie : LotusCraft.Unit.General.Special
	{
		public Elie()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Green/Elie";
			#endregion

			#region UnitParams
			Name = "エリー(式神)";
			HP =  600;
			Armor = 6;
			Speed = 1.0f * BasisSpeed;

			PopulationWeight = 6;

			ViewRange = 12 * Def.MapTipLengthOnField;

			MakingTime = 65 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new[] { 300, 250, 0, 0 };
			
			UnitType = new TargetObjectType[] { TargetObjectType.Clay, };

			RequireBuildings = new string[]{
				typeof(Building.Green.Hyoutan).FullName,
				typeof(Building.Green.Court).FullName,
				typeof(Building.Green.Gate).FullName,
				typeof(Building.Green.SuzuranField).FullName,
			};

            ButtonDescription = "近接ユニット\nとても高い攻撃・耐久力を持ち範囲攻撃を行う";

			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Green/Elie");
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(ElieBullet).FullName, };
			#endregion
		}
		public override void OnLoad(IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Green.ElieSkill(),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
			};
			#endregion

			base.OnLoad(faction);
		}
		public override void OnAppear (IUnit unit)
		{
			unit.AbilityManager.AppendAbility(new Ability.Green.OnGardenEffectAbility());
			base.OnAppear (unit);
		}
	}
}

namespace LotusCraft.Bullet.Green
{
	// LotusCraft.Bullet.Black.OkuBullet より
	public class ElieBullet : General.ShortRangeBullet
	{
		public ElieBullet()
		{
			Type = BulletType.ShortRange;

			DoesHitOnlyTarget = false;
			
			HasSplash = true;
			IsSplashMissHit = true;
			SplashDamageRates.Add(1.0f * Def.MapTipLengthOnField, 1.0f);

			this.Attack = 80;
			Speed = 10.0f * BasisSpeed;
			MaxRange = 1.5f * Def.MapTipLengthOnField;

			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(0.0f * 30);
			AttackSpeed = (int)(1.5f * 30);


			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/ball_yellow";
			TextureAnimation.AlphaBlend = AlphaBlend.Add;
			TextureAnimation.Width = 32;
			TextureAnimation.Height = 32;
			TextureAnimation.Center.X = 16;
			TextureAnimation.Center.Y = 16;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 4;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 4;
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
		}
	}
}

#endif