﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Green;
using LotusCraft.Spell.Green;
using LotusCraft.Building.Green;
using LotusCraft.Effect.Green;

namespace LotusCraft.Unit.Green
{
	public class Komachi : General.Special
	{
		public Komachi ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Green/Komachi";
			#endregion

			#region UnitParams
            Name = "小野塚 小町(式神)";
			HP = 320;
			Speed = 1.0f*BasisSpeed;

			Armor = 2;

			PopulationWeight = 2;

			ViewRange = 10*Def.MapTipLengthOnField;

			MakingTime = 35 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {125,100,0,0};

            ButtonDescription = "近接ユニット\n周囲の味方の射程を伸ばし対空攻撃を可能とさせる";
			Description = _ => ButtonDescription.Split('\n').Select(s => new ColorTextLine(s));
			UnitType = new TargetObjectType[]{TargetObjectType.Clay,};
			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Green/Komachi");
			#endregion

			#region BuildableObjcets
//			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(KomachiBullet).FullName, };
			#endregion

			#region Requires
			RequireBuildings = new string[]{
				typeof(Cherry).FullName,
				typeof(Court).FullName,
			};
			#endregion

		}
		public override void OnLoad (IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new KomachiSkill (),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit> (SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
			};
			#endregion

			base.OnLoad(faction);
		}
		public override void OnAppear (IUnit unit)
		{
			unit.AbilityManager.AppendAbility(new Ability.Green.OnGardenEffectAbility());
			base.OnAppear (unit);
		}
	}
}

namespace LotusCraft.Bullet.Green
{
	public class KomachiBullet : General.ShortRangeBullet
	{
		public KomachiBullet()
		{
			Type = BulletType.ShortRange;
			this.Attack = 30;
			DamageBonus[(int)TargetObjectType.Clay] = 1.6f;
			Speed = 0.0f;
			
			MaxRange = 1 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(1.5f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit =OnHitEffect;
			
		}
		static void OnHitEffect(IBullet bullet,ITargetObject target)
		{
            LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalOrange);
		}
	}
}
