﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.Green;
using LotusCraft.Building.Green;
using LotusCraft.Bullet.Green;

namespace LotusCraft.Unit.Green
{
	public class Kurumi : LotusCraft.Unit.General.Special
	{
		public Kurumi()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Green/Kurumi";
			#endregion

			#region UnitParams
			Name = "くるみ(式神)";
			HP = 200;
			Armor = 0;
			Speed = 1.1f * BasisSpeed;

			PopulationWeight = 3;

			ViewRange = 12 * Def.MapTipLengthOnField;

			MakingTime = 35 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new[] { 100, 125, 0, 0 };

			UnitType = new TargetObjectType[] { TargetObjectType.Water, };
			MoveType |= UnitMoveType.Air;

			RequireBuildings = new string[]{
				typeof(Building.Green.Gate).FullName
			};

			ButtonDescription = "飛行・対地対空ユニット\n攻撃が多段ヒットする";

			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Green/Kurumi");
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			Bullets = new string[] { 
				typeof(KurumiBullet).FullName,
				typeof(KurumiBounsBullet).FullName,
				typeof(KurumiBounsBullet1).FullName,
				typeof(KurumiBounsBullet2).FullName,
				typeof(KurumiBounsBullet3).FullName,
				typeof(KurumiBounsBullet4).FullName,
			};
			#endregion
		}
		public override void OnLoad(IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Green.KurumiSkill(),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
			};
			#endregion

			base.OnLoad(faction);
		}
	}
}

namespace LotusCraft.Bullet.Green
{
	public class KurumiBullet : General.LongRangeBullet
	{
		public KurumiBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			DoesHitOnlyTarget = true;
			this.Attack = 15;
			Speed = 10.0f * BasisSpeed;
			MaxRange = 5 * Def.MapTipLengthOnField;

			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(0.0f * 30);
			AttackSpeed = (int)(1.5f*Def.FPS);

			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 8;
			TextureAnimation.Center.Y = 8;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 8;
			TextureAnimation.Offset.X = 128 * 1 + 16 * 3;
			TextureAnimation.Offset.Y = 128 * 0 + 16 * 0;
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalBlue);
		}
	}
}

#endif