﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.Green;
using LotusCraft.Bullet.Green;
using LotusCraft.Building.Green;

namespace LotusCraft.Unit.Green
{
	public class Low02 : General.Clay
	{
		public Low02 ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Green/Low02";
			#endregion

			#region UnitParams
			Name = "妖精(岩)";
			HP = 300;
			Armor = 2;
			Speed = 1.0f * BasisSpeed;
            ButtonDescription = "射撃ユニット\n高い耐久力を持つ";

			PopulationWeight = 2;

			MakingTime = 28 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {100,25,0,0};
			UnitType = new TargetObjectType[]{TargetObjectType.Clay,};

			RequireBuildings = new string[]{
				typeof(Cherry).FullName,
			};

#endregion


			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Green/Low02");
			Animation.FrameCount = 3;
			AnimationWalk.FrameCount = 3; 
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(Low02Bullet).FullName, };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			#region Buttons
			#endregion

			base.OnLoad (faction);
		}

		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUnitEffect).FullName, unit.Pos + offset, faction);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
		public override void OnAppear (IUnit unit)
		{
			unit.AbilityManager.AppendAbility(new Ability.Green.OnGardenEffectAbility());
			base.OnAppear (unit);
		}
	}
}

namespace LotusCraft.Bullet.Green
{
	public class Low02Bullet : General.MiddleRangeBullet
	{
		public Low02Bullet()
		{
			Type = BulletType.LongRange;
			DoesHitOnlyTarget = true;
			this.Attack = 24;
			Speed = 10.0f * BasisSpeed;
			MaxRange = 3 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(2.0f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 8;
			TextureAnimation.Center.Y = 8;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 8;
			TextureAnimation.Offset.X = 128 * 3 + 16 * 0;
			TextureAnimation.Offset.Y = 128 * 0 + 16 * 0;
		}
		static void OnHitEffect(IBullet bullet,ITargetObject target)
		{
            LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalOrange);
		}
	}
}
