﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Green;
using LotusCraft.Effect.Green;

namespace LotusCraft.Unit.Green
{
	public class SuikaSmallCocoon : General.Water
	{
		public SuikaSmallCocoon ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Green/Farmer";
			#endregion

			#region UnitParams
			Name = "ちび萃香へ変身中";
			HP = 100;
			Armor = 2;
			Speed = 0;

			ViewRange = 3*Def.MapTipLengthOnField;

			PopulationWeight = 1;

			MakingTime = 25 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {50,0,0,0};
			UnitType = new TargetObjectType[]{TargetObjectType.Water,};
			#endregion

#region Animation
			this.SetBearAnimation("LotusCraft/Image/Unit/Green/suikaBear");
#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			#endregion
			
		}
		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUnitEffect).FullName, unit.Pos + offset, faction);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
	}
}
