﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


using thrts;
using LotusCraft.Effect.Green;
using LotusCraft.Bullet.Green;
using LotusCraft.Spell.Green;

namespace LotusCraft.Unit.Green.Unique
{
	public class Suika : General.Unique
	{
		public Suika ()
		{
			#region define_lv_param
			HPs[0] = 50 + (800 + 50)/2 + 150;
			HPs[1] = 50 + HPs[0];
			HPs[2] = 50 + HPs[1];
			HPs[3] = 50 + HPs[2];
			HPs[4] = 50 + HPs[3];
			HPs[5] = 50 + HPs[4];
			HPs[6] = 50 + HPs[5];
			HPs[7] = 50 + HPs[6];
			HPs[8] = 50 + HPs[7];
			HPs[9] = 50 + HPs[8];
			
			Armors[0] = 0;
			Armors[1] = 0;
			Armors[2] = 0;
			Armors[3] = 0;
			Armors[4] = 1;
			Armors[5] = 1;
			Armors[6] = 2;
			Armors[7] = 2;
			Armors[8] = 3;
			Armors[9] = 3;

			ATKs [0] = 2 + 28 + 4;
			ATKs [1] = 2 + ATKs [0];
			ATKs [2] = 3 + ATKs [1];
			ATKs [3] = 3 + ATKs [2];
			ATKs [4] = 3 + ATKs [3];
			ATKs [5] = 4 + ATKs [4];
			ATKs [6] = 4 + ATKs [5];
			ATKs [7] = 4 + ATKs [6];
			ATKs [8] = 4 + ATKs [7];
			ATKs [9] = 5 + ATKs [8];

			for(int i=0;i<ATKs.Length;++i)
				ATKs[i]*= 2;

			#endregion

			#region Icon
			IconPath = "LotusCraft/Image/Button/Green/Unique/Suika";
			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Suika";
			#endregion

			#region UnitParams
			Name = "伊吹 萃香";
			HP = HPs[0];
			Speed = 1*BasisSpeed;
			
			#endregion

			#region Animation
			this.SetBigSizeAnimation("LotusCraft/Image/Unit/Green/Unique/Suika");
			#endregion

			#region Cutin
			this.SetCutinAnimation("LotusCraft/Image/Cutin/Suika");
			//Cutin.Type = CutinType.SlidinFromRight;
			#endregion

			#region BuildableObjcets
			//			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Spell
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Green.MissingPower (),
				new LotusCraft.Spell.Green.Onibi(),
				new LotusCraft.Spell.Green.BlackHole(),
				new LotusCraft.Spell.Green.MissingPurplePower(),
				new LotusCraft.Spell.SpellLevelUp("Green"),
			};
			#endregion

			#region AutoCasts
			AutocasterParams = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
				SpellParams[1].DefaultAutoCast,
				SpellParams[2].DefaultAutoCast,
				SpellParams[3].DefaultAutoCast,
				SpellParams[4].DefaultAutoCast,
				// 経験値取得用オートキャスト
				new LotusCraft.AutoCast.ExpFlagAutoCast<thrts.IUnit> (this.Name + "Exp"),
				// 自動回復用オートキャスト +1% HP/sec
				new LotusCraft.AutoCast.HealUniqueAutoCast<thrts.IUnit> (this.Name + "AutoHeal",0.06f),
			};
			#endregion

			#region Bullets
			Bullets = new string[] { 
				typeof(SuikaBullet).FullName,
				typeof(OnibiLargeBullet).FullName,
				typeof(OnibiMiddleBullet).FullName,
				typeof(OnibiSmallBullet).FullName,
			};
			#endregion
		}
		public override void OnLoad (thrts.IFaction faction)
		{
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].DefaultSpellButton,SpellParams[1].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].DefaultSpellButton,SpellParams[2].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].DefaultSpellButton,SpellParams[3].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].DefaultSpellButton,SpellParams[4].SpellButtons),
				//				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].LevelUpSpellButton),
			};
#endregion
			
			base.OnLoad (faction);
		}
		public override void OnLvUp(thrts.IUnit unit)
		{
            base.OnLvUp(unit);
		}
		
		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUniqueEffect).FullName, unit.Pos + offset, faction);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
	}
}

namespace LotusCraft.Bullet.Green
{
	public class SuikaBullet : General.ShortRangeBullet
	{
		public SuikaBullet()
		{
			Type = BulletType.ShortRange;
			this.Attack = 0;
			Speed = 10.0f * BasisSpeed;
			Gravity = 0f;
			MaxRange = 1.0f * Def.MapTipLengthOnField;

			DamageBonus = AttackBonusSet.Hero.ToArray();
			
			AttackDelay = (int)(0.5f * 30);
			AttackRigor = (int)(1.5f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;
			
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
            LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
		}
	}

	/// <summary>
	/// 鬼火弾(1段目)
	/// </summary>
	public class OnibiLargeBullet : General.CannonBullet
	{
		public OnibiLargeBullet()
		{
			Type = BulletType.LongRange;
			
			Attack = 0;
			FarmerDamageRatio = 0.5f;
			Speed = 5.0f * BasisSpeed;
			Gravity = 1.5f;

			Radius = 2*Def.MapTipLengthOnField;

			HasSplash = true;
			IsSplashMissHit = true;
			SplashDamageRates.Add(Radius, 1.0f);
			
			MaxRange = 10 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(2.5f * Def.FPS);
			AttackRigor = (int)(1.5f * Def.FPS);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit += OnHitEffect;
			OnMiss += OnMissEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/ball_orange_big";
			TextureAnimation.AlphaBlend = AlphaBlend.Add;
			TextureAnimation.Width = 64;
			TextureAnimation.Height = 64;
			TextureAnimation.Center.X = 0;
			TextureAnimation.Center.Y = 0;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 1;
			TextureAnimation.Count.Y = 1;
		}

		void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			var faction = bullet.Generator.Faction;
			float scale = SplashDamageRates.Max(_ => _.Key) / 5.0f;
			//CreateEffect(faction, target.Pos, scale);
            LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.BombGreen);

			CreateSubBullet(bullet);
		}
		
		void OnMissEffect(IBullet bullet)
		{
			var faction = bullet.Generator.Faction;
			float scale = SplashDamageRates.Max(_ => _.Key) / 5.0f;
			CreateEffect(faction, bullet.Position, scale);

			CreateSubBullet(bullet);
		}
		
		public static void CreateEffect(IFaction faction, Vector3D pos, float scale)
		{
			var offset = new Vector3D(0, 0, 20);
			var effect = faction.World.EffectManager.CreateEffect(typeof(SuikaOnibiHitEffect).FullName, pos + offset);
			effect.SetScale(new Vector3D(scale,scale,scale));
			faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.Bom01).FullName, pos);
		}

		public static void CreateSubBullet (IBullet bullet)
		{
			if (null == bullet.Generator || !bullet.Generator.Exists ())
				return;
			var u = bullet.Generator as IUnit;
			
			if (null == u || !u.Exists ())
				return;

			var b = u.GetModifiedBulletParameter (typeof(OnibiMiddleBullet).FullName);
			if (null != b) {
				b.Attack = bullet.Attack/2;

				Vector3D offset = u.Faction.World.GetGroundAtPos(new Vector2D(bullet.Position.X,bullet.Position.Y)) - bullet.Position;
				float l = 2.5f * Def.MapTipLengthOnField;
				u.CreateBullet (typeof(OnibiMiddleBullet).FullName, (new Vector3D (l, 0, 0)) + bullet.Position + offset, bullet.Position + offset);
				u.CreateBullet (typeof(OnibiMiddleBullet).FullName, (new Vector3D (0, l, 0)) + bullet.Position + offset, bullet.Position + offset);
				u.CreateBullet (typeof(OnibiMiddleBullet).FullName, (new Vector3D (-l, 0, 0)) + bullet.Position + offset, bullet.Position + offset);
				u.CreateBullet (typeof(OnibiMiddleBullet).FullName, (new Vector3D (0, -l, 0)) + bullet.Position + offset, bullet.Position + offset);
			}
			
		}
	}

	/// <summary>
	/// 鬼火弾(2段目)
	/// </summary>
	public class OnibiMiddleBullet : General.CannonBullet
	{
		public OnibiMiddleBullet()
		{
			Type = BulletType.LongRange;
			
			Attack = 0;
			Speed = 2.0f * BasisSpeed;
			Gravity = 1.5f;
			
			Radius = 1*Def.MapTipLengthOnField;
			
			HasSplash = true;
			IsSplashMissHit = true;
			SplashDamageRates.Add(Radius, 1.0f);

			MaxRange = 10 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(2.5f * Def.FPS);
			AttackRigor = (int)(1.5f * Def.FPS);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit += OnHitEffect;
			OnMiss += OnMissEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/ball_orange_big";
			TextureAnimation.AlphaBlend = AlphaBlend.Add;
			TextureAnimation.Width = 64;
			TextureAnimation.Height = 64;
			TextureAnimation.Center.X = 0;
			TextureAnimation.Center.Y = 0;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 1;
			TextureAnimation.Count.Y = 1;
		}
		void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			var faction = bullet.Generator.Faction;
			float scale = SplashDamageRates.Max(_ => _.Key) / 5.0f;
			CreateEffect(faction, target.Pos, scale);

			CreateSubBullet(bullet);
		}
		
		void OnMissEffect(IBullet bullet)
		{
			var faction = bullet.Generator.Faction;
			float scale = SplashDamageRates.Max(_ => _.Key) / 5.0f;
			CreateEffect(faction, bullet.Position, scale);

			CreateSubBullet(bullet);
		}
		
		public static void CreateEffect(IFaction faction, Vector3D pos, float scale)
		{
			var offset = new Vector3D(0, 0, 20);
			var effect = faction.World.EffectManager.CreateEffect(typeof(SuikaOnibiHitEffect).FullName, pos + offset);
			effect.SetScale(new Vector3D(scale,scale,scale));
			faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitLongRangeAttack).FullName, pos);
		}

		public static void CreateSubBullet (IBullet bullet)
		{
			if (null == bullet.Generator || !bullet.Generator.Exists ())
				return;
			var u = bullet.Generator as IUnit;

			if (null == u || !u.Exists ())
				return;

			var b = u.GetModifiedBulletParameter (typeof(OnibiSmallBullet).FullName);
			if (null != b) {
				Vector3D offset = u.Faction.World.GetGroundAtPos(new Vector2D(bullet.Position.X,bullet.Position.Y)) - bullet.Position;
				b.Attack = bullet.Attack / 2;
				float l = 1.5f * Def.MapTipLengthOnField;
				u.CreateBullet (typeof(OnibiSmallBullet).FullName, (new Vector3D (l, 0, 0)) + bullet.Position + offset, bullet.Position + offset);
				u.CreateBullet (typeof(OnibiSmallBullet).FullName, (new Vector3D (0, l, 0)) + bullet.Position + offset, bullet.Position + offset);
				u.CreateBullet (typeof(OnibiSmallBullet).FullName, (new Vector3D (-l, 0, 0)) + bullet.Position + offset, bullet.Position + offset);
				u.CreateBullet (typeof(OnibiSmallBullet).FullName, (new Vector3D (0, -l, 0)) + bullet.Position + offset, bullet.Position + offset);
			}

		}
	}

	/// <summary>
	/// 鬼火弾(3段目)
	/// </summary>
	public class OnibiSmallBullet : General.CannonBullet
	{
		public OnibiSmallBullet()
		{
			Type = BulletType.LongRange;
			
			Attack = 0;
			Speed = 2.0f * BasisSpeed;
			Gravity = 1.5f;
			
			Radius = 0.5f*Def.MapTipLengthOnField;

			HasSplash = true;
			IsSplashMissHit = true;
			SplashDamageRates.Add(Radius, 1.0f);

			MaxRange = 10 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(2.5f * Def.FPS);
			AttackRigor = (int)(1.5f * Def.FPS);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit += OnHitEffect;
			OnMiss += OnMissEffect;
			
			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/ball_orange_big";
			TextureAnimation.AlphaBlend = AlphaBlend.Add;
			TextureAnimation.Width = 64;
			TextureAnimation.Height = 64;
			TextureAnimation.Center.X = 0;
			TextureAnimation.Center.Y = 0;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 1;
			TextureAnimation.Count.Y = 1;
		}
		void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			var faction = bullet.Generator.Faction;
			float scale = SplashDamageRates.Max(_ => _.Key) / 5.0f;
			CreateEffect(faction, target.Pos, scale);
		}
		
		void OnMissEffect(IBullet bullet)
		{
			var faction = bullet.Generator.Faction;
			float scale = SplashDamageRates.Max(_ => _.Key) / 5.0f;
			CreateEffect(faction, bullet.Position, scale);
		}
		
		public static void CreateEffect(IFaction faction, Vector3D pos, float scale)
		{
			var offset = new Vector3D(0, 0, 20);
			var effect = faction.World.EffectManager.CreateEffect(typeof(SuikaOnibiHitEffect).FullName, pos + offset);
			effect.SetScale(new Vector3D(scale,scale,scale));
			faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitLongRangeAttack).FullName, pos);
		}
	}
}

#endif