﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Unit.Neutral
{
	public class Cannon : NeutralBase
	{
		public Cannon()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/chen";
			#endregion

			#region UnitParams
			Name = "砲兵";
			HP = 1500;
			Radius = (float)Utls.UnitSize.Medium;
			Speed = 1.0f * BasisSpeed;

			PopulationWeight = 3;

			ViewRange = 11 * Def.MapTipLengthOnField;

			MakingTime = 30 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {150,125,0,0};
			#endregion

			#region Description
			ButtonDescription += "攻城用ユニットです。\nこのユニットは、広い射程と高い攻撃力を持ちます。";

			#endregion
			/*
			#region Animation
			Animation = new TextureAnimation();
			Animation.Path = "LotusCraft/Image/Unit/unit";
			Animation.Width = 32;
			Animation.Height = 32;
			Animation.Center.X = 0;
			Animation.Center.Y = 10;
			Animation.CenterPosition = CenterPosition.MiddleMiddle;
			Animation.FrameCount = 4;
			Animation.FrameTime = 4;
			Animation.HasDirection = true;
			Animation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			Animation.Count.X = 4;
			Animation.Count.Y = 8;
			#endregion

			#region BuildableObjcets
			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Bullets
			Bullets = new string[] { "LotusCraft.Bullet.Gun" };
			#endregion
			*/
		}
		public override void OnLoad (IFaction faction)
		{
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.MoveButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StopButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.HoldPositionButton ()),
//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.PatrolButton ()),
//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.AttackButton ()),
//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StationButton ()),
			};
			#endregion

		}
	}
}
