﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Neutral;
using LotusCraft.Effect.Neutral;

namespace LotusCraft.Unit.Neutral
{
	public class Low01 : NeutralBase
	{
		public Low01()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Neutral/fluff03_n";
			#endregion

			#region UnitParams
			Name = "中立・毛玉";
			HP = 120;
			Radius = (float)Utls.UnitSize.Small;
			Speed = 0.8f * Speed;

			ViewRange = 5 * 32;

			MakingTime = 25 * 30;
			Exp = 20;
			/// mine,gas,sup,?
			Costs = new [] {150,0,0,0};
			#endregion

			#region Description
			ButtonDescription += "中立の毛玉。近くの敵を攻撃することができる。";

			#endregion

			#region Animation
			this.SetKedamaAnimation("LotusCraft/Image/Unit/Neutral/fluff03_n");
			
			#endregion

			#region BuildableObjcets
//			BuildingsMade = new[] {};
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(Low01Bullet).FullName };
			#endregion

		}
		public override void OnLoad (IFaction faction)
		{
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.MoveButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StopButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.HoldPositionButton ()),
//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.PatrolButton ()),
//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.AttackButton ()),
//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StationButton ()),
			};
			#endregion

		}

	}
}


namespace LotusCraft.Bullet.Neutral
{
	public class Low01Bullet : General.ShortRangeBullet
	{
		public Low01Bullet()
		{
			Type = BulletType.ShortRange;
			this.Attack = 8;
			Speed = 0.0f;
//			MaxRange = 0.1f * 32;
			
			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(0.8f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;
			
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
		}
	}
}
