﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Neutral;
using LotusCraft.Effect.Neutral;

namespace LotusCraft.Unit.Neutral
{
	public class Low02 : NeutralBase
	{
		public Low02()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Neutral/yosei03_n";
			#endregion

			#region UnitParams
			Name = "中立・妖精";
			HP = 90;
			Radius = (float)Utls.UnitSize.Small;
			Speed = 0.6f * Speed;

			ViewRange = 5 * 32;

			MakingTime = 25 * 30;
			Exp = 25;
			/// mine,gas,sup,?
			Costs = new [] {200,25,0,0};
			#endregion

			#region Description
			ButtonDescription += "中立の妖精。遠くの敵を攻撃することができる。";

			#endregion

			#region Animation
//			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Neutral/fluff02");
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Neutral/yosei03_n");
			#endregion

			#region BuildableObjcets
//			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(Low02Bullet).FullName };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.MoveButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StopButton ()),
				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.HoldPositionButton ()),
//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.PatrolButton ()),
//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.AttackButton ()),
//				new thrts.ButtonParameterHolder<thrts.IUnit> (new LotusCraft.Button.StationButton ()),
			};
			#endregion

		}
	}
}


namespace LotusCraft.Bullet.Neutral
{
	public class Low02Bullet : General.MiddleRangeBullet
	{
		public Low02Bullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			DoesHitOnlyTarget = true;
			this.Attack = 10;
			Speed = 10.0f * BasisSpeed;
			
			MaxRange = 6 * 32;
			
			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(1.5f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;
			
			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/kome";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 8;
			TextureAnimation.Center.Y = 8;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 4;
			TextureAnimation.Count.Y = 8;
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
		}
	}
}
