﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Red;
using LotusCraft.Effect.Red;

namespace LotusCraft.Unit.Red
{
	public class Kanako : General.Special
	{
		public Kanako()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Red/Kanako";
			#endregion

			#region UnitParams
			Name = "八坂 神奈子(式神)";
			HP = 380;
			Radius = (float)Utls.UnitSize.Large;
			Armor = 2;
			Speed = 0.8f * BasisSpeed;

			PopulationWeight = 6 ;

			ViewRange = 14 * Def.MapTipLengthOnField;

			MakingTime = 47 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {125,175,0,0};

			ButtonDescription = "遠距離砲撃ユニット\n長い射程と高い攻撃力を持つが接近されると攻撃できない";
			Description = _ => ButtonDescription.Split('\n').Select(s => new ColorTextLine(s));
			UnitType = new TargetObjectType[]{TargetObjectType.Clay,};

			#endregion
			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Red/Kanako");
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(KanakoBullet).FullName };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Red.KanakoSkill (),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
			};
			#endregion

			base.OnLoad(faction);
		}
	}
}


namespace LotusCraft.Bullet.Red
{
	public class KanakoBullet : General.CannonBullet
	{
		public KanakoBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Earth;
			DoesHitOnlyTarget = false;

			this.Attack = 30;
			Speed = 7.0f * BasisSpeed;
			
			MaxRange = 8 * Def.MapTipLengthOnField;
			MinRange = 2*Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.5f * 30);
			AttackRigor = 0;
			AttackSpeed = (int)(2*Def.FPS);

			DamageBonus[(int)TargetObjectType.Structure] = 1.5f;
			DamageBonus[(int)TargetObjectType.Water] = 1.8f;

			OnHit = OnHitEffect;
			
			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/onbashira";
			TextureAnimation.Width = 32;
			TextureAnimation.Height = 32;
			TextureAnimation.Center.X = 16;
			TextureAnimation.Center.Y = 16;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 1;
			TextureAnimation.Count.Y = 8;
		}
        static void OnHitEffect(IBullet bullet, ITargetObject target)
        {
            LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.BombRed);
        }
	}
}
