﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Unit;
using LotusCraft.Bullet.Red;
using LotusCraft.Building.Red;

namespace LotusCraft.Unit.Red
{
	public class Namazu : General.Special
	{
		public Namazu ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Red/Namazu";
			#endregion

			#region UnitParams
			Name = "大鯰(式神)";
			HP = 1000;
			Radius = (float)Utls.UnitSize.Large;
			Speed = 0.7f * BasisSpeed;
			Armor = 4;

			PopulationWeight = 8;

			ButtonDescription = "建物破壊専用ユニット\nユニットを攻撃できないかわりに、非常に高い攻撃力を持つ";
			Description = _ => ButtonDescription.Split('\n').Select(s => new ColorTextLine(s));

			ViewRange = 8*Def.MapTipLengthOnField;


			MakingTime = 50 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {175,250,0,0};
			UnitType = new TargetObjectType[]{TargetObjectType.Structure};

			RequireBuildings = new string[]{
				typeof(NamazuSculpture).FullName,
			};

			
#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Red/Namazu");
			#endregion

			#region BuildableObjcets
//			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Bullets
			Bullets = new string[] { 
				typeof(NamazuSiegeBullet).FullName,
			};
			SelectBullet = (unit,target,distance)=>{return (target == null || target is IBuilding) ? 0 : -1;};
			#endregion

		}
		public override void OnLoad (IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Red.NamazuSkill (),
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
			};
			#endregion

			base.OnLoad(faction);
		}
	}
}

namespace LotusCraft.Bullet.Red
{
	public class NamazuBullet : General.ShortRangeBullet
	{
		public NamazuBullet()
		{
			Type = BulletType.ShortRange;
			SpaceType = BulletSpaceType.Earth;

			this.Attack = 0;
			Speed = 0.0f;
			
			MaxRange = 0.5f * 32;
			
			AttackDelay = (int)(0.7f * Def.FPS);
			AttackRigor = (int)(0.3f * Def.FPS);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
		}
	}
	public class NamazuSiegeBullet : General.ShortRangeBullet
	{
		public NamazuSiegeBullet ()
		{
			Type = BulletType.ShortRange;
			SpaceType = BulletSpaceType.Earth;
			for(int i=0;i<this.DamageBonus.Length;++i)
				DamageBonus[i] = 0;

			DamageBonus[(int)TargetObjectType.Structure] = 1;

			this.Attack = 270;
			Speed = 10.0f * BasisSpeed;
			
			//			MaxRange = 0.5f * 32;
			
			AttackDelay = (int)(0.0f * Def.FPS);
			AttackRigor = (int)(3.0f * Def.FPS);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Utls.HitEffectType.ColumnRed);
		}
		
	}
}
