﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.Red;
using LotusCraft.Building.Red;

namespace LotusCraft.Unit.Red
{
	public class Suwako : General.Special
	{
		public Suwako ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Red/Suwako";
			#endregion

			#region UnitParams
			Name = "洩矢 諏訪子(式神)";
			HP = 250;
			Armor = 0;
			Speed = 1.0f * BasisSpeed;

			PopulationWeight = 2;

			ViewRange = 10 * 32;

			MakingTime = 42 * 30;
			/// mine,gas,sup,?
			Costs = new [] {125,75,0,0};

			ButtonDescription = "射撃ユニット\n空中を攻撃でき、岩属性に高いボーナスを持つ";
			Description = _ => ButtonDescription.Split('\n').Select(s => new ColorTextLine(s));
			UnitType = new TargetObjectType[]{TargetObjectType.Water,};

			RequireBuildings = new string[]{
				typeof(FrogSculpture).FullName,
			};

#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/Red/Suwako");
			#endregion

			#region BuildableObjcets
//			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Bullets
			Bullets = new string[] {
				typeof(Bullet.Red.SuwakoBullet).FullName,
				typeof(Bullet.Red.SuwakoAirBullet).FullName,
			};
			#endregion

			SelectBullet = SelectSuwakoBullet;
		}
		public int SelectSuwakoBullet (IUnit unit, ITargetObject target, float distance)
		{
			if (null == target)
				return 0;

			var u = target as IUnit;
			var b = target as IBuilding;

			if (null != u) {
				// 飛んでいたら飛行用弾を選択
				if (u.FlyingState == FlyingState.Fly || u.FlyingState == FlyingState.ToTouchGround || u.FlyingState == FlyingState.ToFly)
					return 1;
				else
					return 0;
			} else if (null != b) {
				return 0;
			}else{
				return 0;
			}
		}
		public override void OnLoad (IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Red.SuwakoSkill (),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
			};
			#endregion

			base.OnLoad(faction);
		}
	}
}
namespace LotusCraft.Bullet.Red
{
	public class SuwakoAirBullet : SuwakoBullet
	{
		public SuwakoAirBullet ()
		{
			SpaceType = BulletSpaceType.Sky;

		}
	}
	public class SuwakoBullet : General.MiddleRangeBullet
	{
		public SuwakoBullet()
		{
			Type = BulletType.ShortRange;
			SpaceType = BulletSpaceType.Both;
			DoesHitOnlyTarget = true;

			this.Attack = 8;
			DamageBonus[(int)TargetObjectType.Clay] = 4.0f;

			Speed = 10.0f * BasisSpeed;
			
			MaxRange = 5 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(1.0f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;
			
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.ColumnBlue);
		}
	}
}
