﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using LotusCraft.Bullet.Red;
using LotusCraft.Effect.Red;
using thrts;

namespace LotusCraft.Unit.Red.Unique
{
	public class Remilia :  General.Unique
	{
		public Remilia ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/Red/Unique/remilia";
			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Remilia";
			#endregion

            #region define_lv_param
			HPs[0] = 30 + 520;
			HPs[1] = 30 + HPs[0];
			HPs[2] = 30 + HPs[1];
			HPs[3] = 30 + HPs[2];
			HPs[4] = 30 + HPs[3];
			HPs[5] = 30 + HPs[4];
			HPs[6] = 30 + HPs[5];
			HPs[7] = 30 + HPs[6];
			HPs[8] = 30 + HPs[7];
			HPs[9] = 30 + HPs[8];
			
			Armors[0] = 0;
			Armors[1] = 0;
			Armors[2] = 1;
			Armors[3] = 1;
			Armors[4] = 2;
			Armors[5] = 2;
			Armors[6] = 3;
			Armors[7] = 3;
			Armors[8] = 4;
			Armors[9] = 4;

			ATKs [0] = 2 + 26;
			ATKs [1] = 2 + ATKs [0];
			ATKs [2] = 3 + ATKs [1];
			ATKs [3] = 3 + ATKs [2];
			ATKs [4] = 3 + ATKs [3];
			ATKs [5] = 4 + ATKs [4];
			ATKs [6] = 4 + ATKs [5];
			ATKs [7] = 4 + ATKs [6];
			ATKs [8] = 4 + ATKs [7];
			ATKs [9] = 5 + ATKs [8];
			
			#endregion

			#region UnitParams
			Name = "レミリア・スカーレット";
			HP = HPs[0];
			Speed = 1.2f*BasisSpeed;

			#endregion

			#region Animation
			this.SetBigSizeAnimation("LotusCraft/Image/Unit/Red/Unique/remilia");
			#endregion

			#region Cutin
			this.SetCutinAnimation("LotusCraft/Image/Cutin/Remilia");
			//Cutin.Type = CutinType.SlidinFromRight;
			#endregion


			#region BuildableObjcets
			//			BuildingsMade = new[] { "LotusCraft/Building/Test" };
			#endregion

			#region Spell
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.Red.HeartBreak (),
				new LotusCraft.Spell.Red.Servant (),
				new LotusCraft.Spell.Red.NightMare (),
				new LotusCraft.Spell.Red.ScarletDevil (),
				new LotusCraft.Spell.SpellLevelUp("Red"),
			};
			#endregion

            #region AutoCasts
            AutocasterParams = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				SpellParams [0].DefaultAutoCast,
				SpellParams [1].DefaultAutoCast,
				SpellParams [2].DefaultAutoCast,
				SpellParams [3].DefaultAutoCast,
				SpellParams [4].DefaultAutoCast,
				// 経験値取得用オートキャスト
				new LotusCraft.AutoCast.ExpFlagAutoCast<thrts.IUnit> (this.Name+"Exp"),
				// 自動回復用オートキャスト +1% HP/sec
				new LotusCraft.AutoCast.HealUniqueAutoCast<thrts.IUnit>(this.Name+"AutoHeal",0.06f),
			};
            #endregion

            #region Bullets
            Bullets = new string[] { 
				typeof(RemiliaBullet).FullName,
				typeof(HeartBullet).FullName,
				typeof(ServantBullet).FullName,
			};
            #endregion
		}
		public override void OnLoad (thrts.IFaction faction)
		{
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].DefaultSpellButton,SpellParams[1].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].DefaultSpellButton,SpellParams[2].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].DefaultSpellButton,SpellParams[3].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].DefaultSpellButton,SpellParams[4].SpellButtons),
				//				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].LevelUpSpellButton),
			};
#endregion
			
			base.OnLoad (faction);
		}
        public override void OnLvUp(thrts.IUnit unit)
        {
            base.OnLvUp(unit);
        }

        public override void OnVanish(IUnit unit)
        {
            var faction = unit.Faction;
            var offset = new Vector3D(-2, -2, 8);
            var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUniqueEffect).FullName, unit.Pos + offset);
            var scale = new Vector3D(8, 8, 8);
            effect.SetScale(scale);
            base.OnVanish(unit);
        }
	}



}

namespace LotusCraft.Bullet.Red
{
    public class RemiliaBullet : General.HeroBullet
    {
        public RemiliaBullet()
        {
            Type = BulletType.ShortRange;
            SpaceType = BulletSpaceType.Earth;
            this.Attack = 0;
            Speed = 0;
            Gravity = 0f;
            MaxRange = 0.5f * Def.MapTipLengthOnField;

            AttackDelay = (int)(0.5f * 30);
            AttackRigor = (int)(0.5f * 30);
            AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;

            OnHit = OnHitEffect;
        }
        static void OnHitEffect(IBullet bullet, ITargetObject target)
        {
			var faction = bullet.Generator.Faction;
			Unit.Utls.ShowHitEffect(target, Unit.Utls.HitEffectType.NormalRed);
			faction.World.SoundManager.PlaySoundEffect(typeof(SoundEffect.HitZangeki).FullName, target.Pos);
        }
    }
}

#endif