﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;

namespace LotusCraft.Unit.White
{
	public class FlyTransporter : General.Fly
	{
		public FlyTransporter ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/White/Fly03";
			#endregion

			#region UnitParams
			Name = "UFO(輸送)";
			HP = 200;
			Armor = 0;
			Speed =1.2f * BasisSpeed;
			Radius = (float)Utls.UnitSize.XL;

			PopulationWeight = 1;

			ViewRange = 12 * Def.MapTipLengthOnField;

			MakingTime = 50 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {100,100,0,0};

			//駐留関連
			Capacity = 10;//このユニットに何人駐留できるか
			StationWeight = 1;//他のオブジェ駐留時に何人分枠を使うか
			CanState = false;//他のオブジェに駐留可能か
			UnitType = new TargetObjectType[]{TargetObjectType.Water,};

			ButtonDescription = "輸送飛行ユニット\n人口10までユニットを駐留させ、運ぶことができる\n";
			#endregion


			#region Animation
			this.SetUFOAnimation("LotusCraft/Image/Unit/White/Fly03");
			Animation.HasDirection = false;
			AnimationWalk.HasDirection = false;
			ClickedWidth = 60;
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new ButtonParameterHolder<IUnit> (new LotusCraft.Button.UnStationUnitButton(false)),
			};
			base.OnLoad (faction);
		}
		public override void OnAppear (IUnit unit)
		{
			unit.IsMPBarShown = true;
			unit.MPBarMax = unit.Parameter.Capacity;
			unit.UnitStayed += (IUnit arg1, IUnit arg2) => unit.MPBarCurrent = arg1.StayedUnitCount;
			unit.UnitReleased += (IUnit arg1, IUnit arg2) => unit.MPBarCurrent = arg1.StayedUnitCount;

			if(null != unit)
				unit.AbilityManager.AppendAbility(new Ability.Common.UFOCloakAbility());

			base.OnAppear (unit);
		}
	}
}
