﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.White;
using LotusCraft.Building.White;

namespace LotusCraft.Unit.White
{
	public class Reisen : LotusCraft.Unit.General.Special
	{
		public Reisen ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/White/Reisen";
			#endregion

			#region UnitParams
			Name = "鈴仙・優曇華院・イナバ(式神)";
			HP = 320;
			Armor = 0;
			Speed = 1.0f * BasisSpeed;

			PopulationWeight = 2;

			ViewRange = 16 * Def.MapTipLengthOnField;

			MakingTime = 40 * Def.FPS;
			/// mine,gas,sup,?
			Costs = new [] {100,100,0,0};

			ButtonDescription = "対空専門射撃ユニット\n長距離射程を持ち、対空攻撃を行うことができる\n周囲のユニットを回復することができる";
			Description = _ => ButtonDescription.Split('\n').Select(s => new ColorTextLine(s));

			UnitType = new TargetObjectType[]{TargetObjectType.Water,};

			RequireBuildings = new string[]{
				typeof(Hospital).FullName,
			};
			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/White/Reisen");
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(Bullet.White.ReisenBullet).FullName, };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.White.ReisenSkill (),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit> (SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
			};
			#endregion

			base.OnLoad(faction);
		}
	}
}

namespace LotusCraft.Bullet.White
{
	public class ReisenBullet : General.LongRangeBullet
	{
		public ReisenBullet()
		{
			Type = BulletType.LongRange;
			DoesHitOnlyTarget = true;
			SpaceType = BulletSpaceType.Sky;
			this.Attack = 12;
			DamageBonus[(int)TargetObjectType.Water] = 1.5f;
			Speed = 10.0f * BasisSpeed;
			Gravity = 0;
			
			MaxRange = 8 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.5f * 30);
			AttackRigor = (int)(0.3f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;
			
			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/shell";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 8;
			TextureAnimation.Center.Y = 8;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 1;
			TextureAnimation.Count.Y = 8;
		}
        static void OnHitEffect(IBullet bullet, ITargetObject target)
        {
            LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.Bomb);
        }
	}
}
