using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Effect.White;
using LotusCraft.Building.White;

namespace LotusCraft.Unit.White
{
	public class Toramaru : LotusCraft.Unit.General.Special
	{
		public Toramaru ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/White/Toramaru";
			#endregion

			#region UnitParams
			Name = "寅丸 星(式神)";
			HP = 450;
			Armor = 4;
			Speed = 1.1f * BasisSpeed;

			PopulationWeight = 2;

			ViewRange = 10 * 32;

			MakingTime = 45 * 30;
			/// mine,gas,sup,?
			Costs = new [] {150,100,0,0};

			UnitType = new TargetObjectType[]{TargetObjectType.Clay,};

			RequireBuildings = new string[]{
				typeof(Houtou).FullName,
			};

			ButtonDescription = "近接ユニット\n高い防御力を持つ";
		
			#endregion

			#region Animation
			this.SetBigSizeAnimation2("LotusCraft/Image/Unit/White/Toramaru");
			#endregion

			#region BuildableObjcets
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(Bullet.White.ToramaruBullet).FullName, };
			#endregion
		}
		public override void OnLoad (IFaction faction)
		{
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.White.ToramaruSkill (),
			};
			AutocasterParams = new AutoCastParameter<IUnit>[]
			{
				SpellParams[0].DefaultAutoCast,
			};
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
			};
			#endregion

			base.OnLoad(faction);
		}
	}
}


namespace LotusCraft.Bullet.White
{
	public class ToramaruBullet : General.ShortRangeBullet
	{
		public ToramaruBullet()
		{
			Type = BulletType.ShortRange;
			this.Attack = 25;
			DamageBonus[(int)TargetObjectType.Clay] = 2.0f;
			Speed = 0.0f;
			MaxRange = 0.5f * 32;
			
			AttackDelay = (int)(0.0f * 30);
			AttackRigor = (int)(0.0f * 30);
			AttackSpeed = (int)(1.5f * 30);
			
			OnHit = OnHitEffect;
			
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			LotusCraft.Unit.Utls.ShowCommonHitEffect(bullet, target);
		}
	}
}
