﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.White;
using LotusCraft.Building.White;
using LotusCraft.Effect.White;


namespace LotusCraft.Unit.White.Unique
{
	public class Eirin : LotusCraft.Unit.General.Unique
	{
		public Eirin ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/White/Unique/Erin";
			ThumbnailPath = @"LotusCraft\Image\Thumbnail\Unique\Erin";
			#endregion

			Costs = new [] {300,100,0,0};
			defaultCosts = new [] {300,100,0,0};
			incCosts = new []{10,5,0,0};

			#region define_lv_param
			HPs[0] = 30 + 500;
			HPs[1] = 30 + HPs[0];
			HPs[2] = 30 + HPs[1];
			HPs[3] = 30 + HPs[2];
			HPs[4] = 30 + HPs[3];
			HPs[5] = 30 + HPs[4];
			HPs[6] = 30 + HPs[5];
			HPs[7] = 30 + HPs[6];
			HPs[8] = 30 + HPs[7];
			HPs[9] = 30 + HPs[8];
			
			Armors[0] = 1;
			Armors[1] = 1;
			Armors[2] = 2;
			Armors[3] = 2;
			Armors[4] = 3;
			Armors[5] = 3;
			Armors[6] = 4;
			Armors[7] = 4;
			Armors[8] = 5;
			Armors[9] = 5;
			
			ATKs [0] = 2 + 16;
			ATKs [1] = 2 + ATKs [0];
			ATKs [2] = 2 + ATKs [1];
			ATKs [3] = 3 + ATKs [2];
			ATKs [4] = 3 + ATKs [3];
			ATKs [5] = 3 + ATKs [4];
			ATKs [6] = 3 + ATKs [5];
			ATKs [7] = 4 + ATKs [6];
			ATKs [8] = 4 + ATKs [7];
			ATKs [9] = 4 + ATKs [8];

			#endregion

			#region UnitParams
			Name = "八意 永琳";
			HP = HPs[0];
			Speed = 1.0f * BasisSpeed;

			#endregion

			#region Animation
			this.SetBigSizeAnimation("LotusCraft/Image/Unit/White/Unique/eirin");
			#endregion

			#region Cutin
			this.SetCutinAnimation("LotusCraft/Image/Cutin/Erin");
			Cutin.Type = CutinType.SlidinFromLeft;
			#endregion


			#region BuildableObjcets
			BuildingsMade = new[] { 
				typeof(Omoikane_lv1).FullName,
				typeof(Omoikane_lv2).FullName,
				typeof(Omoikane_lv3).FullName,
			};
			#endregion

			#region Spell
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.White.Kochomumaru (),
				new LotusCraft.Spell.White.OmoikaneDevice (),
				new LotusCraft.Spell.White.TenmonMissou (),
				new LotusCraft.Spell.White.HourainoKusuri (),
				new LotusCraft.Spell.SpellLevelUp ("White"),
			};
			#endregion

			#region AutoCasts
			AutocasterParams = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				SpellParams [0].DefaultAutoCast,
				SpellParams [1].DefaultAutoCast,
				SpellParams [2].DefaultAutoCast,
				SpellParams [3].DefaultAutoCast,
				SpellParams [4].DefaultAutoCast,
				// 経験値取得用オートキャスト
				new LotusCraft.AutoCast.ExpFlagAutoCast<thrts.IUnit> (this.Name+"Exp"),
				// 自動回復用オートキャスト +1% HP/sec
				new LotusCraft.AutoCast.HealUniqueAutoCast<thrts.IUnit>(this.Name+"AutoHeal"),
			};
			#endregion

			#region Bullets
			Bullets = new string[] { typeof(EirinBullet).FullName };
			#endregion
		}
		public override void OnLoad (thrts.IFaction faction)
		{
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].DefaultSpellButton,SpellParams[1].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].DefaultSpellButton,SpellParams[2].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].DefaultSpellButton,SpellParams[3].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].DefaultSpellButton,SpellParams[4].SpellButtons),
//				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].LevelUpSpellButton),
			};
			#endregion

			base.OnLoad(faction);

		}
		public override void OnLvUp (thrts.IUnit unit)
		{
            base.OnLvUp(unit);
		}

		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUniqueEffect).FullName, unit.Pos + offset);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
	}
}

namespace LotusCraft.Bullet.White
{
	public class EirinBullet : General.HeroBullet
	{
		public EirinBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			
			DamageBonus = AttackBonusSet.Hero.ToArray();
			
			this.Attack = 0;
			Speed = 10.0f * BasisSpeed;
			
			MaxRange = 9*Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.5f * 30);
			AttackRigor = (int)(0.5f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;
			
			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/arrow";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 8;
			TextureAnimation.Center.Y = 8;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = true;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 1;
			TextureAnimation.Count.Y = 8;
		}
		static void OnHitEffect(IBullet bullet,ITargetObject target)
		{
			Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalBlue);
		}
	}
}

#endif