﻿#if !_TRIAL

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.White;
using LotusCraft.Building.White;
using LotusCraft.Effect.White;

namespace LotusCraft.Unit.White.Unique
{
	public class Ichirin : LotusCraft.Unit.General.Unique
	{
		public Ichirin ()
		{
			#region Icon
			IconPath = "LotusCraft/Image/Button/White/Unique/ichirin";
			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Ichirin";
			#endregion

			Costs = new [] {300,100,0,0};
			defaultCosts = new [] {300,100,0,0};
			incCosts = new []{10,5,0,0};

			#region define_lv_param
			// range <= 5
			HPs[0] = 40 + 800/2 + 150;
			HPs[1] = 40 + HPs[0];
			HPs[2] = 40 + HPs[1];
			HPs[3] = 40 + HPs[2];
			HPs[4] = 40 + HPs[3];
			HPs[5] = 40 + HPs[4];
			HPs[6] = 40 + HPs[5];
			HPs[7] = 40 + HPs[6];
			HPs[8] = 40 + HPs[7];
			HPs[9] = 40 + HPs[8];
			
			Armors[0] = 2;
			Armors[1] = 2;
			Armors[2] = 3;
			Armors[3] = 3;
			Armors[4] = 4;
			Armors[5] = 4;
			Armors[6] = 5;
			Armors[7] = 5;
			Armors[8] = 6;
			Armors[9] = 6;
			
			ATKs [0] = 2 + 23;
			ATKs [1] = 2 + ATKs [0];
			ATKs [2] = 3 + ATKs [1];
			ATKs [3] = 3 + ATKs [2];
			ATKs [4] = 3 + ATKs [3];
			ATKs [5] = 3 + ATKs [4];
			ATKs [6] = 4 + ATKs [5];
			ATKs [7] = 4 + ATKs [6];
			ATKs [8] = 4 + ATKs [7];
			ATKs [9] = 4 + ATKs [8];

			#endregion

			#region UnitParams
			Name = "雲居 一輪";
			HP = HPs[0];
			Speed = 1.0f * BasisSpeed;

			#endregion

			#region Animation
			this.SetBigSizeAnimation("LotusCraft/Image/Unit/White/Unique/Ichirin");
			#endregion

			#region Cutin
			this.SetCutinAnimation("LotusCraft/Image/Cutin/Ichirin");
			Cutin.Type = CutinType.FadeIn;
			#endregion

			#region Spell
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.White.Nyoki (),
				new LotusCraft.Spell.White.Tettui (),
				new LotusCraft.Spell.White.TaidenNyudo (),
				new LotusCraft.Spell.White.Oomedama (),
				new LotusCraft.Spell.SpellLevelUp ("White"),
			};
			#endregion

			#region BuildableObjcets
			#endregion

			#region AutoCasts
			AutocasterParams = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				SpellParams [0].DefaultAutoCast,
				SpellParams [1].DefaultAutoCast,
				SpellParams [2].DefaultAutoCast,
				SpellParams [3].DefaultAutoCast,
				SpellParams [4].DefaultAutoCast,
				// 経験値取得用オートキャスト
				new LotusCraft.AutoCast.ExpFlagAutoCast<thrts.IUnit> (this.Name+"Exp"),
				// 自動回復用オートキャスト +1% HP/sec
				new LotusCraft.AutoCast.HealUniqueAutoCast<thrts.IUnit>(this.Name+"AutoHeal"),
			};
			#endregion

			#region Bullets
			Bullets = new string[] { 
				typeof(IchirinBullet).FullName,
				typeof(OomedamaBullet).FullName,
			};
			#endregion

		}
		public override void OnLoad (thrts.IFaction faction)
		{
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].DefaultSpellButton,SpellParams[1].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].DefaultSpellButton,SpellParams[2].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].DefaultSpellButton,SpellParams[3].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].DefaultSpellButton,SpellParams[4].SpellButtons),
				//				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].LevelUpSpellButton),
			};
#endregion
			
			base.OnLoad (faction);
		}
		public override void OnLvUp(thrts.IUnit unit)
		{
            base.OnLvUp(unit);
		}

		public override void OnVanish(IUnit unit)
		{
			var faction = unit.Faction;
			var offset = new Vector3D(-2, -2, 8);
			var effect = faction.World.EffectManager.CreateEffect(typeof(DeadUniqueEffect).FullName, unit.Pos + offset);
			var scale = new Vector3D(8, 8, 8);
			effect.SetScale(scale);
			base.OnVanish(unit);
		}
	}

}

namespace LotusCraft.Bullet.White
{
	public class IchirinBullet : General.HeroBullet
	{
		public IchirinBullet()
		{
			Type = BulletType.LongRange;
			SpaceType = BulletSpaceType.Both;
			
			DamageBonus = AttackBonusSet.Hero.ToArray();
			
			this.Attack = 15;
			Speed = 10.0f * BasisSpeed;
			
			MaxRange = 5 * Def.MapTipLengthOnField;
			
			AttackDelay = (int)(0.5f * 30);
			AttackRigor = (int)(0.5f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;
			
			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/bullets";
			TextureAnimation.Width = 16;
			TextureAnimation.Height = 16;
			TextureAnimation.Center.X = 0;
			TextureAnimation.Center.Y = 0;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 1;
			TextureAnimation.Count.Y = 1;
			TextureAnimation.Offset.X = 128 * 2 + 16 * 0;
			TextureAnimation.Offset.Y = 128 * 1 + 16 * 2;
			TextureAnimation.AlphaBlend = AlphaBlend.Add;
		}
		static void OnHitEffect(IBullet bullet,ITargetObject target)
		{
			Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalPurple);
		}
	}
}

#endif