﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using thrts;
using LotusCraft.Bullet.White;
using LotusCraft.Effect.White;

namespace LotusCraft.Unit.White.Unique
{
	public class Marisa : LotusCraft.Unit.General.Unique
	{
		public  Marisa ()
		{

			Costs = new [] {300,100,0,0};
			defaultCosts = new [] {300,100,0,0};
			incCosts = new []{10,5,0,0};

			#region define_lv_param
			// range <= 5
			HPs[0] = 40 + 800/2 + 150;
			HPs[1] = 40 + HPs[0];
			HPs[2] = 40 + HPs[1];
			HPs[3] = 40 + HPs[2];
			HPs[4] = 40 + HPs[3];
			HPs[5] = 40 + HPs[4];
			HPs[6] = 40 + HPs[5];
			HPs[7] = 40 + HPs[6];
			HPs[8] = 40 + HPs[7];
			HPs[9] = 40 + HPs[8];

			Armors[0] = 2;
			Armors[1] = 2;
			Armors[2] = 3;
			Armors[3] = 3;
			Armors[4] = 4;
			Armors[5] = 4;
			Armors[6] = 5;
			Armors[7] = 5;
			Armors[8] = 6;
			Armors[9] = 6;

			ATKs [0] = 2 + 23;
			ATKs [1] = 2 + ATKs [0];
			ATKs [2] = 3 + ATKs [1];
			ATKs [3] = 3 + ATKs [2];
			ATKs [4] = 3 + ATKs [3];
			ATKs [5] = 3 + ATKs [4];
			ATKs [6] = 4 + ATKs [5];
			ATKs [7] = 4 + ATKs [6];
			ATKs [8] = 4 + ATKs [7];
			ATKs [9] = 4 + ATKs [8];

			
			#endregion

			#region Icon
			IconPath = "LotusCraft/Image/Button/White/Unique/marisa";
			ThumbnailPath = "LotusCraft/Image/Thumbnail/Unique/Marisa";
			#endregion

			#region UnitParams
			Name = "霧雨 魔理沙";
			HP = HPs[0];
			Armor = Armors[0];

			Speed = 1.0f*BasisSpeed;
			
			#endregion

			#region Animation
			this.SetBigSizeAnimation("LotusCraft/Image/Unit/White/Unique/marisa");
			#endregion

			#region Cutin
			this.SetCutinAnimation("LotusCraft/Image/Cutin/Marisa");
			#endregion

			#region Spell
			SpellParams = new thrts.SpellParameter<thrts.IUnit>[]
			{
				new LotusCraft.Spell.White.OrreysSun (),
				new LotusCraft.Spell.White.StarDust (),
				new LotusCraft.Spell.White.BlazingStar (),
				new LotusCraft.Spell.White.MasterSpark (),
				new LotusCraft.Spell.SpellLevelUp ("White"),
			};
			#endregion

			#region AutoCasts
			AutocasterParams = new thrts.AutoCastParameter<thrts.IUnit>[]
			{
				SpellParams [0].DefaultAutoCast,
				SpellParams [1].DefaultAutoCast,
				SpellParams [2].DefaultAutoCast,
				SpellParams [3].DefaultAutoCast,
				SpellParams [4].DefaultAutoCast,
				// 経験値取得用オートキャスト
				new LotusCraft.AutoCast.ExpFlagAutoCast<thrts.IUnit> (this.Name+"Exp"),
				// 自動回復用オートキャスト +1% HP/sec
				new LotusCraft.AutoCast.HealUniqueAutoCast<thrts.IUnit>(this.Name+"AutoHeal"),
			};
			#endregion

			#region Bullets
			Bullets = new string[] {
				typeof(MarisaBullet).FullName,
				typeof(OrrerysBullet).FullName,
			};
			#endregion
		}
		public override void OnLoad (thrts.IFaction faction)
		{
			#region Buttons
			ButtonParams = new thrts.ButtonParameterHolder<thrts.IUnit>[]
			{
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].DefaultSpellButton,SpellParams[0].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[0].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].DefaultSpellButton,SpellParams[1].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[1].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].DefaultSpellButton,SpellParams[2].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[2].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].DefaultSpellButton,SpellParams[3].SpellButtons),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[3].LevelUpSpellButton),
				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].DefaultSpellButton,SpellParams[4].SpellButtons),
				//				new thrts.ButtonParameterHolder<thrts.IUnit>(SpellParams[4].LevelUpSpellButton),
			};
#endregion
			
			base.OnLoad (faction);
		}
	}
}

namespace LotusCraft.Bullet.White
{
	public class MarisaBullet : General.HeroBullet
	{
		public MarisaBullet()
		{
			Type = BulletType.LongRange;
			this.Attack = 0;
			Speed = 10.0f * BasisSpeed;
			Gravity = 0f;
			MaxRange = 6.0f * Def.MapTipLengthOnField;

			AttackDelay = (int)(1.0f * 30);
			AttackRigor = (int)(0.0f * 30);
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;

			OnHit = OnHitEffect;

			TextureAnimation = new TextureAnimation();
			TextureAnimation.Path = "LotusCraft/Image/Bullet/marisa";
			TextureAnimation.Width = 32;
			TextureAnimation.Height = 32;
			TextureAnimation.Center.X = 16;
			TextureAnimation.Center.Y = 16;
			TextureAnimation.CenterPosition = CenterPosition.MiddleMiddle;
			TextureAnimation.FrameCount = 1;
			TextureAnimation.FrameTime = 1;
			TextureAnimation.HasDirection = false;
			TextureAnimation.LoopType = TextureAnimation.AnimetionLoopType.Loop;
			TextureAnimation.Count.X = 11;
			TextureAnimation.Count.Y = 1;
		}
		static void OnHitEffect(IBullet bullet, ITargetObject target)
		{
			Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.BombGreen);
		}
	}

	public class OrrerysBullet : General.CannonBullet
	{
		public OrrerysBullet()
		{
			Type = BulletType.LongRange;
			HitType = BulletHitType.Pierce;
			this.Attack = 0;
			FarmerDamageRatio = 0.5f;

			Speed = 0.0f * BasisSpeed;
			Gravity = 0f;
			MaxRange = 6.0f * Def.MapTipLengthOnField + 2.0f*Def.MapTipLengthOnField;
			
			LengthX = MaxRange;
			LengthY = 0.5f*Def.MapTipLengthOnField;
			RotateCenterX =LengthX/2;
			UseRot = true;
			
			
			CollisionType = BulletCollisionType.Square;
			
			
			AttackDelay = (int)(1.0f * Def.FPS);
			AttackRigor = (int)(1.0f * Def.FPS);
			Duration = AttackRigor;
			AttackSpeed = AttackDelay + AttackRigor; AttackRigor=0;

			OnHit = OnHitEffect;
		}
		static void OnHitEffect(IBullet bullet,ITargetObject target)
		{
			Unit.Utls.ShowCommonHitEffect(bullet, target, Unit.Utls.HitEffectType.NormalOrange);
		}
	}

}
